--  Created by zhangchao on 15-04-17.
--[[
	弹窗
	该对象实际就是一个ZCDialog，背景全透明，其内部有一个container，用于装载ui
	（ZCPopLayer只用于显示阴影层，其他的全部交给container）
	调用show方法显示并播放显示动画
]]
ZCPopLayer = class("ZCPopLayer", function()
    return ZCDialog:create()
end)


function ZCPopLayer:ctor(params)
	--创建默认参数
    local defaultParams = {
    	hideCallback = nil,
    	opacityValue = 70,
    }
    if params == nil then params = {} end
    for k, v in pairs(defaultParams) do
        if params[k] == nil then
            params[k] = v
        end
    end
    self._hideCallback = params.hideCallback
    self._isRemoveLayout = params.isRemoveLayout == nil and true or params.isRemoveLayout
    self.opacityValue = params.opacityValue

	self:setOpacity(0);
	-- local containerLayer = ZCSprite:createWithTexture(nil,cc.rect(0,0,self:getContentSize().width,self:getContentSize().height))
	local containerLayer = ZCSprite:create()
	containerLayer:setContentSize(self:getContentSize())
	containerLayer:setTouchSize(cc.size(10000,10000))
	containerLayer:setPosition(cc.p(self:getContentSize().width / 2 , self:getContentSize().height / 2))
	if params and params.pos then
		containerLayer:setPosition(cc.p(self:getContentSize().width / 2 + params.pos.width, self:getContentSize().height / 2 + params.pos.height))
	end
	self._containerLayer = containerLayer
	self:addChild(containerLayer)
	
	containerLayer:setTouchEndedCallback(function() 
	    self:hide({music = true})
	end)
	self._containerLayer:setCascadeOpacityEnabled(true)
end

function ZCPopLayer:setHideCallback(callback)
	self._hideCallback = callback
end

function ZCPopLayer:getContainerLayer()
	return self._containerLayer
end

function ZCPopLayer:addNodeOnContainer(node,zOrder) --直接在Container之上加东西，一般用来加入在Content和Container之间的吞噬层 Liuluyang
	zOrder = zOrder or 0
	self:getContainerLayer():addChild(node,zOrder)
end

function ZCPopLayer:addContent(node,zOrder)
	zOrder = zOrder or 0
	local SwallowTouch = ZCPushButton:createWithParams({
		--用于遮挡触摸 防止关闭窗口
		touchSize = node:getBoundingBox()
    })
    SwallowTouch:setPosition(node:getPositionX()+(0.5-node:getAnchorPoint().x)*node:getBoundingBox().width,node:getPositionY()+(0.5-node:getAnchorPoint().y)*node:getBoundingBox().height)
    self:getContainerLayer():addChild(SwallowTouch,zOrder)
	self:getContainerLayer():addChild(node,zOrder)
end

function ZCPopLayer:show(animation,_callBack)
	local _opacityValue = self.opacityValue or 70
	if nil == animation or animation == true then
		--[[背景逐渐变暗]]
		local SwallowTouch = ZCPushButton:createWithParams({
			--用于遮挡触摸 防止关闭窗口
			touchSize = self:getBoundingBox(),
			endCallback = function()
				print("----------------")
			end,
	    })
	    SwallowTouch:setPosition( self:getContentSize().width/2, self:getContentSize().height/2 )
	    self:addChild( SwallowTouch )
	    SwallowTouch:runAction(cc.Sequence:create(cc.DelayTime:create(0.3), cc.RemoveSelf:create()))
		self:runAction(cc.FadeTo:create(0.3, _opacityValue))
		local containerLayer = self:getContainerLayer()
		zc.runActionPop(containerLayer, _callBack)
	else
		-- self:setOpacity(_opacityValue)
		self:runAction(cc.FadeTo:create(0.3, _opacityValue))
		if _callBack then
			_callBack()
		end
	end
	return self
end

function ZCPopLayer:hide(params)
	if self._isHiding then
		return
	end
	self._isHiding = true
	-- if params and params.music and params.music == true then
	-- 	musicManager.playEffect("res/sound/sound_closePanel_effect.mp3")
	-- end
	self:setOpacity(0)
	local containerLayer = self:getContainerLayer()
	zc.runHidePop(containerLayer)
	local _hideCall = self._hideCallback
	if self._isRemoveLayout then
		LayerManager.removeLayout(true, true)
	end
	if params and params.animation then
		self:runAction(cc.Sequence:create(cc.DelayTime:create(0.15),cc.RemoveSelf:create(true)))
	else
		self:removeFromParent()
	end
	-- if params and params.noAction then
	-- 	self:removeFromParent()
	-- else
	-- 	self:runAction(cc.Sequence:create(cc.DelayTime:create(0.15),cc.RemoveSelf:create(true)))
	-- end
	if _hideCall then
		_hideCall()
	end
end

function ZCPopLayer:create(params)
	return ZCPopLayer.new(params)
end
