local ContinuityLogin = class("ContinuityLogin", function()
    local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function ContinuityLogin:create( params )
	return ContinuityLogin.new( params )
end

function ContinuityLogin:ctor( params )
	self:initData( params )
    self._size = self:getContentSize()
	self:initUI()
    self:initTableivew()
    self:initButtom()
end

function ContinuityLogin:initData( params )
    -- dump(params)
	local _tasks = params.task or {}
    self._activityName = params.activityName or ""
    self.activityType = params.activityType
    local data = gameData.getDataFromCache("running_login_awards")
	self._datas = {}

	for k,v in pairs(params.list or {}) do
        for f,g in pairs(data) do
            if tonumber(k) == tonumber(g.id) then
                g.status = v.status
                table.insert(self._datas, g)
            end
        end		
	end
    
    self:sortData()
	self._size = self:getContentSize()
end

function ContinuityLogin:sortData()
    self.total_can_get = 0
    -- status 0 可领取 1 已领取 2 未达成
    self.achievementData = {}
    local list1 = {}
    local list2 = {}
    local list3 = {}
    for k,v in pairs(self._datas) do
        if v.status == 0 then
            self.total_can_get = self.total_can_get + 1
            table.insert(list1,v)
        elseif v.status == 1 then
            table.insert(list2,v)
        elseif v.status == 2 then
            table.insert(list3,v)
        end
    end
    table.sort(list1,function (a,b)
        return a.id < b.id
    end)
    table.sort(list2,function (a,b)
        return a.id < b.id
    end)
    table.sort(list3,function (a,b)
        return a.id < b.id
    end)
    for k,v in pairs(list1) do
        table.insert(self.achievementData,v)
    end
    for k,v in pairs(list3) do
        table.insert(self.achievementData,v)
    end
    for k,v in pairs(list2) do
        table.insert(self.achievementData,v)
    end
    -- dump(self.achievementData,"test")
end

function ContinuityLogin:initUI()
    local leftpos = cc.p(102,self._size.height/2 - 35)
	local _tipDi = zc.createSprite("res/Main/activity/continuelogin/meinv.png")
    -- local _tipDi = ccui.Scale9Sprite:create(cc.rect(10, 10, 300, 480), "res/Main/activity/continuelogin/meinv.png")
    -- _tipDi:setContentSize(260,400)
    _tipDi:setScale(0.75)
    -- _tipDi:setScaleX(0.8)
	_tipDi:setPosition(leftpos)
    self:addChild(_tipDi)

    local titleicon = zc.createSprite("res/Main/activity/continuelogin/dllj.png")
    titleicon:setPosition(120,self._size.height - 55)
    self:addChild(titleicon,10,10)
end

function ContinuityLogin:initTableivew( ... )
    local tableSize = cc.size(530,400)
    local tableView = zc.ZCTableView:create(tableSize)
    tableView:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tableView:setPosition(190,62)
    tableView:setDelegate()
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    local _cellWidth = 530
    local _cellHeight = 150
    local function cellSizeForTable(table, cellIndex) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildRightCell(cell,cellIndex + 1,_cellHeight,_cellWidth)
        end
        self:updateRightCell(cell, cellIndex + 1,_cellHeight,_cellWidth)
        return cell
    end
    -- local _num = 5
    local _num = #self.achievementData
    local function numberOfCellsInTableView()
        return _num
    end
    tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self:addChild( tableView )
    tableView:reloadData()

    self.right_tableView = tableView
end

function ContinuityLogin:buildRightCell( cell,cellIndex,_cellHeight,_cellWidth )
    -- bg
    cell._item_bg = ccui.Scale9Sprite:create(cc.rect(20,20,150,150),"res/Main/activity/cell_bg_2.png")
    cell._item_bg:setContentSize(530,150)
    cell._item_bg:setPosition(_cellWidth/2,_cellHeight/2)

    cell:addChild(cell._item_bg)

    local size = cell._item_bg:getContentSize()

    local img = zc.createSprite("res/Main/activity/dekaron/titleTip.png")
    img:setPosition(147,cell._item_bg:getContentSize().height - 24)
    cell._item_bg:addChild(img)

    local posList = {
        cc.p(80,size.height/2 - 8),cc.p(170,size.height/2 - 8),
        cc.p(260,size.height/2 - 8),cc.p(350,size.height/2 - 8)
    }
    for i = 1,3 do
        local _item = zc.createIconByData({
            data = {
                mainType = 1,
                type = 1,
                id = 1,
                num = 1,
            },
            showCount = true,
            pos = posList[i],
        })  
        _item:setScale(0.6)
        cell._item_bg:addChild(_item)
        cell["_item"..i] = _item
    end

    --描述
    cell._task_desc_label = zc.createLabel({
        text = zc.lang("continuity_"),
        fontSize = 21,
        ap = cc.p(0, 0.5),
        color = cc.c3b(251,239,196),
        outLine = true,
        pixel = 1.6,
        pos = cc.p(20,img:getContentSize().height/2 + 2),
    })
    img:addChild(cell._task_desc_label)
    -- level
    cell._task_desc_label_level = zc.createLabel({
        text = "20",
        fontSize = 25,
        ap = cc.p(0, 0.5),
        outLine = true,
        pixel = 1.6,
        pos = cc.p(cell._task_desc_label:getPositionX() + cell._task_desc_label:getContentSize().width,img:getContentSize().height/2 + 2),
    })
    img:addChild(cell._task_desc_label_level)
    -- ji
    cell._task_desc_label_ji = zc.createLabel({
        text = zc.lang("date_day"),
        fontSize = 21,
        ap = cc.p(0, 0.5),
        color = cc.c3b(251,239,196),
        outLine = true,
        pixel = 1.6,
        pos = cc.p(cell._task_desc_label_level:getPositionX() + cell._task_desc_label_level:getContentSize().width,img:getContentSize().height/2 + 2),
    })
    img:addChild(cell._task_desc_label_ji)

    -- 前往
    cell._task_goto = zc.createCommomBtn({
        tag = 1,
        ap = cc.p(0.5,0.5),
        pos = cc.p(size.width - 100, size.height/2 - 5),
        fontSize = 24,
        scale = 0.8,
        text = zc.lang("fetch_2"),
    })
    cell:addChild(cell._task_goto)

    cell.yilingqu = zc.createSprite("res/Main/activity/monthSign/fetched.png")
    cell.yilingqu:setPosition(cell._task_goto:getPositionX(),cell._task_goto:getPositionY())
    cell:addChild(cell.yilingqu)

    cell.noday = zc.createSprite("res/Main/activity/continuelogin/noday.png")
    cell.noday:setPosition(cell._task_goto:getPositionX(),cell._task_goto:getPositionY())
    cell:addChild(cell.noday)
end
function ContinuityLogin:updateRightCell(cell,cellIndex,_cellHeight,_cellWidth )
    local data = self.achievementData[cellIndex]
    if not data then return end

    local status = tonumber(data.status ) or 0
    -- status 0 可领取 1 已领取 2 未达成
    if status == 2 then
        cell.yilingqu:setVisible(false)
        cell._task_goto:setVisible(false)
        cell.noday:setVisible(true)
    elseif status == 0 then
        cell.yilingqu:setVisible(false)
        cell._task_goto:setVisible(true)
        cell.noday:setVisible(false)
    elseif status == 1 then
        cell._task_goto:setVisible(false)
        cell.yilingqu:setVisible(true)
        cell.noday:setVisible(false)
    end
    -- 等级
    local str_nus = tostring(data.loginDays or 1)
    cell._task_desc_label_level:setString(str_nus)
    cell._task_desc_label_ji:setPositionX(cell._task_desc_label_level:getPositionX() + cell._task_desc_label_level:getContentSize().width + 2)
    -- 奖励
    local rewardData = data.reward
    local list = string.split(rewardData,",")
    -- dump(list)
    for i = 1,3 do
        if list[i] then
            local _cont = string.split(list[i],"|")
            zc.updateIconByData(cell["_item"..i],{
                data = {
                    mainType = _cont[1],
                    type = _cont[2],
                    id = _cont[2],
                    num = _cont[3],
                },
                showCount = true,
            })
            cell["_item"..i]:setTouchEndedShowTip()
            cell["_item"..i]:setVisible(true)
        else
            cell["_item"..i]:setVisible(false)
        end
    end
    cell._task_goto:setTouchEndedCall(function()
        -- status 0 可领取 1 已领取 2 未达成
        zc.sendHttp({
            apiName = "Continuity_Get",
            params = {id = data.id},
            successCallback = function( net_data )
                net_data.noAnimation = true
                PlayerData:updataData(net_data)
                zc.createShowReward(net_data)
                for k,v in pairs(self._datas) do
                    if tonumber(v.id) == tonumber(data.id) then
                        v.status = 1
                    end
                end
                self:sortData()
                self.right_tableView:reloadData()
                print("self.total_can_get == ",self.total_can_get)
                if self.total_can_get == 0 then
                    PlayerData:updateRedDotData(16,0)
                    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT, data = {id = 31}})
                end
            end
        })
    end)
end
function ContinuityLogin:initButtom( ... )
    -- bottom
    local _file = "res/Main/role/trinket/sellDi.png"
    local _rect = cc.rect(20, 10, 549, 71)
    local bottom = ccui.Scale9Sprite:create(_rect, _file)
    bottom:setContentSize(724, 67)
    bottom:setAnchorPoint(0.5, 0)
    bottom:setPosition(self._size.width*0.5 + 5, -5)
    self:addChild( bottom )
    local bottomSize = bottom:getContentSize()
    -- 提示
    local timeBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    timeBg:setContentSize(250, 30)
    timeBg:setAnchorPoint(0, 0.5)
    timeBg:setPosition(20, bottomSize.height*0.5)
    bottom:addChild(timeBg)

    local tanhao = zc.createSprite("res/Main/activity/rechargeReward/tanhao.png")
    tanhao:setAnchorPoint(0,0.5)
    tanhao:setPosition(5,15)
    timeBg:addChild(tanhao)
    -- 达到指定等级就可领取相应奖励
    local timeTip = zc.createLabel({
        text = zc.lang("continuity"),
        fontSize = 19,
        ap = cc.p(0, 0.5),
        pos = cc.p(tanhao:getPositionX() + 29, timeBg:getContentSize().height*0.5),
        color = cc.c3b(255,241,202),
    })
    timeBg:addChild(timeTip)
    -- 活动时间
    local _turnInfo = PlayerData:getActivityInfoById(31)
    if _turnInfo.openTime and _turnInfo.endTime then 
        self.time_bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
        self.time_bg:setContentSize(280,30 )
        self.time_bg:setPosition(bottomSize.width - 160,bottomSize.height/2)
        bottom:addChild(self.time_bg)
        --活动时间
        local timeTip = zc.createLabel({
            text = zc.lang("activity_time") .. "：",
            fontSize = 19,
            ap = cc.p(0, 0.5),
            pos = cc.p(10, self.time_bg:getContentSize().height/2),
            color = cc.c3b(250, 244, 192),
        })
        self.time_bg:addChild(timeTip)
        local _openTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), _turnInfo.openTime )
        local _endTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), _turnInfo.endTime )
        self.timeLab = zc.createLabel({
            text = _openTime .. " ~ " .. _endTime,
            fontSize = 19,
            ap = cc.p(0, 0.5),
            pos = cc.p(timeTip:getPositionX() + timeTip:getContentSize().width, timeTip:getPositionY()),
            color = cc.c3b(250, 244, 192),
        })
        self.time_bg:addChild(self.timeLab)
    end
end

return ContinuityLogin