--[[
	签到活动
	唐实聪
	2016.6.3
]]
local GrowUpLayer = class("GrowUpLayer", function()
    local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function GrowUpLayer:create( params )
	return GrowUpLayer.new( params )
end

function GrowUpLayer:ctor( params )
	local allDbs = gameData.getAllDataWithNoClone("growth_fund")
	self._limitVip = 0
	self._level = PlayerData:getUserLevel()
	self._isBuy = tonumber(params.isBuy) or 0
	self._costNum = tonumber(zc.getConsumePriceData(51).price) or 0
	self._totleGet = 0
	local _allStatus = params.status or {}

	local _tables = {}
	for k,v in pairs(allDbs) do
		local _table = {id = v.id, level = v.level}
		local _status = 0
		for _k,_v in pairs(_allStatus) do
			if v.id == tonumber(_k) then
				_status = tonumber(_v)
				break
			end
		end
		_table.status = _status
		local _vipLimit = tonumber(v.vipLimit) or 0
		if self._limitVip < _vipLimit then
			self._limitVip = _vipLimit
		end
		local _rewardInfo = string.split(v.reward, "|")
		local _rewardNum = tonumber(_rewardInfo[3]) or 0
		_table.rewardNum = _rewardNum
		self._totleGet = self._totleGet + _rewardNum
		table.insert(_tables, _table)
	end
	table.sort(_tables, function( a, b )
		if not a or not b then
			return false
		end
		local _idA = tonumber(a.id) or 0
		local _idB = tonumber(b.id) or 0
		return _idA < _idB
	end)
	self._grownDatas = _tables

	self:initUI()
	self:freshUI()
	self:initDengLong()
end

function GrowUpLayer:initDengLong( ... )
	local myScale9 = zc.createSprite()
	myScale9:setContentSize(80, 150)
    local btn = zc.createPushButton({
    	normalNode = myScale9,
        touchSize = cc.size(80, 150),
		touchScale = 0.9,
		pos = cc.p(125,335),
		needSwallow = true,
		needEnableWhenMoving = true,
		endCallback = function()
			zc.sendHttp({
				apiName = "AllPerson_Main",
				successCallback = function( backData )
					zc.createSourcePop("AllPersonFuli", "src/layer/activity/AllPersonFuli.lua", backData)	
				end
			})
		end
	})
	self:addChild(btn, 1)

    local speedsudu = zc.createSpine({
        path = "res/animation/zhuanpan_denglong/",
        fileName = "speedsudu",
        actName = "animation",
        loop = true,
        needInit = false,
    })
    speedsudu:setPosition(40, 130)
    speedsudu:setScale(0.7)
    btn:addChild(speedsudu,10)

    local _boxSpine = zc.createSpine({
        fileName = "quanminfuli",
        actName = "quanminfuli",
        loop = true,
        needInit = false,
    })
    _boxSpine:setPosition(40, 185)
    btn:addChild(_boxSpine)
end


function GrowUpLayer:initUI()
	local _size = self:getContentSize()
	local bg = zc.createSprite("res/Main/activity/growUp/bg.jpg")
	bg:setAnchorPoint(0.5, 1)
	bg:setPosition(_size.width*0.5, _size.height)
	self:addChild(bg)

	local _tipH = 30
	local _tipW = 140
    local _tipDi1 = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    _tipDi1:setContentSize(_tipW, _tipH)
    _tipDi1:setPosition(620, 330)
    self:addChild(_tipDi1)
    local _tip1_lab_1 = zc.createLabel({
    	text = zc.lang("curr_level"),
    	fontSize = 20,
    	color = cc.c3b(214, 184, 78),
    	ap = cc.p(0, 0.5),
    	pos = cc.p(5, _tipH*0.5)
	})
    _tipDi1:addChild(_tip1_lab_1)
    local _tip1_lab_2 = zc.createLabel({
    	text = self._level,
    	fontSize = 20,
    	ap = cc.p(0, 0.5),
    	pos = cc.p(_tipW*0.5 + 25, _tipH*0.5)
	})
    _tipDi1:addChild(_tip1_lab_2)

    local _tipDi2 = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    _tipDi2:setContentSize(_tipW, _tipH)
    _tipDi2:setPosition(_tipDi1:getPositionX(), _tipDi1:getPositionY() - 35)
    self:addChild(_tipDi2)
    local _tip2_lab_1 = zc.createLabel({
    	text = zc.lang("curr_vip"),
    	fontSize = 20,
    	color = cc.c3b(214, 184, 78),
    	ap = cc.p(0, 0.5),
    	pos = cc.p(5, _tipH*0.5),
	})
    _tipDi2:addChild(_tip2_lab_1)
    local _scale = 0.7
    local _tip2_sp_1 = zc.getSprite({
    	src = "res/Main/vip/vip_v.png",
    	ap = cc.p(0, 0.5),
    	pos = cc.p(_tipW*0.5 + 23, _tipH*0.5),
    	scale = _scale,
	})
    _tipDi2:addChild(_tip2_sp_1)
    local _tip2_sp_2 = zc.createFntLabel({
    	text = PlayerData.info.vip,
        fnt = "res/Main/vip/fnt/vip_num.fnt",
        addwidth = -8,
    	scale = _scale,
    	ap = cc.p(0, 0.5),
    	pos = cc.p(_tip2_sp_1:getPositionX() + _tip2_sp_1:getContentSize().width*_scale - 5, _tipH*0.5)
	})
    _tipDi2:addChild(_tip2_sp_2)

    local _bubbleDi = zc.createSprite("res/Main/activity/growUp/bubble.png")
    _bubbleDi:setPosition(480, 400)
    self:addChild(_bubbleDi)
	_bubbleDi:runAction(cc.RepeatForever:create(cc.Sequence:create(
		cc.ScaleTo:create(1.0, 1.2),
		cc.ScaleTo:create(1.0, 1.0)
	)))
	local _bbSize = _bubbleDi:getContentSize()
	local _img = zc.getSprite({
		src = zc.getImgByType(zc.dataTypeGold),
		ap = cc.p(0, 0.5),
		pos = cc.p(_bbSize.width*0.5 - 50, _bbSize.height*0.5 + 20)

	})
	_bubbleDi:addChild(_img)
	local _lab = zc.createLabel({
		text = self._totleGet,
		outLine = true,
		fontSize = 22,
		ap = cc.p(0, 0.5),
		pos = cc.p(_img:getContentSize().width, _img:getContentSize().height*0.5)
	})
	_img:addChild(_lab)

	-- scrollview
	local _nums = #self._grownDatas or 0
	local _scrollH = 150
	local _normalPart = 10
    local _partCellW = 120
    local _partArrowW = 42
	local _view = zc.createScrollview({
        size = cc.size(_size.width, _scrollH),
        innerSize = cc.size(_nums*(_partCellW + _partArrowW) + _normalPart, _scrollH),
        pos = cc.p(0, 80),
    }) 
    _view:setInertiaScrollEnabled(false)
    self:addChild(_view)
    self._rewardBtns = {}
    self._arrows = {}
    local _rewardDiSize = cc.size(80, 30)
    local _moveWidth = 0
    for i=1, _nums do
    	local _btn = zc.createPushButton({
    		normalFile = "res/Main/activity/growUp/di_u.png",
    		selectedFile = "res/Main/activity/growUp/di_d.png",
    		needEnableWhenMoving = true,
    		needSwallow = false,
    		noScaleAction = true,
    		pos = cc.p(_normalPart + (i - 1 + 0.5)*(_partCellW + _partArrowW), _scrollH*0.5 + 10),
    		endCallback = function()
	    		if self._isBuy == 0 then
	    			zc.tipInfo(zc.lang("tips_can_get_after_buy"))
	    			return
	    		end
	    		if self._level < self._grownDatas[i].level then
	    			zc.tipInfo(zc.lang("tips_less_level_cannot_get"))
	    			return
	    		end
	    		if self._grownDatas[i].status == 2 then
	    			zc.tipInfo(LANGUAGE_TOLLGATEHERO.fetched)
	    			return
	    		end
    			zc.sendHttp({
    				apiName = "GrowUp_reward",
    				params = {id = i},
    				successCallback = function( backData )
	    				PlayerData:updataData(backData)
    					local _allStatus = backData.status or {}
						self:updateRedDot(_allStatus)    					
    					for k,v in pairs(_allStatus) do
    						if self._grownDatas[tonumber(k)] then
								self._grownDatas[tonumber(k)].status = tonumber(v)
							end
    					end
    					self:freshUI()
    				end
				})
    		end
    	})
    	_view:addChild(_btn)
    	self._grownDatas[i].btn = _btn
    	local _btnSize = _btn:getContentSize()
    	local _node1 = cc.Node:create()
    	_node1:setPosition(_btnSize.width*0.5, _btnSize.height*0.5)
    	_btn:addChild(_node1)
    	local _sprite = zc.createSprite("res/Main/vip/icon/1.png")
    	_sprite:setPosition(0, 25)
    	_node1:addChild(_sprite)
    	local _spine = zc.getSpine("chengzhangjijin")
    	_spine:playAction("chengzhangjijins", true)
    	_spine:setPosition(0, 25)
    	_node1:addChild(_spine)
    	
    	local _di = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
	    _di:setContentSize(_rewardDiSize)
	    _di:setPosition(0, -20)
	    _node1:addChild(_di)
	    local _label = zc.createLabel({
	    	text = self._grownDatas[i].rewardNum,
	    	fontSize = 20,
	    	pos = cc.p(_rewardDiSize.width*0.5, _rewardDiSize.height*0.5)
	    })
	    _di:addChild(_label)

    	self._grownDatas[i].node1 = _node1
    	local _node2 = zc.createSprite("res/Main/activity/monthSign/fetched.png")
    	_node2:setPosition(_btnSize.width*0.5 - 3, _btnSize.height*0.5 + 10)
    	_btn:addChild(_node2)
    	self._grownDatas[i].node2 = _node2

    	local _lvDi = zc.createSprite("res/Main/activity/growUp/levelDi.png")
		_lvDi:setPosition(_btn:getPositionX(), 15)
    	_view:addChild(_lvDi)

	    local _lvLab = zc.createLabel({
	    	text = self._grownDatas[i].level .. zc.lang("level_1"),
	    	fontSize = 20,
	    	outLine = true,
	    	-- color = cc.c3b(197, 197, 197),
	    	pos = cc.p(_lvDi:getContentSize().width*0.5, _lvDi:getContentSize().height*0.5)
	    })
	    _lvDi:addChild(_lvLab)
    	self._grownDatas[i].lvLab = _lvLab

    	if i ~= 1 then
	    	local _arrow = zc.createSprite("res/Main/activity/growUp/arrow_lock.png")
	    	_arrow:setPosition(_btn:getPositionX() - (_partCellW + _partArrowW)*0.5, _scrollH*0.5)
	    	_view:addChild(_arrow)
	    	self._grownDatas[i].arrow = _arrow
	    end
	    if self._grownDatas[i].status == 2 then
	    	_moveWidth = _btn:getPositionX()
	    end
    end
    local _px = -_moveWidth
    if _px > 0 then
    	_px = 0
	elseif _px < _size.width - _view:getInnerContainer():getContentSize().width then
		_px = _size.width - _view:getInnerContainer():getContentSize().width
    end 
    _view:setInnerContainerPosition(cc.p(_px, 0))

    -- bottom
    local bottom = ccui.Scale9Sprite:create(cc.rect(20, 10, 549, 71), "res/Main/role/trinket/sellDi.png")
    bottom:setContentSize(728, 80)
    bottom:setAnchorPoint(0, 0)
    bottom:setPosition(-2, -5)
    self:addChild( bottom )
    local bottomSize = bottom:getContentSize()
    -- 活动时间
    local timeBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    timeBg:setContentSize(440, 30)
    timeBg:setAnchorPoint(0, 0.5)
    timeBg:setPosition(20, bottomSize.height*0.5)
    bottom:addChild(timeBg)

    cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
    local _pScale = 0.5
    local _leftTipImg1 = zc.getSprite({
        src = "home_icon_info.png",
        plist = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(-5, timeBg:getContentSize().height*0.5),
        scale = _pScale,
    })
    timeBg:addChild(_leftTipImg1)
    local _leftTipLab1 = zc.createLabel({
    	text = zc.lang("tips_buy_growup_canget"),
    	fontSize = 20,
    	color = cc.c3b(255, 252, 204),
    	ap = cc.p(0, 0.5),
    	pos = cc.p(_leftTipImg1:getPositionX() + _leftTipImg1:getContentSize().width*_pScale - 5, _leftTipImg1:getPositionY())
    })
    timeBg:addChild(_leftTipLab1)
    local _leftTipImg1 = zc.getSprite({
    	src = zc.getImgByType(zc.dataTypeGold),
    	ap = cc.p(0, 0.5),
    	pos = cc.p(_leftTipLab1:getPositionX() + _leftTipLab1:getContentSize().width, _leftTipImg1:getPositionY())
    })
    timeBg:addChild(_leftTipImg1)
    local _leftTipLab2 = zc.createLabel({
    	text = self._totleGet,
    	fontSize = 20,
    	ap = cc.p(0, 0.5),
    	outLine = true,
    	pos = cc.p(_leftTipImg1:getPositionX() + _leftTipImg1:getContentSize().width, _leftTipImg1:getPositionY())
    })
    timeBg:addChild(_leftTipLab2)

    if self._isBuy == 0 then
	    local _tipDi3 = cc.Node:create()
	    _tipDi3:setAnchorPoint(0.5, 0.5)
	    _tipDi3:setContentSize(_tipW, _tipH)
	    _tipDi3:setPosition(_tipDi2:getPositionX(), _tipDi2:getPositionY() - 35)
	    self:addChild(_tipDi3)
	    local _scale = 1.3
	    local vipSp = zc.getSprite({
	        src = "vip.png",
	        plist = true,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(0, _tipH*0.5),
	    })
	    _tipDi3:addChild(vipSp)
	    local vipNum = zc.createFntLabel({
	        fnt = "res/Main/common/fnt/mainVip.fnt",
	        text = self._limitVip,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(vipSp:getContentSize().width - 2, 0),
	        scale = _scale,
	        addwidth = -5,
	    })
	    vipSp:addChild(vipNum)
	    local _label = zc.createLabel({
	    	text = zc.lang("canbuy"),
	    	fontSize = 20,
	    	color = cc.c3b(255, 255, 212),
	    	pos = cc.p(_tipW*0.75, _tipH*0.5),
    	})
	    _tipDi3:addChild(_label)

		local _btn = zc.createCommomBtn({
			tag = 1,
			text = zc.lang("buy"),
			pos = cc.p(bottomSize.width - 100, bottomSize.height*0.5 - 5),
			endCallback = function()
				zc.sendHttp({
					apiName = "GrowUp_buy",
					params = {id = i},
					successCallback = function( backData )
						zc.tipInfo(zc.lang("tips_buy_success") .. "!")
	    				PlayerData:updataData(backData)
	    				self._buyBtn:setVisible(false)
	    				_tipDi3:setVisible(false)
	    				self._isBuy = tonumber(backData.isBuy) or 0
						local _allStatus = backData.status or {}
						for k,v in pairs(_allStatus) do
							if self._grownDatas[tonumber(k)] then
								self._grownDatas[tonumber(k)].status = tonumber(v)
							end
						end
						self:freshUI()
					end
				})
			end
		})
		self:addChild(_btn)
		self._buyBtn = _btn
		if _btn:getStateNormal() then
			local _lab = _btn:getStateNormal():getChildByName("normalLab")
			if _lab then
				_lab:setPositionX(_lab:getPositionX() + 28)
			end
		end

		if _btn:getStateSelected() then
			local _lab = _btn:getStateSelected():getChildByName("selectedLab")
			if _lab then
				_lab:setPositionX(_lab:getPositionX() + 28)
			end
		end

		local _img = zc.getSprite({
			src = zc.getImgByType(zc.dataTypeGold),
			ap = cc.p(0, 0.5),
			pos = cc.p(22, _btn:getContentSize().height*0.5)

		})
		_btn:addChild(_img)
		local _lab = zc.createLabel({
			text = self._costNum,
			outLine = true,
			fontSize = 18,
			ap = cc.p(0, 0),
			pos = cc.p(_img:getContentSize().width*0.5, 0)
		})
		_img:addChild(_lab)
	end
end

--红点。
function GrowUpLayer:updateRedDot(_allStatus)
	for k,v in pairs(_allStatus) do
		if tonumber(v) == 1 then
			PlayerData:updateRedDotData(6, 1)
			return
		end
	end

	PlayerData:updateRedDotData(6, 0)
end

function GrowUpLayer:freshUI()
	local _nums = #self._grownDatas or 0
	for i=1, _nums do
		local _info = self._grownDatas[i]
		local _status = tonumber(_info.status) or 0
		if _status == 2 then
			if i ~= 1 then
				_info.arrow:setTexture("res/Main/activity/growUp/arrow_lock.png")
	    	end
	    	_info.lvLab:setColor(cc.c3b(197, 197, 197))
	    else
			if i ~= 1 then
		    	_info.arrow:setTexture("res/Main/activity/growUp/arrow_open.png")
			end
			_info.lvLab:setColor(display.COLOR_YELLOW)
		end

		if _status == 2 then
			_info.node1:setVisible(false)
			_info.node2:setVisible(true)
			_info.btn:setEnable(false)
		else
			_info.node2:setVisible(false)
			_info.node1:setVisible(true)
			_info.btn:setEnable(true)
		end
	end
end

return GrowUpLayer