-- FileName: MounthCardLayer.lua
-- Author: wangming
-- Date: 2016-10-10
-- Purpose: 月卡的领取界面
--[[TODO List]]

local MounthCardLayer = class("MounthCardLayer", function()
	local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function MounthCardLayer:create( params )
	return MounthCardLayer.new( params )
end

function MounthCardLayer:ctor( params )
    self._yueDatas = gameData.getDataFromCache("card")
	self._size = self:getContentSize()
	-- 背景
	local bg = zc.createSprite( "res/Main/activity/mounthCard/bg.jpg" )
	bg:setAnchorPoint( 0.5, 1 )
	bg:setPosition( self._size.width*0.5, self._size.height )
	self:addChild( bg )

	local _leftSp = zc.createSpine({
		fileName = "yuekatexiao",
		actName = "yueka",
		needInit = false,
	})
	_leftSp:setPosition(self._size.width*0.25, 300)
	self:addChild( _leftSp )
	local _leftBtn = zc.createCommomBtn({
		tag = 1,
		text = zc.lang("buy2"),
		pos = cc.p(_leftSp:getPositionX(), _leftSp:getPositionY() - 200),
		endCallback = function()
			if self._yueDatas["7"].status == 0 then
				LayerManager.backToMainCity(false)
				zc.createRechargePop()
			elseif self._yueDatas["7"].status == 1 then
				self:doRecieve(7)
			end
		end
	})
	self:addChild( _leftBtn )
    self._leftBtn = _leftBtn
	local _timesLab = zc.createRichLabel({
        fontSize = 20,
        anchor = cc.p( 0.5, 0.5 ),
        pos = cc.p( _leftBtn:getPositionX(), _leftBtn:getPositionY() + 50),
        color = cc.c3b(255, 229, 200),
    })
    self:addChild( _timesLab )
    self._timesLab = _timesLab
    local _leftCostDi = zc.getSprite({
    	src = "res/Main/activity/mounthCard/costDi.png",
    	pos = cc.p(_leftBtn:getPositionX(), _timesLab:getPositionY() + 50),
	})
    self:addChild( _leftCostDi )
    local _leftCostLab = zc.createLabel({
    	fontSize = 24,
    	outLine = true,
    	text = zc.getGtMoneyFlag() .. zc.changeGtMoney(self._yueDatas["7"].price),
    	pos = cc.p(_leftCostDi:getPosition()),
    })
    self:addChild( _leftCostLab )


	local _rightSp = zc.createSpine({
		fileName = "yuekatexiao",
		actName = "zhongshenka",
		needInit = false,
	})
	_rightSp:setPosition(self._size.width*0.75, _leftSp:getPositionY() + 18)
	self:addChild( _rightSp )
	local _rightBtn = zc.createCommomBtn({
		tag = 1,
		text = zc.lang("buy2"),
		pos = cc.p(_rightSp:getPositionX(), _leftBtn:getPositionY()),
		endCallback = function()
			if self._yueDatas["8"].status == 0 then
				LayerManager.backToMainCity(false)
				zc.createRechargePop()
			elseif self._yueDatas["8"].status == 1 then
				self:doRecieve(8)
			end
		end
	})
	self:addChild( _rightBtn )
    self._rightBtn = _rightBtn
    local _rightCostDi = zc.getSprite({
    	src = "res/Main/activity/mounthCard/costDi.png",
    	pos = cc.p(_rightBtn:getPositionX(), _leftCostDi:getPositionY()),
	})
    self:addChild( _rightCostDi )
    local _rightCostLab = zc.createLabel({
    	fontSize = 24,
    	outLine = true,
    	text = zc.getGtMoneyFlag() .. zc.changeGtMoney(self._yueDatas["8"].price),
    	pos = cc.p(_rightCostDi:getPosition()),
    })
    self:addChild( _rightCostLab )

    -- 头
    local _topDi = zc.getSprite({
    	src = "res/Main/activity/mounthCard/topDi.png",
    	pos = cc.p(self._size.width*0.5, self._size.height - 25),
	})
    self:addChild( _topDi )
    local _topTipLab = zc.createRichLabel({
		text = zc.lang("tips_mouthcard_tip1"),
        fontSize = 28,
        anchor = cc.p( 0.5, 0.5 ),
        pos = cc.p(_topDi:getPosition()),
    })
    self:addChild( _topTipLab )

	-- 底
	local _diSize = cc.size(728, 68)
	local bottom = ccui.Scale9Sprite:create( cc.rect( 20, 10, 549, 71 ), "res/Main/role/trinket/sellDi.png" )
    bottom:setContentSize(_diSize)
    bottom:setAnchorPoint( 0, 0 )
    bottom:setPosition( -2, -5 )
    self:addChild( bottom, 1)

    local _leftTipDi = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(200, 30))
	_leftTipDi:setPosition(_diSize.width*0.3, _diSize.height*0.5)
	bottom:addChild(_leftTipDi)
	local _str = string.split(self._yueDatas["7"].reward, "|")
	local _leftTipLab = zc.createRichLabel({
		text = string.format(zc.lang("tips_mouthcard_tip2"), tostring(_str[3])),
        fontSize = 20,
        anchor = cc.p( 0.5, 0.5 ),
        pos = cc.p( _leftTipDi:getPosition()),
        color = cc.c3b(255, 229, 200),
    })
    bottom:addChild( _leftTipLab )
	local _leftTipImg = zc.getSprite({
		src = "res/Main/activity/mounthCard/dayTime.png",
		pos = cc.p(_leftTipDi:getPositionX() - 135, _leftTipDi:getPositionY()),
	})
	bottom:addChild(_leftTipImg)

	local _rightTipDi = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(200, 30))
	_rightTipDi:setPosition(_diSize.width*0.8, _diSize.height*0.5)
	bottom:addChild(_rightTipDi)
	local _str = string.split(self._yueDatas["8"].reward, "|")
	local _rightTipLab = zc.createRichLabel({
		text = string.format(zc.lang("tips_mouthcard_tip2"), tostring(_str[3])),
        fontSize = 20,
        anchor = cc.p( 0.5, 0.5 ),
        pos = cc.p(_rightTipDi:getPosition()),
        color = cc.c3b(255, 229, 200),
    })
    bottom:addChild( _rightTipLab )
	local _rightTipImg = zc.getSprite({
		src = "res/Main/activity/mounthCard/onLineTime.png",
		pos = cc.p(_rightTipDi:getPositionX() - 150, _rightTipDi:getPositionY()),
	})
	bottom:addChild(_rightTipImg)


    self:freshInfo(params)
end

function MounthCardLayer:freshInfo( params )
	local _params = params or {}
	local _status = _params.status or {}
    self._yueDatas["7"].status = tonumber(_status["1"]) or 0
    self._yueDatas["8"].status = tonumber(_status["2"]) or 0
	self._endDay = tonumber(_params.endDay) or 0

	if self._endDay > 0 then
		self._timesLab:setVisible(true)
		self._timesLab:setString(zc.lang("shengyu") .. "[color=ff00ff00]" .. self._endDay .. "[/color]" .. zc.lang("date_day"))
	else
		self._timesLab:setVisible(false)
	end

	if self._yueDatas["7"].status == 2 then
		self._leftBtn:setEnable(false)
		self._leftBtn:setString(LANGUAGE_TOLLGATEHERO.fetched)
	elseif self._yueDatas["7"].status == 1 then
		self._leftBtn:setEnable(true)
		self._leftBtn:setString(zc.lang("fetch_2"))
	else
		self._leftBtn:setEnable(true)
		self._leftBtn:setString(zc.lang("buy2"))
	end

	if self._yueDatas["8"].status == 2 then
		self._rightBtn:setEnable(false)
		self._rightBtn:setString(LANGUAGE_TOLLGATEHERO.fetched)
	elseif self._yueDatas["8"].status == 1 then
		self._rightBtn:setEnable(true)
		self._rightBtn:setString(zc.lang("fetch_2"))
	else
		self._rightBtn:setEnable(true)
		self._rightBtn:setString(zc.lang("buy2"))
	end
end

function MounthCardLayer:doRecieve( id )
	zc.sendHttp({
        apiName = "EveryDayCard_get",
        params = {id = id},
        successCallback = function(backData)
        	PlayerData:updataData(backData)
        	local _params = {
				status = backData.status,
				endDay = backData.endDay,
			}
        	self:freshInfo(_params)
        end
    })
end

return MounthCardLayer