--[[
	补领体力弹窗
	唐实聪
	2016.6.15
]]
local ReceiveEnergyPop = class("ReceiveEnergyPop", function()
	return ZCPopLayer:create()
end)

function ReceiveEnergyPop:create( params )
	return ReceiveEnergyPop.new( params )
end

function ReceiveEnergyPop:ctor( params )
	self:initData( params )
	self:initUI()
	self:show()
end

function ReceiveEnergyPop:initData( params )
	self._price = params.price
	self._callback = params.callback

	self._size = self:getContentSize()
end

function ReceiveEnergyPop:initUI()
	-- 背景
    local background = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
        pos = cc.p(self._size.width/2, self._size.height/2)
    })
    self:addContent( background )
    local bgSize = background:getContentSize()
    -- 关闭
    local close = zc.createBackButton({
        pos = cc.p( bgSize.width - 20, bgSize.height - 20), 
        listener = function()
            self:hide()
        end,
    })
    background:addChild( close )
    -- 标题
    local title =  zc.getTipPopTitle( "tishi" )
    title:setPosition( bgSize.width/2, bgSize.height - 30 )
    background:addChild(title)

    -- 中间背景
    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    middleBg:setPosition(bgSize.width*0.5, bgSize.height*0.5 + 30)
    background:addChild(middleBg)
    -- 提示文字
    local tipLabel = zc.createLabel({
        text = LANGUAGE_RECIEVEENERGY_TIPS.tip_4,
        fontSize = 20,
        ap = cc.p( 0.5, 1 ),
        pos = cc.p( middleBg:getContentSize().width/2, middleBg:getContentSize().height - 30),
        outLine = true,
        pixel = 1.5,
    })
    middleBg:addChild(tipLabel)
    -- 图标
    local energyBuySp = zc.createSprite( "res/Main/home/buy_energy.png" )
    energyBuySp:setPosition( middleBg:getContentSize().width/2, middleBg:getContentSize().height/2 - 17 )
    middleBg:addChild( energyBuySp )
    -- +120
    local energyAddNum = zc.createLabel({
        text = "+60",
        fontSize = 25,
        color = zc.COLOR_GREEN,
        ap = cc.p( 0, 0 ),
        pos = cc.p( 50, 3),
        outLine = true,
        pixel = 1.5,
    })
    energyBuySp:addChild(energyAddNum)

    -- 购买花费
    local consumeIcon = cc.Sprite:create( "res/Main/common/common_icon_gold.png" )
    consumeIcon:setPosition( 145, 70 )
    background:addChild( consumeIcon )
    local consumeNum = zc.createLabel({
    	text = self._price,
        fontSize = 22,
        ap = cc.p( 0, 0 ),
        pos = cc.p( 25, 0),
        outLine = true,
        pixel = 1.5,
    })
    consumeIcon:addChild(consumeNum)

    -- 购买按钮
    local buyBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p( bgSize.width*0.5, 70 ), 
        text = LANGUAGE_SHOP.buy,
        endCallback = function()
            zc.sendHttp({
                apiName = "ReceiveEnergy_remedy",
                successCallback = function( backData )
                    PlayerData:updataData( backData )
                    if self._callback then
                    	self._callback( backData )
                    end
                    self:hide()
                end,
            })
        end
    })
    background:addChild( buyBtn )
end


return ReceiveEnergyPop