--[[
	FileName: TurntableGetPop.lua
	Author: andong
	Date: 2016-03-17
	Purpose: xx弹窗
]]
local TurntableGetPop = class( "TurntableGetPop", function ()
    return ZCPopLayer:create()
end)

function TurntableGetPop:create(params)
	return TurntableGetPop.new(params)
end

function TurntableGetPop:ctor(params)
	self:initData(params)
	self:initUI()
	self:show()
end

function TurntableGetPop:initData(params)
	local params = params or {}
	self._alreadGet = params.turnTableInfo.received or {}
end

function TurntableGetPop:initUI()
    local popBg = zc.createSprite("res/Main/wushenTower/pop_reward.png")
	popBg:setPosition(zc.width/2, zc.height/2)
	self:addContent(popBg)
	local popSize = popBg:getContentSize()

	local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close)

    local myTableBg = ccui.Scale9Sprite:create(cc.rect(26,25,1,1), "res/Main/wushenTower/pop_tableBg.png")
    myTableBg:setContentSize(419, 245)
    myTableBg:setAnchorPoint(cc.p(0.5, 0.5))
    myTableBg:setPosition(popSize.width/2, popSize.height/2)
    popBg:addChild(myTableBg)

    local totalReward = {}
    local rewardMap = {}
    for i = 1, #self._alreadGet do
    	local v = self._alreadGet[i]
    	if v and v.id then
			local itemInfo = gameData.getDataFromCacheWithPrimaryKey("turn_table_awards", v.id)
			if itemInfo and itemInfo.itemType then
				local itemType = tonumber(itemInfo["itemType"])
				local itemId = tonumber(itemInfo["itemId"])
				local multiple = tonumber(v.multiple) or 1
				if not rewardMap[itemType] then
					rewardMap[itemType] = {}
				end
				local typeMap = rewardMap[itemType]
				if itemType ~= 1 and 
					itemType ~= 4 and 
					itemType ~= 6 then
					typeMap = {}
				end
				if typeMap[itemId] then
					local idx = typeMap[itemId]
					if itemType == 2 then
						totalReward[idx].changeNum = 1
					else
						totalReward[idx].changeNum = tonumber(totalReward[idx].changeNum) + tonumber(itemInfo.itemNum) * multiple
					end
				else
					local idx = #totalReward + 1
					typeMap[itemId] = idx
					totalReward[idx] = {
						itemType = itemType,
			            itemId = itemId, 
	            		itemId = itemId,
	            		changeNum = itemInfo.itemNum * multiple,
					}
				end
			end
		end
    end
    -- dump(totalReward, "totalReward-----------dump--------ad-------------" )

    local linNum = math.floor((table.nums(totalReward)-1)/4) + 1
    local innerHeight = linNum * 102

    if innerHeight < 230 then
    	innerHeight = 230
    end

    local dropScrollView = zc.createScrollview({
        size = cc.size(405, 230),
        innerSize = cc.size(405, innerHeight),
        dir = ccui.ScrollViewDir.vertical,
        -- dir = ccui.ScrollViewDir.both,
        bar = false,
        bounceEnable = true,
    })
    myTableBg:addChild(dropScrollView)
    dropScrollView:ignoreAnchorPointForPosition(false)
    dropScrollView:setAnchorPoint(cc.p(0.5, 0.5))
    dropScrollView:setPosition(myTableBg:getContentSize().width/2,myTableBg:getContentSize().height/2)

    --item
    local idx = 0
    for i = 1, #totalReward do
    	local v = totalReward[i]
    	if v and v.itemType then
        	idx = idx + 1
            local modI = idx <= 4 and (idx-1) or ((idx-1)%4)
            local posX = 52+(modI)*99
            local posY = innerHeight-50-102*( math.floor((idx-1)/4) )

			local multiple = tonumber(v.multiple) or 1
            local item, info= zc.createIconByData({
                data = {
                    mainType = v.itemType,
                    type = v.itemId,
                    id = v.itemId,
                    num = v.changeNum ,
                }, 
                showDetailPop = true,
                pos = cc.p(posX, posY), 
            })
            item:setScale(82/120)
            dropScrollView:addChild(item)
    	end
    end

    if #self._alreadGet == 0 then
	    local tipNoItemLab = zc.createSprite("res/Main/common/empty.png")
	    tipNoItemLab:setPosition(myTableBg:getContentSize().width/2,myTableBg:getContentSize().height/2)
	    myTableBg:addChild(tipNoItemLab)
    end

end

return TurntableGetPop