--[[
	FileName: TurntableLayer.lua
	Author: andong
	Date: 2016-11-23
	Purpose: 转盘界面
]]
local TurntableLayer = class( "TurntableLayer", function ()
	local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function TurntableLayer:create(parmas)
	return TurntableLayer.new(parmas)
end

function TurntableLayer:ctor(parmas)
	zc.addEventListener({
		name = CUSTOM_EVENT.EVENT_TURNLAYER, 
		callback = function(data)
			dump(data,"-----EVENT_TURNLAYER----")
	        if tolua.isnull(self) then
	            return
	        end
	        if self._params then
	        	local rechargeGold = tonumber(data.data.gold or 0)
	        	local _times = rechargeGold/300
	        	local remain_ = rechargeGold%300

	        	self._params.turnTableInfo.times = tonumber(self._params.turnTableInfo.times) + _times
	        	self._params.turnTableInfo.remain = remain_
	        	if self._params.turnTableInfo.times < 0 then self._params.turnTableInfo.times = 0 end
	        	if self.sy_num_lable then
	        		self.sy_num_lable:setString(self._params.turnTableInfo.times)
	        	end
	        	local str = 300 - tonumber(remain_ or 0)
	        	if self.againnum then
					self.againnum:setString(str.."")	        		
	        	end
	        end
		end
	})
	zc.addEventListener({
		name = CUSTOM_EVENT.EVET_GET_REWARD, 
		callback = function(data)
			dump(data,"--------EVET_GET_REWARD----")
			if self._params then
				local id = data.data.id
				table.insert(self._params.turnTableInfo.received,id)
			end
		end
	})
	-- dump(parmas)
	self:initData(parmas)
	self:initUI()
	self:todayGet()
	local function onNodeEvent(event)
        if "cleanup" == event then
            self:onCleanup()
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

function TurntableLayer:initData(parmas)
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end
    self.activityType = parmas.activityType
    self._params = parmas
end
function TurntableLayer:initUI()
	self._size = self:getContentSize()
	local background = zc.createSprite("res/Main/activity/turntable/mainBg.jpg")
	local scaleX = 732/709
	local scaleY = 476/465
	local x = self._size.width/2
	local y = self._size.height/2
	if self.activityType == 2 then
		-- scaleX = 920/709
		-- scaleY = 495/465
		scaleX = 1
		scaleY = 1
		x = self._size.width/2 - 12
		y = self._size.height/2 + 18
	end
	background:setAnchorPoint( 0.5, 0.5 )
	background:setPosition( x, y)
	self:addChild( background )
	background:setScaleX(scaleX)
	background:setScaleY(scaleY)
	local FlipY = {false,true}
	local posVertial = {25,background:getContentSize().width - 20}
	for i = 1,2 do
		-- 竖直装饰线条
		local verticalline = zc.createSprite("res/Main/limittimehot/verticalline.png")
		verticalline:setFlipX(FlipY[i])
		verticalline:setPosition(posVertial[i],background:getContentSize().height/2)
		background:addChild(verticalline)
	end

	local outBg = zc.createSprite("res/Main/activity/turntable/out_bg.png")
	outBg:setAnchorPoint(0.5, 0.5)
	outBg:setPosition(self._size.width/2 - 6, self._size.height/2+18)
	self:addChild(outBg)

	local insideBg = zc.createSprite("res/Main/activity/turntable/inside_bg.png")
	insideBg:setAnchorPoint(0.5, 0.5)
	insideBg:setPosition(outBg:getPositionX(), outBg:getPositionY())
	self:addChild(insideBg)

	self._outBg = outBg
	self._insideBg = insideBg

	local yinghua = zc.createSprite("res/Main/activity/turntable/yinghua.png")
	yinghua:setAnchorPoint(1, 1)
	yinghua:setPosition(self._size.width+120, self._size.height+32)
	self:addChild(yinghua)

    local _particle = cc.ParticleSystemQuad:create("res/Main/activity/turntable/meihua/meihua.plist")
    _particle:setPosition( 666+10, 438 )
    self:addChild( _particle, 6 )
    _particle:setScale(0.8)

    local function calcRefreshPrice(_btn)
	    local _rData = gameData.getDataFromCache("consume_price", {type = 45}) or {}
	    local _rPrice = 0
	    if next(_rData) then
	    	if _rData.price then
	    		_rPrice = _rData.price
	    	else
	    		local _flushTimes = tonumber(self._params.flushTimes) or 0
	        	local index = _flushTimes + 1
	        	if index > table.nums(_rData) then
	        		index = table.nums(_rData)
	        	end
	        	local _rInfo = _rData[index] or {}
	            _rPrice = _rPrice + _rInfo.price or 0
	    	end
	    end

		if _rPrice and _rPrice == 0 then --免费

		else
			_btn:setString(LANGUAGE_SHOP.refresh)
			if _btn._goldImg then
				_btn._goldNum:setString(_rPrice)
			else
				local _normal = _btn:getStateNormal()
				local _select = _btn:getStateSelected()
				_normal:getChildByName("normalLab"):setPositionX(_btn:getContentSize().width/2+15)
				_select:getChildByName("selectedLab"):setPositionX(_btn:getContentSize().width/2+15)

			    local goldImg = zc.createSprite( zc.getImgByType(1) )
			    goldImg:setAnchorPoint(0, 0.5)
			    goldImg:setPosition(25, _btn:getContentSize().height/2 )
			    _btn:addChild(goldImg)
			    local goldNum = zc.createLabel({
			        text = _rPrice,
			        fontSize = 20,
			        ttf = zc.getFont(1),
			        ap = cc.p(0.5, 1),
			        pos = cc.p(goldImg:getContentSize().width/2, 18),
			        outLine = true,
	                pixel = 2,
			    })
			    goldImg:addChild(goldNum)
			    _btn._goldImg = goldImg
			    _btn._goldNum = goldNum
			end
		end
	end
    -- 剩余次数bg
    local sy_bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
	sy_bg:setContentSize(130,30 )
	sy_bg:setPosition(cc.p(760,130))
	self:addChild(sy_bg)
    local sy_times = zc.createLabel({
        text = zc.lang("shengyu")..":",
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos =  cc.p(10,15),
        color = cc.c3b(255,253,213),
    })
    sy_bg:addChild(sy_times)
    -- 剩余次数
    local total_times = tonumber(self._params.turnTableInfo.times)
    if total_times < 0 then total_times = 0 end

    local sy_num_lable = zc.createLabel({
        text = total_times..zc.lang("ci"),
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos =  cc.p(sy_times:getPositionX()+ sy_times:getContentSize().width +5,15),
        color = cc.c3b(0,253,58),
    })
    sy_bg:addChild(sy_num_lable)
    self.sy_num_lable = sy_num_lable

    local _pData = gameData.getDataFromCache("consume_price", {type = 46}) or {}
    local function calcPrice(_times)
	    local _price = 0
	    local _turnTimes = tonumber(self._params.turnTimes) or 0
	    if next(_pData) then
	        if _pData.price then
	            _price = _pData.price
	        else
	        	for i = 1, _times do
		        	local index = _turnTimes + i
		        	if index > table.nums(_pData) then
		        		index = table.nums(_pData)
		        	end
		        	local _pInfo = _pData[index] or {}
		            _price = _price + _pInfo.price or 0
		        end
	        end
	    end
	end

    local _selectedbg = zc.createSprite("res/Main/common/check_bg2.png")
    local checkBox = zc.createPushButton({
        normalNode = _selectedbg,
        touchSize = cc.size(70, 60),
        pos = cc.p(720,70),
        endCallback = function()
        	if self._selectedImg:isVisible() then
        		self._selectedImg:setVisible(false)
        		calcPrice(1)
        	else
        		self._selectedImg:setVisible(true)
        		calcPrice(10)
        	end
        end
    })
    self:addChild(checkBox)
    local _selectedImg = zc.createSprite("res/Main/home/home_reachCondition.png")
    checkBox:addChild(_selectedImg)
    _selectedImg:setPosition(checkBox:getContentSize().width*0.5, checkBox:getContentSize().height*0.5)
    self._selectedImg = _selectedImg
    self._selectedImg:setVisible(false)

    local labBg = zc.getScaleNode("res/Main/common/descDi.png", cc.size(70, 30))
    labBg:setAnchorPoint(cc.p(0, 0.5))
    labBg:setPosition(cc.p(checkBox:getPositionX()+checkBox:getContentSize().width/2, checkBox:getPositionY() ))
    self:addChild(labBg)
    local tenLab = zc.createLabel({
	    text = zc.lang("turn_ten_times"),
	    outLine = true,
	    fontSize = 20,
	    fontName = zc.getFont(1),
	    pos = cc.p(35, labBg:getContentSize().height/2),
	})
	labBg:addChild(tenLab)
	
	local begin_bg = zc.createSprite("res/Main/activity/turntable/begin_bg.png")
	begin_bg:setAnchorPoint(0.5, 0.5)
	begin_bg:setPosition(outBg:getPositionX(), outBg:getPositionY())
	self:addChild(begin_bg)

	local point = zc.createSprite("res/Main/activity/turntable/point.png")
	point:setAnchorPoint(0.5, 0.5)
	point:setPosition(outBg:getPositionX(), outBg:getPositionY()+25)
	self:addChild(point)

	--初始偏移量
	self._initInNum = 0
	self._initOutNum = 0


	local myScale9 = zc.getScaleNode("res/Main/setting/scale9_1.png", cc.size(120, 120))
	local myScale9 = zc.createSprite()
	myScale9:setContentSize(120, 120)

    local _boxSpine = zc.createSpine({
        fileName = "zhuanpan",
        actName = "idle",
        loop = true,
        needInit = false,
    })
    _boxSpine:setPosition(outBg:getPositionX(), outBg:getPositionY())
    self:addChild(_boxSpine)
    self._boxSpine = _boxSpine

    local myScale9 = zc.createSprite()
    myScale9:setContentSize( 120, 120 )
	local touchBtn = zc.createPushButton({
		normalNode = myScale9,
		needSwallow = false,
		touchScale = 0.9,
		pos = cc.p(outBg:getPositionX(), outBg:getPositionY()),
		endCallback = function()
			if tonumber(self._params.turnTableInfo.times) < 0 then
				zc.tipInfo(zc.lang("ci_noenough"))
				return
			end
			if self._selectedImg:isVisible() then
				if tonumber(self._params.turnTableInfo.times) < 10 then
					zc.tipInfo(zc.lang("ci_noenough"))
					return
				end
			end
			--添加屏蔽
			getGuideManager():addMaskLayer()

			local function doTurn(net_data,_endAction)
				self._boxSpine:playAction("start2", false)
				self._boxSpine:registerSpineEventHandler( function ( event )
					if event.animation == "start2" then
						self._boxSpine:playAction("start", true)
					end
				end, sp.EventType.ANIMATION_COMPLETE)

				local outNum = math.random(1, 8)
				local inNum = math.random(1, 8)

				if net_data then
					local getId
					if self._turn_type == 1 then
						getId = tonumber(net_data.id[1])
					else
						getId = tonumber(net_data.id)
					end
					inNum = getId
					outNum = getId 
				end

				local inAngle = 360 / 8 * (self._initInNum+inNum-1)
				local outAngle = 360 / 8 * (self._initOutNum+outNum-1)
				if outAngle > 360 then
					outAngle = outAngle - 360
				end
				if inAngle < 180 then
					inAngle = inAngle + 360
				end
				
			    outBg:runAction(cc.Sequence:create(
			    	cc.EaseIn:create(cc.RotateBy:create(2, -720), 2),
			    	cc.RotateBy:create(1, -720),
			    	cc.EaseOut:create(cc.RotateBy:create(4, -360-outAngle), 4),
			    	cc.DelayTime:create(0.2),
			    	cc.CallFunc:create(function()
		    			self._initInNum = 9 - inNum
						self._initOutNum = 9 - outNum
						self._boxSpine:playAction("idle", true)
						if _endAction then
							_endAction()
						end
			    	end)
			    ))
			    insideBg:runAction(cc.Sequence:create(
			    	cc.CallFunc:create(function() 
			    		performWithDelay(self,function()
			    			self._boxSpine:stopAllActions()
							self._boxSpine:playAction("stop", false)
						end,5.5+1)
			    	end),
			    	cc.EaseIn:create(cc.RotateBy:create(2, 720), 2),
			    	cc.RotateBy:create(1, 720),
			    	cc.EaseOut:create(cc.RotateBy:create(3, 360+(360-inAngle)), 3)
			    ))

			end

			local _type = 1

			if self._selectedImg:isVisible() then
				_type = 10
			end
			self._turn_type = _type
			-- doTurn()
			zc.sendHttp({
			    apiName = "TurnTable_play",
			    params = {type = _type},
			    successCallback = function (net_data)
			    	-- self._params = net_data
			    	self._hasNotUpdateData = true --是否没有刷新数据
			    	local function endAction()
						if net_data then
            				net_data.noAnimation = true
							PlayerData:updataData(net_data)
							self._hasNotUpdateData = false
							if self._turn_type == 1 then
        						zc.createShowReward(net_data)
        					else
        						local params = {
        							id = net_data.id,
        							turnTableData = self._params.turnTableData
        						}
        						zc.createSourcePop("RewardLayer", "src/layer/activity/RewardLayer.lua", params or {})
        					end
				        	if self._selectedImg:isVisible() then
				        		calcPrice(10)
				        	else
				        		calcPrice(1)
				        	end
							getGuideManager():removeMaskLayer()

		                    -- 获得兵器武将
		                    local _weaponInfo = nil
		                    local _heroId = nil
		                    for i, v in ipairs( net_data.clientItems ) do
		                        local _mainType = tonumber( v.type ) or 0
		                        if _mainType == 3 then
		                            _weaponInfo = PlayerData:getWeaponInfoInfoById( v.model.id )
		                            break
		                        elseif _mainType == zc.mainTypeSoldier then
		                            _heroId = v.model.heroId
		                            break
		                        end
		                    end
		                    if _heroId then
		                        zc.createPubShowGetHero({id=_heroId})
		                    elseif _weaponInfo then
		                        zc.createPop("makeGodWeapon", {info = _weaponInfo, onlyShow = true})
		                    end
		                    self.sy_num_lable:setString(self._params.turnTableInfo.times..zc.lang("ci"))
        				end			    	
			    	end

			    	if _type == 1 then
				    	--首先更新消耗的元宝
				    	local firstUpdate = {}
				    	firstUpdate.clientResources = {}
				    	-- firstUpdate.clientResources.gold = ownGold - self._nowUseGold
	    				firstUpdate.noAnimation = true
						PlayerData:updataData(firstUpdate)
						--转盘动作
						self._params.turnTableInfo.times = tonumber(self._params.turnTableInfo.times) - 1
						self._params.turnTableInfo.turnTimes = tonumber(self._params.turnTableInfo.turnTimes) + 1
						doTurn(net_data, endAction)
						
					else
						dump(net_data.id,"---tesst---")
						self._params.turnTableInfo.turnTimes = tonumber(self._params.turnTableInfo.turnTimes) + 10
						self._params.turnTableInfo.times = tonumber(self._params.turnTableInfo.times) - 10
						endAction()
					end
			    end,
	            errorCallback = function(_errorCode,_msg)
		            zc.tipInfo(_msg)
		            getGuideManager():removeMaskLayer()
		        end,
		        failCallback = function()
		            zc.tipInfo(zc.lang("tips_network_error"))
		            getGuideManager():removeMaskLayer()
		        end,
			})
		end,
	})
	self:addChild(touchBtn)
	self._touchBtn = touchBtn

	local begin = zc.createSprite("res/Main/activity/turntable/begin.png")
	begin:setAnchorPoint(0.5, 0.5)
	begin:setPosition(touchBtn:getContentSize().width/2-7, touchBtn:getContentSize().height/2-1)
	touchBtn:addChild(begin)
	--花费
	calcPrice(1)

	self:refreshReward()
	self:initNewUI()
end

function TurntableLayer:initNewUI()
	local data = self._params.turnTableInfo
	local remain = tonumber(data.remain) or 0 
	local againnum_ = 300 - remain

	local bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
	bg:setContentSize(340,30 )
	bg:setPosition(23,25)
	self:addChild(bg)
	self._bg = bg
	local desc = zc.createLabel({
		text = zc.lang("meichongzhi"),
		fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(50, bg:getContentSize().height/2 ),
        color = cc.c3b(250, 244, 192),
	})
	bg:addChild(desc)
	local descNum = zc.createLabel({
		text = "300",
		fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(desc:getPositionX() + desc:getContentSize().width, bg:getContentSize().height/2 ),
        -- color = cc.c3b(250, 244, 192),
        outLine = true,
	})
	bg:addChild(descNum)
	local yuanbao = zc.createSprite( zc.getImgByType(1) )
	yuanbao:setAnchorPoint(0,0.5)
	yuanbao:setPosition(descNum:getPositionX() + descNum:getContentSize().width +2,bg:getContentSize().height/2)
	bg:addChild(yuanbao)

	local desc1 = zc.createLabel({
		text = zc.lang("getChange"),
		fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(yuanbao:getPositionX() + yuanbao:getContentSize().width - 3, bg:getContentSize().height/2 ),
        color = cc.c3b(250, 244, 192),
	})
	bg:addChild(desc1)
	-- 右下角bg
	local right_bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
	right_bg:setContentSize(280,30)
	right_bg:setPosition(self._size.width - 100,-35)
	self:addChild(right_bg)
	-- 再充值多少元宝
	local again = zc.createLabel({
		text = zc.lang("againCz"),
		fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(10, right_bg:getContentSize().height/2 ),
        color = cc.c3b(250, 244, 192),
	})
	right_bg:addChild(again)
	local againnum = zc.createLabel({
		text = againnum_,
		fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(again:getPositionX() + again:getContentSize().width + 2, right_bg:getContentSize().height/2 ),
        -- color = cc.c3b(250, 244, 192),
	})
	right_bg:addChild(againnum)
	self.againnum = againnum

	local yuanbao = zc.createSprite( zc.getImgByType(1) )
	yuanbao:setAnchorPoint(0,0.5)
	yuanbao:setPosition(againnum:getPositionX() + againnum:getContentSize().width + 2,right_bg:getContentSize().height/2)
	right_bg:addChild(yuanbao)
	local againdesc = zc.createLabel({
		text = zc.lang("cangetChange"),
		fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(yuanbao:getPositionX() + yuanbao:getContentSize().width -3, right_bg:getContentSize().height/2 ),
        color = cc.c3b(250, 244, 192),
	})
	right_bg:addChild(againdesc)
end

--刷新奖励
function TurntableLayer:refreshReward()

	if not self._itemList then
		local outPos = {
			[1] = {pos=cc.p(215, 426),angle = 0},
			[2] = {pos=cc.p(362, 373),angle = 45},
			[3] = {pos=cc.p(427, 242),angle = 90},
			[4] = {pos=cc.p(379, 92),angle = 135},
			[5] = {pos=cc.p(233, 19),angle = 180},
			[6] = {pos=cc.p(74, 81),angle = 225},
			[7] = {pos=cc.p(17, 226),angle = 270},
			[8] = {pos=cc.p(69, 359),angle = 315},
		}
		local inPos = {
			[1] = {pos=cc.p(209, 335),angle = 0},
			[2] = {pos=cc.p(306, 281),angle = 45},
			[3] = {pos=cc.p(336, 173),angle = 90},
			[4] = {pos=cc.p(280, 77),angle = 135},
			[5] = {pos=cc.p(172, 48),angle = 180},
			[6] = {pos=cc.p(76, 104),angle = 225},
			[7] = {pos=cc.p(47, 210),angle = 270},
			[8] = {pos=cc.p(102, 308),angle = 315},
		}

		local _nowAwards = self._params.turnTableData
		self._itemList = {}

		self._posMultiple = {}
		for i = 1, 8 do
			--in
			local item_id = _nowAwards[tostring(i)].id
			if item_id then
				-- local itemInfo = gameData.getDataFromCacheWithPrimaryKey("turn_table_awards", item_id)
				local data = _nowAwards[tostring(i)].reward
				local list = string.split(data or "","|")

				if list and list[1] then
			    	local itemType = tonumber(list[1])
			        local _showItem = true
			        local _showHero = nil
			        if tonumber(itemType) == zc.mainTypeSoldier then
			            _showItem = false
			            _showHero = function() zc.createHeroInfoPop({heroId = list[2], showHero = true}) end
			        end
					local _item = zc.createIconByData({
			            data = {
							mainType = list[1],
							type = list[2],
			                id = list[2],
			                num = list[3],
						},
	            		showDetailPop = _showItem,
        				listener = _showHero,
			            pos = inPos[i].pos,
			        })
			        _item:setScale(0.5)
			        _item:setRotation(inPos[i].angle)
			        self._insideBg:addChild(_item)

			        self._itemList[i] = _item
			    end
		    end
			local rate = _nowAwards[tostring(i)].rate
			self._posMultiple[i] = rate
		end
	else
		local _nowAwards = self._params.turnTableData
		for i = 1, 8 do
			local item_id = _nowAwards[tostring(i)].id
			local item = self._itemList[i]
			if item and item_id then
				item:stopAllActions()
				
				-- local itemInfo = gameData.getDataFromCacheWithPrimaryKey("turn_table_awards", item_id)
				local data = _nowAwards[tostring(i)].reward
				local list = string.split(data or "","|")
				-- dump(itemInfo, "-----------dump----itemInfoitemInfo----ad-------------" )
				if list and list[1] then
			    	local itemType = tonumber(list[1])
			        local _showItem = true
			        local _showHero = nil
			        if tonumber(itemType) == zc.mainTypeSoldier then
			            _showItem = false
			            _showHero = function() zc.createHeroInfoPop({heroId = list[2], showHero = true}) end
			        end
		            item:runAction(cc.Sequence:create(cc.ScaleTo:create(0.2, 1.1*0.5),cc.ScaleTo:create(0.1, 1*0.5)))
		            local newParmas = {
		                data = {
							mainType = list[1],
							type = list[2],
			                id = list[2],
			                num = list[3],
		                },
	            		showDetailPop = _showItem,
        				listener = _showHero,
		            }
		            zc.updateIconByData(item,newParmas)
				end
			end
		end
	end
end

function TurntableLayer:todayGet()
	local myScale9 = zc.createSprite()
	myScale9:setContentSize(80, 150)
    local btn = zc.createPushButton({
    	normalNode = myScale9,
        touchSize = cc.size(80, 150),
		touchScale = 0.9,
		pos = cc.p(10,360),
		needSwallow = true,
		needEnableWhenMoving = true,
		endCallback = function()
	    	zc.createSourcePop("ChouJiangChengjiu", "src/layer/activity/ChouJiangChengjiu.lua", self._params)
		end
	})
	self:addChild(btn, 1)

    local speedsudu = zc.createSpine({
        path = "res/animation/zhuanpan_denglong/",
        fileName = "speedsudu",
        actName = "animation",
        loop = true,
        needInit = false,
    })
    speedsudu:setPosition(40, 130)
    speedsudu:setScale(0.7)
    btn:addChild(speedsudu,10)

    local _boxSpine = zc.createSpine({
        fileName = "zhuanpan",
        actName = "denglong",
        loop = true,
        needInit = false,
    })
    _boxSpine:setPosition(40, 185)
    btn:addChild(_boxSpine)
end

function TurntableLayer:onCleanup()
    if self._callback and type(self._callback) == "function" then
        self._callback()
    end
	if self._hasNotUpdateData and self._params then
		PlayerData:updataData(self._params)
	end
	-- PlayerData.turnLayer = false
	zc.removeEventListener(CUSTOM_EVENT.EVENT_TURNLAYER)
	zc.removeEventListener(CUSTOM_EVENT.EVET_GET_REWARD)
end

return TurntableLayer