--[[
出售弹出框
jiangyan
2015-05-06
UsePop.lua
]]

local UsePop = class("UsePop",function()
	return ZCPopLayer:create()
end);

function UsePop:create(data)
    return self.new(data)
end

function UsePop:ctor(data)
    self:initData(data)
	self:initUI()
end

function UsePop:initData( data )
    self._info = data.info--物品信息
    self._maxNum = data.maxNum --使用的最大数量
    self._leftBtnText = data.leftBtnText or zc.lang("cancel")
    self._rightBtnText = data.rightBtnText or zc.lang("kaiqi")
    self._leftFunc = data.leftFunc or nil
    self._rightFunc = data.rightFunc or nil
    self._useNum = 1
end

function UsePop:initUI()
    local bg = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
    })
    bg:setPosition(zc.width/2, zc.height/2)
    self:addContent(bg)
    local _bgSize = bg:getContentSize()
    local useLab = zc.getTipPopTitle( "wupinshiyong" )
    useLab:setPosition( _bgSize.width/2, _bgSize.height - 30 )
    bg:addChild(useLab)
    
    
    local contentBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    contentBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)
    bg:addChild(contentBg)
    local contentBgSize = contentBg:getContentSize()

    local backButton = zc.createBackButton({
        pos = cc.p(bg:getContentSize().width-10, bg:getContentSize().height-10),
        listener = function () 
            LayerManager.removeLayout(true)
        end,
    })
    bg:addChild(backButton)

    --道具
	local item = nil
    if tonumber(self._info["mainType"]) == zc.mainTypeWeapon then 
        item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeWeapon,
                type = 1, 
                id = self._info["weaponId"],
                -- num = 1,
                quality = self._info["color"],
            }, 
        })
    else
        item = zc.createIconByData({
            data = {
                mainType = self._info["mainType"],
                type = 1, 
                id = self._info["itemId"],
                -- num = self._info["num"],
                quality = self._info["color"],
            }, 
        })
    end
    item:setPosition(contentBgSize.width*0.5, contentBgSize.height*0.5 + 30) 
    item:setScale(0.75)
    contentBg:addChild(item)
   
    local name = zc.createLabel({
    	text = self._info["name"],
    	fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(item:getPositionX(), item:getPositionY() - 65),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    contentBg:addChild(name)
    local num = zc.createLabel({
    	text = zc.lang("curr_have")..":",
    	fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(10, contentBgSize.height - 30),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    contentBg:addChild(num)
    local num2 = zc.createLabel({
    	text = self._info["num"],
    	fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(num:getPositionX() + num:getContentSize().width + 10, num:getPositionY()),
        outLine = true,
        color =display.COLOR_YELLOW,
    })
    contentBg:addChild(num2)
    self._num2 = num2
    
    local addBg = cc.Node:create()
    addBg:setContentSize(360, 65)
    addBg:setAnchorPoint(0.5, 0.5)
    addBg:setPosition(contentBgSize.width/2, 30)
    contentBg:addChild(addBg)

    --   -1
    local plusOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn8_u.png",
        selectedFile = "res/Main/common/button/common_btn8_d.png",
        needSwallow = false,
        endCallback = function()
            self:addNum(-1)
        end,
        pos = cc.p(110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(plusOneBtn,2)
    local subTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        text = "Min",
        endCallback = function()
            self:setMinNum(1)
        end,
        pos = cc.p(45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(subTenBtn,2)

    --   +1
    local addOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        needSwallow = false,
        endCallback = function()
            self:addNum(1)
        end,
        pos = cc.p(addBg:getContentSize().width -  110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addOneBtn,2)
    --   +10
    local addTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        text = "Max",
        endCallback = function()
            self:setMaxNum(self._maxNum)
        end,
        pos = cc.p(addBg:getContentSize().width - 45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addTenBtn,2)

    local numBg =  zc.createScale9Sprite({
            size = cc.size(120, 40),
            file = "res/Main/bag/new/bag_text_bg_s.png",
            pos = cc.p(addBg:getContentSize().width/2, addBg:getContentSize().height/2),
        })
    addBg:addChild(numBg)
    local num = zc.createLabel({
        text = self._useNum,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(numBg:getContentSize().width/2, numBg:getContentSize().height/2),
        outLine = true,
        color = display.COLOR_YELLOW
    })
    numBg:addChild(num)
    self._num = num
    
    local sell2 = zc.createLabel({
        text = self._info["price"],
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(230, 75),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    -- bg:addChild(sell2)
    -- self._sell_label = sell2

    --使用按钮
    local useBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(bg:getContentSize().width/2, 70), 
        text = zc.lang("use"),
        endCallback = function () 
            if self._rightFunc then 
                local newinfo = table.copy(self._info)
                newinfo["sellnum"] = self._useNum
                self._maxNum = self._maxNum - self._useNum
                if tonumber(self._maxNum) <= 0 then 
                    self._num:setText(0)
                    self._rightFunc(self._useNum)
                    self:hide()
                else
                    self._num:setText(1)
                    self._num2:setText(self._maxNum)
                    self._rightFunc(self._useNum)
                    self._useNum = 1
                end

            end
        end,
    })
    bg:addChild(useBtn)

end
function UsePop:addNum(addnum)
    self._useNum = self._useNum + addnum
    if self._useNum >= tonumber(self._maxNum) then 
        self._useNum = self._maxNum
    elseif self._useNum <= 1 then
        self._useNum = 1
    end
    self._num:setText(self._useNum)
end
function UsePop:setMaxNum(maxNum)
    self._useNum = maxNum
    self._num:setText(maxNum)
end
function UsePop:setMinNum(minNum)
    self._useNum = minNum
    self._num:setText(minNum)
end
return UsePop