--  Created by zhangchao on 16-06-29.
local hejin = class("hejin", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function hejin:create(params)
	return hejin.new(params)
end

local csbs = nil
function hejin:ctor(params)
	csbs = {"hps_atk"}
	self:preloadCsbs(csbs)
end

function hejin:getCsbFiles()
	return csbs
end

function hejin:getAtkNameBySkillType(skillType)
	local ret = nil
	if skillType == 3 then
		ret = "atk3_1"
	end
    return ret
end

function hejin:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 4
	end
	return count
end

function hejin:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		if evt == "do_atk_hit1" then
			for k,hero in pairs(hurtTargets) do
				local _arrow = zc.battle.createBattleEffect({fileName = "hps_atk" , actName = "atk" , moveCallback = function (armatureBack,movementType,movementID)
	            	if movementType == ccs.MovementEventType.complete and (movementID == "atk_1" ) then
	                    xpcall(
	                    	function()
	                    		armatureBack:removeFromParent()
                    		end,
                    		function ()
	                            print("armatureBack已被删除")
	                        end
                        )
	                end
	            end})
	            if self:getSide() == BATTLE_SIDE.LEFT then
			    	_arrow:setScaleX(-1 * _arrow:getScaleX())
			    end
			    _arrow:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
				})
				hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
			end
			self:doHurt(params)
		end
	else
		self:doHurt(params)
	end
end

function hejin:shouldMoveAttack(atkName)
	local ret = true
	if atkName == "atk3_1" then
		ret = false
	end
	return ret
end

function hejin:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    if skillType == BATTLE_SKILL_TYPE.ATK then
    	
	else
		self:showCommonDefenseEffect(params)
	end
end


return hejin