--  Created by zhangchao on 16-03-29.
local jiaxu = class("jiaxu", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function jiaxu:create(params)
	return jiaxu.new(params)
end

local csbs = nil
function jiaxu:ctor(params)
	csbs = {"jiaxu_atk0_1"}
	self:preloadCsbs(csbs)
end

function jiaxu:getCsbFiles()
	return csbs
end

function jiaxu:doAnimationEvent(evt)
	if evt == "change" then
		local armature = self:getArmature()
		if armature:getBone("weapons") then
			do
				local _bone = armature:getBone("change")
				local armature = zc.battle.createBattleEffect({fileName = "change" , actName = "change" , autoRemove = true, completeCallback = function()					
				end})
			    _bone:addDisplay(armature, 0)
                _bone:changeDisplayWithIndex( 0, true )
                _bone:getDisplayRenderNode():setCascadeOpacityEnabled( false )
                _bone:setOpacity( 255 )
			end

			local weaponId = 64
			zc.soldierChangeWeapon(armature, weaponId)
		else
	    	print(self._heroName.."不存在weapons******************************************")
	    end
	end
end

function jiaxu:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "jxbejing",
		skeletonActName = "jiaxu",
		name = "jiaxu",
		-- 合体技特效
		fileName = "Jiaxu_fit2",
		actName = "Fit2",
	}
	return fitSrc
end

function jiaxu:getFitSkillPos( params )
	local armature = params.armature
	local firstTarget = params.firstTarget

    local tmp_side 	= self:getSide()
    local diffx = 50
    if tmp_side == BATTLE_SIDE.LEFT then
    	tmp_side = BATTLE_SIDE.RIGHT
    else
    	tmp_side = BATTLE_SIDE.LEFT
    	diffx = -50
    end
    local position = 5
    if firstTarget then
    	position = firstTarget:getBattlePosition()
    end
	local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = position})
	-- pos.x 			= pos.x + diffx
	pos.y 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 5}).y
    armature:setPosition(pos)
    if self:getSide() == BATTLE_SIDE.LEFT then
    	armature:setScaleX(-1 * armature:getScaleX())
    end
end

function jiaxu:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		local _fileName = "jiaxu_atk0_1"
		local _actName  = "atk"
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName , loop = true, moveCallback = function (armatureBack,movementType,movementID)
	            if movementType == ccs.MovementEventType.complete and movementID == "atk_1" then
	                xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
	            end
	        end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 3000)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("atk_1")
	    		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	    		if ret and _tmp_ == 1 then
	    			self:doHurt(params)
	    		end
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		local flag = 0
		for k,hero in pairs(hurtTargets) do
			flag = flag + 1
			local armature = zc.battle.createBattleEffect({fileName = "jiaxu_atk0_1" , actName = "atk0_1"})
		    armature:setPosition(hero:getPosition())
		    zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature , zorder = hero:getLocalZOrder() + 15},
			})
		    hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
		    if flag == 1 then
			    armature:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
			    	zc.battle.doShockAndFlash(evt)
			    	--[[每次受击]]
			        if string.find(evt,"do_atk0_hit") then
						self:doHurt(params)
			        end
			    end)
		    end
		end
	else
		self:doHurt(params)
	end
end


function jiaxu:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    if skillType == BATTLE_SKILL_TYPE.ATK0 then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
    end
end
function jiaxu:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	local fileName = nil
	local actName = nil
	
	if skillType == BATTLE_SKILL_TYPE.SUPER and firstTarget then--
		fileName = "jiaxu_atk0_1"
		actName  = "atk3"

		local armature = zc.battle.createBattleEffect({fileName = fileName , actName = actName})
	    armature:setPosition(firstTarget:getPosition())
	    if firstTarget:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
	    armature:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
	    	zc.battle.doShockAndFlash(evt)
	    	--[[每次受击]]
	        if string.find(evt,"do_atk3_hit") then
	        	params.evt = evt
				self:doHurt(params)
	        end
	    end)
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = firstTarget:getLocalZOrder() + 10},
		})
    end
end

function jiaxu:isSkillEventAllDone(skillType,evt)
	local ret = true
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		if string.find(evt,"hit1") or string.find(evt,"hit2") then
			ret = false
	    end 
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		if not string.find(evt,"hit5") then
			ret = false
	    end 
	end
	return ret
end

function jiaxu:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 3
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 5
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		count = 10
	end
	return count
end

return jiaxu




