--  Created by zhangchao on 16-03-29.

local jushou = class("jushou", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function jushou:create(params)
	return jushou.new(params)
end

function jushou:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		for k,v in pairs(hurtTargets) do
			local enemy 		= v
			local point  		= enemy:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "jushou" , actName = "eff_zidan" , loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and movementID == "eff_shouji" then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.RIGHT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)
			_arrow:runAction(cc.Sequence:create(
				cc.MoveTo:create(dt,endPos),
				cc.CallFunc:create(function()
					_arrow:getAnimation():play("eff_shouji")
					enemy:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
					self:doHurt(params)
				end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = enemy:getLocalZOrder() + 1},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		local _count = 0
		for k,v in pairs(hurtTargets) do
			local enemy = v
			enemy:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
			_count = _count + 1
			if _count == table.nums(hurtTargets) then
				self:doHurt(params)
			end
		end
	-- elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
	-- 	if evt == "do_atk0_hit3" then
	-- 		params.evt = "do_atk0_hit4"
	-- 	end
	-- 	self:doHurt(params)
	else
		self:doHurt(params)
	end
end

function jushou:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    if skillType == BATTLE_SKILL_TYPE.ATK then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		local point  	= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,hero)
	    local effect 	= zc.createArmature({parentPath = "res/image/battle/ef_hit_jizhong/", fileName = "ef_hit_jizhong" , actName = "hit"})
	    effect:getAnimation():play("hit", -1, 0)
	    effect:setPosition(point)
	    hero:addChild(effect)
	    if hero:getSide() == BATTLE_SIDE.LEFT then
	    	effect:setScaleX(-1)
	    end
	    performWithDelay(effect,function()
	    	effect:removeFromParent()
		end,2)
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    end
end
function jushou:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.ATK0 or atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = true
	end
	return ret
end
function jushou:getAttackPoint(skillType,targetHero)
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local x 				= targetHero:getPositionX()
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		if self:getSide() == BATTLE_SIDE.RIGHT then
			x = x + 558
		else
			x = x - 558
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		local attackerMidBox	= self:getBoneBoundingBoxByName(BATTLE_BONE_NAME.RECT_SUPER)
		x = denfenser_point.x - attackerMidBox.width / 2
		if self:getSide() == BATTLE_SIDE.RIGHT then
			x = denfenser_point.x + attackerMidBox.width / 2
		end
	end
	local point = cc.p(x,y)
	return point
end
function jushou:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 4
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 7
	end
	return count
end
return jushou
