--  Created by zhangchao on 16-03-29.
local liru = class("liru", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function liru:create(params)
	return liru.new(params)
end

local csbs = nil
function liru:ctor(params)
	csbs = {"liru_atk"}
	self:preloadCsbs(csbs)
end

function liru:getCsbFiles()
	return csbs
end

function liru:doAnimationEvent(evt)
	if evt == "change" then
		local armature = self:getArmature()
		if armature:getBone("weapons") then
			do
				local _bone = armature:getBone("change")
				local armature = zc.battle.createBattleEffect({fileName = "change" , actName = "change" , autoRemove = true, completeCallback = function()					
				end})
			    _bone:addDisplay(armature, 0)
                _bone:changeDisplayWithIndex( 0, true )
                _bone:getDisplayRenderNode():setCascadeOpacityEnabled( false )
                _bone:setOpacity( 255 )
			end

			local weaponId = 41
			zc.soldierChangeWeapon(armature, weaponId)
		else
	    	print(self._heroName.."不存在weapons******************************************")
	    end
	end
end

function liru:doAttack(params)
	local skillType 	= params.skillType
	local evt     		= params.evt
	local firstTarget   = params.firstTarget
	local hurtTargets   = params.hurtTargets
	local process 		= params.process
	
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		if evt == "do_atk_hit" then
			local flag = 0
			local ret = self:isSkillEventAllDone(skillType,evt)
			for k,hero in pairs(hurtTargets) do
				local point  	= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
			    local armature 	= zc.battle.createBattleEffect({fileName = "liru_atk" , actName = "atk", loop = true, autoRemove = false, moveCallback = function (armatureBack,movementType,movementID)
	            	if movementType == ccs.MovementEventType.complete and (movementID == "atk_1" ) then
	                    xpcall(
	                    	function()
	                    		armatureBack:removeFromParent()
	                		end,
	                		function ()
	                            print("armatureBack已被删除")
	                        end
	                    )
	                end
			    end})
			    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
			    if self:getSide() == BATTLE_SIDE.LEFT then
			    	armature:setScaleX(-1 * self:getScaleX())
			    end
			    local _arrow 		= armature
				--起始位置
			    local runningScene 	= cc.Director:getInstance():getRunningScene()
				local _targetSlot   = cc.p(self:getPositionX(),self:getPositionY())
				--目标位置
				local endPos 		= point
				--计算角度
				-- 判定斜率,非弓箭状态
				local deltaY = endPos.y - _targetSlot.y;
				local deltaX = endPos.x - _targetSlot.x;
				local angel = deltaX > 0 and 0 or 180;
				local K = deltaY / deltaX;
				if deltaX ~= 0 then
					-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
				end

				local pos_delta = cc.pGetDistance(endPos, _targetSlot)
				local dt = zc.getDynamicTime(pos_delta, 2000)

				flag = flag + 1
				local _tmp_ = flag
				_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
					armature:getAnimation():play("atk_1")
					if ret and _tmp_ == 1 then
		    			print("结束"..tostring(math.random(0,10)))
		    			self:doHurt(params)
		    		end
				end)))
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
				})
			end
		end
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 and process then
		if evt == "do_atk0_hit" then
			-- 获取加盾对象
			for i, v in pairs( process ) do
				if tonumber( v[1] ) == 5 then
					for j, id in ipairs( v[7] or {} ) do
						local data 				= {id = id}
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
							data = data,
						})
						local hero 		= data.target
						local armature 	= zc.battle.createBattleEffect({fileName = "liru_atk" , actName = "atk0", autoRemove = true})
					    local point  	= hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene)
					    armature:setPosition( point )
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_PLAY_EFFECT,
							data = {node = armature, zorder = hero:getLocalZOrder() + 1},
						})
					end
					self:doHurt(params)
					break
				end
			end
		end
	else
		self:doHurt(params)
	end
end

function liru:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    if skillType ~= BATTLE_SKILL_TYPE.ATK0 then
		self:showCommonDefenseEffect(params)
    end
end

function liru:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = true
	end
	return ret
end

function liru:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 11
	end
	return count
end

function liru:getAttackPoint(skillType,targetHero)
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	-- local x 				= targetHero:getPositionX()
	local x 				= zc.width/2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		-- local pos 	= zc.battle.getInitialMatrixPoint({side = BATTLE_SIDE.LEFT, position = 5})
		x = zc.width/2 + 250
	else
		-- local pos 	= zc.battle.getInitialMatrixPoint({side = BATTLE_SIDE.RIGHT, position = 5})
		x = zc.width/2 - 250
	end
	local point = cc.p(x,y)
	return point
end

return liru




