--[[
	劫镖弹窗
	唐实聪
	2016.8.6
]]
local CountryDartRobPop = class("CountryDartRobPop", function()
	return ZCPopLayer:create({opacityValue = 150})
end)

function CountryDartRobPop:create( params )
	return CountryDartRobPop.new( params )
end

function CountryDartRobPop:ctor( params )
	self:initData( params )
	self:initUI()
    self:buildData( params )
    self:refreshLeftTimes()
    self:show(true, function()
        -- 设置顶部信息
        local _top = LayerManager.getTopInfoLayer()
        _top:setPopInfo( "CountryDartRobPop" )
        local _root = LayerManager.getCurRootLayer()
        _root:reorderChild( _top, _top:getLocalZOrder() )
    end)
end

function CountryDartRobPop:onEnter()
    if self._robbing and self._robUser then
        if inArray( self._robbing, {2,3,4} ) then
            -- 胜利
            performWithDelay(self, function()
                zc.createCountryDartResultPop({type=2, dartId = self._robUser.dartId, countryName = self._robUser.countryName, userName = self._robUser.userName, baseNum = self._baseNum})
                self._robbing = nil
                self._robUser = nil
            end, 0.3)
        end
        zc.sendHttp({
            apiName = "CountryDart_lootedDartMain",
            successCallback = function (result)
                self:buildData( result )
            end,
        })
    end
end

function CountryDartRobPop:initData( params )
    self._timeData = params.timeData

	self._dartList = {}

    self._dartStaticData = gameData.getAllDataWithNoClone( "dart" )

	local _size = self:getContentSize()
	self._width = _size.width
	self._height = _size.height
end

function CountryDartRobPop:initUI()
	local _sp = cc.Sprite:create()
	_sp:setContentSize( self._width, self._height )
	_sp:setPosition( self._width/2, self._height/2 )
	self:addContent( _sp )
	-- 背景
	-- local _bg = cc.Sprite:create( "res/Main/country/countryDart/robBg.png" )
    local _bg = zc.createNormalPop({
        src = "res/Main/country/countryDart/robBg.png",
        bianZOrder = 0,
        height = 533 + 31,
    })
	_bg:setPosition( self._width/2, self._height/2 )
	_sp:addChild( _bg )
	self._bg = _bg
	local _bgSize = _bg:getContentSize()
	local _bgWidth = _bgSize.width
	local _bgHeight = _bgSize.height
	-- tableview
	local _tableview = zc.ZCTableView:create( cc.size( 772, 376 ) )
    _tableview:setBounceable( true )
    _tableview:setInertia( true )
    _tableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    _tableview:setPosition( 32, 96 )
    _tableview:setDelegate()
    _tableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = 772
    local cellHeight = 100
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = _tableview:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, index, cellWidth, cellHeight )
        end
        -- 更新界面
        self:updateCell( cell, index )

        return cell
    end
    local function numberOfCellsInTableView()
    	return #self._dartList
    end
    _tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    _tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    _tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    _bg:addChild( _tableview )
    self._tableview = _tableview
    -- 没有玩家
    local _emptyBg = cc.Sprite:create( "res/Main/country/countryDart/emptyBg.png" )
    _emptyBg:setPosition( _bgWidth/2, 288 )
    _bg:addChild( _emptyBg )
    self._emptyBg = _emptyBg
    local _emptyIcon = cc.Sprite:create( "res/Main/country/countryDart/emptyIcon.png" )
    _emptyIcon:setPosition( 30, 24 )
    _emptyBg:addChild( _emptyIcon )
    local _emptyLabel = zc.createLabel({
        text = zc.lang("now_have_no_dartrob_player"),
        fontSize = 20,
        color = cc.c3b( 76, 18, 18 ),
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 50, 24 ),
    })
    _emptyBg:addChild( _emptyLabel )
    -- 提示1
    local _tipSp_1 = cc.Sprite:create( "res/Main/wushenTower/item.png" )
    _tipSp_1:setPosition( 55, 73 )
    _bg:addChild( _tipSp_1 )
    local _tipLabelText_1 = zc.createLabel({
        text = LANGUAGE_ARENA.times_left .. ":",
        color = cc.c3b( 76, 18, 18 ),
        fontSize = 20,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 75, 73 ),
    })
    _bg:addChild( _tipLabelText_1 )
    local _tipLabel_1 = zc.createLabel({
        fontSize = 20,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( _tipLabelText_1:getPositionX() + _tipLabelText_1:getContentSize().width, _tipLabelText_1:getPositionY() + 1 ),
        color = zc.COLOR_GREEN,
        outLine = true,
    })
    _bg:addChild( _tipLabel_1 )
    self._tipLabel_1 = _tipLabel_1
    -- 提示2
    local _tipSp_2 = cc.Sprite:create( "res/Main/wushenTower/item.png" )
    _tipSp_2:setPosition( 55, 41 )
    _bg:addChild( _tipSp_2 )
    local _tipLabel_2 = zc.createRichLabel({
        text = zc.lang("dartrob_tips"),
        fontSize = 20,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 75, 41 ),
    })
    _bg:addChild( _tipLabel_2 )
    _tipLabel_2:setAnchorPoint( 0, 0.5 )
    -- 刷新按钮
    local _refreshBtn = zc.createCommomBtn({
        tag = 2,
        text = LANGUAGE_SHOP.refresh,
        pos = cc.p( _bgWidth - 100, 54 ),
        endCallback = function()
            zc.sendHttp({
                apiName = "CountryDart_lootedDartMain",
                successCallback = function (result)
                    self:buildData( result )
                end,
            })
        end
    })
    _bg:addChild( _refreshBtn )
	-- 标题
	local _title = cc.Sprite:create( "res/Main/country/countryDart/robTitle.png" )
	_title:setPosition( 63, _bgHeight - 13 )
	_bg:addChild( _title )
	-- 关闭按钮
	local _close = zc.createBackButton({
		pos = cc.p( _bgWidth - 10, _bgHeight ),
		listener = function ()
            LayerManager.getTopInfoLayer():setPopInfo( "" )
			self:hide()
		end
	})
	_bg:addChild( _close )
end

function CountryDartRobPop:buildCell( cell, index, cellWidth, cellHeight )
	-- cellBg
	local _cellBg = cc.Sprite:create( "res/Main/country/countryDart/robCellBg.png" )
	_cellBg:setPosition( cellWidth/2, cellHeight/2 )
	cell:addChild( _cellBg )
    cell._cellBg = _cellBg
	local _cellHeight = _cellBg:getContentSize().height
    -- 品质
    local _quality = cc.Sprite:create()
    _quality:setAnchorPoint( 0, 0.5 )
    _quality:setPosition( 0, _cellHeight/2 )
    _cellBg:addChild( _quality )
    cell._quality = _quality
    local _quality2 = cc.Sprite:create()
    _quality2:setPosition( 58, _cellHeight/2 )
    _cellBg:addChild( _quality2 )
    cell._quality2 = _quality2
    -- 名字背景
    local _nameBg = cc.Sprite:create( "res/Main/wushenTower/name_bg_1.png" )
	_nameBg:setPosition( 310, _cellHeight/2 - 5 )
	_cellBg:addChild( _nameBg )
	local _nameBgSize = _nameBg:getContentSize()
	local _nameBgWidth = _nameBgSize.width
	local _nameBgHeight = _nameBgSize.height
	-- 国家
    local _countryName = zc.createLabel({
        fontSize = 20,
		color = cc.c3b( 76, 18, 18 ),
        pos = cc.p( _nameBgWidth/2, _nameBgHeight ),
    })
    _nameBg:addChild( _countryName )
    cell._countryName = _countryName
    -- 名字
    local _userName = zc.createLabel({
        fontSize = 20,
        pos = cc.p( _nameBgWidth/2, _nameBgHeight/2 - 10 ),
    })
    _nameBg:addChild( _userName )
    cell._userName = _userName
    -- 兵器
    local _weaponSp = cc.Sprite:create()
    _weaponSp:setPosition( 0, _nameBgHeight/2 - 10 )
    _nameBg:addChild( _weaponSp )
    cell._weaponSp = _weaponSp

 	-- 奖励
 	cell._rewardBg = {}
 	for i = 1, 2 do
		-- 奖励背景
		local _rewardBg = cc.Sprite:create( "res/Main/country/countryDart/robRewardBg.png" )
		_rewardBg:setPosition( 508, 105 - 40*i )
		_cellBg:addChild( _rewardBg )
		cell._rewardBg[i] = _rewardBg
		-- 奖励icon
		local _rewardSp = cc.Sprite:create()
		_rewardSp:setPosition( 20, 15 )
		_rewardBg:addChild( _rewardSp )
		_rewardBg._rewardSp = _rewardSp
		-- 奖励文字
		local _rewardLabel = zc.createLabel({
			fontSize = 22,
			color = zc.COLOR_WHITE,
			ap = cc.p( 0, 0.5 ),
			pos = cc.p( 45, 15 ),
		})
		_rewardBg:addChild( _rewardLabel )
		_rewardBg._rewardLabel = _rewardLabel
	end
    -- 刷新消耗
    local _consumeSp = cc.Sprite:create( zc.getImgByType( 1 ) )
    _consumeSp:setPosition( 632, 47 )
    _cellBg:addChild( _consumeSp )
    cell._consumeSp = _consumeSp
    -- 消耗数字
    local _priceData = gameData.getDataFromCache("consume_price", {type=39})
    local _consumeLabel = zc.createLabel({
        text = _priceData.price,
        stroke = true,
        fontSize = 20,
        color = zc.COLOR_WHITE,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 640, 47 ),
    })
    _cellBg:addChild( _consumeLabel )
    cell._consumeLabel = _consumeLabel
    -- 劫掠
    local _robBtn = zc.createPushButton({
    	normalFile = "res/Main/country/countryDart/rob_u.png",
    	selectedFile = "res/Main/country/countryDart/rob_u.png",
    	disableFile = "res/Main/country/countryDart/rob_g.png",
    	touchScale = 0.95,
    	pos = cc.p( 700, 47 ),
    	endCallback = function()
            local _userData = self._dartList[cell.index]
            if _userData.userId then
        		zc.sendHttp({
    		        apiName = "CountryDart_challenge",
    		        params = {targetUserId = _userData.userId},
    		        successCallback = function (result)
    		        	-- dump(result, "CountryDart_challenge")
                        self._robbing = 2
                        self._robUser = _userData
                        result.noAnimation = true
                        PlayerData:updataData(result)
                        if result.warModels then
                            local warModel = result.warModels
                            self._robbing = tonumber( warModel[#warModel][5][1] ) or 2
                        else
                            local _warModel = result.warModel
                            if _warModel then
                                self._robbing = tonumber( _warModel[5][1] ) or 2
                            end
                        end
                        local _data = {}
                        _data.data = result
                        _data.battleType = BattleType.CountryDartRob
                        local battle = zc.createBattle({data = _data})
                        battle:play()
    		        end,
    		    })
            end
    	end
	})
    _cellBg:addChild( _robBtn )
    cell._robBtn = _robBtn
end

function CountryDartRobPop:updateCell( cell, index )
	local _data = self._dartList[index + 1]
    if not _data then
        cell.userId = nil
        return
    end

    cell.index = index + 1

    cell._quality:setTexture( "res/Main/country/countryDart/quality_".._data.dartLevel..".png" )
    cell._quality2:setTexture( zc.getHeroQualificationsPath( DartLevelConfig[_data.dartLevel], 2 )  )
    if _data.dartLevel == 1 or _data.dartLevel == 4 then
        cell._quality2:setScale(1.0)
    else
        cell._quality2:setScale(0.85)
    end
    if cell._head then
        cell._head:removeFromParent()
        cell._head = nil
    end
    local _head = zc.createPlayerHead({iconId = _data.iconId, level = _data.level})
    _head:setPosition( 157, cell._cellBg:getContentSize().height/2 )
    _head:setScale( 0.8 )
    cell._cellBg:addChild( _head )
    cell._head = _head

    cell._countryName:setText( _data.countryName )
    cell._userName:setText( _data.userName )
    local _weaponData = gameData.getDataFromCacheWithPrimaryKey("weapon", _data.weaponId)
    cell._weaponSp:setTexture( zc.getHeroTypeImg( _weaponData.type ) )

    -- local _rewards = string.split( _data.static.goods, "," )
    local hourseInfo = PlayerData:getHouseInfoByHouseId(16)

    local _rewards_ = string.split( _data.static.goods or "", "," )
    local _rewards_goods1 = string.split( _data.static.goods1, "," )
    local count____ = #_rewards_goods1
    local _rewards = {}
    print("count____",count____,"level:;",hourseInfo["level"])
    -- dump(_rewards_goods1)
    for i = 1, 2 do
        -- dump(_rewards_[i])
        if _rewards_[i] and #_rewards_[i] > 0 then
            local _reward = string.split( _rewards_[i], "|" )
            local _itemType = tonumber( _reward[1] ) or 0
            local son_itemType = tonumber( _reward[2] ) or 0
            local _num = tonumber( _reward[3] ) or 0
            for j = 1,count____ do
                -- dump(_rewards_goods1[j])
                if _rewards_goods1[j] and #_rewards_goods1[j] > 0 then
                    local _reward1 = string.split( _rewards_goods1[j], "|" )
                    local _itemType1 = tonumber( _reward1[1] ) or 0
                    local son_itemType1 = tonumber( _reward1[2] ) or 0
                    if _itemType == _itemType1 and son_itemType == son_itemType1 then
                        local _num1 = tonumber( _reward1[3] ) or 0
                        local level = tonumber(hourseInfo["level"]) or 0
                        local num = _num1*level
                        local total_num = _num+num

                        _rewards_[i] =  _reward[1].."|".. _reward[2].."|"..total_num
                        print("total_num...",total_num,_reward[i])
                    end
                end
            end
            table.insert(_rewards,_rewards_[i])
        end
    end

    for i = 1, 2 do
        local _rewardBg = cell._rewardBg[i]
        if _rewards[i] and #_rewards[i] > 0 then
            _rewardBg:setVisible( true )

            local _reward = string.split( _rewards[i], "|" )
            local _itemType = tonumber( _reward[1] ) or 0
            if _itemType == zc.mainTypeResource then
                -- 资源
                _rewardBg._rewardSp:setTexture( zc.getImgByType( _reward[2] ) )
                local _num = tonumber( _reward[3] ) or 0
                _num = _num * self._baseNum
                _rewardBg._rewardLabel:setText( _num )
                _rewardBg._rewardLabel:setPositionX( 45 )
            elseif _itemType == zc.mainTypeProp then
                _rewardBg._rewardSp:setVisible( false )
                local _name = gameData.getDataFromCacheWithPrimaryKey("item", _reward[2]).name or ""
                local _num = tonumber( _reward[3] ) or 0
                _num = _num * self._baseNum
                _rewardBg._rewardLabel:setText( _name.."x".._num )
                _rewardBg._rewardLabel:setPositionX( 25 )
            end
        else
            _rewardBg:setVisible( false )
        end
    end
    
    -- cell._fightingNum:setString( _data.fighting )

    if _data.dartLevel == 4 and self._superLootedTimes > 0 then
        cell._consumeSp:setVisible( true )
        cell._consumeLabel:setVisible( true )
        cell._robBtn:setPositionX( 700 )
    else
        cell._consumeSp:setVisible( false )
        cell._consumeLabel:setVisible( false )
        cell._robBtn:setPositionX( 678 )
    end
end

function CountryDartRobPop:buildData( data )
	-- dump(data,"CountryDartRobPop")
    -- 劫镖获得倍率
    self._baseNum = tonumber( data.baseNum ) or 0
    -- 押镖劫镖次数
    self._timeData[1] = tonumber( data.dartLootedTimes ) or 0
    -- ss劫镖次数
    self._superLootedTimes = tonumber( data.superLootedTimes ) or 0
    -- 镖车
    self._dartList = {}
    for i, v in ipairs( data.dartList or {} ) do
        local _key = tostring( v.dartId )
        local _staticData = self._dartStaticData[_key]
        if _staticData then
            local _dartLevel = tonumber( _staticData.level ) or 0
            local _data = v
            _data.static = _staticData
            _data.dartLevel = _dartLevel
            self._dartList[#self._dartList + 1] = _data
        end
    end
    table.sort(self._dartList, function( a, b )
        return a.dartLevel > b.dartLevel
    end)
    self._tableview:reloadData()
    if #self._dartList == 0 then
        self._emptyBg:setVisible( true )
    else
        self._emptyBg:setVisible( false )
    end
    self:refreshLeftTimes()
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_DART_TIMES})
end

function CountryDartRobPop:refreshLeftTimes()
    local _leftTimes = self._timeData[2] - self._timeData[1]
    _leftTimes = _leftTimes < 0 and 0 or _leftTimes
    self._tipLabel_1:setText( _leftTimes.."/"..self._timeData[2] )
end

return CountryDartRobPop