--[[
	FileName: GrabMineFightTeamLayer.lua
	Author: andong
	Date: 2016-12-06
	Purpose: 国家抢矿战斗队伍
]]

--debug状态
local nowDebug = true

local GrabMineFightTeamLayer = class( "GrabMineFightTeamLayer", function ()
	return zc.createNormalDialog({showBack = false})
end)
function GrabMineFightTeamLayer:create(parmas)
	return GrabMineFightTeamLayer.new(parmas)
end
function GrabMineFightTeamLayer:ctor(parmas)
    self.JuanzhouPage = {
        [1] = 1,
        [2] = 1,
        [3] = 2,
        [4] = 2,
        [5] = 3,
        [6] = 4,
        [7] = 4,
        [8] = 1,
        [9] = 1,
        [10] = 2,
        [11] = 2,
        [12] = 3,
        [13] = 4,
        [14] = 4,
        [15] = 1,
        [16] = 1,
        [17] = 2,
        [18] = 2,
        [19] = 3,
        [20] = 4,
        [21] = 4,
        [22] = 1,
        [23] = 1,
        [24] = 2,
        [25] = 2,
        [26] = 3,
        [27] = 4,
    }

	self:initData(parmas)
	self:initUI()

    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_GRABMINE_TALK,
        callback = function (data) 
            -- zc.tipInfo("接受到抢矿聊天")
            self:dealWithTalkShow(data.data)
        end
    })
end

function GrabMineFightTeamLayer:initData(parmas)
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end
    self:staticData()

    -- 队伍信息
    self._teamsInfo = parmas.teamInfo
    -- 队伍id
    self._teamId = tonumber(self._teamsInfo.id)
    -- 队长userId
    self._createrId = tonumber(self._teamsInfo.createUserId)
    -- 战力
    self._fighting = tonumber(self._teamsInfo.fighting) or 0

    --
    self._isCreater = false --是否是队长
    self._userId = tonumber(PlayerData.info.userId)
    if self._createrId == self._userId then
        self._isCreater = true
        self._isRead = 1
    end
    -- 矿信息
    self._mineInfo = parmas.mineInfo or {}
    -- 区域id
    self._mineAreaId = self._teamsInfo.mineId or 0
    -- 矿id
    self._mineId = self._teamsInfo.mid or 0
    local _data = gameData.getDataFromCacheWithPrimaryKey("mine", self._mineId) or {}
    self._staticMineData = _data
    --被抢矿的信息(重新查找)   
    if not next(self._mineInfo) then
        local _allMineInfo = PlayerData:getCountryMineData() or {}
        local mineInfo = _allMineInfo[self._mineAreaId] or {}
        local mineList = mineInfo.mineList or {}
        for i = 1, #mineList do
            local v = mineList[i]
            if v and v.countryMineId and tonumber(v.countryMineId) == tonumber(self._mineId) then
                self._mineInfo = v
                break
            end
        end
    end

    -- 次数
    self._fightTimes = {freeTimes=0,timesLimit=0}
    for i = 1, self._maxMemberNum do
        if self._teamsInfo["userId"..i] and self._teamsInfo["userId"..i].userId then
            if self._myUserId == tonumber(self._teamsInfo["userId"..i].userId) then
                self._fightTimes.freeTimes  = tonumber(self._teamsInfo["freeTimes"..i]) or 0
                self._fightTimes.timesLimit = tonumber(self._teamsInfo["timesLimit"..i]) or 0
                break
            end
        end
    end
end
--处理数据(临时)
function GrabMineFightTeamLayer:handleData()
    do return end
    --处理数据
    for i = 1, self._maxMemberNum do
        local v = self._teamsInfo["userId"..i]
        if v and next(v) then
            for m,n in pairs(v) do
                if n and n.userId then
                    self._teamsInfo["userId"..i] = n
                    if self._teamsInfo["user"..i] and self._teamsInfo["user"..i].hero then
                        local heroInfo = self._teamsInfo["user"..i].hero
                        if heroInfo.weaponId and tonumber(heroInfo.weaponId) > 0 then
                            self._teamsInfo["userId"..i].weaponId = heroInfo.weaponId
                        end
                    end
                    break
                end
            end
        end
    end
end
function GrabMineFightTeamLayer:staticData()
    -- 聊天文字
    self._chatText = LANGUAGE_grabmine_get_chat_tips()
    -- 位置
    self._posTb = {}
    self._onePart = 190
    self._widthPart = 300
    self._maxMemberNum = 3
    self._inviteCd = 0 --发送消息CD
    self._isRead = 0 --初始进入队伍(除队长)都是未准备的
    self._talkCd = 0 -- 聊天cd
    self._myUserId = tonumber(PlayerData.info.userId)
end
function GrabMineFightTeamLayer:initUI(params)


    local _bg = zc.createImageView({
        src = "res/Main/multyCopy/backgroud.jpg",
        pos = cc.p(zc.width/2 ,zc.height/2),
    })
    zc.setBgSize(_bg)
    self:addChild(_bg, -1)

    --添加云动画
    zc.getYunDongTai(nil,1,function(armUp, armDown)
        if not tolua.isnull(self) then
            self:addChild( armUp )
            self:addChild( armDown )
        end
    end)

	-- 背景
    local __bgImg = zc.createNormalPop({
        width = zc.width - 70,
        height = 511,
        showSide = false,
    })
    __bgImg:setAnchorPoint( 1, 0.5 )
    __bgImg:setPosition( zc.width, zc.height/2 )
    self:addChild( __bgImg )
    local _bgImg = cc.Sprite:create()
    _bgImg:setContentSize( zc.width, 511 )
    _bgImg:setPosition( zc.width/2, zc.height/2 )
    self:addChild( _bgImg )

    -- 卷轴
    local _data = {icon=self._staticMineData.grade}
    local _armature = zc.createArmature({
        parentPath = "res/Main/copy/juanzhou/",
        fileName = "juanzhou_"..self.JuanzhouPage[tonumber(_data.icon)],
        -- loop = true,
        actName = "zudui_".._data.icon.."_stand",
        eventCallback = function() end,
    })
    _armature:setPosition(70, 0)
    _bgImg:addChild(_armature, 4)
    -- 推荐战力
    local powerNum = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight.fnt",
        text = self._fighting,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(_armature:getPositionX(), 180),
        addwidth = -5,
    })
    _bgImg:addChild(powerNum, 4)
    -- 掉落
    local grade = tonumber(self._staticMineData.grade)

    local titleSrc = "res/Main/country/grabMine/building_"..self._staticMineData.grade..".png"
    if not zc.checkFileExist(titleSrc) then
        titleSrc = "res/Main/country/grabMine/building_1.png"
    end
    local _normal = zc.createSprite(titleSrc)
    local _scaleList = {
        [1] = {_scale = 0.8, justX = 8},
        [2] = {_scale = 0.8, justX = 7},
        [3] = {_scale = 0.7, justX = 6},
        [4] = {_scale = 0.5, justX = 0},
    }
    _normal:setScale(_scaleList[grade]._scale)

    local item = zc.createPushButton({
        normalNode = _normal,
        pos = cc.p(_armature:getPositionX()+_scaleList[grade].justX, 120), 
        endCallback = function()
            zc.createGrabMineInfoPop({
                onlyShow=true,
                area=self._mineAreaId,
                mineId=self._mineId,
                popName = "grabShowInfoPop",
            })
        end
    })
    _bgImg:addChild(item , 4)
    
    local _tableSize = cc.size(_bgImg:getContentSize().width - 180, _bgImg:getContentSize().height - 30)
    local _node = cc.Node:create()
    _node:setContentSize(_tableSize)
    _node:setPosition(150, 15)
    _bgImg:addChild(_node)
    self._diNode = _node

    --返回按钮
    local _backButton = zc.createTopBackButton({
        pos = cc.p(zc.width - 60, zc.height - 40), 
        listener = function () 
            self:leaveTeam()
        end,
    })
    self:addChild(_backButton, 6)

    local _autoBtn = zc.createCommomBtn({
        tag = 1,
        text = "",
        listener = function () 
            if self._isCreater then
                self:startFight()
            else
                self:doReady()
            end
        end,
        pos = cc.p(zc.width - 150, 40),
    })
    self:addChild(_autoBtn, 4)
    self._autoBtn = _autoBtn
    self:refreshAutoBtnText()

    local _text = self._isCreater and zc.lang("dismissTeam") or zc.lang("outTeam")
    local _createBtn = zc.createCommomBtn({
        tag = 2,
        listener = function () 
            self:leaveTeam()
        end,
        pos = cc.p(zc.width - 350, 40),
        text = _text,
    })
    self:addChild(_createBtn, 4)

    -- 剩余次数
    local _sp = zc.createSprite("res/Main/copy/leftTimesBg.png")
    _sp:setPosition(20, 20)
    _sp:setAnchorPoint(0, 0)
    self:addChild(_sp, 4)

    local _label = zc.createLabel({
        text = zc.lang("seize_times"),
        fontSize = 22,
        stroke = true,
        pixel = 3,
        ap = cc.p(0, 0.5),
        pos = cc.p(35, _sp:getBoundingBox().height * 0.5 - 1),
    })
    _sp:addChild(_label)

    local _label2 = zc.createLabel({
        text = self._fightTimes.freeTimes,
        fontSize = 22,
        color = display.COLOR_GREEN,
        outLine = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(_label:getPositionX() + _label:getContentSize().width + 10, _label:getPositionY()),
    })
    _sp:addChild(_label2)
    self._leftTimes = _label2

    --
    self._userDis = {}
    self:freshTeamList()

end
--准备
function GrabMineFightTeamLayer:doReady()

    if self._fightTimes.freeTimes <= 0 then
        local function buyTime()
            zc.sendHttp({
                apiName = "CountryMine_buyFightTime",
                successCallback = function (net_data)
                    zc.tipInfo(zc.lang("tips_buy_success") .. "!")
                    PlayerData:updataData( net_data )
                    self._fightTimes.freeTimes = tonumber(net_data.freeTimes)  or 0
                    self._fightTimes.timesLimit = tonumber(net_data.timesLimit) or 0
                    self._leftTimes:setString(self._fightTimes.freeTimes)
                end
            })
        end
        local priceInfo = zc.getConsumePriceData( 50, self._fightTimes.timesLimit+1 ) or {}
        local price = priceInfo.price or 0
        local comfirm = ZCConfirmDialog:createWithParams({
            title = zc.lang("prompt"),
            msg = LANGUAGE_SEIZE_BUYGOLD(price),
            showDi = true,
            rightCallback = function()
                buyTime()
            end
        })
        self:addChild(comfirm, 11)
    else
        local _readyStatus = self._isRead == 1 and 2 or 1
        zc.sendHttp({
            apiName = "CountryMine_readyTeam",
            params = { teamId = self._teamId },
            successCallback = function (result)
                self._isRead = _readyStatus
                self:refreshAutoBtnText()
            end,
        })
    end 
end
--离开队伍
function GrabMineFightTeamLayer:leaveTeam(_justLeave) --_justLeave直接退出
    local _config = "CountryMine_quitTeam"
    local _title = zc.lang("prompt")
    local _text = zc.lang("tips_is_to_quit_team")
    local _tipText = zc.lang("tips_quit_team_success")
    if self._isCreater then
        _config = "CountryMine_dissTeam"
        _text = zc.lang("tips_is_to_dissolve_team")
        _tipText = zc.lang("tips_dissolve_team_success")
    end

    local function quit()
        zc.sendHttp({
            -- 接口
            apiName = _config,
            -- 参数
            params = {mineId=self._mineAreaId,teamId=self._teamsInfo.id},
            -- 成功回调
            successCallback = function(result)
                if _justLeave then
                    self._justLeave = true
                end
                self:goBack(_tipText)
            end,
            errorCallback = function( errorCode , msg)
                local _errorCode = ( tonumber( errorCode ) or 0 )
                -- zc.tipInfo(msg.."xxxxxxxxxxxxxxx")
                self._justLeave = true
                self:goBack()
            end,
            failCallback = function()
                self._justLeave = true
                self:goBack()
            end, 
        }) 
    end
    if _justLeave then
        _tipText = nil
        quit()
    else
        local _comfirmPop = ZCConfirmDialog:createWithParams({
            title = _title,
            msg = _text,
            showDi = true,
            rightCallback = function()
                quit()
            end
        }) 
        self:addChild(_comfirmPop, 10)
    end
end

--获取自己队伍的信息
function GrabMineFightTeamLayer:getMyTeamInfo( data )
    if data.id then
        local _teamId = tonumber(data.id) or 0
        if _teamId == self._teamId then
            self._teamsInfo = data
            self:checkSelfIsInTeam()
            return true
        end
    elseif next(data) then
        for k,v in pairs(data) do
            local _teamId = tonumber(v.id) or 0
            if _teamId == self._teamId then
                self._teamsInfo = v
                self:checkSelfIsInTeam()
                return true
            end
        end
    end
    return false
end
--检查自己是否还在队伍中
function GrabMineFightTeamLayer:checkSelfIsInTeam()
    self._isInTheTeam = false
    if self._teamsInfo then
        for i= 1, 3 do
            local _userData = self._teamsInfo["userId"..i]
            if _userData and _userData.userId then
                if tonumber(_userData.userId) == self._userId then
                    self._isInTheTeam = true
                    break
                end
            end
        end
    end
end
function GrabMineFightTeamLayer:doEvent( opType, data )
    -- dump(data, opType.."-----------dump--------ad-------------" )
    if opType == "CountryMine_teamDiss" then
        if self._teamId ~= tonumber( data.data.id ) then
            return
        elseif self._teamId == tonumber( data.data.id ) and not self._isCreater then
            self:goBack(zc.lang("tips_dissolve_team_success"))
        end
    elseif opType == "CountryMine_teamChange" then --队伍发生变化（加入队伍、解散队伍、调整位置、准备/取消准备、退出队伍、被踢出队伍）
        local _data = data.data
        local isMy = self:getMyTeamInfo(_data)
        if isMy == false then
            return
        end
        if not self._isInTheTeam then
            self:goBack(zc.lang("tips_kicked_out_team"))
        else
            self:freshTeamList()
        end
    elseif opType == "CountryMine_fight_report" then
        if self._fight then --如果正在战斗
            return
        end
        self._fight = true
        for i=3, 1, -1 do
            local _id = tonumber(self._teamsInfo["userId"..i].userId) or -1
            if _id ~= self._createrId then
                -- 不是队长
                self._teamsInfo["ready"..i] = 0
            end
        end
        self:freshTeamList()
        self._isRead = self._isCreater and 1 or 0
        if not self._isCreater then
            -- 队员
            self:refreshAutoBtnText()
        end

        local grabShowInfoPop = zc.getPop("grabShowInfoPop")
        if grabShowInfoPop then
            grabShowInfoPop:hide()
        end
        --挑战扣一次次数
        self._fightTimes.freeTimes = self._fightTimes.freeTimes - 1
        PlayerData:setCountryMineFightTimes({freeTimes=self._fightTimes.freeTimes})

        if data.data.warModels and next(data.data.warModels) then
            local _info = {
                data = data.data,
                battleType = BattleType.CountryGrabMine,
                isFirstFight = true,
                fightScene = 9,
                battleResultData = {  --战斗结果页需要的数据
                    teamUserName = "",
                    countryName = self._mineInfo["countryName"] or "",
                    mineId = self._mineId,
                },
            }
            local battle = zc.createBattle({data = _info})
            battle:play()
        else
            zc.tipInfo(zc.lang("tips_occupation_success"))
        end

    end
end
--刷新队伍每个人的信息
function GrabMineFightTeamLayer:freshTeamList()
    local bg = self._diNode
    local _size = bg:getContentSize()

    local _onePart = self._onePart
    local _widthPart = self._widthPart 
    local _posY = _size.height*0.5
    for i=3, 1, -1 do
        local _userData = self._teamsInfo["userId"..i]
        local _di = self._userDis[i]
        local _userId = tonumber(_userData.userId) or 0
        if not _di or tonumber(_di.userId) ~= _userId then
            if _di then
                _di:removeFromParent()
            end
            _di = self:getOnePlayer(i)
            if _userId ~= 0 and self._isCreater then
                _di:setTouchEnabled(true)
                _di:addTouchEventListener(function ( sender, eventType )
                    if eventType == ccui.TouchEventType.began then
                        self._partPoint = sender:getTouchBeganPosition()
                        _di:setLocalZOrder(4)
                        return true
                    elseif eventType == ccui.TouchEventType.moved then 
                        local _movePoint = sender:getTouchMovePosition()
                        local _pos = cc.pSub(_movePoint, self._partPoint)
                        _pos = cc.pAdd(_pos, cc.p(_di:getPosition()))
                        self._partPoint = _movePoint
                        _di:setPosition(_pos.x, _di:getPositionY())
                        self:checkMove(_di)
                    else
                        -- self:resetUserDiPos()
                        if not self:checkHaveChange() then
                            self:resetUserDiPos()
                        end
                    end 
                end)
            end
            bg:addChild(_di, 3 - i)
        end

        local _posX = _onePart + (i-1)*_widthPart
        _di:setPosition(_posX, _posY)
        self._posTb[i] = i
        _di.index = i
        self._userDis[i] = _di
        if tonumber(self._teamsInfo["ready"..i]) == 1 then
            if not _di.readyImg then
                local _ready = zc.createSprite("res/Main/multyCopy/ready.png")
                _ready:setPosition(180, 360)
                _di:addChild(_ready)
                _di.readyImg = _ready
            end
            if _di._notEnoughImg then
                _di._notEnoughImg:removeFromParent()
                _di._notEnoughImg = nil
            end
        elseif tonumber(self._teamsInfo["freeTimes"..i]) and tonumber(self._teamsInfo["freeTimes"..i]) == 0 then
            local _notEnough = zc.createSprite("res/Main/country/grabMine/notEnough.png")
            _notEnough:setPosition(180, 360)
            _di:addChild(_notEnough)
            _di._notEnoughImg = _notEnough
        else
            if _di.readyImg then
                _di.readyImg:removeFromParent()
                _di.readyImg = nil
            end
            if _di._notEnoughImg then
                _di._notEnoughImg:removeFromParent()
                _di._notEnoughImg = nil
            end
        end
    end
end

--创建一个玩家信息体
function GrabMineFightTeamLayer:getOnePlayer( index )
    local _userData = self._teamsInfo["userId"..index]
    local _di = nil
    if _userData and next(_userData) ~= nil then
        local _userId = tonumber(_userData.userId) or 0
        if _userId == self._myUserId then
            -- 自己
            _di = ccui.ImageView:create("res/Main/multyCopy/selfDi.png")
            for j=1,4 do
                local _bar = zc.createPushButton({
                    normalFile = "res/Main/multyCopy/wordsDi.png",
                    touchScale = 0.95,
                    endCallback = function() 
                        self:sendWorldsToTeam(self._chatText[j])
                    end,
                    pos = cc.p(_di:getContentSize().width*0.5 - 45 + j*13, 75 + (j - 1)*55) 
                })
                _di:addChild(_bar, 1)
                local _ttf = zc.createLabel({
                    text = self._chatText[j],
                    fontSize = 22,
                    color2 = cc.c3b( 51, 0, 0 ),
                    pos = cc.p(_bar:getContentSize().width*0.5, _bar:getContentSize().height*0.5),
                    outLine = true,
                    pixel = 1,
                })
                _bar:addChild(_ttf)
            end
        else
            -- 队友
            _di = ccui.ImageView:create("res/Main/multyCopy/teamMateDi.png")
            local _posX = _di:getContentSize().width/2
            local _posY = _di:getContentSize().height/2 + 10
            -- 称号
            local _role_title = zc.createLabel({
                text = zc.getGodNameById( _userData.godName ),
                fontSize = 20,
                color = zc.COLOR_PURPLE,
                outLine = true,
                pixel = 1,
            })
            _role_title:setPosition( _posX, _posY )
            _di:addChild( _role_title )
            local _laceLeft = cc.Sprite:create( "res/Main/common/lace.png" )
            _laceLeft:setAnchorPoint( 1, 0.5 )
            _laceLeft:setPosition( _role_title:getPositionX() - _role_title:getContentSize().width/2, _role_title:getPositionY() )
            _di:addChild( _laceLeft )
            local _laceRight = cc.Sprite:create( "res/Main/common/lace.png" )
            _laceRight:setAnchorPoint( 0, 0.5 )
            _laceRight:setPosition( _role_title:getPositionX() + _role_title:getContentSize().width/2, _role_title:getPositionY() )
            _laceRight:setFlippedX( true )
            _di:addChild( _laceRight )
            --名称
            local _role_name_bg = ccui.Scale9Sprite:create( cc.rect( 12, 11, 14, 10 ), "res/Main/role/common/name_bg.png" )
            _role_name_bg:setContentSize( 220, 30 )
            _role_name_bg:setPosition( _posX - 5, _posY - 35 )
            _di:addChild( _role_name_bg )
            local _role_name = zc.createLabel({
                text = zc.getLevelTipShow()..tostring( _userData.level ).." ".._userData.userName,
                fontSize = 20,
                pos = cc.p(_posX - 5, _role_name_bg:getPositionY()),
                outLine = true,
                pixel = 1,
            })
            _di:addChild(_role_name)

            local _value = {
                {LANGUAGE_getAttributeTextById(1), 0},
                {LANGUAGE_getAttributeTextById(2), 0},
                {LANGUAGE_getAttributeTextById(3), 0},
            }

            local _attributeInfo = {}
            if self._teamsInfo["user"..index] and self._teamsInfo["user"..index]["hero"] then
                _attributeInfo = self._teamsInfo["user"..index]["hero"]["attribute"] or {}
            end

            _value[1][2] = _attributeInfo.force or 0
            _value[2][2] = _attributeInfo.wisdom or 0
            _value[3][2] = _attributeInfo.soma or 0

            for i = 1, 3 do
                local _attrBg = ccui.Scale9Sprite:create( cc.rect( 12, 11, 14, 10 ), "res/Main/role/common/name_bg.png" )
                _attrBg:setContentSize( 220, 27 )
                _attrBg:setPosition( _posX - 5 - i*10, _posY - 35 - 35*i )
                _di:addChild( _attrBg )
                local _attrText = zc.createRichLabel({
                    text = _value[i][1],
                    fontSize = 18,
                    anchor = cc.p( 0, 0.5 ),
                    pos = cc.p( 10, _attrBg:getContentSize().height/2 ),
                })
                _attrText:setGradientColor( cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1) )
                _attrBg:addChild( _attrText )
                local _attrNum = zc.createLabel({
                    text = _value[i][2],
                    fontSize = 18,
                    ap = cc.p(  1, 0.5 ),
                    pos = cc.p( 210, _attrText:getPositionY() ),
                    outLine = true,
                })
                _attrBg:addChild( _attrNum )
            end

            if self._isCreater then
                -- 踢人
                local _btn = zc.createPushButton({
                    normalFile = "res/Main/multyCopy/kickOut.png",
                    touchScale = 0.9,
                    endCallback = function() 
                        self:kickOutOne(_userData.userId, _userData.userName)
                    end,
                    anchor = cc.p(0.5, 0.5),
                    pos = cc.p(_di:getContentSize().width - 20, _di:getContentSize().height - 15),
                })
                _di:addChild(_btn, 1)
            end
        end

        _di.userId = _userId
        local num1 = self._createrId
        local num2 = _userId
        if num1 == num2 then
            -- 队长
            local _teamLeader = zc.createImageView({
                src = "res/Main/multyCopy/teamMaster.png",
                ap = cc.p(0, 1),
                pos = cc.p(80, _di:getContentSize().height +5) 
            })
            _di:addChild(_teamLeader, 1)
        end

        local _heroDatas = zc.getHeroInfo(_userData.seigniorId)
        local modelId = _heroDatas.modelId
        local _user = self._teamsInfo["user"..index] or {}
        local _hero = _user["hero"] or {}
        local _weaponId = tonumber(_hero.weaponId) or 0
        local armature = zc.battle.createHeroArmatureWithResId(modelId, _weaponId)
        armature:setPosition(290, 310)
        armature:getAnimation():play("idle")
        _di:addChild(armature, 1)
        zc.soldierChangeWeapon(armature, _weaponId)

        --战斗力img
        local power = zc.createSprite("res/Main/role/common/fight_bg.png")
        power:setAnchorPoint(0, 0.5)
        power:setPosition(_di:getContentSize().width*0.5 - 15, _di:getContentSize().height*0.5 + 60)
        power:setScale( 0.7 )
        _di:addChild(power, 1)
        --战力
        local powerNum = zc.createFntLabel({
            fnt = "res/Main/common/fnt/fight_change.fnt",
            text = _userData.fighting,
            ap = cc.p(0, 0.5),
            pos = cc.p(90, power:getContentSize().height/2 ),
            addwidth = -14,
        })
        powerNum:setScale( 0.7 )
        power:addChild(powerNum)

        if self._isCreater then
            local _tagDi = zc.createImageView({
                src = "res/Main/multyCopy/changeStand.png",
                ap = cc.p(0.5, 0),
                pos = cc.p(_di:getContentSize().width*0.5 - 30, 5)
            })
            _di:addChild(_tagDi, 1)

            local _tagSp = zc.createImageView({
                src = "res/Main/multyCopy/hand_" .. index .. ".png",
                pos = cc.p(5, _tagDi:getContentSize().height*0.5)
            })
            _tagDi:addChild(_tagSp)
        end
    else
        _di = ccui.ImageView:create("res/Main/multyCopy/selfDi.png")
        _di.userId = 0

        local _emptyDi = zc.createSprite("res/Main/multyCopy/emptyBg.png")
        _emptyDi:setPosition(_di:getContentSize().width*0.5 + 40, _di:getContentSize().height*0.5 + 20)
        _di:addChild(_emptyDi)

        local _plus = zc.createImageView({
            src = "res/Main/multyCopy/plus.png",
            pos = cc.p(_di:getContentSize().width*0.5 + 8, _di:getContentSize().height*0.5 + 40),
            listener = function()
                -- self:showInvitePop()
                if not self._isCreater then
                    zc.tipInfo(zc.lang("tips_leader_can_use_func"))
                    return 
                end
                local _needData = {
                    _type = 2,
                    teamId = self._teamId,
                    mineId = self._mineAreaId,
                    mineInfo = self._mineInfo,
                }
                zc.createGrabCountryList(_needData)
            end,
            touchScale = 0.9,
        })
        _di:addChild(_plus)
        if index == 2 then
            self._guidePlusBtn = _plus
        end
    end
    return _di
end

function GrabMineFightTeamLayer:sendWorldsToTeam( text )
    if self._talkCd ~= 0 then
        zc.tipInfo(zc.lang("tips_send_words_cding") .. self._talkCd)
        return
    end
    self._talkCd = 5
    self._cdAction = schedule(self, function()
        self._talkCd = self._talkCd - 1
        if self._talkCd == 0 then
            self:stopAction(self._cdAction)
        end
    end, 1)
    for i=1, 3 do
        local _userData = self._teamsInfo["userId"..i]
        local _userId = tonumber(_userData.userId) or 0
        if _userId ~= 0 and _userId ~= self._myUserId then
            local _data = {toUserId = _userId}
            getNetManager():getRequestCenter():sendWords(101, text, _data)
        end
    end
    --可以处理下自己显示下自己说的话
    self:dealWithTalkShow({userId = self._myUserId, text = text}, true)
end
function GrabMineFightTeamLayer:dealWithTalkShow( data, isSelfShow )
    local _isSelfShow = isSelfShow == nil and false or isSelfShow
    if _isSelfShow then
    elseif data.userId == self._myUserId then
        return
    end
    for k,v in pairs(self._userDis) do
        local _userId = v.userId
        if _userId == data.userId then
            --可以处理显示了
            local _text = data.text
            local _chatDi = zc.createSprite("res/Main/multyCopy/talkBar.png")
            _chatDi:setAnchorPoint(1, 0.5)
            local _chatPos = cc.p(280, 370)
            _chatDi:setPosition(_chatPos)
            v:addChild(_chatDi, 2)
            _chatDi:setScale(0.1)
            _chatDi:runAction(cc.Sequence:create(
                cc.ScaleTo:create(0.1, 1),
                cc.DelayTime:create(2),
                cc.ScaleTo:create(0.1, 0.1),
                cc.RemoveSelf:create(true)
            ))
            local _label = zc.createLabel({
                text = _text,
                width = 150,
                fontSize = 20,
                color = cc.c3b( 51, 0, 0 ),
                pos = cc.pMul(cc.pFromSize(_chatDi:getContentSize()), 0.5),
                -- stroke = true,
            })
            _chatDi:addChild(_label)
            break
        end
    end 
end
--发送邀请
function GrabMineFightTeamLayer:showInvitePop()
    if not self._isCreater then
        zc.tipInfo(zc.lang("tips_leader_can_use_func"))
        return 
    end
    if self._inviteCd ~= 0 then
        zc.tipInfo(zc.lang("tips_invite_cding") .. self._inviteCd)
        return
    end
    -- teamId = self._teamId
    -- tollgateId = self._tollgateId
    local _name = "xxxxx"
    local _info = "“".. PlayerData.info.userName .. "”" .. zc.lang("team_to_fight") .. "“" .. _name .. "”，" .. zc.lang("heros_to_join") .. "。"

    local _text = {
        teamId = self._teamId,
        tollgateId = self._tollgateId,
        info = _info
    }
    local function _sendSuccess()
        zc.tipInfo(zc.lang("tips_send_success"))
        self._inviteCd = 30
        self._inviteCdAction = schedule(self, function()
            self._inviteCd = self._inviteCd - 1
            if self._inviteCd == 0 then
                self:stopAction(self._inviteCdAction)
            end
        end, 1)
    end

    local inputBoxSize = cc.size(400, 100) 
    local inputBox = ccui.EditBox:create(inputBoxSize, "res/Main/common/img_empty.png") 
    inputBox:setContentSize(inputBoxSize)
    inputBox:setFontSize(22)
    inputBox:setFontName(zc.getFont(1))
    inputBox:setAnchorPoint(0, 0.5)
    inputBox:setFontColor(cc.c3b(108,85,64))
    inputBox:setPlaceHolder(_info)
    inputBox:setPlaceholderFontColor(cc.c3b(108,85,64))
    inputBox:setPlaceholderFont(zc.getFont(1), 22)
    inputBox:setMaxLength(40) 
    inputBox:setInputMode(cc.EDITBOX_INPUT_MODE_ANY)
    inputBox:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    inputBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE )
    inputBox:setText(_info)
    inputBox:setPosition(cc.p(zc.width/2-200,zc.height/2))

    local function _leftCallback()
        local _str = inputBox:getText()
        if _str ~= "" and string.len(_str) > 0 then
            _text.info = _str
        end
        getNetManager():getRequestCenter():sendWords(2, _text)
        _sendSuccess()
    end

    local _isHide = true
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_11907 then
        _isHide = false
    end
    local _comfirmPop = nil
    _comfirmPop = ZCConfirmDialog:createWithParams({
        title = zc.lang("SEND_INVITE"),
        -- contentNode = inputBox,
        showDi = true,
        doshow = false,
        isHide = _isHide,
        leftText = zc.lang("SENDTOWORLD"),
        rightText = zc.lang("SENDTOCOUNTRY"),
        leftCallback = function()
            _leftCallback()
        end,
        rightCallback = function()
            local _str = inputBox:getText()
            if _str ~= "" and string.len(_str) > 0 then
                _text.info = _str
            end
            local _countryId = tonumber(PlayerData:getBaseInfoByTag("countryId")) or 0
            if _countryId == 0 and PlayerData:getBaseInfoByTag("countryName") == ""  then 
                zc.tipInfo(zc.lang("tips_unjoin_country"))
                return
            end
            local _data = {countryId = _countryId}
            getNetManager():getRequestCenter():sendWords(2, _text, _data)
            _sendSuccess()
        end
    }) 
    _comfirmPop:addChild(inputBox)
    self:addChild(_comfirmPop, 10)

end
--开始战斗
function GrabMineFightTeamLayer:startFight()
    zc.sendHttp({
        apiName = "CountryMine_challenge",
        params = {mineId=self._mineAreaId,id=self._mineInfo.countryMineId,teamId=self._teamsInfo.id},
        successCallback = function (net_data)
            --防止重复点击
            LayerManager.addShieldLayout(nil, 0.3)
        end,
        -- 错误回调
        errorCallback = function( errorCode , errorMsg)
            local _errorCode = ( tonumber( errorCode ) or 0 )
            zc.tipInfo(errorMsg)
            if _errorCode == 314 then
                zc.tipInfo(errorMsg)
            else
                self:leaveTeam(true)
            end
        end,
        failCallback = function()
            self:leaveTeam(true)
        end,
    })

end
--重置玩家位置
function GrabMineFightTeamLayer:resetUserDiPos()
    local _onePart = self._onePart
    local _widthPart = self._widthPart
    for j=1, 3 do
        self._posTb[j] = self._userDis[j].index
        self._userDis[j]:stopAllActions()
        self._userDis[j]:setLocalZOrder(3 - self._userDis[j].index)
        self._userDis[j]:setPosition(_onePart + (self._userDis[j].index-1)*_widthPart, self._userDis[j]:getPositionY())
    end
end

--检查是否可移动 
function GrabMineFightTeamLayer:checkMove( _di )
    local _onePart = self._onePart
    local _widthPart = self._widthPart
    local _idx1 = _di.index == 1 and 2 or 1
    local _idx2 = _di.index == 3 and 2 or 3
    local _posX = _di:getPositionX()

    local function _go( target, x )
        target.isMoveing = true
        target:runAction(cc.Sequence:create(
            cc.MoveBy:create(0.1, cc.p(x, 0)),
            cc.CallFunc:create(function()
                target.isMoveing = false
            end)
        ))
    end

    local _part = (_posX - _onePart)/_widthPart
    if _part > 1.5 then
        self._posTb[3] = _di.index
        self._posTb[2] = _idx2
        self._posTb[1] = _idx1
    elseif _part > 0.5 then
        self._posTb[3] = _idx2
        self._posTb[2] = _di.index
        self._posTb[1] = _idx1
    else
        self._posTb[3] = _idx2
        self._posTb[2] = _idx1
        self._posTb[1] = _di.index
    end

    for i=1,3 do
        local _nIdx = self._posTb[i]
        local _tar = self._userDis[_nIdx]
        if _nIdx ~= _di.index and not _tar.isMoveing then
            local _tarX = _tar:getPositionX()
            local _pNum = _onePart + (i-1)*_widthPart - _tarX
            if _pNum ~= 0 then
                _go(_tar, _pNum)
            end
        end
    end
end

--监测调整的状态
function GrabMineFightTeamLayer:checkHaveChange( index )
    for i=1,3 do
        if self._posTb[i] ~= i then
            self:adjustTeam()
            return true
        end
    end
    return false
end
--调整
function GrabMineFightTeamLayer:adjustTeam()
    local _change = ""
    for i = 1, 3 do
        if _change == "" then
            _change = ""..self._posTb[i]
        else
            _change = _change.."|"..self._posTb[i]
        end
    end
    zc.sendHttp({
        apiName = "CountryMine_teamChangee",
        params = {teamId = self._teamId, change = _change},
    })
end
-- 刷新右侧的按钮文字
function GrabMineFightTeamLayer:refreshAutoBtnText()
    if self._isCreater then
        -- 队长，只有开始挑战
        self._autoBtn:setString( zc.lang("start_seize") )
    elseif self._isRead == 1 then
        -- 队员，取消准备
        self._autoBtn:setString( zc.lang("unReady") )
    else
        -- 队员，准备
        self._autoBtn:setString( zc.lang("doReady") )
    end
end

--返回
function GrabMineFightTeamLayer:goBack( showInfo )
    if not self._justLeave and self._fight then --开始战斗后，就不能由推送来控制退出
        return
    end
    if showInfo then
        zc.tipInfo(showInfo)
    end

    LayerManager.addShieldLayout()
    LayerManager.removeLayout()
end
--踢出队伍
function GrabMineFightTeamLayer:kickOutOne( _userId, name )
    local _comfirmPop = ZCConfirmDialog:createWithParams({
        title = zc.lang("prompt"),
        showDi = true,
        msg = string.format(zc.lang("tips_is_kick_out_team"), tostring(name)),
        rightCallback = function()
        	zc.tipInfo(zc.lang("tips_kick_out_player"))

            zc.sendHttp({
                apiName = "CountryMine_kickOut",
                params = {teamId = self._teamId, kickUserId = _userId},
            })
        end
    }) 
    self:addChild(_comfirmPop, 10)
end
function GrabMineFightTeamLayer:onCleanup()
    zc.removeEventListener(CUSTOM_EVENT.EVENT_GRABMINE_TALK)
    if self._callback and type(self._callback) == "function" then
        self._callback()
    end
end
function GrabMineFightTeamLayer:onEnter( ... ) 
    if self._notInit then --挑战之后直接退出
        self:leaveTeam(true)
    end
    self._notInit = true
end
function GrabMineFightTeamLayer:onExit( ... )
end
return GrabMineFightTeamLayer