--[[
    FileName: GrabFoodRankPop.lua
    Author: wangming
    Date: 2017-03-16
    Purpose: 抢粮榜弹窗
]]
local GrabFoodRankPop = class( "GrabFoodRankPop", function ()
    return zc.createNormalDialog()
end)
function GrabFoodRankPop:create(params)
    return GrabFoodRankPop.new(params)
end
function GrabFoodRankPop:ctor(params)
    self:initData(params)
    self:initUI()
end

function GrabFoodRankPop:initUI()
    -- 标题背景云
    local titleCloud = cc.Sprite:create( "res/Main/common/title_bg_cloud.png" )
    self:addChild( titleCloud )
    local popBg = zc.createNormalPop({
        tag = 2,
        src = "res/Main/common/popBg/bgWhite.png",
        bianZOrder = 1,
        height = 555,
    })
    popBg:setPosition(zc.width*0.5, zc.height*0.5 - 20)
    self:addChild(popBg)

    local popSize = popBg:getContentSize()

    titleCloud:setAnchorPoint( 0, 0.5 )
    titleCloud:setPosition( zc.width/2 - popSize.width/2 - 80, zc.height/2 + popSize.height/2+7 )

    -- 标题背景
    local titleBg = cc.Sprite:create( "res/Main/common/title_bg_shadow.png" )
    titleBg:setAnchorPoint( 0, 0.5 )
    titleBg:setPosition( -30, popSize.height )
    popBg:addChild( titleBg , 10)
    -- 标题
    local title = cc.Sprite:create( "res/Main/arena/rank/title.png" )
    title:setAnchorPoint( 0, 0.5 )
    title:setPosition( -5, popSize.height )
    popBg:addChild( title , 10)

    local scaleSize = cc.size(155, 461)
    local tabButtonBg = zc.getScaleNode("res/Main/common/img_empty.png", scaleSize)
    tabButtonBg:setAnchorPoint(cc.p(0, 0))
    tabButtonBg:setPosition(cc.p(7, 12))
    popBg:addChild(tabButtonBg)

    self._innerSize = cc.size(155, 440)
    local tabSroll = ccui.ScrollView:create()
    tabSroll:setTouchEnabled(true)
    tabSroll:setBounceEnabled(true)
    tabSroll:setContentSize( self._innerSize )
    tabSroll:setPosition(cc.p(0, 10))
    tabSroll:setDirection(ccui.ScrollViewDir.vertical)
    tabSroll:setScrollBarEnabled(false)
    tabSroll:setInnerContainerSize( self._innerSize )
    tabButtonBg:addChild(tabSroll)
    self._tabSroll = tabSroll

    local tableInfoBgSize = cc.size(699, 455)
    local tableInfoBg = zc.getScaleNode("res/Main/setting/scale9_1.png",tableInfoBgSize)
    tableInfoBg:setAnchorPoint(cc.p(1, 0))
    tableInfoBg:setPosition(cc.p(popSize.width-5, 10))
    popBg:addChild(tableInfoBg)

    local tipNoItemImg = zc.createSprite("res/Main/common/empty.png")
    tipNoItemImg:setPosition(tableInfoBgSize.width/2, tableInfoBgSize.height/2)
    tableInfoBg:addChild(tipNoItemImg)
    tipNoItemImg:setVisible(false)
    self._tipNoItemImg = tipNoItemImg

    local tableBg = zc.getScaleNode("res/Main/common/img_empty.png", tableInfoBgSize)
    tableBg:setAnchorPoint(cc.p(1, 0))
    tableBg:setPosition(cc.p(popSize.width-5, 15))
    popBg:addChild(tableBg)
    self._tableBg = tableBg

    --创建title
    self._titleLabList = {}
    for i = 1, 5 do
        local titleLab = zc.createLabel({
            text = "",
            stroke = false,
            fontSize = 18,
            pos = cc.p(0,0),
            color = cc.c3b(66,12,17),
        })
        tableBg:addChild(titleLab)
        table.insert(self._titleLabList,titleLab)
    end
    self._perHeight = 61
    self:createTabButton()

    self:updateRedDot()
end

function GrabFoodRankPop:updateRedDot()
    local status1 = PlayerData:getRedState(1)
    zc.registerAndRefreshRedDot(self._tabButtonList[1], status1,  -10, -10)

    local status2 = PlayerData:getRedState(2)
    zc.registerAndRefreshRedDot(self._tabButtonList[2], status2, -10, -10)

    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_FOODSRED, data = {}})
end


function GrabFoodRankPop:createTabButton()
    self._tabButtonList = {}
    local i = 0
    for k,v in pairs(self._tabName) do
        i = i + 1
        local tabBtn = zc.createPushButton({
            normalFile = "res/Main/rankList/tab_button_u.png",
            selectedFile = "res/Main/rankList/tab_button_u.png",
            needSwallow = false,
            needEnableWhenMoving = true,
            anchor = cc.p(0.5, 0.5),
            pos = cc.p(155/2, self._innerSize.height - 40 - (i-1)*self._perHeight), -- 61*
            endCallback = function() end,
        })
        tabBtn:setTag(k)
        table.insert(self._tabButtonList, tabBtn)

        self._tabSroll:addChild(tabBtn)
        tabBtn:setTouchEndedCall(function()
            self:changeTab(tabBtn)
        end)
        local nameLab = zc.createLabel({
            text = self._tabName[k]["name"],
            fontSize = 24,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(tabBtn:getContentSize().width/2, tabBtn:getContentSize().height/2),
            color = cc.c3b(40,17,0),
        })
        tabBtn:addChild(nameLab, 1)
        tabBtn._nameLab = nameLab
        if self._tabName[k]["moreRank"] then
            local arrow = zc.createSprite("res/Main/rankList/up_arrow.png")
            arrow:setAnchorPoint(0, 0.5)
            arrow:setPosition(nameLab:getContentSize().width+2, nameLab:getContentSize().height/2)
            nameLab:addChild(arrow)
            nameLab:setPositionX(tabBtn:getContentSize().width/2-arrow:getContentSize().width/2-1)
            tabBtn["arrow"] = arrow
        end
    end
    self:changeTab(self._tabButtonList[1])
end

function GrabFoodRankPop:changeTab(_node)
    local function getNormal()
        return zc.createSprite("res/Main/rankList/tab_button_u.png")
    end
    local function getSelected()
        return zc.createSprite("res/Main/rankList/tab_button_d.png")
    end
    if not self._selectedBtn or self._selectedBtn ~= _node then
        local _tag = _node:getTag()
        if not self._selectedBtn then
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelected() )
            self._selectedBtn:setStateSelected( getSelected() )
            _node._nameLab:setColor(display.COLOR_WHITE)
            -- _node._nameLab:enableShadow(cc.c4b(130,85,23,255), cc.size(2, -2))
            _node._nameLab:enableOutline(cc.c4b(130,85,23,255), 2)
        else
            self._selectedBtn:setStateNormal( getNormal() )
            self._selectedBtn:setStateSelected( getNormal() )
            self._selectedBtn._nameLab:setColor(cc.c3b(40,17,0))
            -- self._selectedBtn._nameLab:enableShadow(cc.c4b(0,0,0,0), cc.size(2, -2))
            self._selectedBtn._nameLab:enableOutline(cc.c4b(0,0,0,0), 2)
            if self._selectedBtn["arrow"] then
                self._selectedBtn["arrow"]:setFlipY(false)
            end
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelected() )
            self._selectedBtn:setStateSelected( getSelected() )
            _node._nameLab:setColor(display.COLOR_WHITE)
            -- _node._nameLab:enableShadow(cc.c4b(130,85,23,255), cc.size(2, -2))
            _node._nameLab:enableOutline(cc.c4b(130,85,23,255), 2)
        end
        self._tag = _tag
        --选中
        if _node["arrow"] then
            _node["arrow"]:setFlipY(true)
        end
        --展开
        self:openAction(_tag)
    end
end

--刷新位置
function GrabFoodRankPop:refreshPos()
    for i = 1, table.nums(self._tabButtonList) do
        local button = self._tabButtonList[i]
        button:setPositionY(self._innerSize.height - 40 - (i-1)*self._perHeight)
    end
end

--展开
function GrabFoodRankPop:openAction(_tag, isFresh)
    local subTabInfo = self._tabName[_tag]
    local nameStrTable = self._subTabName[_tag] or {}
    local _secondTag = nameStrTable[1]["infoTag"]
    self:getRankInfo(_secondTag,function()
        if not self._showInfo or not next(self._showInfo["rank"]) then
            self._tipNoItemImg:setVisible(true)
        else
            self._tipNoItemImg:setVisible(false)
        end
        --刷新榜 title
        local titleInfo = self._titleInfoList[_secondTag]
        for i = 1, table.nums(self._titleLabList) do
            local v = self._titleLabList[i]
            if i == table.nums(self._titleLabList) then
                v:setText("")
                break
            end
            v:setText(titleInfo[i]["name"] or "")
            v:setPosition(titleInfo[i]["pos"])
        end
        --创建排行榜
        self:createRankListInfo(isFresh)
        --刷新自己的榜
        self:refreshSelefRank()
    end)
end

function GrabFoodRankPop:createRankListInfo(isFresh)
    if self._myTableview then
        if isFresh then
            self._myTableview:reloadDataAndScrollToCurrentCell()
        else
            self._myTableview:reloadData()
            self._myTableview:scrollToCell(0, false)
            self:initAnimation()
        end
        return
    end
    local tableSize = cc.size(self._tableBg:getContentSize().width,346)
    self._tableviewSize = tableSize
    local myTableBg = zc.getScaleNode("res/Main/setting/scale9_1.png", tableSize )
    myTableBg:setAnchorPoint(cc.p(0.5, 0))
    myTableBg:setPosition(cc.p(self._tableBg:getContentSize().width/2, 77))
    self._tableBg:addChild(myTableBg)

    local cellSize = cc.size(tableSize.width-4, 85)
    local myTable = zc.ZCTableView:create(cc.size(tableSize.width-4,tableSize.height-8))
    myTable:setPosition(2,5)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    myTableBg:addChild(myTable)

    local function cellSizeForTable(table,idx)
        return cellSize.height, cellSize.width
    end

    local function numberOfCellsInTableView(table)
        local _num = self._listLength[self._tag] or 0
        local _num2 = #self._showInfo["rank"]
        return _num > _num2 and _num2 or _num
    end

    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(cellSize.width, cellSize.height))
            self:createCell(cell, nowIdx)
        end
        self:updateCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    myTable:reloadData()
    self._myTableview = myTable
    self:initAnimation()
end

function GrabFoodRankPop:createCell(cell, nowIdx)
    local cellSize = cell:getContentSize()
    local posyMiddle = cellSize.height/2
    local cell_img = zc.createSprite("res/Main/arena/rank/bg_4.png")
    cell_img:setPosition(cellSize.width/2, posyMiddle)
    cell_img:setName("cell_img")
    cell:addChild(cell_img)

    local top3 = zc.createSprite()
    top3:setPosition(70, posyMiddle)
    top3:setName("top3")
    cell_img:addChild(top3, 1)
    top3:setVisible(false)

    local rankNum = zc.createFntLabel({
        fnt = "res/Main/arena/rank/fnt/arenaRank_num.fnt",
        pos = cc.p( 70, posyMiddle ),
    })
    rankNum:setName("rankNum")
    cell_img:addChild( rankNum , 1)

    --head
    local head = zc.createPlayerHead({
        level = 1,
        iconId = 1,
    })
    head:setName("head")
    head:setScale(58/80)
    head:setPosition( cc.p(155,posyMiddle) )
    cell_img:addChild(head, 1)

    --name
    local name = zc.createLabel({
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(190, posyMiddle),
        color = cc.c3b(66,12,17),
    })
    name:setName("name")
    cell_img:addChild(name, 1)

    --power
    local power = zc.createLabel({
        fontSize = 20,
        pos = cc.p(374, posyMiddle),
        color = cc.c3b(66, 12, 17),
    })
    cell_img:addChild(power,1)
    power:setName("power")

    local _rewardIcon = zc.createSprite()
    _rewardIcon:setPosition(460, posyMiddle)
    cell_img:addChild(_rewardIcon, 1)
    _rewardIcon:setName("rewardIcon")

    local _rewardLab = zc.createLabel({
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(480, posyMiddle),
    })
    cell_img:addChild(_rewardLab, 1)
    _rewardLab:setName("rewardLab")

    local _grabBtn = zc.createPushButton({
        normalFile = "res/Main/grabFood/grabBtn_u.png",
        disableFile = "res/Main/grabFood/grabBtn_g.png",
        pos = cc.p(cellSize.width - 65, posyMiddle),
        endCallback = function() end,
    })
    _grabBtn:setName("grabBtn")
    cell_img:addChild(_grabBtn, 1)

    for i = 1, 4 do
        local split = zc.createSprite("res/Main/setting/separate_line.png")
        split:setPosition(self._linePosx[i], posyMiddle)
        cell_img:addChild(split)
        split:setScaleY(0.75)
    end
end

function GrabFoodRankPop:updateCell(cell, nowIdx)
    local cellSize = cell:getContentSize()
    local cellData = self._showInfo["rank"][nowIdx]
    local cell_img = cell:getChildByName("cell_img")
    cell_img:setScale(1.0)
    local _rank = tonumber(cellData.rank) or 0
    local top3 = cell_img:getChildByName("top3")
    top3:setVisible(_rank <= 3)
    local rankNum = cell_img:getChildByName("rankNum")
    rankNum:setVisible(_rank > 3)
    local imgPath = "res/Main/arena/rank/bg_" .. _rank .. ".png"
    if _rank <= 3 then
        top3:setTexture("res/Main/arena/rank/icon_" .. _rank .. ".png")
    else
        rankNum:setString(_rank)
        imgPath = "res/Main/arena/rank/bg_4.png"
    end
    cell_img:setTexture(imgPath)

    local head = cell_img:getChildByName("head")
    zc.updatePlayerHead({
        headBg=head,
        level = cellData.level,
        iconId = cellData.iconId,
        callback = function()
            zc.createOtherPlayerSelect(cellData.userId)
        end
    })
    local name = cell_img:getChildByName("name")
    name:setText(cellData["userName"])

    local power = cell_img:getChildByName("power")
    power:setText(cellData["num"])


    local _dbs = self._rewards[self._tag] or {}
    local _db, _rankMax, _rankMin
    for i = 1, #_dbs do
        _rankMax = tonumber(_dbs[i].rankMax) or 0
        _rankMin = tonumber(_dbs[i].rankMin) or 0
        if _rank <= _rankMax and _rank >= _rankMin then
            _db = _dbs[i]
            break
        end
    end

    local _rewardIcon = cell_img:getChildByName("rewardIcon")
    local _rewardLab = cell_img:getChildByName("rewardLab")
    if _db then
        _rewardIcon:setVisible(true)
        _rewardIcon:setTexture(zc.getImgByType(_db.rewardInfo[2]))
        _rewardLab:setString(_db.rewardInfo[3])
    else
        _rewardIcon:setVisible(false)
        _rewardLab:setString(zc.lang("no"))
    end

    local _grabBtn = cell_img:getChildByName("grabBtn")
    _grabBtn:setTouchEndedCall(function()
        if self._times <= 0 then
            zc.tipInfo(zc.lang("tips_left_times_unenough"))
            return
        end
        zc.sendHttp({
            apiName = "GodFight_getEnemyInfo",
            params = {targetUserId = cellData.userId},
            successCallback = function(net_data)
                local enemyData = {enemys = {}}
                for i = 1, 9 do
                    local _data = net_data[tostring(i)]
                    enemyData.enemys[i] = {}
                    if _data then
                        enemyData.enemys[i] = _data
                    end
                end
                local _params = {
                    battleType= BattleType.GrabFight,
                    toUserId = cellData.userId,
                    sType = 1,
                    enemys = enemyData,
                    fightScene = 6,
                }
                zc.createMatrixBattle(_params)
            end
        })
    end)
    _grabBtn:setEnable(tonumber(cellData.userId) ~= self._selfUid)
end

-- 入场动画
function GrabFoodRankPop:initAnimation()
    local cellHeight = 85
    local cellNum = math.ceil( self._tableviewSize.height/cellHeight )
    for i = 1, cellNum do
        local cell = self._myTableview:cellAtIndex( i - 1 )
        if cell then
            cell:stopAllActions()
            cell:setPosition( 0, self._myTableview:getContentSize().height - cellHeight - self._tableviewSize.height )
            cell:runAction(
                cc.Sequence:create(
                    cc.DelayTime:create( i*0.15 ),--math.sqrt( ( i - 1 )*0.05 ) ),
                    cc.EaseExponentialOut:create( cc.MoveTo:create( 0.8, cc.p( 0, self._myTableview:getContentSize().height - cellHeight*i ) ) )
                )
            )
        end
    end
end

function GrabFoodRankPop:refreshSelefRank()
    local selfRankInfo = self._showInfo["rankOther"] or {}

    if not self._selfRankBg then
        local selfRankBgSize = cc.size(694, 80)
        local selfRankBg = cc.Node:create()
        selfRankBg:setContentSize(selfRankBgSize)
        selfRankBg:setAnchorPoint(cc.p(0.5, 0))
        selfRankBg:setPosition(cc.p(self._tableBg:getContentSize().width/2, 0))
        self._tableBg:addChild(selfRankBg)
        self._selfRankBg = selfRankBg
        local posyMiddle = selfRankBgSize.height/2
        local __px, __y = 15, 20
        local _myRank1 = zc.createLabel({
            text = zc.lang("zi_wo"),
            outLine = true,
            fontSize = 18,
            ap = cc.p(0.5, 1),
            pos = cc.p(__px, posyMiddle + __y*2),
            color2 = cc.c3b(119, 87, 87),
        })
        selfRankBg:addChild(_myRank1)
        local _myRank2 = zc.createLabel({
            text = zc.lang("zi_de"),
            outLine = true,
            fontSize = 18,
            ap = cc.p(0.5, 1),
            pos = cc.p(__px, posyMiddle + __y),
            color2 = cc.c3b(119, 87, 87),
        })
        selfRankBg:addChild(_myRank2)
        local _myRank3 = zc.createLabel({
            text = zc.lang("zi_pai"),
            outLine = true,
            fontSize = 18,
            ap = cc.p(0.5, 1),
            pos = cc.p(__px, posyMiddle),
            color2 = cc.c3b(119, 87, 87),
        })
        selfRankBg:addChild(_myRank3)
        local _myRank4 = zc.createLabel({
            text = zc.lang("zi_ming"),
            outLine = true,
            fontSize = 18,
            ap = cc.p(0.5, 1),
            pos = cc.p(__px, posyMiddle - __y),
            color2 = cc.c3b(119, 87, 87),
        })
        selfRankBg:addChild(_myRank4)

        local outRankLab = zc.createLabel({
            text = zc.lang("bangwai"),
            stroke = false,
            fontSize = 20,
            pos = cc.p(70, posyMiddle),
            color = cc.c3b(66,12,17),
        })
        selfRankBg:addChild(outRankLab)
        local rankImg = zc.createSprite()
        rankImg:setPosition(70, posyMiddle)
        selfRankBg:addChild(rankImg)

        local rankNum = zc.createFntLabel({
            fnt = "res/Main/arena/rank/fnt/arenaRank_num.fnt",
            pos = cc.p( 70, posyMiddle ),
        })
        selfRankBg:addChild( rankNum )

        selfRankBg._outRankLab = outRankLab
        selfRankBg._rankImg = rankImg
        selfRankBg._rankNum = rankNum

        --head
        local head = zc.createPlayerHead({
            level = PlayerData.info.level,
            iconId = PlayerData.info.iconId,
        })
        head:setScale(58/80)
        head:setPosition( cc.p(155,posyMiddle) )
        selfRankBg:addChild(head)

        --name
        local name = zc.createLabel({
            text = PlayerData.info.userName,
            stroke = false,
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(190, posyMiddle),
            color = cc.c3b(66,12,17),
        })
        selfRankBg:addChild(name)

        --power
        local power = zc.createLabel({
            stroke = false,
            fontSize = 20,
            pos = cc.p(374, posyMiddle),
            color = cc.c3b(66,12,17),
        })
        selfRankBg:addChild(power)

        local _rewardIcon = zc.createSprite()
        _rewardIcon:setPosition(460, posyMiddle)
        selfRankBg:addChild(_rewardIcon, 1)

        local _rewardLab = zc.createLabel({
            outLine = true,
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(480, posyMiddle),
        })
        selfRankBg:addChild(_rewardLab, 1)

        local _grabBtn = zc.createCommomBtn({
            tag = 3,
            scale = 0.7,
            fontSize = 28,
            text = zc.lang("fetch_2"),
            pos = cc.p(selfRankBgSize.width - 65, posyMiddle),
            endCallback = function()
                zc.sendHttp({
                    apiName = "GrabFood_getRankAward",
                    params = {type = self._tag - 5},
                    successCallback = function( net_data )
                        PlayerData:updataData(net_data)
                        if net_data.endTime then
                            self._endTime = tonumber(net_data.endTime) or 0
                        end
                        if net_data.lastRank then
                            self._lastRank = tonumber(net_data.lastRank) or 0
                        end

                        local _status = 0
                        if net_data.awardInfo == 1 then
                            _status = 1
                            PlayerData:updateRedDotData(self._tag - 5, _status)
                        else
                            if net_data.endTime then
                                if net_data.endTime == 0 then
                                    PlayerData:updateRedDotData(self._tag - 5, 1)
                                else
                                    PlayerData:updateRedDotData(self._tag - 5, net_data.endTime)
                                end
                            else
                                PlayerData:updateRedDotData(self._tag - 5, _status)
                            end
                        end

                        self._awards = 0
                        self:refreshSelefRank()
                        self:updateRedDot()
                    end,
                })
            end
        })
        selfRankBg:addChild(_grabBtn, 1)

        local _grabLab = zc.createSprite("res/Main/grabFood/noRewardFlag.png")
        _grabLab:setPosition(_grabBtn:getPositionX(), posyMiddle)
        selfRankBg:addChild(_grabLab, 1)

        selfRankBg._myRank1 = _myRank1
        selfRankBg._myRank2 = _myRank2
        selfRankBg._power = power
        selfRankBg._rewardIcon = _rewardIcon
        selfRankBg._rewardLab = _rewardLab
        selfRankBg._grabBtn = _grabBtn
        selfRankBg._grabLab = _grabLab

        for i = 1, 4 do
            local split = zc.createSprite("res/Main/setting/separate_line.png")
            split:setPosition(self._linePosx[i], posyMiddle)
            selfRankBg:addChild(split)
            split:setScaleY(0.75)
        end
    end
    local outRankLab = self._selfRankBg._outRankLab
    local rankImg = self._selfRankBg._rankImg
    local rankNum = self._selfRankBg._rankNum
    local power = self._selfRankBg._power
    local rewardIcon = self._selfRankBg._rewardIcon
    local rewardLab = self._selfRankBg._rewardLab
    local grabBtn = self._selfRankBg._grabBtn
    local grabLab = self._selfRankBg._grabLab

    if selfRankInfo["num"] then
        power:setText(selfRankInfo["num"])
    else
        power:setText(self._foodsNum)
    end

    local _rank = tonumber(selfRankInfo["rank"]) or 0
    if self._awards == 1 then
        _rank = self._lastRank
        self._selfRankBg._myRank1:setString(zc.lang("zi_shang"))
        self._selfRankBg._myRank2:setString(zc.lang("zi_qi"))
    else
        self._selfRankBg._myRank1:setString(zc.lang("zi_wo"))
        self._selfRankBg._myRank2:setString(zc.lang("zi_de"))
    end
    local _dbs = self._rewards[self._tag] or {}
    local _db, _rankMax, _rankMin
    for i = 1, #_dbs do
        _rankMax = tonumber(_dbs[i].rankMax) or 0
        _rankMin = tonumber(_dbs[i].rankMin) or 0
        if _rank <= _rankMax and _rank >= _rankMin then
            _db = _dbs[i]
            break
        end
    end

    if grabBtn.__actTag then
        grabBtn:stopAction(grabBtn.__actTag)
    end
    if _db then
        rewardIcon:setVisible(true)
        rewardIcon:setTexture(zc.getImgByType(_db.rewardInfo[2]))
        rewardLab:setAnchorPoint(0, 0.5)
        rewardLab:setString(_db.rewardInfo[3])
        outRankLab:setVisible(false)
        rankImg:setVisible(false)
        grabLab:setVisible(false)
        grabBtn:setVisible(true)
        if self._awards == 1 then
            grabBtn:setEnable(true)
            grabBtn:setText(zc.lang("fetch_2"))
        else
            grabBtn:setEnable(false)
            local function _freshTime()
                local _nowTime = self._endTime - PlayerData:getTime()
                if _nowTime <= 0 then
                    if grabBtn.__actTag then
                        grabBtn:stopAction(grabBtn.__actTag)
                    end
                    grabBtn.__actTag = nil
                    grabBtn:setText(zc.lang("fetch_2"))
                    grabBtn:setEnable(true)
                    self:updateRedDotData(2, 1)
                    self:updateRedDot()
                else
                    local _hour = math.modf(_nowTime/(60*60))
                    local _leftTime = _nowTime%(60*60)
                    local _minute = math.modf(_leftTime/60)
                    local _seconds = _leftTime%60
                    _hour = _hour >= 10 and _hour or ("0" .. _hour)
                    _minute = _minute >= 10 and _minute or ("0" .. _minute)
                    _seconds = _seconds >= 10 and _seconds or ("0" .. _seconds)
                    grabBtn:setText(_hour .. ":" .. _minute .. ":" .. _seconds)
                end
            end
            grabBtn.__actTag = schedule(grabBtn, _freshTime, 1)
            _freshTime()
        end
        if _rank <= 3 then
            rankImg:setVisible(true)
            rankNum:setVisible(false)
            rankImg:setTexture("res/Main/arena/rank/icon_" .. _rank .. ".png")
        else
            rankNum:setString(_rank)
            rankImg:setVisible(false)
            rankNum:setVisible(true)
        end
    else
        rewardIcon:setVisible(false)
        rewardLab:setAnchorPoint(0.5, 0.5)
        rewardLab:setString(zc.lang("no_have_for_now") .. zc.lang("reward"))
        outRankLab:setVisible(true)
        rankImg:setVisible(false)
        rankNum:setVisible(false)
        grabBtn:setVisible(false)
        grabLab:setVisible(true)
    end
end

function GrabFoodRankPop:freshData( params )
    self._endTime = tonumber(params.endTime) or 0
    self._awards = tonumber(params.awards) or 0
    self._showInfo = {rank = {}, rankOther = {}}
    self._lastRank = tonumber(params.lastRank) or 0
    local _ranks = params.rank or {}
    for k,v in pairs(_ranks) do
        v.rank = tonumber(k)
        self._showInfo.rank[v.rank] = v
        if tonumber(v.userId) == self._selfUid then
            self._showInfo.rankOther = v
        end
    end
    table.sort(self._showInfo.rank, function( a, b )
        local _rankA = tonumber(a.rank) or 0
        local _rankB = tonumber(b.rank) or 0
        return _rankA < _rankB
    end)
end

function GrabFoodRankPop:getRankInfo(_infoTag, _doNext)
    if not self._haveInit then
        if _doNext then
            _doNext()
        end
        return
    end
    if not _infoTag then
        return
    end
    local _api = "GrabFood_getRankListType1"
    if _infoTag == 21 then
        _api = "GrabFood_getRankListType2"
    end
    zc.sendHttp({
        apiName = _api,
        successCallback = function (net_data)
            self:freshData(net_data or {})
            if _doNext then
                _doNext()
            end
        end
    })
end

--初始化配置数据
function GrabFoodRankPop:initData(params)
    local _params = params or {}
    self._tag = 6
    self._times = tonumber(_params.times) or 0
    self._foodsNum = tonumber(_params.myFoodNums) or 0
    self._linePosx = {116, 319, 433, 560}
    self._selfUid = tonumber(PlayerData["info"]["userId"])
    --排行榜信息，总共19个，初始进入只请求了前两个，后面的在点击按钮时，分别请求
    local _datas = LANGUAGE_get_rank_list_basedatas()
    self:freshData(_params)
    --一级标签
    self._tabName = {
        [6] = _datas[1][6], 
        [7] = _datas[1][7],
    }
    --二级标签
    self._subTabName = _datas[2]

    --title
    self._titleInfoList = _datas[3]

    self._rewards = {}
    self._listLength = {}
    for i = 6, 7 do
        local _dbs = gameData.getDataFromCache("foodGrabRank", {type=(i-5)})
        table.sort(_dbs, function( a, b )
            local _idA = tonumber(a.id) or 0
            local _idB = tonumber(b.id) or 0
            return _idA < _idB
        end)
        local _max = 0
        for k,v in pairs(_dbs) do
            v.rewardInfo = string.split(v.reward or "", "|")
            local _pM = tonumber(v.rankMax) or 0
            if _max < _pM then
                _max = _pM
            end
        end

        self._rewards[i] = _dbs
        self._listLength[i] = _max
    end
end

function GrabFoodRankPop:onEnter()
    if not self._haveInit then
        self._haveInit = true
        local _currentGID = getGuideManager():getCurrentGID()
        if _currentGID == GuideKey.KEY_14609 then
            local function _callBack()
                LayerManager.removeLayout()
            end
            getGuideManager():setHeroFuncCallBack(_callBack)
            getGuideManager():startGuide()
        end
        return
    end
    local data = PlayerData:getLastSceneData() or {}
    if data.lastScene ~= "GrabFight" then
        return
    end
    self._times = tonumber(data.times) or 0
    if data.ownGrabInfo then
       self._foodsNum = tonumber(data.ownGrabInfo.num) or 0
    end
    self:openAction(self._tag, true)
end


return GrabFoodRankPop