-- requires("src/layer/guide/GuideScript.lua")

GuideScriptLayer = class( "GuideScriptLayer", function ( params )
	return ZCDialog:create()
end)

function GuideScriptLayer:ctor(params)
	local winSize 		= self:getContentSize();
    local winWidth 		= winSize.width;
    local winHeight 	= winSize.height;
	local _opacity = 70
	if params.opacity then 
		_opacity = params.opacity
	end 
	local storyId 	= params.storyId
	local callback 	= params.callback
	local auto 		= params.auto
	-- local storyData = GuideScript[tostring(storyId)]--gameData.getDataFromCSV("GuideScript", {["iplotid"]=storyId})
	local storyData = gameData.getDataFromCacheWithPrimaryKey("story", storyId)
	if not storyData then
		return
	end
	-- dump(storyData, "wm----GuideScriptLayer : ")
	self:setOpacity(_opacity)
	--[[--默认开启自动]]
	if auto == nil then
		auto = true
	end
	
	local txtBG = zc.createSprite("res/image/guide/talkBar.png")
	txtBG:setPosition( cc.p(winWidth*0.5,txtBG:getContentSize().height / 2) )
	self:addChild(txtBG)
	txtBG:setCascadeOpacityEnabled(true)

	local _jumDi = zc.createSprite("res/image/guide/blackDi.png")
	_jumDi:setAnchorPoint(0.5, 1)
	_jumDi:setPosition(zc.width*0.5, zc.height)
	self:addChild(_jumDi)

	local _h = 55
	local _w = 30
	local _jumpImg = zc.createSprite("res/image/guide/jumpImg.png")
	_jumpImg:setAnchorPoint(1, 0)
	_jumpImg:setPosition(zc.width - _w, zc.height - _h)
	self:addChild(_jumpImg, 1)

	local _guidInfo = getGuideManager():getCurrentInfo() or {}
	local _guideForce = tonumber(_guidInfo.force) or 1
	local _guideString = _guideForce == 0 and zc.lang("jump_guide") or zc.lang("jump_story")
	local _jumpTTF = zc.createLabel({
		text = _guideString,
		color2 = cc.c3b(37, 95, 111),
		pixel = 2,
		fontSize = 24,
		ap = cc.p(1, 0),
		pos = cc.p(zc.width - _w - _jumpImg:getContentSize().width, zc.height - _h),
	})
	self:addChild(_jumpTTF, 1)
	local _size = cc.size(_jumpTTF:getContentSize().width + _jumpImg:getContentSize().width, _jumpTTF:getContentSize().height)
	local jumpBtn = zc.createPushButton({
		-- normalNode = zc.getScaleNode("res/Main/common/button/btn_light_big.png", _size),
		anchor = cc.p(0, 0),
		pos = cc.p(_jumpTTF:getPositionX() - _jumpTTF:getContentSize().width - 30, zc.height - _h - 10),
		endCallback = function()
			if _guideForce == 0 then
				self:removeFromParent()
				getGuideManager():setFuncGuideOver()
			else
				self:removeFromParent()
				if callback then
					callback()
				end
			end
		end
	})
	jumpBtn:setContentSize(cc.size(_size.width + 100, _size.height + 50))
	self:addChild(jumpBtn)
	if _guideForce == -1 then
		_jumpImg:setVisible(false)
		_jumpTTF:setVisible(false)
		jumpBtn:setEnable(false)
		jumpBtn:setVisible(false)
	end

	-- 对话背景框的size
	local txtBGSize = txtBG:getBoundingBox()
	
	local body = zc.createSprite("res/Main/hero/body/101.png")--ccui.ImageView:create("res/Main/hero/body/101.png")
	body:setScale(0.8)
	body:setAnchorPoint(1, 1)
	body:setPosition(0, 0)
	self:addChild(body)

	-- 向下的箭头
	local arrow = cc.Sprite:create("res/image/guide/arrow_down.png")
	local moveBy = cc.MoveBy:create(1.0 / 4, cc.p(0, 5))
	local seqAction = cc.Sequence:create(moveBy, moveBy:reverse())
	local repeatAction = cc.RepeatForever:create(seqAction)
	arrow:runAction( repeatAction )
	
	local arrow_rect = cc.Sprite:create("res/image/guide/-.png")
	arrow:setPosition(cc.p(arrow_rect:getBoundingBox().width / 2 , arrow_rect:getBoundingBox().height + 5))
	arrow_rect:addChild(arrow)
	self:addChild(arrow_rect);
	arrow_rect:setVisible(false)
	local labTxt = zc.createRichLabel({
		text = "",
		anchor = cc.p(0, 1),
		pos = cc.p(100, 170),
		fontSize = 22,
	})
	labTxt:setDimensions(cc.size(500, 130))
	labTxt:setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
	labTxt:setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP)
	self:addChild( labTxt )

	local _nameTxt = zc.createLabel({
		ap = cc.p(0, 0),
		text = "",
		color = display.COLOR_YELLOW,
		color2 = display.COLOR_RED,
		pixel = 2,
		fontSize = 22,
	})
	self:addChild(_nameTxt)


	-- body:runAction(cc.Sequence:create(cc.DelayTime:create(0.1),cc.MoveBy:create(0.25, cc.p(-900,0))))

	local timeTxt = zc.createLabel({fontSize = 22,text = ""})
	timeTxt:setPosition(450,300)
	-- timeTxt:setOpacity(0)
	txtBG:addChild( timeTxt )
	timeTxt:setVisible(false)
	self._textureKeys = {}
	local stories = {}
	if storyData then
		for i=1,10 do
			if storyData["words"..i] ~= nil and storyData["words"..i] ~= "" then
				local word = storyData["words"..i]
				local words = string.split(word,"|")
				stories[#stories + 1] = words
			end
		end--for end
	end
	-- dump(stories)
	local function showTxt()
		--[[每次取第一条]]
		for i=1,#stories do
			local story 		= stories[i]
			local text 			= story[#story]
			local name 			= story[1] or ""
			local resourceid 	= story[2] or 101
			local side 			= tonumber(story[3]) or 1
			local y 			= tonumber(story[4]) or 0
			local scale 		= tonumber(story[5]) or 1.0
			-- local spineAct 		= story[6]
			-- local isActRepeat	= story[7] --1循环 其他为不循环
			-- local talkId		= story[8] --1循环 其他为不循环
			-- local isActStay		= story[8] --播完动画后是否停在当前动画最后一帧
			--主角图片
			-- if tostring(resourceid) == "nanzhu" then
			-- 	local _data = PlayerData:getBaseInfo()
			-- 	local _heroData = PlayerData:getGeneralInfoById( _data.heroId )
			-- 	if _heroData then
			-- 		resourceid = _heroData.picture
			-- 		name = 
			-- 	end
			-- else
			if tostring(resourceid) == "zhangliang" then
				resourceid = "15"
			elseif tonumber(resourceid) == 101 then
				if BATTLE_NOW_MAINROLE == "nanzhu_shan" then
					resourceid = "103"
				elseif BATTLE_NOW_MAINROLE == "nvzhujue" then
					resourceid = "102"
				elseif BATTLE_NOW_MAINROLE == "nvzhuqiang" then
					resourceid = "104"
				end
				local _name = PlayerData:getBaseInfoByTag("userName")
				-- print("wm----_name : ", _name)
				if _name and _name ~= "" then
					name = _name
				end
			end
			local _textureKey = "res/Main/hero/body/" .. tostring(resourceid) .. ".png"
			table.insert(self._textureKeys, _textureKey)
			body:setTexture(_textureKey)
			body:setScale(0.9)
			local function _callBack()
				body._isPlaying = false
			end
			--[[如果是右边]]
			local _x = 170
			local _y = 180
			body:setScale(scale)
			local _bodyWidth =  body:getBoundingBox().width
			_bodyWidth = _bodyWidth > 550 and 550 or _bodyWidth
			local _bodyHeight =  body:getBoundingBox().height
			_bodyHeight = _bodyHeight > 520 and 520 or _bodyHeight
			body:setPositionY(_bodyHeight + y)
			print("wm----_bodySize : ", _bodyWidth, " , " , _bodyHeight)
			if tonumber(side) == 2 then
				_nameTxt:setPosition(_x, _y)
				labTxt:setDimensions(cc.size(500, 130))
				labTxt:setPosition(_x, _y - 10)
				-- body:setScaleX(math.abs(body:getScaleX()))
				body:setAnchorPoint(0, 1)
				body:setPositionX(winWidth)
				body:runAction(cc.Sequence:create(cc.DelayTime:create(0.1), cc.MoveBy:create(0.25, cc.p(-_bodyWidth, 0)), cc.CallFunc:create(_callBack)))
				arrow_rect:setPosition(500, labTxt:getBoundingBox().y - 20)
			else
				_x = 500
				_y = 230
				_nameTxt:setPosition(_x, _y)
				labTxt:setDimensions(cc.size(450, 100))
				labTxt:setPosition(_x, _y - 10)
				body:setAnchorPoint(1, 1)
				-- body:setScaleX(-1*math.abs(body:getScaleX()))
				body:setPositionX(0)
				body:runAction(cc.Sequence:create(cc.DelayTime:create(0.1), cc.MoveBy:create(0.25, cc.p(_bodyWidth, 0)), cc.CallFunc:create(_callBack)))
				arrow_rect:setPosition(450 + 530, labTxt:getBoundingBox().y - 10)
			end
			table.remove(stories,i)
			_nameTxt:setString(name)
			body._isPlaying = true
			labTxt:setString("") 
			labTxt:runAction(cc.Sequence:create(
				cc.FadeOut:create(0.2), 
				cc.CallFunc:create(function() 
					labTxt:setString(text)
					labTxt._isPlaying = true
					-- labTxt:startLoopDisplay(0.05, 0, 0, cc.CallFunc:create(function() 
					-- 	labTxt:setString(text)
						-- print("text="..tostring(text))
						labTxt:setVisible(true)
						labTxt._isPlaying = false
						arrow_rect:setVisible(true)
						arrow_rect:setPosition( cc.p(labTxt:getBoundingBox().x + 400, labTxt:getBoundingBox().y - 20) )
					-- end))
				end),
				cc.FadeIn:create(0.5)))
			break
		end
	end
	local strs = {}
	strs[#strs + 1] = "①"
	strs[#strs + 1] = "②"
	strs[#strs + 1] = "③"
	strs[#strs + 1] = "④"
	strs[#strs + 1] = "⑤"
	
	local TIME = 10
	local _time_ = TIME
	local touchCallback = nil
	touchCallback = function( ... )
		_time_ = TIME
		if #stories > 0 then
			showTxt()
			if auto == true then
				timeTxt:setVisible(false)
				timeTxt:stopAllActions()
				schedule(timeTxt, function() 
					_time_ = _time_ - 1
			        if _time_ < 1 then
			        	touchCallback()
			        end
			        if strs[_time_] then
			       		timeTxt:setString(tostring(strs[_time_]))
			        end
			        if _time_ < 6 then
			        	timeTxt:setVisible(true)
			        else
			        	timeTxt:setVisible(false)
			        end
			    end, 2.0,1)
			    timeTxt:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.FadeOut:create(2), cc.FadeIn:create(0))))
			end
		else
			self:removeFromParent()
			if callback then
				callback()
			end
		end
	end
	touchCallback()
	self:setTouchEndedCallback(function() 
		if body._isPlaying == true then
			self:setTouchEnabled(false)
			performWithDelay(self, function ()
				self:setTouchEnabled(true)
			end,0.4)
			return
		end
		touchCallback()
	end)
	txtBG:setPosition(cc.p((winWidth - 350)*0.5 ,25))
	-- txtBG:setPosition(cc.p(winWidth*0.5,txtBG:getContentSize().height / 2))
	local scaleX = txtBG:getScaleX()
	-- txtBG:runAction(cc.Sequence:create( cc.MoveTo:create(0.1,cc.p(winWidth*0.5,txtBG:getContentSize().height / 2)) , cc.ScaleTo:create(0.1,scaleX,1.1), cc.ScaleTo:create(0.1,scaleX,1.0)  ))
end

function GuideScriptLayer:onCleanup()
	if self._textureKeys then
		local textureCache = cc.Director:getInstance():getTextureCache()
		for k,v in pairs(self._textureKeys) do
			textureCache:removeTextureForKey(v)
		end
	end
end

function GuideScriptLayer:createWithParams(params)
	return GuideScriptLayer.new(params)
end
