--[[
   
    Purpose: 英雄试炼首杀奖励预览
]]
local HeroCopyRewardPop = class( "HeroCopyRewardPop", function ()
    return ZCPopLayer:create()
end)
function HeroCopyRewardPop:create(params)
    return HeroCopyRewardPop.new(params)
end
function HeroCopyRewardPop:ctor(params)
    self:initData(params)
    self:initUI()
    self:show(false)

    self:guideFunc()
end

function HeroCopyRewardPop:guideFunc()
    local currentGID = getGuideManager():getCurrentGID()

    if currentGID == GuideKey.KEY_15009 then
        getGuideManager():setObjTarget(self.getBtn)
        getGuideManager():startGuide()
    end
end

function HeroCopyRewardPop:initData(params)
    self.rewardList = params.reward
    self.tollgateId = params.tollgateId
    self.canGet = params.canGet
    self.callback = params.callback
end
function HeroCopyRewardPop:initUI()
    local popBg = cc.Sprite:create("res/Main/wushenTower/pop_reward.png")
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    self._popBg = popBg
    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close)

    local getBtn = zc.createCommomBtn({
        tag =1,
        btnText = zc.lang("fetch"),
        needSwallow = false,
        -- anchor = cc.p(0.5, 0.5),
        pos = cc.p(popBg:getContentSize().width/2, 75),
        endCallback = function() 
            zc.sendHttp({
            apiName = "Hero_GetFirstReward",
                params = {tollgateId = self.tollgateId},
                successCallback = function(data)
                    local currentGID = getGuideManager():getCurrentGID()
                    if currentGID == GuideKey.KEY_15009 then
                        getGuideManager():setCurrentGID(GuideKey.KEY_15010)
                        getGuideManager():guideOver()
                    end
                    data.noAnimation = true
                    PlayerData:updataData(data)
                    
                    zc.createShowReward({
                        clientItems = data.clientItems,
                        clientResources = data.clientResources,

                        callback = function()
                            if self.callback then
                                self.callback()
                            end
                            self:hide()
                        end
                    })
                   
                end,
            })
        end,
    })
    popBg:addChild(getBtn)
    getBtn:setEnable(self.canGet)
    self.getBtn = getBtn

    self:createReward()
end

function HeroCopyRewardPop:createReward()
    local tableHeight = 132
    local tableSize = cc.size(435, tableHeight)
    local tableNode = self._popBg
    local myTableBg = ccui.Scale9Sprite:create(cc.rect(26,25,1,1), "res/Main/wushenTower/pop_tableBg.png")
    myTableBg:setContentSize(tableSize)
    myTableBg:setAnchorPoint(cc.p(0.5, 0.5))
    myTableBg:setPosition(cc.p(tableNode:getContentSize().width/2, tableNode:getContentSize().height/2 + 20))
    tableNode:addChild(myTableBg)    
   
   self:createTableView()
end


function HeroCopyRewardPop:createTableView()
    local tableSize = cc.size(435, 132)
    local tableNode = self._popBg
    local myTableBg = ccui.Scale9Sprite:create(cc.rect(26,25,1,1), "res/Main/wushenTower/pop_tableBg.png")
    myTableBg:setContentSize(tableSize)
    myTableBg:setAnchorPoint(cc.p(0.5, 0.5))
    myTableBg:setPosition(cc.p(tableNode:getContentSize().width/2, tableNode:getContentSize().height/2 + 20))
    tableNode:addChild(myTableBg)
    local myTable = zc.ZCTableView:create(cc.size(myTableBg:getContentSize().width-4,myTableBg:getContentSize().height-4))
    myTable:setPosition(2,2)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(true)
    myTable:setDirection(cc.SCROLLVIEW_DIRECTION_HORIZONTAL)
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    
    myTableBg:addChild(myTable)
    
    local function cellSizeForTable(table,idx)
        return 92, tableSize.width/4
    end
    local function numberOfCellsInTableView(table)
        return #self.rewardList
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(tableSize.width-4, 92))
        else
            cell:removeAllChildren()
        end
        self:updateCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    
    myTable:reloadData()
end

function HeroCopyRewardPop:updateCell(cell, indx)

    local nowData = self.rewardList[indx]

    local item, info = zc.createIconByData({
        data = {
            mainType = nowData.type, 
            type = nowData.id,
            id = nowData.id,
            num = nowData.num,
        }, 
        showDetailPop = true,
        pos = cc.p(435/8, 27), 
    })
    item:setTouchEndedShowTip()
    item:setScale(0.65)
    cell:addChild(item)

end
return HeroCopyRewardPop