--[[
	将魂信息
	wangming
	2017.4.12
]]
local HeroSoulInfoPop = class("HeroSoulInfoPop", function()
    return ZCPopLayer:create({opacityValue=0})
end)

function HeroSoulInfoPop:create( params )
	return HeroSoulInfoPop.new( params )
end

function HeroSoulInfoPop:ctor( params )
	self._randIdx = params.randIdx
	self._pos = params.pos or cc.p(zc.width*0.5, zc.height*0.5)
	local _width, _height = 280, 180
	local _soulData = params.soulData
	local _dbId = params.soulId
	if self._randIdx then
		_soulData = gameData.getDataFromCacheWithPrimaryKey("heroSoul", params.soulId)
		_height = 260
	elseif params.soulData then	
		_dbId = _soulData.heroSoulId
	end

	local _posx, _posy
    if self._pos.x <= zc.width*0.5 then 
        --左边
        _posx = self._pos.x + _width*0.5 + 100
    else
        --右边
        _posx = self._pos.x - _height*0.5 - 100
    end
    _posy = zc.height*0.5

    local effBg = zc.getScaleNode("res/Main/ornaments/general_tips_s_bg.png", cc.size(_width, _height))
    effBg:setAnchorPoint(0.5, 0.5)
    effBg:setPosition(_posx, _posy)
    self:addChild(effBg)

    local item = zc.createIconByData({
        data = {
            mainType = zc.mainTypeHeroSoul,
            type = 1,
            id = _dbId,
        },
        pos = cc.p(55, _height - 55), 
    })
    item:setScale(0.6)
    effBg:addChild(item)
    local weaponName = zc.createLabel({
        text = _soulData.name,
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(110, _height - 36),
        pixel = 1.3
    })
    effBg:addChild(weaponName)

    if not self._randIdx then
        local _lockLab = zc.createLabel({
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            color = cc.c3b(251, 209, 100),
            pos = cc.p(weaponName:getPositionX(), weaponName:getPositionY() - 36),
            pixel = 1.3
        })
        effBg:addChild(_lockLab)

        local _status = tonumber(_soulData.status) or 0
        local function _freshLockStatus()
    		local _text = _status == 0 and LANGUAGE_ROLE.not_locked or LANGUAGE_ROLE.have_locked
	        local _file = _status == 0 and "unlock" or "lock"
    		_lockLab:setString("(" .. _text .. ")")
    		self._lockBtn:setStateNormal(zc.createSprite("res/Main/heroSoul/" .. _file .. ".png"))
        end

        local _lockBtn = zc.createPushButton({
        	normalFile = "res/Main/heroSoul/unlock.png",
        	pos = cc.p(_width - 30, _height - 30),
        	endCallback = function()
	        	zc.sendHttp({
	        		apiName = "HeroSoul_soulLock",
			        params = {soulId = _soulData.id, type = _status + 1},
			        successCallback = function( backData )
			        	_status = _status == 0 and 1 or 0
			        	_freshLockStatus()
			        	_soulData.status = _status
			        	PlayerData:updateHeroSoul(_soulData)
			        	if params.freshCallback then
			        		params.freshCallback(_status)
			        	end
			        end
        		})
        	end
        })
        self._lockBtn = _lockBtn
        effBg:addChild(_lockBtn)
        _freshLockStatus()
    end

    local line1 = zc.createSprite("res/Main/login/login_line2.png")
    line1:setPosition(_width*0.5, _height - 100)
    effBg:addChild(line1)

    local baseEffTitle = zc.createLabel({
        text = zc.lang("base_attribute"),
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(30, _height - 120),
        pixel = 1.3
    })
    effBg:addChild(baseEffTitle)

    local effectStr = LANGUAGE_getAttributeTextById(_soulData.attributeType)
    local effectNum = zc.getAttributeNumById(_soulData.attributeType, _soulData.attributeValue)
    local effectLab = zc.createLabel({
        text = effectStr .. "：" .. effectNum,
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(32, _height - 150),
        color = cc.c3b(238, 98, 3),
        pixel = 1.3
    })
    effBg:addChild(effectLab)

    if not self._randIdx then
    	return
    end

    local line1 = zc.createSprite("res/Main/login/login_line2.png")
    line1:setPosition(_width*0.5, _height - 175)
    effBg:addChild(line1)

	local _sellDb = gameData.getDataFromCacheWithPrimaryKey("heroSoul_Sell", _soulData.quality)
    local _btnShop = zc.createCommomBtn({
    	tag = 1,
    	text = next(_sellDb) == nil and zc.lang("gather") or zc.lang("sell"),
    	pos = cc.p(_width*0.5, _height - 215),
    	endCallback = function()
    		if next(_sellDb) == nil then
    			if params.getCallback then
    				params.getCallback()
    			end
    		else
    			if params.sellCallback then
    				params.sellCallback()
    			end
    		end
            self:hide()
    	end
	})
	effBg:addChild(_btnShop)
end

return HeroSoulInfoPop