--[[
    UserTopLayer
    唐实聪修改
    2016.4.21
]]
local UserTopLayer = class("UserTopLayer", function ()
    return cc.Node:create()
end)

function UserTopLayer:create(params)
    return UserTopLayer.new(params)
end
function UserTopLayer:ctor(params)
    self:initData()
    self:initUI()
    self:setPopInfo(params.sceneName or "")
end
function UserTopLayer:onCleanup()
    zc.removeEventListener(CUSTOM_EVENT.EVENT_CHANGE_USER_HEAD)
    zc.removeEventListener(CUSTOM_EVENT.EVENT_VIP_CHANGED)
    zc.removeEventListener(CUSTOM_EVENT.EVENT_REFRESH_NAME_MAINCIGY)
end

-- 刷新名字
function UserTopLayer:refreshUserName()
    self._userName:setString(PlayerData.info.userName)
end

-- 初始化数据
function UserTopLayer:initData()
    self._infoConfig = {
        {
            -- 元宝
            id = 1,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeGold,
            src = zc.getImgByType(zc.dataTypeGold),
            addBtn = true,
            twoNum = false,
        },
        {
            -- 银币
            id = 2,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeMoney,
            src = zc.getImgByType(zc.dataTypeMoney),
            addBtn = true,
            twoNum = false,
        },
        {
            -- 声望
            id = 3,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypePrestige,
            src = zc.getImgByType(zc.dataTypePrestige),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 蓝宝石
            id = 4,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeSapphire,
            src = zc.getImgByType(zc.dataTypeSapphire),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 黄宝石
            id = 5,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeTopaz,
            src = zc.getImgByType(zc.dataTypeTopaz),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 紫宝石
            id = 6,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeAmethyst,
            src = zc.getImgByType(zc.dataTypeAmethyst),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 体力
            id = 7,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeEnergy,
            src = zc.getImgByType(zc.dataTypeEnergy),
            addBtn = true,
            twoNum = true,
        },
        {
            -- 税金
            id = 8,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeTax,
            src = zc.getImgByType(zc.dataTypeTax),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 木材
            id = 9,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeWood,
            src = zc.getImgByType(zc.dataTypeWood),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 矿石
            id = 10,
            itemType = zc.mainTypeResource,
            itemId = zc.dataMineral,
            src = zc.getImgByType(zc.dataMineral),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 武魂
            id = 11,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeHeroSoul,
            src = zc.getImgByType(zc.dataTypeHeroSoul),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 名将册体力
            id = 12,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeCaptainEnergy,
            src = zc.getImgByType(zc.dataTypeCaptainEnergy),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 战功分
            id = 13,
            itemType = zc.mainTypeResource,
            itemId = zc.dataServicePoints,
            src = zc.getImgByType(zc.dataServicePoints),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 粮食
            id = 14,
            itemType = zc.mainTypeResource,
            itemId = zc.dataTypeGrain,
            src = zc.getImgByType(zc.dataTypeGrain),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 突飞卡
            id = 15,
            itemType = zc.mainTypeProp,
            itemId = 1001,
            src = "res/Main/bag/gem/1.png",
            addBtn = false,
            twoNum = false,
            itemScale = 0.35,
        },
        {
            -- 升星石
            id = 16,
            itemType = zc.mainTypeProp,
            itemId = 139,
            src = "res/Main/bag/gem/139.png",
            addBtn = false,
            twoNum = false,
            itemScale = 0.35,
        },
        {
            -- 鉴定卷轴绿
            id = 17,
            itemType = zc.mainTypeProp,
            itemId = 425,
            src = "res/Main/bag/gem/25.png",
            addBtn = false,
            twoNum = false,
            itemScale = 0.35,
        },
        {
            -- 鉴定卷轴蓝
            id = 18,
            itemType = zc.mainTypeProp,
            itemId = 426,
            src = "res/Main/bag/gem/26.png",
            addBtn = false,
            twoNum = false,
            itemScale = 0.35,
        },
        {
            -- 鉴定卷轴紫
            id = 19,
            itemType = zc.mainTypeProp,
            itemId = zc.cardExtractPopId,
            src = zc.cardExtractPopSmallImg,
            addBtn = false,
            twoNum = false,
        },
        {
            -- 特训积分
            id = 20,
            itemType = zc.mainTypeResource,
            itemId = zc.dataSpecialPoint,
            src = zc.getImgByType(zc.dataSpecialPoint),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 突破石
            id = 21,
            itemType = zc.mainTypeResource,
            itemId = zc.dataBreakthroughStone,
            src = zc.getImgByType(zc.dataBreakthroughStone),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 鉴定卷轴紫碎片
            id = 22,
            itemType = zc.mainTypeProp,
            itemId = zc.cardExtractPopFragmentId,
            src = zc.cardExtractPopFragmentSmallImg,
            addBtn = false,
            twoNum = false,
        },
        {
            -- 挑战令
            id = 23,
            itemType = zc.mainTypeResource,
            itemId = zc.dataWeaponTollgateTimes,
            src = zc.getImgByType(zc.dataWeaponTollgateTimes),
            addBtn = true,
            twoNum = true,
        },
        {
            -- 挑战令
            id = 24,
            itemType = zc.mainTypeResource,
            itemId = zc.dataArenaRankPoint,
            src = zc.getImgByType(zc.dataArenaRankPoint),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 招财猫
            id = 25,
            itemType = zc.mainTypeProp,
            itemId = 654,
            src = "res/Main/bag/gem/143.png",
            itemScale = 0.35,
        },
        {
            -- 招财猫
            id = 26,
            itemType = zc.mainTypeResource,
            itemId = zc.dataLightSoul,
            src = zc.getImgByType(zc.dataLightSoul),
            addBtn = false,
            twoNum = false,
        },
        {
            -- 猜拳币
            id = 27,
            itemType = zc.mainTypeResource,
            itemId = zc.dataLightSoul,
            src = "res/Main/common/common_icon_caiqaun.png",
            addBtn = false,
            twoNum = false,
        },
        {
            -- 猜拳币
            id = 28,
            itemType = zc.mainTypeResource,
            itemId = zc.dataLightSoul,
            src = "res/Main/morra/caiquanjifen.png",
            addBtn = false,
            twoNum = false,
        },
    }
    --showHead是否显示头像  showGoods显示内容
    self._showConfig = {
        ["bag"]               = {showHead = false, showGoods = {10,7,2,1}, showBack = true},--背包
        ["Buzhen"]            = {showHead = false, showGoods = {1}, showBack = true},--布阵
        ["Country"]           = {showHead = false, showGoods = {9, 10, 8, 1}, showBack = true},--国家
        ["CountryShop"]       = {showHead = false, showGoods = {2, 8, 1 }, showBack = true},--国家
        ["GeneralManualLayer"]   = {showHead = false, showGoods = {8, 13}, showBack = true,showAdd={8, 13}},--酒馆
        ["mainCity"]          = {showHead = true, showGoods = {9, 10, 7, 2, 1}, showBack = false},--主城
        ["heroList"]          = {showHead = false, showGoods = {7, 2, 1}, showBack = true },--英雄列表
        ["Smithy"]            = {showHead = false, showGoods = {10, 2, 1}, showBack = true},--铁匠铺
        ["SmithyBook"]        = {showHead = false, showGoods = {10, 7,2, 1}, showBack = true},--兵器铺
        ["SmithyCasting"]     = {showHead = false, showGoods = {10, 2, 1}, showBack = true},--兵器强化
        ["SmithyMake"]        = {showHead = false, showGoods = {10,7, 2, 1}, showBack = true},--兵器打造
        ["SmithyGodWeapon"]   = {showHead = false, showGoods = {10,7, 2, 1}, showBack = true},--铁匠铺 神兵
        ["WeaponClear"]       = {showHead = false, showGoods = {2, 1}, showBack = true},--铁匠铺 洗练
        ["DrillFieldLayer"]   = {showHead = false, showGoods = {15, 2, 1}, showBack = true, showAdd={15}},--校场
        ["TradeLayer"]        = {showHead = false, showGoods = {4, 5, 6, 2, 1}, showBack = true},--铜雀台
        ["InheritanceTower"]  = {showHead = false, showGoods = {7, 2, 1}, showBack = true},--传承塔
        ["tollgate"]          = {showHead = false, showGoods = {7, 2, 1}, showBack = true},--副本
        ["EnemyInfo"]         = {showHead = false, showGoods = {7, 2, 1}, showBack = true},--副本
        -- ["Talent"]            = {showHead = false, showGoods = {4, 5, 6, 1}, showBack = true, showDif = 170},--命格
        ["Talent"]            = {showHead = false, showGoods = {15, 1}, showBack = true, showDif = 170, showAdd={15}},--命格
        ["WushenTower"]       = {showHead = false, showGoods = {2, 1}, showBack = true},--武神塔 
        ["QunXiongMain"]      = {showHead = false, showGoods = {11, 2, 1}, showBack = true},--研究院群雄
        ["BingFaMain"]        = {showHead = false, showGoods = {11, 2}, showBack = true},--研究院兵法
        ["ArenaMain"]         = {showHead = false, showGoods = {13, 2, 1}, showBack = true},--演武榜 
        ["RoleAttributeLayer"]   = {showHead = false, showGoods = {7, 2, 1}, showBack = true, showAdd={7,2,1}},--武将总览
        ["RoleStarupLayer"]   = {showHead = false, showGoods = {7,16, 2, 1}, showBack = true, showAdd={7,16,2,1}},--武将升星
        ["RoleCultureLayer"]  = {showHead = false, showGoods = {2, 1}, showBack = true},--武将培养
        ["RoleFetterLayer"]   = {showHead = false, showGoods = {7, 2, 1}, showBack = true },--武将羁绊
        ["trinketReplaceAttr"] = {showHead = false, showGoods = {2, 1}, showBack = true},--饰品洗炼
        -- ["Wharf"]             = {showHead = false, showGoods = {9, 10, 2, 1}, showBack = true},--通商
        -- ["HouseShopLayer"]    = {showHead = false, showGoods = {7, 9, 10, 2, 1}, showBack = true},--商店
        ["HouseShopLayer"]    = {showHead = false, showGoods = {4, 5, 6, 15}, showBack = true},--商店
        ["ArenaShopLayer"]    = {showHead = false, showGoods = {9,10,13, 16, 2}, showBack = true, showAdd={}},--军功商店
        ["ExpCardShopLayer"]  = {showHead = false, showGoods = {4, 5, 6, 15}, showBack = true},--突飞卡商店
        ["TimeLimitShopLayer"]  = {showHead = false, showGoods = {15,16,21, 1}, showBack = true},--限时商店
        ["WorldBossLayer"]    = {showHead = false, showGoods = {2, 1}, showBack = true, showDif = 315},-- 世界boss
        ["TenEvenPumpLayer"]  = {showHead = false, showGoods = {2, 17, 18, 19, 1}, showBack = true},-- 十连抽
        ["TenEvenPumpResultPop"] = {showHead = false, showGoods = {2, 17, 18, 19, 1}, showBack = true},-- 十连抽结果
        ["houseDetail"]       = {showHead = false, showGoods = {9, 10, 2, 1}, showBack = true},-- 劫镖弹窗
        ["farm"]              = {showHead = false, showGoods = {9, 10, 2, 1}, showBack = true},-- 劫镖弹窗
        ["WeaponCopyLayer"] = {showHead = false, showGoods = {23, 1}, showBack = true },-- 兵器副本
        ["CountryDartGetPop"] = {showHead = false, showGoods = {1}, showBack = true},-- 接镖弹窗
        ["CountryDartHelpPop"] = {showHead = false, showGoods = {1}, showBack = true},-- 押镖帮助弹窗
        ["CountryDartRobPop"] = {showHead = false, showGoods = {1}, showBack = true, showDif = 280},-- 劫镖弹窗
        ["SmithyPracticeLayer"] = {showHead = false, showGoods = {9,10,2,1}, showBack = true},--武器熟练度 
        ["RoleEquipPop"] = {showHead = false, showGoods = {7,2,1}, showBack = true },-- 装备弹窗
        ["RoleTrinket"] = {showHead = false, showGoods = {2,1}, showBack = true },-- 装备弹窗
        ["WushenshilianLayer"] = {showHead = false, showGoods = {1}, showBack = true, showDif = 280},-- 武神试练
        ["Levy"] = {showHead = false, showGoods = {9,10,2, 1}, showBack = true},-- 武神试练
        ["RechargePop"]   = {showHead = false, showGoods = {2, 1}, showBack = true},--充值
        ["ActivityPop"]   = {showHead = false, showGoods = {7, 2, 1}, showBack = true, showAdd={} },--活动
        ["DrillFieldHeroListLayer"] = {showHead = false, showGoods = {7, 2, 1}, showBack = true},--校场
        ["TollgateHeroChapter"] = {showHead = false, showGoods = {16, 7, 2, 1}, showBack = true},--校场
        ["RoleGemLayer"] = {showHead = false, showGoods = {7, 2, 1}, showBack = true},--宝石
        ["GemShopLayer"] = {showHead = false, showGoods = {7, 2, 1}, showBack = true, showAdd={1}},--宝石商店
        ["LimitChallengeCopy"] = {showHead = false, showGoods = {20}, showBack = true},--特训副本
        ["RoleFettersRegionalMap"] = {showHead = false, showGoods = {21}, showBack = true},--特训副本
        ["GrabMineMapFirstLayer"] = {showHead = false, showGoods = { 2 }, showBack = true},--抢矿一界面
        ["GrabMineMapSecondLayer"] = {showHead = false, showGoods = {7, 2, 1}, showBack = true},--抢矿二界面
        ["WeaponCast"] = {showHead = false, showGoods = {10, 1}, showBack = true},--特训副本
        ["RoleBreakthrough"] = {showHead = false, showGoods = {21, 2, 1}, showBack = true},--突破
        ["CardExtract"] = {showHead = false, showGoods = {24, 19, 22, 1}, showBack = true, showAdd={19,22,1}},--抽卡
        ["WeaponCopyListLayer"] = {showHead = false, showGoods = {23, 1}, showBack = true},--兵器副本
        ["GodFightList"] = {showHead = false, showGoods = {24, 1}, showBack = true},--武神榜
        ["GrabFoodMain"] = {showHead = false, showGoods = {2, 1}, showBack = true},--武神榜
        ["ActivityExchange"] = {showHead = false, showGoods = {25, 2, 1}, showBack = true},--武神榜
        ["HeroSoulRand"] = {showHead = false, showGoods = {26, 2, 1}, showBack = true},--猎魂界面
        ["HeroSoulShop"] = {showHead = false, showGoods = {26, 2, 1}, showBack = true},--将魂商店界面
        ["ZhanFaLayer"] = {showHead = false, showGoods = {21, 2, 1}, showBack = true}, --战法主界面       
        ["HeroCopyPop"] = {showHead = false, showGoods = {7, 2, 1}, showBack = true}, --英雄试炼
        ["MakePop"] = {showHead = false, showGoods = { 2, 1}, showBack = true}, --打造
        -- ["HeroCopyDetailPop"] = {showHead = false, showGoods = {}, showBack = true} --英雄试炼二级界面
        ["LimitTimeHot"] = {showHead = false, showGoods = {7, 2, 1}, showBack = true}, --限时热点界面
        ["PrestigeShopLayer"] = {showHead = false, showGoods = {15,3,21, 1}, showBack = true},-- 声望商店
        ["MainCityTargetLayer"] = {showHead = false, showGoods = {9, 10, 2, 1}, showBack = true},-- 目标活动
        ["MorraLayer"] = {showHead = false, showGoods = {28,27,1}, showBack = true},-- 猜拳活动
    }
    self._sceneName = ""
end
-- 初始化UI
function UserTopLayer:initUI()
	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -----------------------------------------------------------------------------------------------------------头像
    -- 英雄头像
    local head = zc.createSpriteWithFrameName("headDi.png")
    head:setPosition(cc.p(60, zc.height - 60))
    self:addChild(head)
    self._head = head

    print("-----------log--------ad------------- width ", head:getContentSize().width, head:getContentSize().height )

    local headIcon = zc.createPlayerHead({
        iconId = PlayerData.info.iconId,
        needSwallow = true,
        isNew = true,
        callback = function()
            --查看信息界面
            zc.createSettingPop()
        end
    })
    headIcon:setPosition(head:getContentSize().width/2, head:getContentSize().height/2 + 5)
    head:addChild(headIcon)

    --战斗力 
    local powerbg = zc.getSprite({
        src = "zhanliDi.png",
        plist = true,
        ap = cc.p(0, 0),
        pos = cc.p(55, 14)
    })
    head:addChild(powerbg, -1)
    local name = zc.createLabel({
        text = PlayerData.info.userName,
        fontSize = 22,
        color = display.COLOR_WHITE,
        outLine = true,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(130, 60),
    })
    powerbg:addChild(name)
    self._userName = name
    local power = zc.getSprite({
        src = "zhanli.png",
        plist = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(90, 40)
    })
    head:addChild(power)
    local powerNum = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight_change.fnt",
        text = PlayerData.info.fighting,
        ap = cc.p(0, 0.5),
        pos = cc.p(power:getPositionX() + power:getContentSize().width - 10, power:getPositionY()),
        addwidth = -14,
    })
    head:addChild(powerNum)
    self._numScale = 0.6
    powerNum:setScale(self._numScale)
    self._powerNum = powerNum
    local _totleWidth = powerNum:getBoundingBox().width + power:getContentSize().width - 10
    local _startX = 165 - _totleWidth*0.5
    power:setPositionX(_startX)
    powerNum:setPositionX(_startX + power:getContentSize().width - 10)
    local levelbg = zc.getSprite({
        src = "levelDi.png",
        plist = true,
        pos = cc.p(15, 35),
    }) 
    head:addChild(levelbg)
    local level =  zc.createLabel({
        text = PlayerData.info.level,
        fontSize = 18,
        ttf = zc.getFont(1),
        color = display.COLOR_WHITE,
        stroke = true,
        pixel = 2,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(levelbg:getContentSize().width/2, levelbg:getContentSize().height/2),
    })
    levelbg:addChild(level)
    self._level = level


    local vipBg = zc.createPushButton({
        normalFile = "vipDiNew.png",
        plist = true,
        pos = cc.p(55, 11),
        touchScale = 0.9,
        needSwallow = true,
        endCallback = function ()
            zc.createVipPop()
        end
    }) 
    head:addChild(vipBg)
    self._vipBg = vipBg
    local vipSp = zc.getSprite({
        src = (APP_REVIEW and "res/Main/setting/vip_review.png" or "vip.png"),
        plist = (not APP_REVIEW),
        scale = 0.8,
        ap = cc.p(0, 0.5),
        pos = cc.p(15, 12),
    })
    vipBg:addChild(vipSp)
    local vipNum = zc.createFntLabel({
        fnt = "res/Main/common/fnt/mainVip.fnt",
        text = PlayerData.info.vip,
        ap = cc.p(0, 0.5),
        pos = cc.p(vipSp:getContentSize().width + 3, 4),
        addwidth = -5,
    })
    vipBg:addChild(vipNum)
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_VIP_CHANGED,
        callback = function()
            local _newVip = PlayerData:getBaseInfoByTag("vip")
            vipNum:setString(_newVip)
        end
    })

    -- 变强
    local _icon = zc.createPushButton({
        normalFile = "bianqiang.png",
        plist = true,
        btnEff = zc.effect.btnOpen,
        touchScale = 0.9,
        pos = cc.p(265, 40),
        endCallback = function()
            zc.createStrongerLayer()
        end,
    })
    head:addChild(_icon)

    -------
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_CHANGE_USER_HEAD ,
        callback = function()
            if headIcon and headIcon:getStateNormal() then
                local _normal = headIcon:getStateNormal()
                local headImg = _normal:getChildByName("headSprite")
                if headImg then
                    local _head,_body,_list,_headId = PlayerData:getMainRoleHeadImg()
                    local _iconPath = "res/Main/hero/head/hero_head_new".._headId..".png"
                    if not zc.checkFileExist(_iconPath) then
                        _iconPath = "res/Main/hero/head/hero_head_new101.png"
                    end
                    headImg:setTexture(_iconPath)
                end
            end
        end
    })
    -- 刷新名字
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_REFRESH_NAME_MAINCIGY,
        callback = function()
            self:refreshUserName()
        end
    })
    -- 经验条
    self._expBarHeight = 5
    local expBarBg = zc.getScaleNode("expBg.png", cc.size(zc.width, self._expBarHeight), true)
    expBarBg:setAnchorPoint(0, 0)
    self:addChild(expBarBg, -1)
    self._expDi = expBarBg
    for i=1,10 do
        local _sp = zc.getSprite({
            src = "expPart.png",
            plist = true,
            ap = cc.p(0.5, 1),
            pos = cc.p(zc.width/11*i, self._expBarHeight),
        })
        expBarBg:addChild(_sp, 1)
    end
    local expBar = zc.getScaleNode("expbar.png", cc.size(zc.width, self._expBarHeight), true)
    expBar:setAnchorPoint(0, 0)
    expBarBg:addChild(expBar)
    local expBl = tonumber(PlayerData.info.exp)/tonumber(PlayerData.info.expLimit)
    if expBl >= 1 then 
        expBl = 1
    end
    expBar:setContentSize(cc.size(expBl*zc.width, self._expBarHeight))
    self._expBar = expBar
    

    ---------------------------------------------------------------------------------------------------------元宝银币
    self._goodsItem = {}
    for i=1,5 do
        self._goodsItem[i] = {}
	    local itemBg  = zc.createPushButton({
	    	normalNode = zc.createSpriteWithFrameName("resBar.png"),
	    	pos = cc.p(0, zc.height - 30),
            touchScale = 0.95,
            endCallback = function() end,
	    })
	    self:addChild(itemBg)
        self._goodsItem[i]._itemBg = itemBg
	    local itemImg = zc.createImageView({
	    	src = "res/Main/common/common_icon_gold.png",
	    	pos = cc.p(25, itemBg:getContentSize().height*0.5)
	    }) 
	    itemBg:addChild(itemImg)
        self._goodsItem[i]._itemImg = itemImg
	    -- 元宝 银币 体力 数值
    	local itemLabel = zc.createLabel({
	        text = "100/",
	        fontSize = 20,
	        ttf = zc.getFont(1),
	        color = display.COLOR_WHITE,
	        outLine = true,
	        ap = cc.p(0.5, 0.5),
	        pos = cc.p(0, itemBg:getContentSize().height*0.5),
	    })
	    itemBg:addChild(itemLabel)
        self._goodsItem[i]._itemLabel = itemLabel

	    local itemBtn = zc.getSprite({
            src = "plus.png",
            plist = true,
            pos = cc.p(40, itemBg:getContentSize().height*0.5 - 7),
	    })
	    itemBg:addChild(itemBtn)
        self._goodsItem[i]._itemBtn = itemBtn
    end
end
-- 设置显示
function UserTopLayer:setPopInfo(sceneName)
    print("==========================sceneName=",sceneName)
    -- 数据
    if sceneName == "mainCity" then
        local _mainCity = zc.getScene("mainCity")
        if _mainCity and _mainCity._farm and _mainCity._farm:isFarmShow() then
            sceneName = "farm"
        end
    end
    self._sceneName = sceneName
    local config = self._showConfig[sceneName]
    local showUsertop = false
    local showHead = false
    local showAdd = {}
    local beginX = 110
    self._goods = {}
    showAddBtn = {}
    if config then
        local _flag = false --"+"按钮默认显示(如果物资本身有显示"+"的属性)
        if config.showAdd then --如果需要特定显示"+"，则根据配置来,showAdd配显示哪个就显示哪个，不配就不显示
            _flag = true
        end
        showHead = config.showHead
        showUsertop = true
        showGoods = config.showGoods
        if _flag then
            for i, v in ipairs( config.showAdd or {} ) do
                showAdd[v] = true
            end
        else
            for i, v in ipairs(showGoods) do
                if self._infoConfig[v].addBtn then
                    showAdd[v] = true
                end
            end
        end
        --设置显示内容
        for i, v in ipairs( showGoods ) do
            local _index = #self._goods + 1
            self._goods[_index] = self._infoConfig[v]
            showAddBtn[_index] = showAdd[v]
            if sceneName == "Levy" and (v == 2 or v == 1)then
                showAddBtn[_index] = false
            elseif sceneName == "RechargePop" and (v == 2 or v == 1) then
                showAddBtn[_index] = false
            end
        end
        if config.showDif then
            beginX = config.showDif
        elseif config.showBack then
            beginX = 235
        end
    end
    -- 设置
    self:setVisible(showUsertop)
    self._head:setVisible(showHead)
    if sceneName == "farm" then
        self._expDi:setVisible(true)
    else
        self._expDi:setVisible(showHead)
    end
    -- 设置物资的位置
    for i, v in ipairs( self._goodsItem ) do
        if self._goods[i] then
            -- 设置位置
            v._itemBg:setPositionX( zc.width - beginX - ( #self._goods - i )*155 )
            v._itemBg:setVisible(true)
            v._itemImg:loadTexture(self._goods[i].src)
            v._itemImg:setScale(self._goods[i].itemScale or 1)
            -- 增加按钮
            local btnWidth = 0
            if showAddBtn[i] then --如果需要显示按钮，并且物资本身有显示按钮的特性
                v._itemBtn:setVisible(true)
                v._itemBg:setEnable(true)
                v._itemBg:setTouchEndedCall(function()
                    self:buyCallback( self._goods[i] )
                end)
                btnWidth = -10
                if self._goods[i].id == 22 then
                    v._itemBtn:setTexture("res/Main/common/hecheng.png")
                else
                    cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
                    v._itemBtn:setSpriteFrame("plus.png")
                end
            else
                v._itemBtn:setVisible(false)
                v._itemBg:setEnable(false)
            end
            -- 数量
            if self._goods[i].id == 15 then
                -- 突飞卡
                self._goods[i]._num = zc.getBagNumByType( 1, 1001 )
            elseif self._goods[i].id == 27 then
                -- 猜拳币
                self._goods[i]._num = zc.getNumByTypeId( 4, 674)
            elseif self._goods[i].id == 28 then
                -- 猜拳积分
                self._goods[i]._num = PlayerData.intergral
            else
                self._goods[i]._num = zc.getNumByTypeId( self._goods[i].itemType, self._goods[i].itemId )
            end
            if self._goods[i].twoNum then 
                if self._goods[i].id == 7 then 
                    --体力
                    v._itemLabel:setText( zc.getWan( self._goods[i]._num ).."/"..PlayerData.resourcesInfo.energyLimit )
                    v._itemLabel:setPositionX( v._itemBg:getContentSize().width/2 + 8 + btnWidth )
                elseif self._goods[i].id == 23 then
                    local _houerData = PlayerData:getHouseInfoByHouseId(15) or {}
                    local _dbData = gameData.getDataFromCache("house_level", {houseId = 15, level = _houerData.level})
                    local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_arenaTower", _dbData.effectId)
                    local _limit = tonumber(_effectDb.storeLimit) or 12 -- PlayerData.resourcesInfo.energyLimit
                    v._itemLabel:setText( zc.getWan( self._goods[i]._num ).."/".. _limit)
                    v._itemLabel:setPositionX( v._itemBg:getContentSize().width/2 + 8 + btnWidth )
                end
            else
                v._itemLabel:setPositionX( v._itemBg:getContentSize().width/2 + btnWidth + 5 )
                v._itemLabel:setText( zc.getWan( self._goods[i]._num ) )
            end
        else
            v._itemBg:setVisible(false)
            v._itemBg:setEnable(false)
        end
    end
end
-- 点击购买回调
function UserTopLayer:buyCallback( data )
    if data.id == 1 then
        -- 元宝
        zc.createRechargePop()
    elseif data.id == 2 then
        -- 银币
        zc.createLevy()
    elseif data.id == 4 then
        -- 蓝宝石
        if self._sceneName == "Pub" then
            zc.createTradeLayer(function()
                LayerManager.removeLayout()
            end)
        else
            zc.createTradeLayer()
        end
    elseif data.id == 5 then
        -- 黄宝石
        if self._sceneName == "Pub" then
            zc.createTradeLayer(function()
                LayerManager.removeLayout()
            end)
        else
            zc.createTradeLayer()
        end
    elseif data.id == 6 then
        -- 紫宝石
        if self._sceneName == "Pub" then
            zc.createTradeLayer(function()
                LayerManager.removeLayout()
            end)
        else
            zc.createTradeLayer()
        end
    elseif data.id == 7 then
        -- 体力
        zc.createBuyEnergyPop({type = zc.dataTypeEnergy})
    elseif data.id == 8 then
        -- 国家税金
        if self._sceneName == "GeneralManualLayer" then --如果是在图鉴界面，跳转到国家
            if zc.getFunctionStatus(24, true) then
                zc.createCountryScene({showList=false})
            end
        end
    elseif data.id == 13 then
        -- 战功分
        if self._sceneName == "GeneralManualLayer" then  --如果是在图鉴界面，跳转到演武榜
            if zc.getFunctionStatus(22, true) then
                zc.createArenaScene()
            end
        end
    elseif data.id == 15 then
        -- 突飞卡
        zc.createExpCardShopLayer()
    elseif data.id == 16 then
        -- 升星石
        zc.createArenaShopLayer()
    elseif data.id == 19 then
        -- 抽奖卷
        local _idx = 1
        local _db = gameData.getDataFromCacheWithPrimaryKey("hero_handbook_card", _idx)
        zc.createSourcePop("CardExtractBuyPop", "src/layer/pub/CardExtractBuyPop.lua", {
            id = data.itemId,
            idx = _idx,
            cost = _db.price,
        })
    elseif data.id == 22 then
        zc.createWeaponSynthesisPop({
            isBagItem = true,
            itemType = 4,
            itemId = zc.cardExtractPopFragmentId,
        })
    elseif data.id == 23 then
        -- 挑战令牌
        zc.createBuyEnergyPop({type = zc.dataWeaponTollgateTimes})
    end
end
-- 获取item位置
function UserTopLayer:getItemPos(itemType, itemId)
    for i, v in ipairs( self._goods ) do
        if v.itemType == itemType and v.itemId == itemId then
            local itemImg = self._goodsItem[i]._itemImg

            return itemImg:convertToWorldSpace(cc.p( 0, itemImg:getContentSize().height/2 )), itemImg
        end
    end
    return cc.p(0, 0) 
end

function UserTopLayer:onEnter()
	print("UserTopLayer..onEnter")
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_BASEINFOCHANGE,
        callback = function()
            self:dataChange()
        end
    })
end
function UserTopLayer:onExit()
    print("UserTopLayer..onExit")
	zc.removeEventListener(CUSTOM_EVENT.EVENT_BASEINFOCHANGE)
end
--数据变化的回调方法
function UserTopLayer:dataChange()
    print("资源条信息变化")
    if self._goods and #self._goods > 0 then
        for i, v in ipairs( self._goods ) do
            local curNum = 0
            if v.id == 15 then
                -- 突飞卡
                curNum = zc.getBagNumByType( 1, 1001 )
            elseif v.id == 27 then
                curNum = zc.getNumByTypeId( 4, 674)
            elseif v.id == 28 then
                curNum = PlayerData.intergral
            else
                curNum = zc.getNumByTypeId( self._goods[i].itemType, self._goods[i].itemId )
            end
            if curNum ~= self._goods[i]._num then
                if v.id == 7 then
                    zc.setLabelTTFColor( self._goodsItem[i]._itemLabel, zc.getWan( curNum ).."/"..PlayerData.resourcesInfo.energyLimit )
                elseif v.id == 23 then
                    local _houerData = PlayerData:getHouseInfoByHouseId(15) or {}
                    local _dbData = gameData.getDataFromCache("house_level", {houseId = 15, level = _houerData.level})
                    local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_arenaTower", _dbData.effectId)
                    local _limit = tonumber(_effectDb.storeLimit) or 12 -- PlayerData.resourcesInfo.energyLimit
                    zc.setLabelTTFColor( self._goodsItem[i]._itemLabel, zc.getWan( curNum ).."/".. _limit )
                else
                    zc.setLabelTTFColor( self._goodsItem[i]._itemLabel, zc.getWan( curNum ) )
                end
            end
            self._goods[i]._num = curNum
        end
    end
    --经验
    local expBl = tonumber(PlayerData.info.exp)/tonumber(PlayerData.info.expLimit)
    if self._expBar then
        self._expBar:setContentSize(cc.size(expBl*zc.width, self._expBarHeight))--经验

        --战斗力
        local oriFight = tonumber( self._powerNum:getString() or 0 ) or 0
        local dstFight = tonumber( PlayerData.info.fighting or 0 )
        if dstFight ~= 0 and oriFight ~= dstFight then
            self._powerNum:setScale(self._numScale)
            zc.numChangeAnimation({
                label = self._powerNum,
                pos = cc.p( self._powerNum:getContentSize().width/2, 20 ),
                callback = function()
                    self._powerNum:setString( dstFight )
                end
            })
        end
        
        self._level:setText(PlayerData.info.level)--等级
    end
end

--新手引导处理VIP按钮
function UserTopLayer:setVipNodeVisible(_flag)
    self._vipBg:setVisible(_flag)
end
return UserTopLayer