--[[
    打造
]]

local MakePop = class("MakePop", function()
    return zc.createNormalDialog({showFlower = false, yunTag = 2, yunOffY = {0, -60}, yunZorder = {4,4}, showYun = true})
end)


function MakePop:create( params )
    return MakePop.new( params )
end

function MakePop:onEnter( ... )
    
end

function MakePop:refreshMainCityBubble()
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "house", id = 11}})
end

function MakePop:guideFunc()
    local _currentGID = getGuideManager():getCurrentGID()
    if not PlayerData:getFuncGuideInfo(391) or _currentGID == GuideKey.KEY_14904 then
        if not PlayerData:getFuncGuideInfo(391) then
            getGuideManager():sendFuncGuideTrigger(391)
        end
        zc.setGuideFuncNextStep(GuideKey.KEY_14904)
        local function _callBack()
            getGuideManager():setObjTarget(self.guideBtn1)
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end
end

function MakePop:ctor( params )
	self:initData(params)
    self._tabIndex = 1
	self:initUI()
    self._tabBtn[1]:setSelected( true )
    self._tabBtn[2]:setSelected( false )

    if tonumber(self.serverData.type) == 1 then
        self.startCD = false
    end

    self:updateUI()
    self:guideFunc()
end

function MakePop:initData(params)
    print("data..........")
    dump(params)
    self._tabInfo = {
        [1] = {
            -- 进阶材料
            name = zc.lang("Make_breakItem"),
            openTag = 34,
            index = 1,
        },
        [2] = {
            -- 升星材料
            name = zc.lang("Make_starItem"),
            openTag = 14,
            index = 2,
        },
    }
    -- dump(data)

    self.serverData = params.data

    self._checkIndex = 0
    
    self:updateData()
end

function MakePop:updateData()

    self.itemStatic = gameData.getDataFromCache("produce_table_awards")
    -- print("PlayerData:getTssTime(): " .. PlayerData:getTssTime())
    -- print("tonumber(self.serverData.flushTime): " .. tonumber(self.serverData.flushTime))
    self.flushTime = tonumber(self.serverData.flushTime) - tonumber(PlayerData:getTssTime())

    -- print("self.flushTime:" .. self.flushTime)

    if self.serverData.produceEndTime then
        self.finishedTime = tonumber(self.serverData.produceEndTime) - tonumber(PlayerData:getTssTime())
    end
end

--获得解锁信息
function MakePop:getPoslockInfo(idx)
    local staticInfo = gameData.getDataFromCache("houseEffect_smith")
    local tb = {}
    for k,v in pairs(staticInfo) do
        if tonumber(v.productionSlot) == idx then
            table.insert(tb, tonumber(k))
        end
    end

    table.sort( tb, function(a,b) return a < b end)

    return tb[1]
end

--获取附加产量的个数
function MakePop:getAddCount()
    local staticInfo = gameData.getDataFromCache("houseEffect_smith")
    local houseInfo = PlayerData:getHouseInfoByHouseId( 11 )
    local level = tonumber(houseInfo.level)

    if self.serverData.attachNum then
        return tonumber(self.serverData.attachNum)
    end
    local num = self._checkIndex*self:getBaseMakeNum() + tonumber(staticInfo[tostring(level)].produceAdded) + self:getBaseAddNum()
    return num
end

--获得购买次数价格
function MakePop:getBuyPrice()
   local allCount = 0
    for k,v in pairs(gameData.getDataFromCache("consume_price")) do
        if tonumber(v.type) == 65 then
            allCount = allCount + 1
        end
    end

    if allCount <= tonumber(self.serverData.buyProduceNum) + 1 then
        local info = gameData.getDataFromCache("consume_price", {type = 65, subtype = allCount})
        return info.price
    else
        local info = gameData.getDataFromCache("consume_price", {type = 65, subtype = (tonumber(self.serverData.buyProduceNum) + 1)})
        return info.price
    end
end

--获得刷新价格
function MakePop:getFlushPrice()
    local allCount = 0

    -- print("self.serverData.buyFlushNum" .. self.serverData.buyFlushNum)


    for k,v in pairs(gameData.getDataFromCache("consume_price")) do
        if tonumber(v.type) == 64 then
            allCount = allCount + 1
        end
    end

    if allCount <= tonumber(self.serverData.buyFlushNum) + 1 then
        local info = gameData.getDataFromCache("consume_price", {type = 64, subtype = allCount})
        return info.price
    else
        local info = gameData.getDataFromCache("consume_price", {type = 64, subtype = (tonumber(self.serverData.buyFlushNum) + 1)})
        return info.price
    end
end

--获得解锁的个数
function MakePop:getUnlockPos()
    return tonumber(self.serverData.openSolt)
end

--获取材料信息
function MakePop:getItemInfoById(id)
    for k,v in pairs(self.itemStatic) do
        if tonumber(id) == tonumber(v.id) then
            return v
        end
    end
end

--是否能选择这个材料
function MakePop:isCanClickRightIcon(id)
    for k,v in pairs(self.serverData.selectMaterial) do
        if v ~= "" and tonumber(v) == tonumber(id) then
            return false
        end
    end

    return true
end

--是否能点击开始
function MakePop:canClickStar()
    local flag = false
    for k,v in pairs(self.serverData.selectMaterial) do
        if v ~= "" then
            flag = true
        end
    end

    return flag
end

--刷新倒计时
function MakePop:refreshTime()
    self.makingLabel:setVisible(tonumber(self.serverData.type) ~= 0)

    self.freeLabel:setVisible(tonumber(self.serverData.type) == 0)
    self.refreshTimeLabel:setVisible(tonumber(self.serverData.type) == 0)
    if tonumber(self.serverData.type) == 0 then
        if not self.refreshTimer then
            self.refreshTimer = scheduler.scheduleGlobal(function()
                self.flushTime = self.flushTime - 1
                if self.flushTime >= 0 then
                    local time = zc.getTimeHMS(self.flushTime)
                    self.refreshTimeLabel:setText(time)
                else
                    if self.refreshTimer then
                        scheduler.unscheduleGlobal( self.refreshTimer )
                        self.refreshTimer = nil
                        zc.sendHttp({
                            apiName = "Make_Main",
                            params = {type = self._tabIndex},
                            successCallback = function(data)
                            print("refreshTime")
                            dump(data)

                                self:initData({data = data})
                                self:updateUI()
                            end,
                        })
                    end
                end
            end, 1)
        end
    else
        if tonumber(self.serverData.type) == 1 then
            self.makingLabel:setText(zc.lang("Make_making"))
        elseif tonumber(self.serverData.type) == 2 then
            self.makingLabel:setText(zc.lang("Make_canGet"))
        end
        if self.refreshTimer then
            scheduler.unscheduleGlobal( self.refreshTimer )
            self.refreshTimer = nil
        end
    end
end

--  获得打造时间
function MakePop:getAllMakeTime()
    local info = gameData.getDataFromCache("production", {type = self._tabIndex})    
    return tonumber(info.productionTime)
end

-- 获得基础产量
function MakePop:getBaseMakeNum()
    local info = gameData.getDataFromCache("production", {type = self._tabIndex})    
    return tonumber(info.productionBase)
end

-- 获得默认附加产量
function MakePop:getBaseAddNum()
    local info = gameData.getDataFromCache("production", {type = self._tabIndex})    
    return tonumber(info.productionAdded)
end

--生产倒计时
function MakePop:finishTime()
    if tonumber(self.serverData.type) == 1 then
        if not self.finishTimer then
            self.finishTimer = scheduler.scheduleGlobal(function()
                self.finishedTime = self.finishedTime - 1
                if self.finishedTime >= 0 then
                    local time = zc.getTimeHMS(self.finishedTime)
                    self.finishLabel:setText(zc.lang("Make_leftTime") .. time)
                else
                    if self.finishTimer then
                        self.finishLabel:setText(zc.lang("Make_leftTime") .. "00:00:00")
                        scheduler.unscheduleGlobal( self.finishTimer )
                        self.finishTimer = nil
                        zc.sendHttp({
                            apiName = "Make_Main",
                            params = {type = self._tabIndex},
                            successCallback = function(data)
                                print("refreshTime")
                                dump(data)
                                self:initData({data = data})
                                self:updateUI()
                            end,
                        })
                    end
                end
            end, 1)
        end
    else
        self.finishLabel:setText(zc.lang("Make_makeFinish"))
    end
end

-- 处理桌子
function MakePop:updateDesk(flag)
    -- ccp(270, 80)

    local deskImg = self:getChildByName("deskImg")

    local smallHammer = deskImg:getChildByName("smallHammer")
    local oneLabel = smallHammer:getChildByName("oneLabel")
    local smallMoey = deskImg:getChildByName("smallMoey")


    if tonumber(self.serverData.produceNum) == 0 then
        oneLabel:setColor(display.COLOR_RED)
    else
        oneLabel:setColor(display.COLOR_WHITE)
    end

    local showFunc = function() --checkbox  显示
        self._checkBox[1].btn:setVisible( tonumber(self.serverData.type) == 0 )
        self._checkBox[1].check:setVisible( tonumber(self.serverData.type) == 0 and self._checkIndex == 1 )
        self._checkBox[2].btn:setVisible( tonumber(self.serverData.type) == 0 )
        self._checkBox[2].check:setVisible( tonumber(self.serverData.type) == 0 and self._checkIndex == 2 )
        smallHammer:setVisible(tonumber(self.serverData.type) == 0)
        smallMoey:setVisible(tonumber(self.serverData.type) == 0)
    end

    local finishBg = deskImg:getChildByName("finishBg")
    finishBg:setVisible(tonumber(self.serverData.type) ~= 0)

    finishBg:getChildByName("price"):setVisible(tonumber(self.serverData.type) == 1)
    finishBg:getChildByName("img"):setVisible(tonumber(self.serverData.type) == 1)

    if tonumber(self.serverData.type) == 1 and self.finishedTime then 
        local time = zc.getTimeHMS(self.finishedTime)
        self.finishLabel:setText("倒计时: " .. time)
    end

    if flag == 1 then    --走动作 开始打造
        showFunc()
        getGuideManager():addMaskLayer()
        deskImg:runAction(cc.Sequence:create(
            cc.MoveTo:create(0.2, ccp(270, 150)),
            cc.CallFunc:create(function()
                getGuideManager():removeMaskLayer()
            end))
        )
    elseif flag == 2 then    --领取
        getGuideManager():addMaskLayer()
        deskImg:runAction(cc.Sequence:create(
            cc.MoveTo:create(0.2, ccp(270, 80)),
            cc.CallFunc:create(function()
                showFunc()
                getGuideManager():removeMaskLayer()
            end))
        )
    else
        showFunc()
        if tonumber(self.serverData.type) == 0 then
            deskImg:setPosition(ccp(270, 80))
        else
            deskImg:setPosition(ccp(270, 150))
        end
    end

end


function MakePop:initUI()
	local bg = ZCSprite:create("res/Main/dazao/MakingBg.jpg")
    bg:setAnchorPoint(ccp(0.5, 1))
    bg:setPosition(ccp(zc.width/2, zc.height + 100))
    self:addChild(bg)
    local circleBg_config = { ccp(290, 480), ccp(175, 355), ccp(400, 355)}

    self.progressBar = {}


    for i=1,3 do
        local circleBg = ZCSprite:create("res/Main/dazao/itemBg.png")
        circleBg:setName("circleBg" .. i)
        circleBg:setPosition(circleBg_config[i])
        self:addChild(circleBg)

        local countBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
        countBg:setPosition(ccp(circleBg:getContentSize().width/2, 0))
        countBg:setName("countBg")
        countBg:setContentSize(120,30)
        countBg:addChild(zc.createLabel({ text = "", fontSize = 20, pos = ccp(countBg:getContentSize().width/2, countBg:getContentSize().height/2), ap = ccp(0.5, 0.5), name = "countLabel"})) 
        circleBg:addChild(countBg,2)

        local unlockImg = ZCSprite:create("res/Main/dazao/bgRotate.png")
        unlockImg:setPosition(ccp(circleBg:getContentSize().width/2, circleBg:getContentSize().height/2))
        unlockImg:setName("unlockImg")
        circleBg:addChild(unlockImg)

        local info = zc._getIconInfo({
            data = {
                mainType = 1, 
                type = 1,
                id = 1,
                num = 1,
            }, 
        })
        local item = ZCSprite:create( info.img ) 
        item:setScale(0.8)
        item:setName("leftItem")
        item:setTag(i)
        item:setPosition(ccp(circleBg:getContentSize().width/2, circleBg:getContentSize().height/2))
        circleBg:addChild(item)

        local progressBar = cc.ProgressTimer:create(cc.Sprite:create("res/Main/dazao/cd.png"))
        progressBar:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)
        progressBar:setMidpoint(cc.p(0.5, 0.5))
        progressBar:setReverseProgress(true)
        progressBar:setAnchorPoint(cc.p(0.5,0.5))
        progressBar:setPosition(cc.p(circleBg:getContentSize().width/2,circleBg:getContentSize().height/2))
        circleBg:addChild(progressBar)
        self.progressBar[i] = progressBar

        local lockImg = ZCSprite:create("res/Main/dazao/lock.png")

        lockImg:setTouchEndedCallback(function()
            zc.tipInfo(zc.lang("Make_pleaseUplevel"))
            return 
        end)

        lockImg:setName("lockImg")
        lockImg:setPosition(ccp(circleBg:getContentSize().width/2, circleBg:getContentSize().height/2))
        circleBg:addChild(lockImg)
    end

    local deskImg = ZCSprite:create("res/Main/dazao/desk.png")
    deskImg:setName("deskImg")
    deskImg:setPosition(ccp(270, 80))
    self:addChild(deskImg)
    
    local finishBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(170,32) )
    finishBg:setPosition(ccp(deskImg:getContentSize().width/2, deskImg:getContentSize().height/2 + 20))
    finishBg:setName("finishBg")
    deskImg:addChild(finishBg)

    finishBg:addChild(zc.createLabel({name = "finishLabel", fontSize = 18, color = display.COLOR_GOLD, text = "", pos = ccp(85, 16)}))
    self.finishLabel = finishBg:getChildByName("finishLabel")
    local img = zc.getSprite({
            src = zc.getImgByType(zc.dataTypeGold),
            pos = cc.p(70, -30),
        })
    img:setName("img")
    img:setScale(0.8)
    finishBg:addChild(img)
    local priceInfo = gameData.getDataFromCache("consume_price", {type = 66, subtype = 1})
    finishBg:addChild(zc.createLabel({name = "price", text = priceInfo.price, fontSize = 18, pos = ccp(100, -30)}))

    local startBtn = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("Make_startMake"),
        pos = cc.p(270, 70),
        endCallback = function()

            if self._guideHand then
                self._guideHand:removeFromParent()
                self._guideHand = nil
            end

            if tonumber(self.serverData.type) == 0  then
                if not self:canClickStar() then
                    zc.tipInfo(zc.lang("Make_selectItem"))
                    return
                elseif self.serverData.produceNum == 0 then
                    self:buyTimes()
                    return
                end
                zc.sendHttp({
                    apiName = "Make_Start",
                    params = {type = self._tabIndex, attachNum = self._checkIndex},
                    successCallback = function(data)
                    print("Make_Start")
                        -- dump(data)
                        self.startCD = false
                        PlayerData:updataData(data)
                        self.serverData.produceEndTime = data.produceEndTime
                        self.serverData.produceMaterial = data.produceMaterial
                        self.serverData.produceNum = data.produceNum
                        self.serverData.type = data.type
                        self.serverData.attachNum = data.attachNum
                        self:updateData()
                        self:updateUI(1)
                    end,
                })
            else
                local getType = 0
                if tonumber(self.serverData.type) == 1 then
                    getType = 1
                end

                zc.sendHttp({
                    apiName = "Make_GetReward",
                    params = {isImmediately = getType},
                    successCallback = function(data)
                    print("Make_GetReward")
                        zc.createShowReward({
                            clientItems = data.clientItems,
                            clientResources = data.clientResources,
                        })
                        data.noAnimation = true
                        PlayerData:updataData(data)
                        zc.sendHttp({
                            apiName = "Make_Main",
                            params = {type = self._tabIndex},
                            successCallback = function(data)
                                self:initData({data = data})
                                self:updateUI(2)
                            end,
                        })
                    end,
                })
            end
        end
    })
    self.startBtn = startBtn
    self:addChild(startBtn,5)

    self._checkBox = {}
    local choiceConfig = {
        zc.dataTypeGold,
        zc.dataTypeGold,
    }

    for i, v in ipairs( choiceConfig ) do
        -- 训练选择背景
        self._checkBox[i] = {}
        local _size = cc.size(325, 48)
        local _normalNode = zc.getScaleNode("res/Main/common/checkBar_u.png", _size)
        local _selectedNode = zc.getScaleNode("res/Main/common/checkBar_d.png", _size)
        local checkBox = zc.createPushButton({
            normalNode = _normalNode,
            selectedNode = _selectedNode,
            pos = cc.p(deskImg:getContentSize().width/2, 245 - (i-1)*55),
            endCallback = function()

                print("_checkIndex" ..self. _checkIndex)
                if self._checkIndex == 0 then
                    self._checkIndex = i
                    self._checkBox[self._checkIndex].check:setVisible( true )
                elseif self._checkIndex ~= i then
                    self._checkBox[self._checkIndex].check:setVisible( false )
                    self._checkBox[i].check:setVisible( true )
                    self._checkIndex = i
                elseif self._checkIndex == i then
                    self._checkBox[self._checkIndex].check:setVisible( false )
                    self._checkIndex = 0
                end
                self:updateUI()
            end
        })
        deskImg:addChild( checkBox )

        local _check = zc.createSprite("res/Main/common/check.png")
        checkBox:addChild(_check)
        _check:setPosition(26, checkBox:getContentSize().height*0.5)
        _check:setVisible(false)

        self._checkBox[i].btn = checkBox
        self._checkBox[i].check = _check
        local icon = zc.getSprite({
            src = zc.getImgByType(v),
            pos = cc.p(76, checkBox:getContentSize().height*0.5),
        })
        checkBox:addChild(icon)
        local info = gameData.getDataFromCache("consume_price", {type = 63, subtype = i}) 

        local price = zc.createLabel({
            fontSize = 22,
            text = info.price,
            ap = cc.p(0, 0.5),
            pos = cc.p( icon:getPositionX() + 25, checkBox:getContentSize().height*0.5),
            outLine = true,
        })
        checkBox:addChild(price)
        self._checkBox[i].price = price
        checkBox:addChild(zc.createLabel({text = zc.lang("Make_add"), fontSize = 20, color = ccc3(237, 213, 160), pos = ccp(163, checkBox:getContentSize().height*0.5)}))
        checkBox:addChild(zc.createLabel({text = i .. "00%", fontSize = 20, color = display.COLOR_GREEN, pos = ccp(207, checkBox:getContentSize().height*0.5)}))   
        checkBox:addChild(zc.createLabel({text = zc.lang("Make_baseNum"), fontSize = 20, color = ccc3(237, 213, 160), pos = ccp(270, checkBox:getContentSize().height*0.5)}))    
    end
    local smallHammer = zc.createImageView({name = "smallHammer", pos = ccp(deskImg:getContentSize().width/2 - 60, 140), src = "res/Main/dazao/hammer.png", scale = 0.8})
    smallHammer:addChild(zc.createLabel({name = "oneLabel", text = "1", pos = ccp(60, 15), color = display.COLOR_WHITE}))
    deskImg:addChild(smallHammer)

    local smallMoey =  zc.createImageView({name = "smallMoey", pos = ccp(deskImg:getContentSize().width/2 + 10, 140), src = zc.getImgByType(zc.dataTypeMoney), scale = 0.9})
    smallMoey:addChild(zc.createLabel({name = "moneyLabel", fontSize = 22, text = "5000", pos = ccp(63, 20), color = display.COLOR_WHITE}))
    deskImg:addChild(smallMoey)

    self:initTabBoard()
    self:initTabs()
    self:initTopHammer()
end

function MakePop:buyTimes()
    local price = self:getBuyPrice()

    local vipLv = tonumber( PlayerData:getBaseInfoByTag( "vip" ) ) or 0

    local info = gameData.getDataFromCacheWithPrimaryKey("vip", 26)    
    local maxNum = tonumber(info["vip" .. vipLv])
    if tonumber(self.serverData.buyProduceNum) >= maxNum then
        zc.tipInfo(zc.lang("herocopy_countLimit"))
        return 
    end

    local length = string.len(tostring(price)) + 2 

    -- 购买弹窗
    local params = {
        tip = LANGUAGE_DAZAO_BUY( price ),
        special = {
            {
                begin = 5,
                length = length,
                color = display.COLOR_YELLOW,
            }
        },
        consume = {
            [1] = {
                type = 1,
                num = price,
            }
        },
        bottomDes = {
            maxNum = maxNum,
            haveBuyNum = tonumber(self.serverData.buyProduceNum)
        },
        clickHide = true,
        callback = function( data )
            zc.sendHttp({
                apiName = "Make_BuyMakeTimes",
                params = {},
                successCallback = function(data)
                    PlayerData:updataData(data)
                    dump(data)
                    self.serverData.buyProduceNum = data.buyProduceNum
                    self.serverData.produceNum = tonumber(self.serverData.produceNum) + 1
                    self:updateUI()
                end
            })
        end
    }
    zc.createSourcePop( "MakeBuyTimesPop", "src/layer/makeUp/MakeBuyTimesPop.lua", params )
end

--上方锤子
function MakePop:initTopHammer()
    local itemBg  = zc.createPushButton({
        normalNode = zc.createSpriteWithFrameName("resBar.png"),
        pos = cc.p(zc.width/2, zc.height - 30),
        touchScale = 0.95,
        endCallback = function() 

            self:buyTimes()
        end,
    })
    self:addChild(itemBg)
    local itemImg = zc.createImageView({
        src = "res/Main/dazao/hammer.png",
        pos = cc.p(25, itemBg:getContentSize().height*0.5)
    }) 
    itemBg:addChild(itemImg)

    local itemLabel = zc.createLabel({
        text = "0/2",
        fontSize = 20,
        ttf = zc.getFont(1),
        color = display.COLOR_WHITE,
        outLine = true,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(80, itemBg:getContentSize().height*0.5),
    })
    itemBg:addChild(itemLabel)

    self.leftTimeLabel = itemLabel

    local itemBtn = zc.getSprite({
        src = "plus.png",
        plist = true,
        pos = cc.p(40, itemBg:getContentSize().height*0.5 - 7),
    })
    itemBg:addChild(itemBtn)
end

--右侧面板
function MakePop:initTabBoard()
   local right_bg = zc.createNormalPop({
        width = 500,
        height = 500,
        srcTag = 2,
    })

   right_bg:setPosition(ccp(zc.width - 333, zc.height/2))
   self:addChild(right_bg)
   self.rightBg = right_bg

   local _topBg = cc.Sprite:create( "res/Main/role/common/top_bg.jpg" )
    _topBg:setAnchorPoint( 0.5, 1 )
    _topBg:setPosition( cc.p(right_bg:getContentSize().width/2,right_bg:getContentSize().height-5 ) )
    right_bg:addChild( _topBg )
    _topBg:setScaleX( 500/_topBg:getContentSize().width )

    local _descBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/exclamation_u.png",
        selectedFile = "res/Main/common/button/exclamation_d.png",
        pos = cc.p(470, 440),
        endCallback = function()
            zc.createRulePop(17)
        end
    })
    right_bg:addChild(_descBtn,4)

    local nameBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(408,32) )
    nameBg:setPosition(cc.p(_topBg:getContentSize().width/2, _topBg:getContentSize().height/2))
    _topBg:addChild(nameBg)

    right_bg:addChild(zc.createLabel({text = zc.lang("Make_topTitle"), color = ccc3(214, 193, 150), fontSize = 22,pos = cc.p(250, 440)}),2)

    for i=1,6 do
        local itemBg = ZCSprite:create("res/Main/role/fetter/fetterItemBg.png")
        itemBg:setName("itemBg" .. i)

        local configX = i
        if i > 3 then
            configX = i - 3
        end

        itemBg:setPosition(ccp(95 + (configX-1)*155, 335 - (math.floor(i/4)*145)))
        itemBg:setScale(0.95)
        self.rightBg:addChild(itemBg)

        local item = zc.createIconByData({
            data = {
                mainType = 1, 
                type = 1,
                id = 1,
                num = 1,
            }, 
        })  
        item:setScale(0.8)
        item:setName("item")
        item:setTag(i)
        item:setPosition(ccp(itemBg:getContentSize().width/2 - 2, itemBg:getContentSize().height/2 + 3))
        itemBg:addChild(item)

        --新手引导用按钮
        if i == 1 then
            self.guideBtn1 = item
        elseif i == 4 then
            self.guideBtn2 = item
        end

        local itemEffect = zc.createSpine({
            fileName = "jiban",
            actName = "unlock",
            loop = true,
        })
        itemEffect:setScale(1.3)
        itemEffect:setName("itemEffect")
        itemEffect:setPosition(ccp(item:getContentSize().width/2, item:getContentSize().height/2))
        item:addChild(itemEffect)

        local itemNameBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(100,32) )
        itemNameBg:setPosition(cc.p(itemBg:getContentSize().width/2, -15))
        itemNameBg:setName("itemNameBg")
        itemNameBg:addChild(zc.createLabel({text = "",fontSize = 22, name = "itemName", pos = ccp(50, 16)}))
        itemBg:addChild(itemNameBg)
    end

    local bottomBg = zc.getScaleNode("res/Main/role/trinket/sellDi.png", cc.size(500,85) )
    bottomBg:setAnchorPoint(ccp(0, 0))
    bottomBg:setName("bottomBg")
    self.rightBg:addChild(bottomBg, 1)

    local refreshTimeBg = zc.getScaleNode("res/Main/dazao/refreshBg.png", cc.size(220,55) )
    refreshTimeBg:setAnchorPoint(ccp(0, 0.5))
    refreshTimeBg:setPosition(ccp(20, bottomBg:getContentSize().height/2))
    refreshTimeBg:setName("refreshTimeBg")
    bottomBg:addChild(refreshTimeBg)

    refreshTimeBg:addChild(zc.createLabel({text = zc.lang("Make_freeFreshTime"), name = "freeLabel",fontSize = 18, color = display.COLOR_GOLD, ap = ccp(0, 0.5), pos = ccp(10, 27)}))
    self.freeLabel = refreshTimeBg:getChildByName("freeLabel")


    self.makingLabel = zc.createLabel({text = zc.lang("Make_making"), fontSize = 18, color = display.COLOR_GOLD, pos = ccp(110, 27)})
    refreshTimeBg:addChild(self.makingLabel)

    local time = zc.getTimeHMS(self.flushTime)
    self.refreshTimeLabel = zc.createLabel({text = time, fontSize = 18, color = display.COLOR_GOLD, ap = ccp(0, 0.5), pos = ccp(130, 27)})
    refreshTimeBg:addChild(self.refreshTimeLabel)

    local diamondIcon = zc.getSprite({
            src = zc.getImgByType(zc.dataTypeGold),
            pos = cc.p(270, 42),
        })
    diamondIcon:setName("diamondIcon")
    diamondIcon:addChild(zc.createLabel({text = "100", fontSize = 22, name = "refreshCostLabel", pos = ccp(diamondIcon:getContentSize().width + 20, diamondIcon:getContentSize().height/2)}))
    self.refreshCostLabel = diamondIcon:getChildByName("refreshCostLabel")
    bottomBg:addChild(diamondIcon)
    local refreshBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("Make_freshNow"),
        pos = cc.p(400, 42),
        scale = 0.9,
        endCallback = function()
            zc.sendHttp({
                apiName = "Make_Refresh",
                params = {type = self._tabIndex},
                successCallback = function(data)
                -- dump(data)
                    PlayerData:updataData(data)
                    self.serverData.materials = data.materials
                    self.serverData.buyFlushNum = data.buyFlushNum
                    self:updateUI()
                end,
            })
        end
    })
    self.refreshBtn = refreshBtn
    bottomBg:addChild(refreshBtn)
end

-- 创建标签按钮
function MakePop:initTabs()
    -- 创建标签
    self._tabBtn = {}
    local _tabPosX =  zc.width - 58
    local _tabPosY =  zc.height - 40
    for i, v in ipairs( self._tabInfo ) do
        local _tabInfo = v
        local _normal = cc.Sprite:create( "res/Main/dazao/tab_small_u.png" )
        local scaleY = 1
        local size = _normal:getContentSize()
        _normal:setContentSize(size.width, size.height*scaleY)
        _normal:setScaleY(scaleY)

        local _normal_label = zc.createLabel({
            color = cc.c3b( 122, 42, 0 ),
            color2 = cc.c3b( 255, 232, 128 ),
            outLine = true,
            pixel = 0.5,
            fontSize = 23,
            width = 30,
            text = v.name,
            pos = cc.p( _normal:getContentSize().width/2 - 5, _normal:getContentSize().height/2 + 2),
        })
        _normal_label:setScaleY(1/scaleY)
        _normal:addChild( _normal_label )
        local _selected = cc.Sprite:create( "res/Main/dazao/tab_small_d.png" )

        local size = _selected:getContentSize()
        _selected:setContentSize(size.width, size.height*scaleY)
        _selected:setScaleY(scaleY)

        local _selected_label = zc.createLabel({
            color = display.COLOR_WHITE,
            color2 = cc.c3b( 72, 37, 0 ),
            outLine = true,
            pixel = 0.5,
            fontSize = 23,
            text = v.name,
            width = 30,
            pos = cc.p( _selected:getContentSize().width/2 - 5, _selected:getContentSize().height/2 + 2),
        })
        _selected_label:setScaleY(1/scaleY)

        _selected:addChild( _selected_label )
        local _tabBtn = zc.createPushButton({
            normalNode = _normal,
            selectedNode = _selected,
            needSwallow = true,
            pos = cc.p( _tabPosX, _tabPosY - i*140), 
            endCallback = function()

                print("_tabInfo.index" .. _tabInfo.index)

                if _tabInfo.index ~= self._tabIndex then
                    local _currentGID = getGuideManager():getCurrentGID()
                    if _currentGID == GuideKey.KEY_11403
                      or _currentGID == GuideKey.KEY_11510
                      or _currentGID == GuideKey.KEY_12310
                      then
                        zc.setGuideFuncNextStep(_currentGID)
                    end
                    self:clickTab( _tabInfo.index )
                end
            end,
        })
        self:addChild( _tabBtn, 3 )
        self._tabBtn[i] = _tabBtn
        _tabBtn._normal_label = _normal_label
        _tabBtn._selected_label = _selected_label
    end
end

function MakePop:updateUI(flag)
    self:refreshTime()
    self:finishTime()
    self.refreshCostLabel:setText(self:getFlushPrice())
    self:updateDesk(flag)

    --更新红点 10 对应的状态。
    if tonumber(self.serverData.type) == 1 then
        if self.finishedTime and self.finishedTime > 0 then
            PlayerData:updateRedDotData(10, self.finishedTime)
            PlayerData:startBubbleTimer() -- 开启红点定时器
        end
    elseif tonumber(self.serverData.type) == 0 then
        PlayerData:updateRedDotData(10, 0)
    elseif tonumber(self.serverData.type) == 2 then
        PlayerData:updateRedDotData(10, 1)
    end

    self:refreshMainCityBubble()

    self.leftTimeLabel:setText( self.serverData.produceNum .. "/2")
    self.refreshBtn:setEnable(tonumber(self.serverData.type) == 0)

    local startTxt = zc.lang("Make_startMake")
    if tonumber(self.serverData.type) == 1 then
        startTxt = zc.lang("Make_getNow")
    elseif tonumber(self.serverData.type) == 2 then
        startTxt = zc.lang("Make_get")
    end

    self.startBtn:setText(startTxt)

    for i=1,6 do
        local itemId = self.serverData.materials[tostring(i)]
        local itemInfo = self:getItemInfoById(itemId)
        local itemBg = self.rightBg:getChildByName("itemBg" .. i)
        local itemNameBg = itemBg:getChildByName("itemNameBg")
        local item = itemBg:getChildByName("item")
        local itemEffect = item:getChildByName("itemEffect")

        local info = zc.updateIconByData(item, {
            data = {
                mainType = itemInfo.type,
                type = itemInfo.itemId,
                id = itemInfo.itemId,
            },
        })
        item:setTouchEndedCall(function()
            local idx = item:getTag()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_14906 then
                zc.setGuideFuncNextStep(_currentGID)
                getGuideManager():setObjTarget(self.guideBtn2)
                getGuideManager():startGuide()
            elseif _currentGID == GuideKey.KEY_14907 then
                getGuideManager():guideOver()
                getGuideManager():setCurrentGID(GuideKey.KEY_14908)
                local function _callBack()
                    performWithDelay(self, function()
                       self:addHandFlag()
                    end, 0.3)
                end
                getGuideManager():setHeroFuncCallBack(_callBack)
                getGuideManager():startGuide()
            end


            if self:isCanClickRightIcon(self.serverData.materials[tostring(idx)]) then
                zc.sendHttp({
                    apiName = "Make_SelectItem",
                    params = {type = self._tabIndex, id = self.serverData.materials[tostring(idx)]},
                        successCallback = function(data)
                        print("Make_SelectItem")
                        dump(data)
                        self.serverData.selectMaterial = data.selectMaterial
                        self:updateUI()
                    end,
                })
            else
                zc.sendHttp({
                    apiName = "Make_CancelItem",
                    params = {type = self._tabIndex, id = self.serverData.materials[tostring(idx)]},
                    successCallback = function(data)
                        print("Make_CancelItem")
                        dump(data)
                        self.serverData.selectMaterial = data.selectMaterial
                        self:updateUI()
                    end,
                }) 
            end
        end)

        itemEffect:setVisible(not self:isCanClickRightIcon(self.serverData.materials[tostring(i)])) 
        itemNameBg:getChildByName("itemName"):setText(info.name)
        itemNameBg:getChildByName("itemName"):setColor(zc.getColorByQuality(info.quality))
        if i <= 3 then
            local circleBg = self:getChildByName("circleBg" .. i)
            local countBg = circleBg:getChildByName("countBg")          --bg
            local countLabel = countBg:getChildByName("countLabel")     --label
            local leftItem = circleBg:getChildByName("leftItem")
            local lockImg = circleBg:getChildByName("lockImg")
            local unlockImg = circleBg:getChildByName("unlockImg")

            --获得选择的材料信息
            local selectItemId = self.serverData.selectMaterial[tostring(i)]
            if tonumber(self.serverData.type) ~= 0 then
                selectItemId = self.serverData.produceMaterial[tostring(i)]
            end

            if selectItemId ~= "" then
                local itemInfo = self:getItemInfoById(selectItemId)
                local _info = zc._getIconInfo({
                    data = {
                        mainType = itemInfo.type,
                        type = itemInfo.itemId,
                        id = itemInfo.itemId,
                    },
                })
                leftItem:setVisible(true)
                leftItem:setTexture(_info.img)

                countBg:setVisible(true)
                local addNum = self:getAddCount()
                local txt = self:getBaseMakeNum()
                if addNum == 0 then
                    countLabel:setText(txt)
                    local length = string.len(txt)
                    countBg:setContentSize(length*20,30)
                else
                    txt = txt .. "+" .. addNum
                    local length = string.len(txt)
                    countLabel:setText(txt)
                    countBg:setContentSize(length*20,30)
                    for i=2,length do
                        local _letter = countLabel:getLetter(i)
                        if _letter then
                            _letter:setColor( display.COLOR_GREEN )
                        end
                    end
                end
                
                --再点这个物品就会取消选择
                leftItem:setTouchEndedCallback(function()
                    zc.sendHttp({
                        apiName = "Make_CancelItem",
                        params = {type = self._tabIndex, id = self.serverData.selectMaterial[tostring(i)]},
                        successCallback = function(data)
                            print("Make_CancelItem")
                            dump(data)
                            self.serverData.selectMaterial = data.selectMaterial
                            self:updateUI()
                        end,
                    }) 
                end)
            else
                countBg:setVisible(false)
                leftItem:setVisible(false)
            end

            if i <= self:getUnlockPos() then --解锁
                lockImg:setVisible(false)
                unlockImg:setVisible(true)
            else
                lockImg:setVisible(true)
                unlockImg:setVisible(false)
                countBg:setVisible(true)
                countBg:setContentSize(120,30)
                countLabel:setText(zc.lang("Make_houseLv") .. self:getPoslockInfo(i))
                countLabel:setColor(display.COLOR_WHITE)
            end
            self.progressBar[i]:setVisible(tonumber(self.serverData.type) == 1)
            countLabel:setPosition(ccp(countBg:getContentSize().width/2, countBg:getContentSize().height/2))
        end
    end

    self:startFinishCD()
end

--开始cd
function MakePop:startFinishCD()
    if tonumber(self.serverData.type) == 1 and not self.startCD then
        self.startCD = true
        for i=1,3 do
            if self.serverData.produceMaterial[tostring(i)] ~= "" then
                self.progressBar[i]:setVisible(true)
                self.progressBar[i]:setPercentage(self.finishedTime/self:getAllMakeTime()*100)
                CCProgressTo:create(self.finishedTime, 0)
                self.progressBar[i]:runAction(CCProgressTo:create(self.finishedTime, 0))
            else
                self.progressBar[i]:setVisible(false)
            end
        end
    end
end

-- 切换钮标签处理
function MakePop:clickTab( index )
    -- 开启条件
    local _tabInfo = self._tabInfo[index]
    if _tabInfo.openTag then
        local _flag = zc.getFunctionStatus( _tabInfo.openTag, true )
        if not _flag then
            return
        end
    end

    if self._tabIndex then
        self._tabBtn[self._tabIndex]:setSelected( false )
    end
    self._tabIndex = index
    self._tabBtn[self._tabIndex]:setSelected( true )

    zc.sendHttp({
        apiName = "Make_Main",
        params = {type = self._tabIndex},
        successCallback = function(data)
        print("clickTab")
        -- dump(data)

            self:initData({data = data})
            self:updateUI()
        end,
    })

end

-- 软引导，小手
function MakePop:addHandFlag()
    local _guideHand = zc.createSpine({
        fileName = "shou",
        actName = "shou",
    })
    _guideHand:setPosition(cc.p(270, 70))
    self:addChild(_guideHand, 5)
   self._guideHand = _guideHand
end

function MakePop:onExit( ... )

    getGuideManager():guideOver()
    if self._guideHand then
        self._guideHand:removeFromParent()
        self._guideHand = nil
    end

    if self.refreshTimer then
        scheduler.unscheduleGlobal( self.refreshTimer )
        self.refreshTimer = nil
    end

    if self.finishTimer then
        scheduler.unscheduleGlobal( self.finishTimer )
        self.finishTimer = nil
    end
end


function MakePop:onCleanup()

end


return MakePop