--[[
    FileName: PubShowHeroPop.lua
    Author: andong
    Date: 2016-03-17
    Purpose: xx弹窗
]]
local PubShowHeroPop = class( "PubShowHeroPop", function ()
    return ZCPopLayer:create()
end)
function PubShowHeroPop:create(params)
    return PubShowHeroPop.new(params)
end

function PubShowHeroPop:onCleanup()
    local manager = ccs.ArmatureDataManager:getInstance()
    manager:removeArmatureFileInfo("res/Main/pub/yingxiongdengru/yingxiongdengru.csb", true) 
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/Main/pub/showNameBg.jpg")
    if self._callBack then
        self._callBack()
    end
end

function PubShowHeroPop:ctor(params)
    -- dump(params, "params=====")
    self:initData(params)
    self:initUI()
    self:createAction()
    -- self:createHeroAction()
    self:show()
end
function PubShowHeroPop:initData(params)
    self._params = params
    self._scene = params.scene
    self._callBack = params.callback
end
function PubShowHeroPop:initUI()
    local popBg = cc.Sprite:create("res/Main/pub/evaluate_bg.jpg")
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    zc.setBgSize(popBg)
    self._popBg = popBg
    local closeBtn = zc.createPushButton({
        needSwallow = true,
        touchSize = cc.size(10000,10000),
        endCallback = function()
            print("clicked ... ======================")
            self:hide()
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(0, 0)
    })
    self:addChild(closeBtn)
    closeBtn:setEnable(false)
    self._closeBtn = closeBtn

    -- 如果达到条件就显示分享按钮
    local platform = cc.Application:getInstance():getTargetPlatform()
    if cc.PLATFORM_OS_ANDROID == platform then

    elseif (cc.PLATFORM_OS_IPHONE == platform) or (cc.PLATFORM_OS_IPAD == platform) then
        -- local heroType = tonumber(self._params.info["type"])
        local quality = tonumber(self._params.info["qualifications"])
        local _info = zc.getShareItemInfo(1, quality)
        if _info ~= nil then
            local shareBtn = zc.createShareBtn(true, _info)
            self:addChild(shareBtn, 10)
        end
    end
end

-- function PubShowHeroPop:createHeroAction()

--     local popBg = self._popBg
--     local hero = zc.createSprite("res/Main/hero/body/"..self._params.info.picture..".png")
--     hero:setAnchorPoint(0, 0.5)
--     hero:setPosition(-370, zc.height)
--     popBg:addChild(hero, 1)
--     hero:setScale(1.2)
    
--     hero:setPosition(-335, zc.height/2+40)

--     local nameBg = zc.createSprite("res/Main/pub/card_bg.png")
--     nameBg:setAnchorPoint(1, 1)
--     nameBg:setPosition(zc.width, zc.height)
--     popBg:addChild(nameBg)
--     nameBg:setPosition(zc.width, zc.height+120)

--     local name1 = zc.createSprite("res/Main/pub/hero_word.png")
--     name1:setAnchorPoint(0.5, 0.5)
--     name1:setPosition(30, 288-10)
--     nameBg:addChild(name1)

--     local name2 = zc.createSprite("res/Main/pub/dengru.png")
--     name2:setAnchorPoint(0.5, 0.5)
--     name2:setPosition(412-168, 203-10)
--     nameBg:addChild(name2)

--     local tallentBg = zc.createSprite("res/Main/pub/evaluate_bgImg.png")
--     tallentBg:setAnchorPoint(1, 0)
--     tallentBg:setPosition(zc.width-10, 20)
--     popBg:addChild(tallentBg)

--     local tallent = zc.createSprite("res/Main/role/qualifications_"..self._params.info.qualifications..".png")
--     tallent:setAnchorPoint(0.5, 0.5)
--     tallent:setPosition(tallentBg:getContentSize().width/2, tallentBg:getContentSize().height/2)
--     tallentBg:addChild(tallent)


    
--     local myLab = zc.createLabel({
--         text = "点击任意区域退出",
--         stroke = false,
--         fontSize = 26,
--         fontName = zc.getFont(1),
--         ap = cc.p(0.5, 0),
--         pos = cc.p(zc.width-490, 66),
--         color = display.COLOR_DEEPGRAY,
--         color2 = display.COLOR_BLACK,
--         align = kCCTextAlignmentCenter,
--         pixel = 1.3
--     })
--     popBg:addChild(myLab, 11)
    
--     hero:setPosition(cc.p(hero:getPositionX()-530, hero:getPositionY()+600))
--     name1:setPosition(cc.p(name1:getPositionX()+zc.width/2, name1:getPositionY()))
--     name2:setPosition(cc.p(name2:getPositionX()+zc.width/2, name2:getPositionY()))
--     tallent:setVisible(false)

--     self:runAction(cc.Sequence:create(
--         cc.Spawn:create(
--             cc.CallFunc:create(function()
--                 hero:runAction(cc.Sequence:create(cc.MoveBy:create(0.5,cc.p(265, -305))))
--             end),
--             cc.CallFunc:create(function()
--                 name1:runAction(cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(-zc.width/4-50, 0)), cc.MoveBy:create(0.12,cc.p(50, 0)) ))
--                 name2:runAction(cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(-zc.width/4-30, 0)), cc.MoveBy:create(0.1,cc.p(30, 0)) ))
--             end)
--         ),
--         cc.CallFunc:create(function()
--             tallent:setScale(3.0)
--             tallent:runAction(cc.Sequence:create(
--                 cc.DelayTime:create(0.4),
--                 cc.CallFunc:create(function()
--                     tallent:setVisible(true)
--                 end),
--                 cc.ScaleTo:create(0.3, 1),
--                cc.CallFunc:create(function()
--                     self._closeBtn:setEnable(true)
--                 end)
--             )) 
--         end)
--     ))
-- end

function PubShowHeroPop:createAction()
    local popBg = self._popBg
    
    local backBg = zc.createSprite()
    backBg:setContentSize(cc.size(zc.width,zc.height))
    backBg:setPosition(zc.width/2, zc.height/2)
    self:addChild(backBg)

    musicManager.playEffect(zc.effect.zhaomu)
    -- local armature
    -- armature = zc.createArmature({
    --     fileName          = "yingxiongdengru", --文件名，不包括父目录以及后缀名
    --     actName           = "", --需要播放的动作名
    --     loop              = false, --是否循环，默认不循环
    --     parentPath        = "res/Main/pub/yingxiongdengru/", --父目录
    --     suffix            = nil, --后缀
    --     completeCallback  = function()  end , --动作完成后的回调事件
    --     eventCallback     = function() print("is end ... ") end, --帧事件
    --     moveCallback      = nil, --
    --     autoRemove        = false, ----动作complete后是否自动删除
    -- })
    -- armature:setPosition(zc.width/2, zc.height/2)
    -- backBg:addChild(armature, 1)
    zc.createArmature({
        fileName          = "yingxiongdengru", --文件名，不包括父目录以及后缀名
        parentPath        = "res/Main/pub/yingxiongdengru/", --父目录
    })
    local armature = ccs.Armature:create("yingxiongdengru")
    armature:setPosition(zc.width/2, zc.height/2)
    backBg:addChild(armature, 1)
    self._armature = armature

    local showNameBg = zc.createSprite("res/Main/pub/showNameBg.png")
    showNameBg:setAnchorPoint(0, 0.5)
    -- showNameBg:setPosition(522, 486)
    showNameBg:setPosition(-50 + zc.width, 215 + zc.width*(math.sin(math.rad(9))))
    armature:addChild(showNameBg,10)

    local nameBg = zc.createSprite()
    nameBg:setContentSize(300,50)
    nameBg:setAnchorPoint(0, 0.5)
    nameBg:setPosition(20, 35)
    showNameBg:addChild(nameBg)
    local name = zc.createLabel({
        text = self._params.info.name,
        stroke = true,
        fontSize = 40,
        ap = cc.p(0, 0.5),
        pos = cc.p(10, 25),
        color = display.COLOR_YELLOW,
        pixel = 1.3
    })
    nameBg:addChild(name)
    local dot = zc.createLabel({
        text = "●",
        stroke = true,
        fontSize = 16,
        ap = cc.p(0, 0.5),
        pos = cc.p(name:getPositionX()+name:getContentSize().width+5, name:getPositionY()),
        pixel = 1.3
    })
    nameBg:addChild(dot)
    local chenghao = zc.createLabel({
        text = self._params.info.title,
        stroke = true,
        fontSize = 40,
        ap = cc.p(0, 0.5),
        pos = cc.p(dot:getPositionX()+dot:getContentSize().width+5, name:getPositionY()),
        color = cc.c3b(233,150,3),
        pixel = 1.3
    })
    nameBg:addChild(chenghao)
    nameBg:setRotation( -9.5 )

    showNameBg:runAction(cc.Sequence:create(cc.MoveBy:create(0.2,cc.p(-zc.width,-zc.width*(math.sin(math.rad(9))) ))))
    
    self._showNameBg = showNameBg

    local heroImg = "res/Main/hero/body/"..self._params.info.picture ..".png"
    if not zc.checkFileExist(heroImg) then
        heroImg = "res/Main/hero/body/101.png"
    end
    local hero = ccs.Skin:create(heroImg)
    self._armature:getBone("hero"):addDisplay(hero, 0)
    self._armature:getBone("hero"):changeDisplayWithIndex(0, true)
    local a_spImg = zc.getHeroQualificationsPath( self._params.info.qualifications )
    local a_sp = ccs.Skin:create(a_spImg)
    self._armature:getBone("A"):addDisplay(a_sp, 0)
    self._armature:getBone("A"):changeDisplayWithIndex(0, true) 
    self._armature:getBone("A"):setPositionX(self._armature:getBone("A"):getPositionX() - 100)
    self._armature:getBone("pinzhi"):setPositionX(self._armature:getBone("pinzhi"):getPositionX() - 100)
    armature:getAnimation():play("start", -1, 0)
    performWithDelay(self, function()
        backBg:runAction(cc.Sequence:create(CCShake:create(0.5, 30)))
    end, 0.6)
    performWithDelay(self, function()
        armature:getAnimation():play("idle", -1, 1)
        self._closeBtn:setEnable(true)

        -- zc.shake(cc.Director:getInstance():getRunningScene(), 6 ,0 ,20, 4)

        -- backBg:runAction(cc.Sequence:create(
            -- cc.DelayTime:create(0.01),
            -- CCShake:create(0.1, 200),
            -- CCShake:create(0.1, 100),
            -- CCShake:create(0.1, 100),
            -- CCShake:create(0.1, 100),
            -- CCShake:create(0.5, 10)
            -- cc.CallFunc:create(function() backBg:setPosition(cc.p(zc.width/2, zc.height/2)) end)
            
            -- cc.CallFunc:create(function() 
            --     zc.shake(cc.Director:getInstance():getRunningScene(), 6 ,0 ,20, 4)
            -- end),
            -- cc.CallFunc:create(function() 
            --     zc.shake(cc.Director:getInstance():getRunningScene(), 6 ,20 ,0, 10)
            -- end)
        -- ))
        -- self:shake()
        
    end, 0.8)

    self._closeBtn:setTouchEndedCall(function()
        self._closeBtn:setEnable(false)
        armature:stopAllActions()
        armature:getAnimation():play("back", -1, 0)
        self._showNameBg:runAction(cc.Sequence:create(cc.MoveBy:create(0.2,cc.p(zc.width,zc.width*(math.sin(math.rad(9))) ))))
        performWithDelay(self, function()
            local _callBack = self._params.callback
            if self._scene then
                self:removeFromParent()
            else
                LayerManager.removeLayout(true)
            end
            --新手引导
            if _callBack then
                _callBack() 
            end
        end, 0.4)
    end)

end

function PubShowHeroPop:shake(params)
    print("shake ====== ")
    local delta     = 10
    local time      = 0.1
    local speed     = 0.05
    local shakeNode = self
    if params then
        if params.delta then
            delta = params.delta
        end
        if params.time then
            time = params.time
        end
        if params.speed then
            speed = params.speed
        end
        if params.shakeNode then
            shakeNode = params.shakeNode
        end
    end
    time = math.modf(time*10)
    if time < 1 then
        time = 1
    end

    local _shakePos1 = cc.p(delta*0.5, delta*0.5)
    local _shakePos2 = cc.p(-delta, -delta)
    --[[--防止多个震屏互相叠加]]
    -- self:setPosition(cc.p(0,0))
    shakeNode:runAction(cc.Repeat:create(cc.Sequence:create(
        cc.MoveBy:create(speed*0.5, _shakePos1),
        cc.MoveBy:create(speed, _shakePos2),
        cc.MoveBy:create(speed*0.5, _shakePos1)
    ), time))
end

return PubShowHeroPop