--[[
    FileName: RankListPop.lua
    Author: andong
    Date: 2016-08-02
    Purpose: 排行榜弹窗
]]
local RankListPop = class( "RankListPop", function ()
    return zc.createNormalDialog({
        closeCallBack = function()
            LayerManager.removeLayout(nil, nil, false)
        end
    })
end)
function RankListPop:create(params)
    return RankListPop.new(params)
end
function RankListPop:ctor(params)
    self:initData(params)
    self:initUI()
end
--信息标签 1、2、3、4、5、6、7、8、9、10、11、12、13、14、15、16、17、18
function RankListPop:getRankInfo(_infoTag, _doNext)
    if self._rankListInfo[_infoTag] then
        self._showInfo = self._rankListInfo[_infoTag]
        if _doNext then
            _doNext()
        end
    else
        if not _infoTag then
            return
        end
        zc.sendHttp({
            apiName = "RankList_main",
            params = {types = _infoTag },
            successCallback = function (net_data)
                self._rankListInfo[_infoTag] = net_data[tostring(_infoTag)]
                self._showInfo = self._rankListInfo[_infoTag]
                if _doNext then
                    _doNext()
                end
            end
        })
    end
end
function RankListPop:initUI()
    -- 标题背景云
    local titleCloud = cc.Sprite:create( "res/Main/common/title_bg_cloud.png" )
    self:addChild( titleCloud )
    local popBg = zc.createNormalPop({
        tag = 2,
        src = "res/Main/common/popBg/bgWhite.png",
        bianZOrder = 1,
        height = 555,
    })
    popBg:setPosition(zc.width*0.5, zc.height*0.5 - 20)
    self:addChild(popBg)

    local popSize = popBg:getContentSize()

    titleCloud:setAnchorPoint( 0, 0.5 )
    titleCloud:setPosition( zc.width/2 - popSize.width/2 - 80, zc.height/2 + popSize.height/2+7 )

    local _tipBg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 163, 8 ), "res/Main/common/popBg/di_properties.png" )
    _tipBg:setContentSize( 285, 32 )
    _tipBg:setAnchorPoint(cc.p(1,0.5))
    _tipBg:setPosition( popSize.width - 30, popSize.height-30 )
    popBg:addChild( _tipBg, 11 )
    cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
    local _tipSp = zc.getSprite({
        src = "home_icon_info.png",
        plist = true,
        pos = cc.p( 15, 32/2 ),
        scale = 0.5,
    })
    _tipBg:addChild( _tipSp )
    local _tipLabel = zc.createRichLabel({
        fontSize = 22,
        pos = cc.p( 40, 32/2 ),
    })
    _tipBg:addChild( _tipLabel )
    _tipLabel:setAnchorPoint( 0, 0.5 )
    _tipLabel:setString( "[color=ff746548]" .. zc.lang("tips_rank_fresh_time") .. "[/color]" )


    -- 标题背景
    local titleBg = cc.Sprite:create( "res/Main/common/title_bg_shadow.png" )
    titleBg:setAnchorPoint( 0, 0.5 )
    titleBg:setPosition( -30, popSize.height )
    popBg:addChild( titleBg , 10)
    -- 标题
    local title = cc.Sprite:create( "res/Main/arena/rank/title.png" )
    title:setAnchorPoint( 0, 0.5 )
    title:setPosition( -5, popSize.height )
    popBg:addChild( title , 10)

    local scaleSize = cc.size(155, 461)
    local tabButtonBg = zc.getScaleNode("res/Main/common/img_empty.png", scaleSize)
    tabButtonBg:setAnchorPoint(cc.p(0, 0))
    tabButtonBg:setPosition(cc.p(7, 12))
    popBg:addChild(tabButtonBg)

    self._innerSize = cc.size(155, 440)
    local tabSroll = ccui.ScrollView:create()
    tabSroll:setTouchEnabled(true)
    tabSroll:setBounceEnabled(true)
    tabSroll:setContentSize( self._innerSize )
    tabSroll:setPosition(cc.p(0, 10))
    tabSroll:setDirection(ccui.ScrollViewDir.vertical)
    tabSroll:setScrollBarEnabled(false)
    tabSroll:setInnerContainerSize( self._innerSize )
    tabButtonBg:addChild(tabSroll)
    self._tabSroll = tabSroll

    local tableInfoBgSize = cc.size(699, 455)
    local tableInfoBg = zc.getScaleNode("res/Main/setting/scale9_1.png",tableInfoBgSize)
    tableInfoBg:setAnchorPoint(cc.p(1, 0))
    tableInfoBg:setPosition(cc.p(popSize.width-5, 10))
    popBg:addChild(tableInfoBg)

    local tipNoItemImg = zc.createSprite("res/Main/common/empty.png")
    tipNoItemImg:setPosition(tableInfoBgSize.width/2, tableInfoBgSize.height/2)
    tableInfoBg:addChild(tipNoItemImg)
    tipNoItemImg:setVisible(false)
    self._tipNoItemImg = tipNoItemImg

    local tableBg = zc.getScaleNode("res/Main/common/img_empty.png", tableInfoBgSize)
    tableBg:setAnchorPoint(cc.p(1, 0))
    tableBg:setPosition(cc.p(popSize.width-5, 15))
    popBg:addChild(tableBg)
    self._tableBg = tableBg

    --创建title
    self._titleLabList = {}
    for i = 1, 5 do
        local titleLab = zc.createLabel({
            text = "",
            stroke = false,
            fontSize = 18,
            pos = cc.p(0,0),
            color = cc.c3b(66,12,17),
        })
        tableBg:addChild(titleLab)
        table.insert(self._titleLabList,titleLab)
    end
    self._perHeight = 61
    self:createTabButton()

end
function RankListPop:createTabButton()

    self._tabButtonList = {}
    for i = 1, #self._tabName do
        local tabBtn = zc.createPushButton({
            normalFile = "res/Main/rankList/tab_button_u.png",
            selectedFile = "res/Main/rankList/tab_button_u.png",
            needSwallow = false,
            needEnableWhenMoving = true,
            anchor = cc.p(0.5, 0.5),
            pos = cc.p(155/2, self._innerSize.height - 40 - (i-1)*self._perHeight), -- 61*
            endCallback = function() end,
        })
        tabBtn:setTag(i)
        table.insert(self._tabButtonList, tabBtn)

        self._tabSroll:addChild(tabBtn)
        tabBtn:setTouchEndedCall(function()
            self:changeTab(tabBtn)
        end)
        local nameLab = zc.createLabel({
            text = self._tabName[i]["name"],
            fontSize = 24,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(tabBtn:getContentSize().width/2, tabBtn:getContentSize().height/2),
            color = cc.c3b(40,17,0),
        })
        tabBtn:addChild(nameLab, 1)
        tabBtn._nameLab = nameLab
        if self._tabName[i]["moreRank"] then
            local arrow = zc.createSprite("res/Main/rankList/up_arrow.png")
            arrow:setAnchorPoint(0, 0.5)
            arrow:setPosition(nameLab:getContentSize().width+2, nameLab:getContentSize().height/2)
            nameLab:addChild(arrow)
            nameLab:setPositionX(tabBtn:getContentSize().width/2-arrow:getContentSize().width/2-1)
            tabBtn["arrow"]  =arrow
        end
    end
    self:changeTab(self._tabButtonList[1])
end
function RankListPop:changeTab(_node)
    local function getNormal()
        return zc.createSprite("res/Main/rankList/tab_button_u.png")
    end
    local function getSelected()
        return zc.createSprite("res/Main/rankList/tab_button_d.png")
    end
    if not self._selectedBtn or self._selectedBtn ~= _node then
        local _tag = _node:getTag()
        if not self._selectedBtn then
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelected() )
            self._selectedBtn:setStateSelected( getSelected() )
            _node._nameLab:setColor(display.COLOR_WHITE)
            -- _node._nameLab:enableShadow(cc.c4b(130,85,23,255), cc.size(2, -2))
            _node._nameLab:enableOutline(cc.c4b(130,85,23,255), 2)
        else
            self:closeAction(self._tag)
            self._selectedBtn:setStateNormal( getNormal() )
            self._selectedBtn:setStateSelected( getNormal() )
            self._selectedBtn._nameLab:setColor(cc.c3b(40,17,0))
            -- self._selectedBtn._nameLab:enableShadow(cc.c4b(0,0,0,0), cc.size(2, -2))
            self._selectedBtn._nameLab:enableOutline(cc.c4b(0,0,0,0), 2)
            if self._selectedBtn["arrow"] then
                self._selectedBtn["arrow"]:setFlipY(false)
            end
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelected() )
            self._selectedBtn:setStateSelected( getSelected() )
            _node._nameLab:setColor(display.COLOR_WHITE)
            -- _node._nameLab:enableShadow(cc.c4b(130,85,23,255), cc.size(2, -2))
            _node._nameLab:enableOutline(cc.c4b(130,85,23,255), 2)
        end
        self._tag = _tag
        --选中
        if _node["arrow"] then
            _node["arrow"]:setFlipY(true)
        end
        --展开
        self:openAction(_tag)
    elseif self._selectedBtn and self._selectedBtn == _node then
        local _tag = _node:getTag()
        --收起
        self._selectedBtn:setStateNormal( getNormal() )
        self._selectedBtn:setStateSelected( getNormal() )
        _node._nameLab:setColor( cc.c3b(40,17,0) )
        -- _node._nameLab:enableShadow(cc.c4b(0,0,0,0), cc.size(2, -2))
        _node._nameLab:enableOutline(cc.c4b(0,0,0,0), 2)

        if self._selectedBtn["arrow"] then
            self._selectedBtn["arrow"]:setFlipY(false)
        end
        self._selectedBtn = nil
        self:closeAction(_tag)
    end
end
--收起
function RankListPop:closeAction(_tag)
    local subTabInfo = self._tabName[_tag]
    if subTabInfo["rankTabNum"] <= 0 then
        return
    end
    self._innerSize = cc.size(self._innerSize.width, self._innerSize.height - subTabInfo["rankTabNum"]*self._perHeight  + 61)
    self._tabSroll:setInnerContainerSize(self._innerSize)
    if self._innerSize.height <= 440 then
        self._tabSroll:setBounceEnabled(false)
    else
        self._tabSroll:setBounceEnabled(true)
    end
    for i = 1, subTabInfo["rankTabNum"] do
        local removeButton = self._tabButtonList[_tag+1]
        removeButton:removeFromParent()
        table.remove(self._tabButtonList, _tag+1)
    end
    self:refreshPos()
end
--刷新位置
function RankListPop:refreshPos()
    for i = 1, table.nums(self._tabButtonList) do
        local button = self._tabButtonList[i]
        button:setPositionY(self._innerSize.height - 40 - (i-1)*self._perHeight)
    end
end
--展开
function RankListPop:openAction(_tag)
    local subTabInfo = self._tabName[_tag]
    local nameStrTable = self._subTabName[_tag] or {}
    if subTabInfo["rankTabNum"] <= 0 then
        self:changeSubTab(subTabBtn, nameStrTable[1]["infoTag"])
        return
    end
    --恢复初始
    self._innerSize = cc.size(155, 440)
    self._innerSize = cc.size(self._innerSize.width, self._innerSize.height + subTabInfo["rankTabNum"]*self._perHeight  - 61)

    self._tabSroll:setInnerContainerSize(self._innerSize)
    if self._innerSize.height <= 440 then
        self._tabSroll:setBounceEnabled(false)
    else
        self._tabSroll:setBounceEnabled(true)
    end
    --如果是兵器榜和世界boss榜 需要移到位置
    local coner = self._tabSroll:getInnerContainer()

    local moveY = 0
    if _tag == 2 then
        moveY = self._perHeight * 1
    elseif _tag == 5 then
        moveY = self._perHeight * 1
    end

    coner:setPositionY( coner:getPositionY()+moveY )
    local _scale = 0.85
    local function getNormal()
        local _normal = zc.createSprite("res/Main/rankList/tab_button_u.png")
        _normal:setScale(_scale)
        return _normal
    end
    for i = 1, subTabInfo["rankTabNum"] do
        local subTabBtn = zc.createPushButton({
            normalNode = getNormal(),
            selectedNode = getNormal(),
            needSwallow = false,
            needEnableWhenMoving = true,
            anchor = cc.p(0.5, 0.5),
            pos = cc.p(155/2, 0),
            endCallback = function() end,
        })
        subTabBtn:setTag(nameStrTable[i]["infoTag"])
        self._tabSroll:addChild(subTabBtn)

        local nameLab = zc.createLabel({
            text = nameStrTable[i]["name"] or "",
            outLine = true,
            fontSize = 24,
            pos = cc.p(subTabBtn:getContentSize().width/2, subTabBtn:getContentSize().height/2),
            color = cc.c3b(109,96,56),
            pixel = 1.5
            
        })
        subTabBtn._nameLab = nameLab
        subTabBtn:addChild(nameLab, 1)
        subTabBtn:setTouchEndedCall(function()
            self:changeSubTab(subTabBtn)
        end)
        if i == 1 then
            self:changeSubTab(subTabBtn)
        end
        table.insert(self._tabButtonList, _tag + i,subTabBtn)
    end
    self:refreshPos()
end

--更换二级标签
function RankListPop:changeSubTab(_node, tag)
    local firstTag = self._tag
    local function getNormal()
        local _normal = zc.createSprite("res/Main/rankList/tab_button_u.png")
        _normal:setScale(0.85)
        return _normal
    end
    local function getSelected()
        local _select = zc.createSprite("res/Main/rankList/tab_button_d.png")
        _select:setScale(0.85)
        return _select
    end
    -- self._selectSecondBtn 二级按钮
    if tolua.isnull(self._selectSecondBtn) then
        self._selectSecondBtn = nil
    end
    if not self._selectSecondBtn or self._selectSecondBtn ~= _node then
        local _secondTag = tag 
        if _node then
            _secondTag = _node:getTag() --二级tag就是对应的标签tag
        end
        self._secondTag = _secondTag
        --取数据，如果没有成功直接返回
        self:getRankInfo(_secondTag,function()
            if not self._selectSecondBtn then
                self._selectSecondBtn = _node
                if _node then
                    self._selectSecondBtn:setStateNormal( getSelected() )
                    self._selectSecondBtn:setStateSelected( getSelected() )
                    _node._nameLab:setColor(display.COLOR_WHITE)
                    -- _node._nameLab:enableShadow(cc.c4b(130,85,23,255), cc.size(2, -2))
                    _node._nameLab:enableOutline(cc.c4b(130,85,23,255), 2)
                end
            else
                self._selectSecondBtn:setStateNormal( getNormal() )
                self._selectSecondBtn:setStateSelected( getNormal() )
                self._selectSecondBtn._nameLab:setColor(cc.c3b(109,96,56))
                self._selectSecondBtn._nameLab:enableOutline(cc.c3b(0,0,0,0), 1.5)
                self._selectSecondBtn = _node

                if _node then
                    self._selectSecondBtn:setStateNormal( getSelected() )
                    self._selectSecondBtn:setStateSelected( getSelected() )
                    _node._nameLab:setColor(display.COLOR_WHITE)
                    _node._nameLab:enableOutline(cc.c4b(130,85,23,255), 2)
                end
            end

            if not self._showInfo or not next(self._showInfo["rank"]) then
                self._tipNoItemImg:setVisible(true)
                self._tableBg:setVisible(false)
                return
            end
            self._tipNoItemImg:setVisible(false)
            self._tableBg:setVisible(true)
            --刷新榜 title
            self:refreshTitle(_secondTag)
            --创建排行榜
            self:createRankListInfo()
            --刷新自己的榜
            self:refreshSelefRank()
        end)
    end
end


--刷新榜 title
function RankListPop:refreshTitle(_secondTag)
    local titleInfo = self._titleInfoList[_secondTag]
    --是否有称号信息，如果没有则去掉称号这一栏
    local top3Title = self:getTop3Title()
    if not top3Title then
        self._haveTitle = false
    else
        self._haveTitle = true
    end
    for i = 1, table.nums(self._titleLabList) do
        local v = self._titleLabList[i]
        v:setText("")
        if i == table.nums(self._titleLabList) then
            if not self._haveTitle then
                break
            end
        end
        v:setText(titleInfo[i]["name"] or "")
        v:setPosition(titleInfo[i]["pos"])
    end
end

function RankListPop:createRankListInfo()
    if not self._myTableview then
        local tableSize = cc.size(self._tableBg:getContentSize().width,346)
        self._tableviewSize = tableSize
        local myTableBg = zc.getScaleNode("res/Main/setting/scale9_1.png", tableSize )
        myTableBg:setAnchorPoint(cc.p(0.5, 0))
        myTableBg:setPosition(cc.p(self._tableBg:getContentSize().width/2, 77))
        self._tableBg:addChild(myTableBg)

        local cellSize = cc.size(tableSize.width-4, 85)
        local myTable = zc.ZCTableView:create(cc.size(tableSize.width-4,tableSize.height-8))
        myTable:setPosition(2,5)
        myTable:setInertia(true) --设置惯性
        myTable:setBounceable(true)
        myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL) --设置横向纵向
        myTable:setDelegate()
        myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
        myTableBg:addChild(myTable)
        local function cellSizeForTable(table,idx)
            return cellSize.height, cellSize.width
        end
        local function numberOfCellsInTableView(table)
            return #self._showInfo["rank"]
        end
        local function tableCellAtIndex(table,idx)
            local nowIdx = idx + 1
            local cell = table:dequeueCell()
            if cell == nil then
                cell = zc.ZCTableViewCell:new()
                cell:setContentSize(cc.size(cellSize.width, cellSize.height))
                self:createCell(cell, nowIdx)
            end
            self:updateCell(cell, nowIdx)
            return cell
        end
        myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
        myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
        myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
        myTable:reloadData()
        self._myTableview = myTable
        self:initAnimation()
    else
        self._myTableview:reloadData()
        self._myTableview:scrollToCell(0, false)
        self:initAnimation()
    end
end
function RankListPop:createCell(cell, nowIdx)
    local cellSize = cell:getContentSize()
    local posyMiddle = cellSize.height/2
    local cell_img = zc.createPushButton({
        normalNode = zc.createSprite("res/Main/arena/rank/bg_4.png"),
        needSwallow = false,
        needEnableWhenMoving = false,
        noScaleAction = true,
        touchScale = 0.9,
        pos = cc.p(cellSize.width/2, posyMiddle),
        endCallback = function() end,
    })
    cell_img:setName("cell_img")
    cell:addChild(cell_img)

    local top3 = zc.createSprite()
    top3:setPosition(70, posyMiddle)
    top3:setName("top3")
    cell_img:addChild(top3, 1)
    top3:setVisible(false)
    local rankNum = zc.createFntLabel({
        fnt = "res/Main/arena/rank/fnt/arenaRank_num.fnt",
        pos = cc.p( 70, posyMiddle ),
    })
    rankNum:setName("rankNum")
    cell_img:addChild( rankNum , 1)
    --head
    local head = zc.createPlayerHead({
        level = 1,
        iconId = 1,
    })
    head:setName("head")
    head:setScale(58/80)
    head:setPosition( cc.p(155,posyMiddle) )
    cell_img:addChild(head, 1)
    --旗帜
    local _file = APP_REVIEW and "res/Main/country/main/country_flag_review.png" or "res/Main/country/main/country_flag.png"
    local country_flag = zc.createSprite(_file)
    country_flag:setAnchorPoint(0.5, 0.5)
    country_flag:setPosition(155+60,posyMiddle)
    cell_img:addChild(country_flag, 1)
    country_flag:setName("country_flag")
    country_flag:setScale(0.5)
    --name
    local name = zc.createLabel({
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(190, posyMiddle),
        color = cc.c3b(66,12,17),
    })
    name:setName("name")
    cell_img:addChild(name, 1)
    --职业
    local zhiye = zc.createSprite(zc.getHeroTypeImg(1))
    zhiye:setPosition(362, posyMiddle)
    cell_img:addChild(zhiye, 1)
    zhiye:setName("zhiye")
    --国家君主
    local countryKingName = zc.createLabel({
        text = "",
        fontSize = 18,
        pos = cc.p(362+60, posyMiddle),
        color = cc.c3b(66,12,17),
    })
    cell_img:addChild(countryKingName,1)
    countryKingName:setName("countryKingName")
    --power
    local power = zc.createLabel({
        fontSize = 20,
        pos = cc.p(480, posyMiddle),
        color = cc.c3b(66,12,17),
    })
    cell_img:addChild(power,1)
    power:setName("power")
    --称号
    local chenghaoImg = zc.createPushButton({
        normalFile = "res/Main/rankList/rank_1.png",
        needSwallow = false,
        needEnableWhenMoving = true,
        touchScale = 0.9,
        pos = cc.p(cellSize.width-80, posyMiddle+10),
        noScaleAction = true,
    })
    cell_img:addChild(chenghaoImg,1)
    local top3Title = zc.createLabel({
        fontSize = 18,
        pos = cc.p(61, 16),
        color = display.COLOR_GOLD,
    })
    top3Title:setName("top3Title")
    chenghaoImg:addChild(top3Title, 1)
    local chenghaoLab = zc.createLabel({
        fontSize = 22,
        pos = cc.p(cellSize.width-75, posyMiddle),
        color = cc.c3b(66,12,17),
    })
    cell_img:addChild(chenghaoLab,1)
    chenghaoImg:setName("chenghaoImg")
    chenghaoLab:setName("chenghaoLab")
    local linePosx = {116,309,422,540}
    for i = 1, 4 do
        local line = zc.createSprite("res/Main/setting/separate_line.png")
        line:setPosition(linePosx[i], posyMiddle)
        cell_img:addChild(line,1)
        line:setName("line"..i)
        line:setScaleY(0.75)
        line:setVisible(false)
    end
end
--获取对应职业id和名称
function RankListPop:getZhiYeInfo( iconId )
    -- body
    local _iconId = tonumber(iconId) or 1
    local zhiyeId = {[1]=1,[2]=5,[3]=5,[4]=1}
    return zhiyeId[_iconId] or 1
end
function RankListPop:updateCell(cell, nowIdx)
    local cellSize = cell:getContentSize()
    local cellData = self._showInfo["rank"][nowIdx]
    local cell_img = cell:getChildByName("cell_img")
    cell_img:setScale(1.0)
    local top3 = cell_img:getChildByName("top3")
    local rankNum = cell_img:getChildByName("rankNum")
    top3:setVisible(false)
    rankNum:setVisible(false)
    local chenghaoImg = cell_img:getChildByName("chenghaoImg")
    local chenghaoLab = cell_img:getChildByName("chenghaoLab")
    chenghaoImg:setVisible(false)
    chenghaoLab:setVisible(false)

    local name = cell_img:getChildByName("name")
    name:setText(cellData["userName"])

    local power = cell_img:getChildByName("power")
    power:setText(cellData["filed"])

    local _id = self:getZhiYeInfo(cellData.iconId)

    local zhiye = cell_img:getChildByName("zhiye")
    zhiye:setTexture(zc.getHeroTypeImg(_id))
    local countryKingName = cell_img:getChildByName("countryKingName")

    local head = cell_img:getChildByName("head")
    zc.updatePlayerHead({
        headBg=head,
        level = cellData.level,
        iconId = cellData.iconId,
        callback = function()
            zc.createOtherPlayerSelect(cellData.userId)
        end
    })

    local country_flag = cell_img:getChildByName("country_flag")

    local imgPath = "res/Main/arena/rank/bg_"..nowIdx..".png"
    if nowIdx <= 3 then
        local top3Path = "res/Main/arena/rank/icon_"..nowIdx..".png"
        top3:setVisible(true)
        top3:setTexture(top3Path)
        local chenghaoImgPath = "res/Main/rankList/rank_"..nowIdx..".png"
        chenghaoImg:setVisible(true)
        chenghaoImg:setStateNormal(zc.createSprite(chenghaoImgPath))
        chenghaoImg:setTouchEndedCallback(function()
            zc.createSourcePop("RankTitlePop", "src/layer/rankList/RankTitlePop.lua", {tag=self._secondTag,rank=nowIdx})
        end)
        local top3TitleInfo = self:getTop3Title() or {}
        local nowTop3Title = top3TitleInfo[nowIdx] or {}
        local top3Title = chenghaoImg:getChildByName("top3Title")
        if top3Title then
            top3Title:setText(nowTop3Title["name"])
            if not nowTop3Title["name"] or nowTop3Title["name"] == "" then
                chenghaoImg:setVisible(false)
            end
        end
    elseif nowIdx > 3 then
        rankNum:setVisible(true)
        chenghaoLab:setVisible(true)
        rankNum:setString( cellData.rank )
        imgPath = "res/Main/arena/rank/bg_4.png"
    end
    cell_img:setStateNormal( zc.createSprite(imgPath) )

    if self._secondTag == 8 then
        countryKingName:setVisible(true)
        zhiye:setVisible(false)
        chenghaoImg:setVisible( false )
        countryKingName:setText(cellData["monarchName"] or "")
        head:setVisible(false)
        country_flag:setVisible(true)
        name:setPositionX(190+60)
        power:setPositionX(480+120)
    else
        countryKingName:setVisible(false)
        zhiye:setVisible(true)
        chenghaoImg:setVisible( chenghaoImg:isVisible() )
        head:setVisible(true)
        country_flag:setVisible(false)
        name:setPositionX(190)
        power:setPositionX(480)
    end


end
-- 入场动画
function RankListPop:initAnimation()
    local cellHeight = 85
    local cellNum = math.ceil( self._tableviewSize.height/cellHeight )
    for i = 1, cellNum do
        local cell = self._myTableview:cellAtIndex( i - 1 )
        if cell then
            cell:stopAllActions()
            cell:setPosition( 0, self._myTableview:getContentSize().height - cellHeight - self._tableviewSize.height )
            cell:runAction(
                cc.Sequence:create(
                    cc.DelayTime:create( i*0.15 ),--math.sqrt( ( i - 1 )*0.05 ) ),
                    cc.EaseExponentialOut:create( cc.MoveTo:create( 0.8, cc.p( 0, self._myTableview:getContentSize().height - cellHeight*i ) ) )
                )
            )
        end
    end
end
function RankListPop:refreshSelefRank()
    local selfRankInfo = self._showInfo["rankOther"] or {}
    if not self._selfRankBg then
        local selfRankBgSize = cc.size(694, 80)
        local selfRankBg = zc.getScaleNode("res/Main/common/img_empty.png", selfRankBgSize)
        selfRankBg:setAnchorPoint(cc.p(0.5, 0))
        selfRankBg:setPosition(cc.p(self._tableBg:getContentSize().width/2, 2))
        self._tableBg:addChild(selfRankBg)
        self._selfRankBg = selfRankBg
        local posyMiddle = selfRankBgSize.height/2
        local linePosx = {116,309,422,540}
        local outRankLab = zc.createLabel({
            text = zc.lang("bangwai"),
            stroke = false,
            fontSize = 20,
            pos = cc.p(70, posyMiddle),
            color = cc.c3b(66,12,17),
        })
        selfRankBg:addChild(outRankLab)
        local rankImg = zc.createSprite()
        rankImg:setPosition(70, posyMiddle)
        selfRankBg:addChild(rankImg)

        local rankNum = zc.createFntLabel({
            fnt = "res/Main/arena/rank/fnt/arenaRank_num.fnt",
            pos = cc.p( 70, posyMiddle ),
        })
        selfRankBg:addChild( rankNum )

        selfRankBg._outRankLab = outRankLab
        selfRankBg._rankImg = rankImg
        selfRankBg._rankNum = rankNum

        --head
        local head = zc.createPlayerHead({
            level = PlayerData.info.level,
            iconId = PlayerData.info.iconId,
        })
        head:setScale(58/80)
        head:setPosition( cc.p(155,posyMiddle) )
        selfRankBg:addChild(head)
        --旗帜
        local _file = APP_REVIEW and "res/Main/country/main/country_flag_review.png" or "res/Main/country/main/country_flag.png"
        local country_flag = zc.createSprite(_file)
        country_flag:setAnchorPoint(0.5, 0.5)
        country_flag:setPosition(155+60,posyMiddle)
        selfRankBg:addChild(country_flag, 1)
        country_flag:setScale(0.5)
        --name
        local name = zc.createLabel({
            text = PlayerData.info.userName,
            stroke = false,
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(190, posyMiddle),
            color = cc.c3b(66,12,17),
        })
        selfRankBg:addChild(name)

        local _id = self:getZhiYeInfo(PlayerData.info.iconId)
        --职业
        local zhiye = zc.createSprite(zc.getHeroTypeImg(_id))
        zhiye:setPosition(362, posyMiddle)
        selfRankBg:addChild(zhiye)
        --国家君主
        local countryKingName = zc.createLabel({
            stroke = false,
            fontSize = 18,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(362+60, posyMiddle),
            color = cc.c3b(66,12,17),
        })
        selfRankBg:addChild(countryKingName,1)
        countryKingName:setName("countryKingName")

        local nocountry = zc.createLabel({
            text = zc.lang("tips_unjoin_country"),
            stroke = false,
            fontSize = 20,
            pos = cc.p(selfRankBg:getContentSize().width/2, selfRankBg:getContentSize().height/2),
            color = cc.c3b(66,12,17),
        })
        selfRankBg:addChild(nocountry)
        nocountry:setVisible(false)

        --power
        local power = zc.createLabel({
            stroke = false,
            fontSize = 20,
            pos = cc.p(480, posyMiddle),
            color = cc.c3b(66,12,17),
        })
        selfRankBg:addChild(power)

        local chenghaoImg = zc.createSprite()
        chenghaoImg:setPosition(selfRankBgSize.width-80, posyMiddle+10)
        selfRankBg:addChild(chenghaoImg)
        local top3Title = zc.createLabel({
            stroke = false,
            fontSize = 18,
            pos = cc.p(61, 16),
            color = display.COLOR_GOLD,
        })
        top3Title:setName("top3Title")
        chenghaoImg:addChild(top3Title)
        local chenghaoLab = zc.createLabel({
            text = zc.lang("no"),
            stroke = false,
            fontSize = 22,
            pos = cc.p(selfRankBgSize.width-75, posyMiddle),
            color = cc.c3b(66,12,17),
        })
        selfRankBg:addChild(chenghaoLab)

        selfRankBg._power = power
        selfRankBg._chenghaoImg = chenghaoImg
        selfRankBg._chenghaoLab = chenghaoLab

        selfRankBg._countryKingName = countryKingName
        selfRankBg._zhiye = zhiye
        selfRankBg._head = head
        selfRankBg._country_flag = country_flag
        selfRankBg._name = name
        selfRankBg._power = power
        selfRankBg._nocountry = nocountry
    end
    local outRankLab = self._selfRankBg._outRankLab
    local rankImg = self._selfRankBg._rankImg
    local rankNum = self._selfRankBg._rankNum
    local countryKingName = self._selfRankBg._countryKingName
    local zhiye = self._selfRankBg._zhiye
    local head = self._selfRankBg._head
    local country_flag = self._selfRankBg._country_flag
    local name = self._selfRankBg._name
    local power = self._selfRankBg._power
    local nocountry = self._selfRankBg._nocountry

    name:setText(PlayerData.info.userName)
    outRankLab:setVisible(false)
    rankImg:setVisible(false)
    rankNum:setVisible(false)
    local chenghaoImg = self._selfRankBg._chenghaoImg
    local chenghaoLab = self._selfRankBg._chenghaoLab
    chenghaoImg:setVisible(false)
    chenghaoLab:setVisible(false)

    if selfRankInfo["myrank"] and tonumber(selfRankInfo["myrank"]) > 0 then
        local rank = tonumber(selfRankInfo["myrank"])
        if rank < 4 then
            local top3Path = "res/Main/arena/rank/icon_"..rank..".png"
            rankImg:setVisible(true)
            rankImg:setTexture(top3Path)
            local chenghaoImgPath = "res/Main/rankList/rank_"..rank..".png"
            chenghaoImg:setVisible(true)
            chenghaoImg:setTexture(chenghaoImgPath)
            local top3TitleInfo = self:getTop3Title() or {}
            local nowTop3Title = top3TitleInfo[rank] or {}
            local top3Title = chenghaoImg:getChildByName("top3Title")
            if top3Title then
                top3Title:setText(nowTop3Title["name"])
                if not nowTop3Title["name"] or nowTop3Title["name"] == "" then
                    chenghaoImg:setVisible(false)
                    chenghaoLab:setVisible(true)
                end
            end
        else 
            rankNum:setVisible(true)
            rankNum:setString( rank )
            chenghaoLab:setVisible(true)
        end
    else
        outRankLab:setVisible(true)
        chenghaoLab:setVisible(true)
    end

    if self._secondTag == 8 then
        zhiye:setVisible(false)
        chenghaoImg:setVisible(false)
        head:setVisible(false)
        chenghaoLab:setVisible(false)
        name:setPositionX(190+60)
        power:setPositionX(480+120)
        if tonumber(selfRankInfo["filed"]) == 0 and tonumber(selfRankInfo["myrank"]) == 0 then
            nocountry:setVisible(true)
            power:setVisible(false)
            name:setVisible(false)
            outRankLab:setVisible(false)
        elseif tonumber(selfRankInfo["myrank"]) > 0 then
            local rank = tonumber(selfRankInfo["myrank"])
            local rankInfo = self._showInfo["rank"] or {}
            local selfRank = rankInfo[rank]
            countryKingName:setVisible(true)
            countryKingName:setText(selfRank["monarchName"])
            country_flag:setVisible(true)
            name:setText(selfRank["userName"])
        end
    else
        power:setVisible(true)
        name:setVisible(true)
        nocountry:setVisible(false)
        countryKingName:setVisible(false)
        zhiye:setVisible(true)
        chenghaoImg:setVisible( chenghaoImg:isVisible() )
        head:setVisible(true)
        country_flag:setVisible(false)
        name:setPositionX(190)
        power:setPositionX(480)
    end

    local power = self._selfRankBg._power
    power:setText(selfRankInfo["filed"])
end
--初始化配置数据
function RankListPop:initData(params)
    self._tag = 1
    self._selfUid = PlayerData["info"]["userId"]
    --排行榜信息，总共19个，初始进入只请求了前两个，后面的在点击按钮时，分别请求
    self._rankListInfo = {}
    self._rankListInfo[1] = params["1"] or nil
    self._rankListInfo[2] = params["2"] or nil

    local _datas = LANGUAGE_get_rank_list_basedatas()
    --一级标签
    self._tabName = _datas[1]
    table.remove(self._tabName)
    table.remove(self._tabName)
    --二级标签
    self._subTabName = _datas[2]

    --title
    self._titleInfoList = _datas[3]

    --称号表
    self._chenhaoInfo = {}
end
--获取前三的称号
function RankListPop:getTop3Title()
    local _tag = self._secondTag
    if self._chenhaoInfo[_tag] then
        return self._chenhaoInfo[_tag]
    else
        local title = gameData.getDataFromCache("title",{displayPosition=_tag})
        self._chenhaoInfo[_tag] = title
        return title
    end
end


return RankListPop