--[[
	武将升星信息弹窗
	唐实聪
	2016.4.8
]]
local RoleStarupInfoPop = class("RoleStarupInfoPop", function()
	return ZCPopLayer:create()
end)

function RoleStarupInfoPop:create( params )
	return self.new( params )
end

function RoleStarupInfoPop:ctor( params )
	self:initData( params )
	self:initUI()
	self:show()
end

function RoleStarupInfoPop:initData( params )
	-- dump( params, "RoleStarupInfoPop" )
	self._data = params.data
	self._status = params.status
	self._key = params.key
	self._heroId = params.heroId
	self._starId = params.starId
	self._index = params.index
	self._itemId = tonumber( self._data.itemId )
	self._callback = params.callback

	local _size = self:getContentSize()
	self._width = _size.width
	self._height = _size.height
end

function RoleStarupInfoPop:initUI()
	local iconData = zc._getIconInfo({
		data = {
			mainType = zc.mainTypeProp,
			type = self._itemId,
			id = self._itemId,
		}
	})

	-- 背景
	local _bgWidth = 384
	local _bgHeight = 475 + 31
	if self._status.activated then
		_bgHeight = 210 + 31
	end
    local _bg = zc.createNormalPop({
        tag = 1,
        titleTag = 1,
        height = _bgHeight,
        showSide = false,
    })
	_bg:setPosition( self._width/2, self._height/2 )
	self:addContent( _bg )

	-- 顶部
	local _topBgWidth = _bgWidth - 36
	local _topBgHeight = 130 + 15
    local _topBg = zc.createGeneralPopScale({
        width = _topBgWidth,
        height = _topBgHeight,
    })
	_topBg:setPosition( _bgWidth/2 - 8, _bgHeight - 152 )
	_bg:addChild( _topBg, 1 )
    -- 背景
    local _iconBg = cc.Sprite:create( "res/Main/common/popBg/bgFlower.png" )
    _iconBg:setPosition( 70, _topBgHeight*0.5 )
    _iconBg:setScale( 0.7 )
    _topBg:addChild( _iconBg )
    -- 未激活
	local _iconBg_2 = cc.Sprite:create( "res/Main/role/starup/emptyBg_"..self._key..".png" )
	_iconBg_2:setPosition( _iconBg:getPosition() )
	_topBg:addChild( _iconBg_2 )
	local _icon = cc.Sprite:create( iconData.img )
	_icon:setPosition( _iconBg:getPosition() )
	_icon:setScale( 0.8 )
	_topBg:addChild( _icon )

	local _posX = 240
	local _difY = 35
	local _posY = #self._data.effect*_difY
	_posY = _topBgHeight/2 + _posY/2 + _difY/2
	for i, v in ipairs( self._data.effect ) do
		_posY = _posY - _difY
		-- 属性
		local _attrBgWidth = 193
		local _attrBgHeight = 32
		local _attrBg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 163, 8 ), "res/Main/common/popBg/di_properties.png" )
		_attrBg:setContentSize( _attrBgWidth, _attrBgHeight )
		_attrBg:setPosition( _posX, _posY )
		_topBg:addChild( _attrBg )
        local _attrText = zc.createRichLabel({
        	text = v.attr or "",
            fontSize = 20,
            pos = cc.p( 15, _attrBgHeight/2 ),
        })
        _attrText:setGradientColor( cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1) )
        _attrText:setAnchorPoint( 0, 0.5 )
        _attrBg:addChild( _attrText )
        -- 数值
        local _attrNum = zc.createLabel({
        	text = "+"..( v.value or 0 ),
            fontSize = 20,
            ap = cc.p( 1, 0.5 ),
            color = zc.COLOR_GREEN,
            pos = cc.p( _attrBgWidth - 15, _attrBgHeight/2 ),
            outLine = true,
            pixel = 0.5,
        })
        _attrBg:addChild( _attrNum )
	end

	if self._status.activated then
		return
	end

	-- 底部
	local _bottomBgWidth = _bgWidth - 36
	local _bottomBgHeight = 260
	local _bottomBg = zc.createGeneralPopScale({
        tag = 3,
        width = _bottomBgWidth,
        height = _bottomBgHeight,
    })
	_bottomBg:setAnchorPoint( 0.5, 0 )
	_bottomBg:setPosition( _bgWidth/2 - 8, 15 )
	_bg:addChild( _bottomBg )

	-- 需要材料背景
	local _consumeBgWidth = _bottomBgWidth - 18
	local _consumeBgHeight = 150
	local _consumeBg = zc.createGeneralPopScale({
        tag = 2,
        width = _consumeBgWidth,
        height = _consumeBgHeight,
    })
	_consumeBg:setAnchorPoint( 0.5, 1 )
	_consumeBg:setPosition( _bottomBgWidth/2, _bottomBgHeight - 10 )
	_bottomBg:addChild( _consumeBg )
	-- 材料标题
	local _consumeTitle = cc.Sprite:create( "res/Main/role/equip/advanceConsume.png" )
	_consumeTitle:setPosition( _consumeBgWidth/2, _consumeBgHeight - 20 )
	_consumeBg:addChild( _consumeTitle )
    for i, v in ipairs( self._data.consume ) do
        -- iconBg
        local _iconBg = cc.Sprite:create( "res/Main/common/popBg/di_2.png" )
        _iconBg:setPosition( _consumeBgWidth/#self._data.consume*( i - 0.5 ), 57 )
        _iconBg:setScale( 1 )
        _consumeBg:addChild( _iconBg )
		local _icon = zc.createIconByData({
	        data = {
	            mainType = v.itemType,
	            type = v.itemId,
	            id = v.itemId,
	        },
            attrLabel = {
                now=zc.getNumByTypeId( v.itemType, v.itemId ),
                need=v.itemNum,
            },
	        pos = cc.p( _iconBg:getPositionX(), _iconBg:getPositionY() + 3 ), 
	    	listener = function()
            	zc.createItemSynthesisPop({
                    itemType = v.itemType,
                    itemId = v.itemId,
                    costNum = v.itemNum, --需要消耗的数量
                    hidecallback = function()
                    	self:hide()
                   	end,
                })
	    	end
	    })
	    _icon:setScale( 0.7 )
		_consumeBg:addChild( _icon )
	end

    -- 装备
	local _btn = zc.createCommomBtn({
        tag = 2,
        text = LANGUAGE_ROLE.activate_space,
        pos = cc.p( _bottomBgWidth/2, 50 ),
        listener = function()
        	zc.sendHttp({
        		apiName = "Hero_activeGrid",
        		params = {heroId = self._heroId, starId = self._starId, indexs = self._index},
        		successCallback = function(data)
    			--功能引导
	    			local _currentGID = getGuideManager():getCurrentGID()
					if _currentGID == GuideKey.KEY_11405 then
						zc.setGuideFuncNextStep(_currentGID, false)
					end
	    			PlayerData:updataData( data )
	    			PlayerData:setGeneralInfoById( data.hero.id, data.hero )
	    			if self._callback then
	    				self._callback( data.hero.grid )
	    			end
					-- 刷新升星红点
					zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ROLELAYER_CHANGE, data = {id = 4}})
	    			self:hide()
    			end,
    		})
    	end
	})
	_bottomBg:addChild( _btn )

	if self._status.activatable then
		-- 可以镶嵌
		_btn:setEnable( true )
	else
		-- 不能镶嵌
		_btn:setEnable( false )
	end
	self._guide_btn = _btn
end

function RoleStarupInfoPop:onEnter()
	getGuideManager():addMaskLayer()
	performWithDelay(self, function ()
		getGuideManager():removeMaskLayer()
		self:guideFunc_1()
	end,0.3)
end

--功能引导
function RoleStarupInfoPop:guideFunc_1()
	--功能引导
	local _currentGID = getGuideManager():getCurrentGID()
	if _currentGID == GuideKey.KEY_11405 then
		if self._guide_btn and self._guide_btn:isEnable() then
			getGuideManager():setObjTarget(self._guide_btn)
	        getGuideManager():startGuide()
		else
			zc.setGuideFuncNextStep(_currentGID)
			if self._callback then
				self._callback()
			end
			self:hide()
		end
	end
end

return RoleStarupInfoPop