local ZhanFaLayer = class("ZhanFaLayer", function()
	local params = {
		src = "res/Main/common/commom_zhanfa.png"
	}
    return zc.createNormalDialog(params)
end)
function ZhanFaLayer:create( params )
    return ZhanFaLayer.new( params )
end

function ZhanFaLayer:onEnter( ... )
	zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_ZHANFA_CHANGE,
        callback = function(data)
            dump(data.data, "---EVENT_REDORBUBBLE_CHANGEEVENT_REDORBUBBLE_CHANGE--")
            if tolua.isnull(self) then
                return
            end
            
        	if data.data.isTiaoZhaun then
        		self.isTiaoZhaun = true
        		self:refrehData(true)
        		local id = data.data.id
        		for k,v in pairs(self._heroList) do
        			if v.id == id then
        				self.selectindex = k 
        				self._data = v
        			end
        		end
	        	self.seletToCell = data.data.seletToCell
	        	self.heroTableView:reloadDataAndScrollToCurrentCell()
				self.heroTableView:scrollToCell(self.selectindex - 1, false)
			    self._tableView:reloadDataAndScrollToCurrentCell()
			    self.isTiaoZhaun = false
			    return
			end
			if data.data.isEquip then
				self.isTiaoZhaun = true
	    		self:refrehData(true)
	    		if self._data_id then
	    			for k,v in pairs(self._heroList) do
	        			if v.id == self._data_id then
	        				self.selectindex = k 
	        				self._data = v
	        			end
	        		end
	    		end
	        	self.isEquip = data.data.isEquip
	        	self._tableView:reloadDataAndScrollToCurrentCell()
	        	self.heroTableView:reloadDataAndScrollToCurrentCell()
				self.heroTableView:scrollToCell(self.selectindex - 1, false)
	        	self.isTiaoZhaun = false
	        	return
        	end
        	if data.data.isUpgrade then
        		self:refrehData(true)
        		if self._data_id then
	    			for k,v in pairs(self._heroList) do
	        			if v.id == self._data_id then
	        				self.selectindex = k 
	        				self._data = v
	        			end
	        		end
	    		end
        		self._tableView:reloadDataAndScrollToCurrentCell()
	        	self.heroTableView:reloadDataAndScrollToCurrentCell()
	        	return
        	end
        	if data.data.isUnLoad then
        		self:refrehData(true)
        		if self._data_id then
	    			for k,v in pairs(self._heroList) do
	        			if v.id == self._data_id then
	        				self.selectindex = k 
	        				self._data = v
	        			end
	        		end
	    		end
        		self._tableView:reloadDataAndScrollToCurrentCell()
	        	self.heroTableView:reloadDataAndScrollToCurrentCell()

	        	self.heroTableView:scrollToCell(self.selectindex - 1, false)
	        	return
	        end
	        if data.data.isBack then
		        self:refrehData(true)
		        self.select_index = data.data.select_index
		        self.seletToCell = data.data.seletToCell
	    		self._tableView:reloadDataAndScrollToCurrentCell()
	        	self.heroTableView:reloadDataAndScrollToCurrentCell()
        	end
        	
        end
    })
end

function ZhanFaLayer:onExit( ... )
	zc.removeEventListener("EVENT_ZHANFA_CHANGE")
end

function ZhanFaLayer:ctor( params )
	self._size = self:getContentSize()
	self:initData(params)
	self:initUI(params)
	self:initRoleHeadUI(params)
	self:initTableView()
end

function ZhanFaLayer:initUI(params)
	local fireEffect = zc.createSpine( {scale = 1.1, fileName = "skeleton", path = "res/animation/zhanfa_fire/"} )
    fireEffect:playAction("idle1", true)
    fireEffect:setPosition(ccp(530, 305))
    self:addChild(fireEffect)

	local bg = zc.createSprite("res/Main/role/zhanfaskill.png")
	bg:setAnchorPoint(0.5,1)
	bg:setPosition(cc.p(180,self._size.height - 10))
	self:addChild(bg)

	self._leftBtn = zc.createPushButton({
    	normalFile = "res/Main/arena/hallFame/arrow_up.png",
    	selectedFile = "res/Main/arena/hallFame/arrow_down.png",
    	pos = cc.p(201,60),
    	endCallback = function()
    	end,
    })
    self._leftBtn:setEnable(false)
    self:addChild(self._leftBtn)
    local _node1 = zc.createSprite("res/Main/arena/hallFame/arrow_up.png")
    _node1:setFlippedX(true)
    local _node2 = zc.createSprite("res/Main/arena/hallFame/arrow_down.png")
    _node2:setFlippedX(true)

    self._rightBtn = zc.createPushButton({
    	normalNode = _node1,
    	selectedNode = _node2,
    	pos = cc.p(890 + self._leftBtn:getContentSize().width, 60),
    	endCallback = function()
    	end,
    })
    self._rightBtn:setEnable(false)
    self:addChild(self._rightBtn)

    local _descBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/exclamation_u.png",
        selectedFile = "res/Main/common/button/exclamation_d.png",
        pos = cc.p(40, 500),
        endCallback = function()
            zc.createRulePop(15)
        end
    })
    self:addChild(_descBtn)
end

function ZhanFaLayer:initData(params)
	-- 主角武将id
    self._mainHeroId = tonumber( PlayerData.info.heroId ) or 0
    self._heroIndex = 1
    self.selectindex =1
    self.selectSkillIndex = 0
    self.skillCellNum = 1
    self.seletToCell = 1
    self.isEquip = false
    self.select_index = 0
    self:refrehData(false)
    self._data = self._heroList[1]
    self.isTiaoZhaun = false
    self:guideFunc()

end
function ZhanFaLayer:guideFunc()
	local currentGID = getGuideManager():getCurrentGID()
	if not PlayerData:getFuncGuideInfo(388) or currentGID == GuideKey.KEY_14802 then
		if not PlayerData:getFuncGuideInfo(388) then
			getGuideManager():sendFuncGuideTrigger(388)
		end
		if not PlayerData:getFuncGuideInfo(386) then
			getGuideManager():sendFuncGuideTrigger(386)
		end
		local _currentGID = 14803
		getGuideManager():setCurrentGID(GuideKey.KEY_14803)
		local function _callBack()
        	getGuideManager():addMaskLayer()
        	performWithDelay(self, function()
        		zc.setGuideFuncNextStep(_currentGID, true)
        		-- getGuideManager():removeMaskLayer()
        		local _layer = self:getChildByTag(20000)
	            getGuideManager():setObjTarget(_layer.plus_list[1])
	            getGuideManager():startGuide()
		    end, 0.3)
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end
end

function ZhanFaLayer:refrehData(flag)
	-- 上阵武将
    local _upMatrix = {}
    for i, v in pairs( PlayerData:getFormationsInfo()) do
        if ( tonumber( v.status ) or 0 ) == 1 then
            for j = 1, 9 do
                _upMatrix[tonumber( v["location"..j])] = true
            end
        end
    end
    self._upMatrix = _upMatrix
    --武将列表
    self._heroList = {}
    local _heroList = PlayerData:getGeneralInfo()
    local _mainHeroData = {}
    for i, v in ipairs( _heroList ) do
    	local _newAdvance = tonumber(v.newAdvance) or 0
    	local _params = {
	        heroId = v.heroId,
	        star = v.star, 
	        newAdvance = newAdvance,
	    }
	    if tonumber(v.id) == tonumber(PlayerData.info.heroId) then
	        _params.heroData = v
	    end
	    local _skillData = zc.getHeroSkillData(_params)
	    for d,_data in pairs(_skillData) do
	    	if _data.skillType == 3 or _data.skillType == 4 then
		        if tonumber( v.id ) ~= self._mainHeroId then
		            self._heroList[#self._heroList + 1] = v
		        else
		            _mainHeroData = v
		        end
		        break
	    	end
	    end
    end
    table.sort(self._heroList, function( a, b )
    	local idA = tonumber(a.id)
        local idB = tonumber(b.id)
        if _upMatrix[idA] ~= _upMatrix[idB] then
            return  _upMatrix[idA]
    	end
		local _canComposeA = tonumber(a.canCompose) or 0
		local _canComposeB = tonumber(b.canCompose) or 0
		if _canComposeA ~= _canComposeB then
			return _canComposeA > _canComposeB
		end
		if _canComposeA == 1 then
			local _dbA = a.db or {}
			local _dbB = b.db or {}
			local _qualificationsA = tonumber(_dbA.qualifications) or 0
			local _qualificationsB = tonumber(_dbB.qualifications) or 0
			if _qualificationsA ~= _qualificationsB then
				return _qualificationsA > _qualificationsB
			end
			local _idA = tonumber( _dbA.id ) or 0
			local _idB = tonumber( _dbB.id ) or 0
			return _idA < _idB
		end
		local tacticsA = tonumber(a.tactics.tactics)
    	local tacticsB = tonumber(b.tactics.tactics)
    	if tacticsA ~= tacticsB then
    		return tacticsA < tacticsB
    	end
    	return tonumber( a.fighting ) > tonumber( b.fighting )
    end)
    table.insert(self._heroList, 1, _mainHeroData)
end

function ZhanFaLayer:initRoleHeadUI(params)
	local bg = ccui.Scale9Sprite:create(cc.size(100,252,1,1),"res/Main/heroSoul/bar.png")
	bg:setContentSize(105,1005)
	bg:setRotation(90)
	bg:setPosition(610,68)
	self:addChild(bg)

	local bgsize = bg:getContentSize()
	local size_ = self:getContentSize()
	local tableView = zc.ZCTableView:create(cc.size(640 ,95))
    tableView:setDirection( cc.SCROLLVIEW_DIRECTION_HORIZONTAL )
    tableView:setPosition(248,20)
    tableView:setDelegate()
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    local _cellWidth = 93
    local _cellHeight = 95
    local function cellSizeForTable(table, cellIndex) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell(cell, cellIndex + 1,_cellWidth,_cellHeight)
        end
        -- 更新界面
        self:updateHeroCell(cell, cellIndex + 1,table)
        return cell
    end
    local function numberOfCellsInTableView()
    	local num = #self._heroList
        return num --#self._heroList[self._heroIndex]
    end
    tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    tableView:registerScriptHandler(function()
    	if #self._heroList <= 7 then
    		self._leftBtn:setVisible( false)
    		self._rightBtn:setVisible(false)
    	else
        	local pos = tableView:getContainer():getPosition()
        	self._leftBtn:setVisible( pos < 0)
        	self._rightBtn:setVisible( pos > -93*(#self._heroList - 7) + 19)
    	end
    end, cc.SCROLLVIEW_SCRIPT_SCROLL)
    self:addChild( tableView )
    -- tableView:scrollToCell(self.selectindex - 1,true)
    tableView:reloadData()
    self.heroTableView = tableView
    local posX = {201,920}
    for i = 1,2 do
    	local btn1 = zc.createPushButton({
			touchSize = cc.size(100,105),
	        pos = cc.p(posX[i],60),
	        endCallback = function()
	        	-- print("i::::::",i)
	        	return
	        end
		})
		self:addChild(btn1)
    end
end

function ZhanFaLayer:buildCell(cell,cellIndex,_cellWidth,_cellHeight)
	local _data = self._heroList[cellIndex]
	if _data then
		local _item = zc.createIconByData({
	        data = {
	            mainType = zc.mainTypeSoldier,
	            type = 1, 
	            id = _data.heroId,
	            level = zc.getLevelTipShow() .. _data.level,
	            reincarnate = _data.reincarnate,
	        }, 
	        quality = _data.quality,
	        -- showLevel = true,
	        scale = 0.7,
	        pos = cc.p(_cellWidth * 0.5, _cellHeight*0.5), 
	        listener = function ( ... )
	        end
	    })
        local weaponType = zc.createSprite("res/Main/role/common/weapon_icon_1.png" )
        weaponType:setScale(0.7)
        weaponType:setPosition(ccp(_item:getContentSize().width - 20, _item:getContentSize().height - 20))
        weaponType:setName("weaponType")
        _item:addChild(weaponType)

	    cell:addChild(_item)
	    cell.item = _item

	    local zhen = zc.createSprite("res/Main/role/role_zhen.png")
	    zhen:setPosition(_cellWidth * 0.5 + 27,_cellHeight * 0.5 - 25)
	    zhen:setVisible(false)
	    zhen:setScale(0.8)
	    cell:addChild(zhen)
	    cell.zhen = zhen
	    local duigou = zc.createSprite("res/Main/role/selet_head.png")
	    duigou:setPosition(_cellWidth * 0.5,_cellHeight * 0.5)
	    duigou:setVisible(false)
	    duigou:setScale(0.7)
	    cell:addChild(duigou,-1)
	    cell.duigou = duigou

	    local tiao_bg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 8, 8 ), "res/Main/common/popBg/di_properties.png" )
	   	tiao_bg:setContentSize(95,30)
	   	tiao_bg:setPosition(_item:getContentSize().width/2 + 10,15)
	   	_item:addChild(tiao_bg)

	   	local useedLabel = zc.createLabel({
	    		text = zc.lang("already1")..zc.lang("use"),
	            outLine = true,
	            fontSize = 24,
	            pos = cc.p( tiao_bg:getContentSize().width/2, tiao_bg:getContentSize().height/2 ),
	            outLine = true,
	            color = cc.c3b(235,204,160),
	    	})
	    tiao_bg:addChild(useedLabel)
	    cell.tiao_bg = tiao_bg
	    tiao_bg:setVisible(false)
	end
end

function ZhanFaLayer:updateHeroCell(cell,cellIndex,table_)
	-- print("cellIndex:",cellIndex)
	local _data = self._heroList[cellIndex]
	-- dump(_data,"测试：")
	if _data then
		-- print("selectindex:",self.selectindex,"cellIndex:",cellIndex)
		cell.duigou:setVisible(self.selectindex == cellIndex and true or false)
        cell.zhen:setVisible(self._upMatrix[tonumber(_data.id)] and true  or false)
        cell.tiao_bg:setVisible(tonumber(_data.tactics.tactics) == 1 and true or false)
        if self.selectindex == cellIndex then self._data_id = _data.id end
		local _info = zc.updateIconByData(cell.item, {
			data = {
	            mainType = zc.mainTypeSoldier,
	            type = 1, 
	            id = _data.heroId,
	            level = zc.getLevelTipShow() .. _data.level,
	            reincarnate = _data.reincarnate,
	            qualifications = _data.qualifications,
	        }, 
	        quality = _data.quality,
            showQuality = true,
	        listener = function()
	        	if self.selectindex == cellIndex then print("英雄你点到自己了") return end
	        	if tonumber(_data.tactics.tactics) == 1 then
                    zc.tipInfo(zc.lang("thisHeroUsing"))
        			return
        		end
	        	for i=1,#self._heroList do
					local cell_ = table_:cellAtIndex(i-1)
					if cell_ then
						if cell_ == cell then
                            self.selectindex = cellIndex
							cell.duigou:setVisible(true)
						else
							cell_.duigou:setVisible(false)
						end
					end
				end
		        self._data = self._heroList[cellIndex]
		        -- dump("-----------self._data-----",self._data)
		        
		        self.selectSkillIndex = 0
		        self.selectindex = cellIndex
		        -- print("self.selectindex:",self.selectindex)
		        self.seletSkillIndex = cellIndex
		        self._data_id = _data.id
		        if self.isTiaoZhaun == false then
				    if tonumber(self._data.tactics.isUseCombine) == 2 then
				    	self.seletToCell = 2
				    elseif tonumber(self._data.tactics.isUseCombine) == 1 or tonumber(self._data.tactics.isUseCombine) == 0 then
				    	self.seletToCell = 1
				    else
				    	self.seletToCell = 1
				    end
				end
	        	self._tableView:reloadData()
            end
		})
        local weaponType = cell.item:getChildByName("weaponType")
        local weapon
        local _mainRoleId = tonumber( PlayerData.info.heroId ) or 0
        if _data.id == _mainRoleId  then
            local mainData = PlayerData:getWeaponsInfoById(_mainRoleId)
            weapon = mainData.type
        else
            weapon = _data.weaponType
        end
        weaponType:setTexture("res/Main/role/common/weapon_icon_" .. weapon .. ".png")
	end
end

function ZhanFaLayer:initTableView()
	local bg = zc.createSprite("res/Main/role/skilldi.png")
	bg:setPosition(self._size.width - 86,self._size.height/2)
	self:addChild(bg)
	self.bgsize = bg:getContentSize()
	local tableSize = cc.size(174,400)
    local tableView = zc.ZCTableView:create(tableSize)
    tableView:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tableView:setPosition( -15, 0 )
    tableView:setDelegate()
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN) --kTableViewFillBottomUp  kTableViewFillTopDown
    local _cellWidth = self.bgsize.width
    local _cellHeight = 130
    -- dump(self._data)
    local function cellSizeForTable(table, cellIndex) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:createCell(cell)
        end
        -- 更新界面
        -- print("cellIndex.       ",cellIndex)
        self:updateCell(cell, cellIndex + 1,table)

        return cell
    end
    local function numberOfCellsInTableView()
    	local _newAdvance = tonumber(self._data.newAdvance) or 0
	    local _params = {
	        heroId = self._data.heroId,
	        star = self._data.star, 
	        newAdvance = newAdvance,
	    }
	    if self._data.id == tonumber(PlayerData.info.heroId) then
	        _params.heroData = self._data
	    end
	    local _skillData = zc.getHeroSkillData(_params)
	    local _newData = {}
	    for i=1,#_skillData do
	    	local data = _skillData[i]
	    	if data.skillType == 3 or data.skillType == 4 then
	    		table.insert(_newData,data)
	    	end
	    end
	    self.skillCellNum = #_newData
        return self.skillCellNum
    end
    tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    bg:addChild( tableView )
    tableView:reloadData()

    self._tableView = tableView
end

function ZhanFaLayer:createCell(cell)
	local cellsize = cell:getContentSize()
	local bg = zc.createSprite("res/Main/role/modi.png")
	bg:setAnchorPoint(0,0.5)
	bg:setPosition(10,cellsize.height + 60)
	cell:addChild(bg)
	cell.bg = bg

	local bgsize = bg:getContentSize()
	local x = bgsize.width/2 + 3
	local img = ZCSprite:create("res/Main/hero/hero_item1.png")
	img:setPosition(cc.p(x, bg:getContentSize().height/2 ))
	img:setTouchSize(cc.size(bgsize.width,bgsize.height))
	img:setSwallowTouches(false)
	img:setTouchEndedCallback(function ()
	end)
	cell.img = img
	bg:addChild(img)
	img:setScale(0.7)
	local _info = zc._getIconInfo({
		data = {
            mainType=zc.mainTypeSkill,
            type=1, 
            id=1,
		}
	})
	
	local skillicon = zc.createSprite(_info.img)
	skillicon:setScale(0.9)
	skillicon:setPosition(x,bgsize.height/2)
	bg:addChild(skillicon)

	cell.skillicon = skillicon
	local _tag = cc.Sprite:create("res/Main/role/bisha.png")
	_tag:setPosition( skillicon:getPositionX() - skillicon:getContentSize().width/2,skillicon:getContentSize().height - 30)
	bg:addChild( _tag )
	local num_icon = zc.createSprite("res/Main/role/1.png")
	num_icon:setPosition(_tag:getContentSize().width/2 - 2,_tag:getPositionY() - _tag:getContentSize().height/2 + 25)
	_tag:addChild(num_icon)
	cell.num_icon = num_icon
	cell._tag = _tag

	self.pos = cell.bg:getPosition()
	self.imgx = cell.img:getPositionX()
	self.imgy = cell.img:getPositionY()
	self.iconposx = cell.skillicon:getPositionX()
    self.iconposy = cell.skillicon:getPositionY()
    self.tagx = cell._tag:getPositionX()
    self.tagy = cell._tag:getPositionY()
end

function ZhanFaLayer:updateCell(cell,index,table_)
	local _newAdvance = tonumber(self._data.newAdvance) or 0
    local _params = {
        heroId = self._data.heroId,
        star = self._data.star, 
        newAdvance = _newAdvance,
    }
    if self._data.id == tonumber(PlayerData.info.heroId) then
        _params.heroData = self._data
    end
    local _skillData = zc.getHeroSkillData(_params)
    local list = {}
    local defaultID = _skillData[1].combineSkillId

    for k,v in pairs(_skillData) do
    	if v.skillType == 3 or v.skillType == 4 then
    		table.insert(list,v)
    	end
    end
    local list_ = {}
    local hetiji
    for k,v in pairs(list) do
    	if v.skillType == 4 then
    		if tonumber(v.id) ~= defaultID then
    			table.insert(list_,v)
    		else
    			hetiji = v
    		end
    	else
    		table.insert(list_,v)
    	end
    end
    if hetiji then
    	table.insert(list_,1,hetiji)
    end
    local _data = list_[index]

    if _data and (_data.skillType == 3 or _data.skillType == 4 ) then
    	local _info = zc._getIconInfo({
			data = {
	           	mainType=zc.mainTypeSkill,
	            type=_data.id, 
	            id=_data.id,
			}
		})
		local distance = 18
		print("seletToCell:",self.seletToCell,"index:",index)
        local function SetCell(cell)
        	cell.bg:setTexture("res/Main/role/modi.png")
			cell.bg:setPositionX(self.pos + 8)
            cell.img:setPosition(self.imgx + 8, self.imgy)
            cell.skillicon:setPosition(self.iconposx + 8,self.iconposy)
            cell._tag:setPosition(self.tagx + 8,self.tagy)
        end
		cell.skillicon:setTexture(_info.img)

		if self.seletToCell == index then
			cell.bg:setTexture("res/Main/role/selectmodi.png")
            cell.bg:setPositionX(self.pos - 19)
            cell.img:setPosition(self.imgx + distance, self.imgy + distance)
            cell.skillicon:setPosition(self.iconposx + distance ,self.iconposy + distance)
            cell._tag:setPosition(self.tagx + distance,self.tagy + distance + 10)
            self:setLeftSkillInfo(_data,index)
		else
			SetCell(cell)
		end
		if self.selectSkillIndex ~= index then
			cell.img:setTouchEndedCallback(function ()
				for i = 1,self.skillCellNum do
	            	local cell_ = table_:cellAtIndex(i-1)
					if cell_ then
						if index == i then
                            self.selectSkillIndex = index
                            self.seletToCell = index
                            self.select_index = index
							cell.bg:setTexture("res/Main/role/selectmodi.png")
				            cell.bg:setPositionX(self.pos - 19)
				            cell.img:setPosition(self.imgx + distance, self.imgy + distance)
				            cell.skillicon:setPosition(self.iconposx + distance ,self.iconposy + distance)
				            cell._tag:setPosition(self.tagx + distance,self.tagy + distance + 10)
				            self:setLeftSkillInfo(_data,index)

						else
							SetCell(cell_)
						end
					end
	            end
			end)
		end
        cell._tag:setVisible(false)
        if _data.skillType == 3 then
            -- 必杀
            cell._tag:setTexture( "res/Main/role/bisha.png" )
            cell._tag:setVisible( true )
            cell.num_icon:setVisible(false)
        elseif _data.skillType == 4 then
            -- 奥义
            cell.num_icon:setVisible(true)
            cell._tag:setTexture( "res/Main/role/aoyi.png" )
            cell._tag:setVisible( true )
            local num = 0
            local cur_id = _data.id
            for k,v in pairs(list_) do
            	if _data.skillType == 4 then
            		num = num + 1
            	end
            end
            if num > 1 then
            	local _index
            	for i = 1,num do
            		local id = list_[i].id
            		if tonumber(cur_id) == tonumber(id) then
            			_index = i
            		end
        		end
        		cell.num_icon:setTexture("res/Main/role/".._index..".png")
            end
        else
            cell._tag:setVisible( false )
        end
    end
end

function ZhanFaLayer:setLeftSkillInfo(_data,index)
	self.skillData = _data
	self.heroData = self._data
	-- dump(self._data,"--------------更新武将信息---------")
	if _data == nil then
		if self.bisha_layer then
			self.bisha_layer:setVisible(false)
		end
		if self.aoyi_layer then
			self.aoyi_layer:setVisible(false)
		end
		return
	end
	local params = {
		skillData =  _data, -- 技能数据
		heroData =  self._data, -- 吃武将数据
		isEquip = self.isEquip, -- 区分卸下或者装备 true 卸下
		select_index = self.select_index, -- 第几个位置
		seletToCell = self.seletToCell -- 当前选择的英雄位置
	}
	if _data.skillType == 3 then
		local layer = self:getChildByTag(20000)
		if layer then
			self:removeChildByTag(20000)
		end
		local layer = self:getChildByTag(20001)
		if layer then
			self:removeChildByTag(20001)
		end
		local bisha_layer = requires("src/layer/role/ZhanFaBiSha.lua"):create(params)
		bisha_layer:setPosition(420,180)
		bisha_layer:setTag(20000)
		self:addChild(bisha_layer)
	elseif _data.skillType == 4 then
		local layer = self:getChildByTag(20000)
		if layer then
			self:removeChildByTag(20000)
		end
		local layer = self:getChildByTag(20001)
		if layer then
			self:removeChildByTag(20001)
		end
		params.index = index
		local aoyi_layer = requires("src/layer/role/ZhanFaAoYI.lua"):create(params)
		aoyi_layer:setPosition(420,180)
		aoyi_layer:setTag(20001)
		self:addChild(aoyi_layer)
	end
	self.isEquip = false
	self.select_index = 0
end

return ZhanFaLayer