--[[
FileName 		IdCardSignPop.lua --实名认证
ProjectName		HJ2
    
Created by wangming on 16-07-20

]]

local IdCardSignPop = class("IdCardSignPop", function()
	return ZCPopLayer:create({opacityValue = 0})
end)

function IdCardSignPop:create()
	local _pop = IdCardSignPop.new()
    _pop:show(false)
	return _pop
end

function IdCardSignPop:ctor()
	local _bg = zc.createNormalPop({
        tag = 2,
        src = "res/Main/common/popBg/bgWhite.png",
        bianZOrder = 1,
    })
	_bg:setPosition(zc.width*0.5, zc.height*0.5)
	self:addContent(_bg)

    local _size = _bg:getContentSize()

    local _closeBtn = zc.createBackButton({
        pos = cc.p(_size.width-10, _size.height-10),
        listener = function () 
            self:hide()
        end,
    })
    _bg:addChild(_closeBtn, 1)

    local _title = zc.createSprite("res/Main/setting/idCardSignTitle.png")
    _title:setPosition(50, _size.height)
    _bg:addChild(_title, 1)

    local _diSize = cc.size(830, 300)
    local _di = zc.getScaleNode("res/Main/setting/idCardSignDi.png", _diSize)
    _di:setPosition(_size.width*0.5, _size.height*0.5 + 40)
    _bg:addChild(_di)

    local _text = "1、《青龙战纪》积极响应国家新闻出版总署防沉迷政策要求，自主开发出本游戏防沉迷系统。\n"
                .. "2、年龄已满18周岁的玩家，在填写身份资料后，可以不受防沉迷系统影响，自由进行游戏。否则当日游戏在线时间累积到达3小时后，将被系统强行下线。\n"
                .. "3、系统仅支持输入15位或18位的中国居民身份证号码，持有其他证件的玩家请与客服联系。\n"
                .. "4、填写身份信息将使我们可以对您的年龄作出判断，以确定您是否需要纳入防沉迷系统\n"
                .. "5、用户填写的身份信息属于用户隐私，游戏绝不会公开、编辑或透露用户的个人信息，除非有法律许可及公安管理规定。"

    local _showText = zc.createLabel({
        text = _text,
        fontSize = 22, 
        color = cc.c3b(90, 50, 41),
        width = _diSize.width - 20,
        ap = cc.p(0.5, 1),
        pos = cc.p(_diSize.width*0.5, _diSize.height - 20),
    })
    _di:addChild(_showText)

    _diSize = cc.size(_diSize.width, 70)
    local _di2 = zc.getScaleNode("res/Main/setting/idCardSignDi2.png", _diSize)
    _di2:setAnchorPoint(0.5, 1)
    _di2:setPosition(_size.width*0.5, _size.height*0.5 - 95)
    _bg:addChild(_di2)

    local _nameLabel = zc.createLabel({
        text = zc.lang("player_name") .. ":",
        size = 24,
        ap = cc.p(0, 0.5),
        pos = cc.p(40, _diSize.height*0.5),
    })
    _di2:addChild(_nameLabel)

    local _inputSize = cc.size(240, 40)
    local _nameInputBg = zc.getScaleNode("res/Main/setting/inputBg.png", _inputSize)
    _nameInputBg:setAnchorPoint(0, 0.5)
    _nameInputBg:setPosition(_nameLabel:getContentSize().width + 5, _nameLabel:getContentSize().height*0.5)
    _nameLabel:addChild(_nameInputBg)

    local _nameBox = ccui.EditBox:create(_inputSize, "res/Main/common/img_empty.png") 
    _nameBox:setFontSize(22)
    _nameBox:setAnchorPoint(0, 0.5)
    _nameBox:setPlaceHolder(zc.lang("enter_name"))
    _nameBox:setPlaceholderFontColor(cc.c3b(105,94,79))
    _nameBox:setPlaceholderFont(zc.getFont(1), 22)
    _nameBox:setMaxLength(20) 
    _nameBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
    _nameBox:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    _nameBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE )
    _nameBox:setPosition(0, _inputSize.height*0.5)  
    _nameInputBg:addChild(_nameBox)

    local _idLabel = zc.createLabel({
        text = zc.lang("id_card") .. ":",
        size = 24,
        ap = cc.p(0, 0.5),
        pos = cc.p(_diSize.width*0.5 - 30, _diSize.height*0.5),
        
    })
    _di2:addChild(_idLabel)

    _inputSize = cc.size(330, 40)
    local _idInputBg = zc.getScaleNode("res/Main/setting/inputBg.png", _inputSize)
    _idInputBg:setAnchorPoint(0, 0.5)
    _idInputBg:setPosition(_idLabel:getContentSize().width + 5, _idLabel:getContentSize().height*0.5)
    _idLabel:addChild(_idInputBg)

    local _idBox = ccui.EditBox:create(_inputSize, "res/Main/common/img_empty.png") 
    _idBox:setFontSize(22)
    _idBox:setAnchorPoint(0, 0.5)
    _idBox:setPlaceHolder(zc.lang("enter_id_card_num"))
    _idBox:setPlaceholderFontColor(cc.c3b(105,94,79))
    _idBox:setPlaceholderFont(zc.getFont(1), 22)
    _idBox:setMaxLength(20) 
    _idBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
    _idBox:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    _idBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE )
    _idBox:setPosition(5, _inputSize.height*0.5)
    _idInputBg:addChild(_idBox)


    local _shadow = zc.getScaleNode("res/Main/common/popBg/shadow_white.png", cc.size(_size.width, 12))
    _shadow:setAnchorPoint(0.5, 1)
    _shadow:setPosition(_size.width*0.5, _size.height - 50)
    _bg:addChild(_shadow)

    local myScale9 = zc.getScaleNode("res/Main/role/trinket/sellDi.png", cc.size(_size.width, 85))
    myScale9:setAnchorPoint(cc.p(0.5, 0))
    myScale9:setPosition(cc.p(_size.width/2, 0))
    _bg:addChild(myScale9)

    local btn_left = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("commit_2"),
        pos = cc.p(_size.width*0.25 + 50, 45),
        endCallback = function()
            local _name = _nameBox:getText()
            local _id = _idBox:getText()
            if not _name or _name == "" then
                zc.tipInfo(zc.lang("enter_name"))
                return
            elseif not _id or _id == "" then
                zc.tipInfo(zc.lang("enter_id_card_num"))
                return
            end
            zc.sendHttp({
                apiName = "User_idRegeist",
                params = {idname = _name, idcard = _id},
                successCallback = function(data)
                    if data.result == 1 then
                        zc.tipInfo(zc.lang("tips_renzheng_success"))
                        PlayerData:setBaseInfoByTag("isRealName", 1)
                        self:hide()
                    else
                        zc.tipInfo(zc.lang("tips_renzheng_fail"))
                    end
                end,
            })
        end,
    })
    _bg:addChild(btn_left)
    
    ------------be added artistic word
  
    local btn_right = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("cancel2"),
        pos = cc.p(_size.width*0.75 - 50, 45),
        endCallback = function()
            self:hide()
        end,
     })
    _bg:addChild(btn_right)
end

return IdCardSignPop