--[[
    FileName: SmithyGodPreViewPop.lua
    Author: andong
    Date: 2016-03-17
    Purpose: 神兵进阶预览弹窗
]]
local SmithyGodPreViewPop = class( "SmithyGodPreViewPop", function ()
    return ZCPopLayer:create()
end)
function SmithyGodPreViewPop:create(params)
    return SmithyGodPreViewPop.new(params)
end
function SmithyGodPreViewPop:ctor(params)
    self._weaponId = params["weaponId"]
    self:initUI()
    self:show()
end

function SmithyGodPreViewPop:initUI()
    local popBg = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
        pos = cc.p(zc.width*0.5, zc.height*0.5)
    })
    self:addContent(popBg)
    self._popBg = popBg
    local _bgSize = popBg:getContentSize()

    local close = zc.createBackButton({
        pos = cc.p(_bgSize.width-10, _bgSize.height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close)

    local titleLab = zc.getTipPopTitle( "jinjieyulan" )
    titleLab:setPosition( _bgSize.width/2, _bgSize.height - 30 )
    popBg:addChild(titleLab)
    
    -- 背景
    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 180))
    middleBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 40)
    middleBg:setName("middleBg")
    popBg:addChild(middleBg)

    local arrow = zc.createSprite("res/Main/smithy/shenbing/shenbing_arrow.png")
    arrow:setAnchorPoint(0.5, 0.5)
    arrow:setPosition(middleBg:getContentSize().width/2, middleBg:getContentSize().height/2)
    middleBg:addChild(arrow)
        
    --
    self:showAdvanceInfo()
end
function SmithyGodPreViewPop:showAdvanceInfo()
    local weaponId = self._weaponId
    if not weaponId then
        return
    end
    local _nowJinjieTable = gameData.getDataFromCacheWithPrimaryKey("weapon_advanced", weaponId)
    
    local nextWeaponInfo = {}
    if not _nowJinjieTable or not _nowJinjieTable["id"] then
        local item1, info= zc.createIconByData({
            data = {
                mainType = zc.mainTypeWeapon,
                type = 1,
                id = weaponId,
                quality = 1,
            }, 
            pos = cc.p(self._popBg:getContentSize().width/2, 234 + 20), 
        })
        item1:setScale(95/120)
        self._popBg:addChild(item1)
        -- dump(info)
        local name1 = zc.createLabel({
            text = info.name,
            outLine = true,
            fontSize = 18,
            pos = cc.p(item1:getPositionX(), 165 + 20),
            color = zc.getColorByQuality(info.star),
            pixel = 1.3
        })
        self._popBg:addChild(name1)
        
        nextWeaponInfo["id"] = weaponId
    else
        nextWeaponInfo = gameData.getDataFromCacheWithPrimaryKey("weapon", _nowJinjieTable["newId"])

        local tipLab = zc.createLabel({
            text = zc.lang("achieve") .._nowJinjieTable["needStrengthen"].. zc.lang("level_1") .. zc.lang("can_advance_to"),
            outLine = true,
            fontSize = 20,
            pos = cc.p(self._popBg:getContentSize().width/2, 160 + 20),
            pixel = 1.3
        })
        self._popBg:addChild(tipLab)
        

        local item1, info= zc.createIconByData({
            data = {
                mainType = zc.mainTypeWeapon,
                type = 1, 
                id = _nowJinjieTable["id"],
                quality = 1,
            }, 
            pos = cc.p(90+30, 234+ 20), 
        })
        item1:setScale(95/120)
        self._popBg:addChild(item1)
        local name1 = zc.createLabel({
            text = info.name,
            outLine = true,
            fontSize = 18,
            pos = cc.p(item1:getPositionX(), 165+ 20),
            color = zc.getColorByQuality(info.star),
            pixel = 1.3
        })
        self._popBg:addChild(name1)
        
        local item2, info2= zc.createIconByData({
            data = {
                mainType = zc.mainTypeWeapon,
                type = 1, 
                id = _nowJinjieTable["newId"],
                quality = 1,
            }, 
            pos = cc.p(371+30,234+ 20), 
        })
        item2:setScale(95/120)
        self._popBg:addChild(item2)
        local name2 = zc.createLabel({
            text = info2.name,
            outLine = true,
            fontSize = 18,
            pos = cc.p(item2:getPositionX(), 165+ 20),
            color = zc.getColorByQuality(info2.star),
            pixel = 1.3
        })
        self._popBg:addChild(name2)
        
    end 

    local consumeTitleBg = zc.createSprite("res/Main/smithy/shenbing/title_bg.png")
    consumeTitleBg:setAnchorPoint(0, 1)
    consumeTitleBg:setPosition(6, 126 + 20)
    self._popBg:addChild(consumeTitleBg)
    local consumeTitle = zc.createLabel({
        text = zc.lang("advanced") .. zc.lang("skill"),
        outLine = true,
        fontSize = 20,
        pos = cc.p(consumeTitleBg:getContentSize().width/2-13, consumeTitleBg:getContentSize().height/2),
        pixel = 1.3
    })
    consumeTitleBg:addChild(consumeTitle)
        
    --技能
    local skillData = gameData.getDataFromCache("weapon_skill", {weaponId=nextWeaponInfo["id"]} )
    local skillInfo = {}
    for i = 1, #skillData do
        local v = skillData[i]
        if v["skillId"] and tonumber(v["skillId"]) > 0 then
            local static = gameData.getDataFromCacheWithPrimaryKey("skill", v["skillId"])
            if static["subType"] and tonumber(static["subType"]) ~= 1 then
                local idx = #skillInfo + 1
                skillInfo[idx] = {}
                skillInfo[idx].skillid = v["skillId"]
                skillInfo[idx].skillname = static["name"] or ""
            end
        end
    end

    for i = 1, #skillInfo do
        local item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSkill,
                type = 1, 
                id = skillInfo[i].skillid,
            }, 
            pos = cc.p(75+(i-1)*110, 52 + 15), 
            listener = function ()
                zc.createSkillInfoPop({id = skillInfo[i].skillid})
            end
        })
        self._popBg:addChild(item)
        item:setScale(0.8)
    end
end

return SmithyGodPreViewPop