--[[
    解锁新神兵
    by wangxiaomeng
]]
local UnlockGodWeponLayer = class("UnlockGodWeponLayer", function ()
    return ZCDialog:create()
end)

function UnlockGodWeponLayer:create( params )
    return UnlockGodWeponLayer.new( params )
end

function UnlockGodWeponLayer:onCleanup()
    
end

function UnlockGodWeponLayer:onEnter(  )
    self._isUnlockNew = true
    self:guid()
end
function UnlockGodWeponLayer:guid(  )
    local _currentGID = getGuideManager():getCurrentGID()
    print("unlockWeapon id:".._currentGID)
    if _currentGID == GuideKey.KEY_15106 then
        zc.setGuideFuncNextStep(_currentGID, true)
        local function _callback()
            print("unlockWeapon 对话")
            self._isUnlockNew = false
        end
        getGuideManager():setHeroFuncCallBack(_callback)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_15108 then
        getGuideManager():setObjTarget(self._btn_back)
        getGuideManager():startGuide()
    end
end
function UnlockGodWeponLayer:ctor( params )
    self:initData(params)
    self:initUI()
end

function UnlockGodWeponLayer:initData( params )
    self._roleWeapons = params._roleWeapons or {}
    -- print("长度："..table.getn(self._roleWeapons))
    local baseInfo = PlayerData:getBaseInfo()
    local _sexId = tonumber(baseInfo["seigniorId"]) or 1
    local _initModel = {[1]="nanzhu",[2]="nvzhujue"}
    local _nowModel = _initModel[_sexId]
    self._nowModel = _nowModel --当前玩家的模型
    if _nowModel == "nanzhu" then
        zc.createArmature({fileName = "nanzhu_shan" , async = true, asyncCallback = function() end})
    elseif _nowModel == "nvzhujue" then
        zc.createArmature({fileName = "nvzhuqiang", async = true, asyncCallback = function() end})
    end
    self._isContinueGuid = false
    -- 老玩家如果进来，没有可以打造的神器就变为true,可以退出
    -- dump(self._roleWeapons, "nnnnnn--")
    local isFlag = true
    for k,v in pairs(self._roleWeapons) do
        if v["ISOPEN"] == false then
            isFlag = false
            break
        end
    end
    self._flag = isFlag
end

function UnlockGodWeponLayer:initUI( )
    -- 背景
    local background = cc.Sprite:create( "res/Main/smithy/unlockshenbing/bg.png" )
    background:setPosition( zc.width / 2, zc.height / 2 )
    self:addChild( background )
    self._bgImg = background

    -- 云
    zc.getYunDongTai(nil,2,function(armUp, armDown)
        if not tolua.isnull(self) then
            self:addChild( armUp, 2 )
            -- self:addChild( armDown, 3 )
        end
    end)
    -- 返回按钮
    local _back = zc.createTopBackButton({
        listener = function ()
            local _currentGID = getGuideManager():getCurrentGID()
            print("退出的时候：".._currentGID)
            if self._flag == true then
                print("已经都解锁了")
                if _currentGID == GuideKey.KEY_15108 then
                    getGuideManager():setCurrentGID(GuideKey.KEY_15110, true)
                end
                LayerManager.removeLayout()
            elseif self._isUnlockNew == false then
                zc.tipInfo(zc.lang("tip_xiandazao"))
            elseif self._isContinueGuid == true then
                print("进入self._isContinueGuid = true")
                zc.setGuideFuncNextStep(_currentGID, true)
                LayerManager.removeLayout()
            else
                if _currentGID == GuideKey.KEY_15108 then
                    getGuideManager():setCurrentGID(GuideKey.KEY_15110, true)
                end
                LayerManager.removeLayout()
            end
        end
    })
    _back:setPosition( zc.width , zc.height )
    self:addChild(_back, 3)
    self._btn_back = _back

    -- local ll = zc.createLabel({
    --     text = "dafdd",
    --     fontSize = 30,
    --     pos = cc.p(zc.width / 2,zc.height / 2),
    --     endCallback = function ( )
    --         zc.setGuideFuncNextStep(_currentGID, true)
    --         self:guid()
    --     end
    --     })
    -- background:addChild(ll)
    -- 标题
    local _title_di = zc.createSprite("res/Main/smithy/unlockshenbing/title_di.png")
    _title_di:setAnchorPoint(cc.p(0, 1))
    _title_di:setPosition(cc.p(38, zc.height - 20))
    self:addChild(_title_di, 3)

    local _title_sprite = zc.createSprite("res/Main/smithy/unlockshenbing/title.png")
    _title_sprite:setAnchorPoint(cc.p(0, 1))
    _title_sprite:setPosition(cc.p(0, zc.height))
    self:addChild(_title_sprite, 3)


    local _cellWidth = background:getContentSize().width / 4
    local _cellHeight = background:getContentSize().height
    self._cellWidth = _cellWidth
    self._cellHeight = _cellHeight
    local length = table.getn(self._roleWeapons)
    -- tableview
    local tableview = zc.ZCTableView:create(cc.size(background:getContentSize().width, _cellHeight))
    tableview:setBounceable(true)
    tableview:setInertia(true)
    tableview:setDirection(cc.SCROLLVIEW_DIRECTION_HORIZONTAL)
    tableview:setDelegate()
    tableview:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    self._tableview = tableview

    local function cellSizeForTable(table, index)
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, _cellWidth, _cellHeight)
        end
        self:updateCell(cell, index + 1)
        return cell
    end
    local function numberOfCellsInTableView()
        local len = table.getn(self._roleWeapons)
        if len < 4 then
            return 4
        end
        return table.getn(self._roleWeapons)
    end
    tableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    background:addChild(tableview)
    tableview:setPosition(cc.p(0, 0))
    tableview:reloadData()
    self._tableview = tableview
    
end

function UnlockGodWeponLayer:buildCell( cell, _cellWidth, _cellHeight )
    local bg_unopen = zc.createSprite("res/Main/smithy/unlockshenbing/unopen.png")
    bg_unopen:setPosition(cc.p(_cellWidth / 2, _cellHeight / 2))
    cell:addChild(bg_unopen)
    cell._unopenBg = bg_unopen
    local bg = zc.createSprite("res/Main/smithy/unlockshenbing/nan_1.png")
    bg:setPosition(cc.p(_cellWidth / 2, _cellHeight / 2))
    cell:addChild(bg)
    cell._bg = bg

    local armature = self:createArmature(1)
    armature:setPosition(cc.p(_cellWidth / 2, _cellHeight / 2 - 140))
    bg:addChild(armature)
    cell._armature = armature

    local _btn_dazao = zc.createCommomBtn({
        tag = 1,
        btnText = zc.lang("daozao"),
        needSwallow = false,
        touchScale = 0.9,
        needEnableWhenMoving = true,
        pos = cc.p(_cellWidth / 2 - 30, 65),
        endCallback = function() 

        end,
    })
    bg:addChild(_btn_dazao)
    cell._btn_dazao = _btn_dazao

    local _yidazao = zc.createSprite("res/Main/smithy/unlockshenbing/yidazao.png")
    _yidazao:setPosition(_btn_dazao:getPosition())
    bg:addChild(_yidazao)
    cell._yidazao = _yidazao

    -- icon
    local _weaponIcon = cc.Sprite:create()
    _weaponIcon:setPosition( cc.p(40, self._cellHeight / 2 - 100) )
    _weaponIcon:setScale(0.6)
    bg:addChild( _weaponIcon )
    cell._weaponIcon = _weaponIcon
    -- 查看特性按钮
    local _txt_sprite = zc.createSprite("res/Main/smithy/unlockshenbing/txt_chankantexing.png")
    _txt_sprite:setPosition(cc.p(self._cellWidth / 2 - 30, _weaponIcon:getPositionY()))
    bg:addChild(_txt_sprite)

    -- 查看
    local _lookupBtn = zc.createPushButton({
        normalFile = "res/Main/arena/lookup.png",
        pos = cc.p( self._cellWidth - 100, _weaponIcon:getPositionY() ),
    })
    bg:addChild(_lookupBtn)
    cell._lookupBtn = _lookupBtn

    -- 消耗
    local consumeItemBg = zc.createSprite("res/Main/smithy/shenbing/item_bg.png")
    consumeItemBg:setAnchorPoint(0.5, 0.5)
    consumeItemBg:setPosition(cc.p(_cellWidth / 2 - 30, 150))
    bg:addChild(consumeItemBg)

    local item = zc.createIconByData({
        data = {
            mainType = 4,
            type = 80, 
            id = 80,
        }, 
        pos = cc.p(consumeItemBg:getContentSize().width/2,consumeItemBg:getContentSize().height/2), 
    })
    item:setScale(76/120)
    consumeItemBg:addChild(item)
    cell._item = item

    local costItemsmNum = zc.createLabel({
            text = "0/0",
            fontSize = 26,
            ap = cc.p(1, 0.5),
            pos = cc.p(item:getContentSize().width-10, 15),
            outLine = true,
            color = display.COLOR_RED,
        })
    item:addChild(costItemsmNum)
    cell._costItemNum = costItemsmNum
    
end

function UnlockGodWeponLayer:updateCell( cell, index )
    local weaponInfo = self._roleWeapons[index] or nil
    if weaponInfo == nil then
        cell._bg:setVisible(false)
        return
    else
        cell._unopenBg:setVisible(false)
    end
    local ty = tonumber(weaponInfo["type"])   -- 1.枪 5.扇子
    local newIdx = 1
    local src = ""
    if ty == 5 then
        newIdx = 2
    end
    if self._nowModel == "nanzhu" then -- 1.枪 2.扇子    
        src = "nan_"..newIdx..".png"
    else
        src = "nv_"..newIdx..".png"
    end
    local fullpath = "res/Main/smithy/unlockshenbing/"..src
    cell._bg:setTexture(fullpath)
    local armature = self:createArmature(index, cell._armature)
    armature:setPosition(cc.p(self._cellWidth / 2 - 30, self._cellHeight / 2 - 65))
    cell._bg:addChild(armature)
    cell._armature = armature
    
    if weaponInfo["ISOPEN"] == true then
        cell._btn_dazao:setVisible(false)
        cell._yidazao:setVisible(true)
    else
        cell._btn_dazao:setVisible(true)
        cell._yidazao:setVisible(false)
    end

    local heroTypeImg = zc.getHeroTypeBigImg( weaponInfo["type"] )
    cell._weaponIcon:setTexture(heroTypeImg)

    -- 查找拥有和消耗
    local _weaponId = tonumber(weaponInfo["weaponId"])
    local shang = math.floor(_weaponId / 1000)
    local _newWeaponId = shang * 1000 + 1
    local weaponCost = gameData.getDataFromCacheWithPrimaryKey( "weapon_foundry", _newWeaponId )
    -- print(_newWeaponId .. "=====")
    -- dump(weaponCost)
    local itemId = weaponCost.itemId
    local costNum = weaponCost.itemNum
    local bagInfo = PlayerData:getBagInfoByID(itemId) or {} -- 消耗的都是玄铁
    local _ownNum = bagInfo["num"] or 0
    local _numStr = _ownNum.."/"..costNum
    cell._costItemNum:setString(_numStr)
    if tonumber(_ownNum) >= tonumber(costNum) then
        cell._costItemNum:setColor(display.COLOR_WHITE)
    else
        cell._costItemNum:setColor(display.COLOR_RED)
    end
    -- 刷新消耗材料
    local newParmas = {
                data = {
                    mainType = 4,
                    type = tonumber(itemId), 
                    id = tonumber(itemId),
                },
                showDetailPop = true,
                listener = function ()
                    -- body
                end,
            }
    zc.updateIconByData(cell._item,newParmas)

    cell._btn_dazao:setTouchEndedCall(function ( )
        self._houseInfo = PlayerData:getHouseInfoByHouseId(11)
        -- dump(self._houseInfo, "houseInfo:")
        zc.sendHttp({
            apiName = "Weapon_foundry",
            params = {                            
                houseId = self._houseInfo["id"], 
                id = weaponInfo["weaponId"], 
                type = 1,
                synthInfo = paTrsSynthInfo
            },
            successCallback = function (net_data)
                dump(net_data, "打造成功：")
                PlayerData:updataData(net_data)
                local weapon = net_data["weapon"][1]
                PlayerData:updateWeaponsInfoById(v)
                --打造成功
                weaponInfo["ISOPEN"] = true
                for k,v in pairs(weapon) do
                    weaponInfo[k] = v
                end
                self._tableview:reloadData()
                self._tableview:scrollToCell(index, false)
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_DAZAO_SUCCESS, data = { idx = index}})
                zc.createSourcePop("SmithyGodAdvance", "src/layer/smithyHouse/SmithyGodMakePop.lua", {
                    before={},
                    info=weaponInfo,
                    callback = function()     
                        weaponInfo["status"] = 0
                        self._isUnlockNew = true
                        local _currentGID = getGuideManager():getCurrentGID()
                        print("打造成功——curGID:".._currentGID)
                        if _currentGID == GuideKey.KEY_15108 then
                            print("打造成功进入guid")
                            self._isContinueGuid = true
                            -- zc.setGuideFuncNextStep(_currentGID, true)
                            self:guid()
                        end
                    end,        
                })

            end,
            errorCallback = function( errorCode, errorMsg )
                zc.tipInfo(errorMsg)
                self._isUnlockNew = true
            end,
        })
    end)
    cell._lookupBtn:setTouchEndedCall(function ( )
        zc.createSourcePop("ViewProperties", "src/layer/smithyHouse/ViewProperties.lua", {_id = index,_roleWeapons = self._roleWeapons})
    end)
end

-- 人物动画
function UnlockGodWeponLayer:createArmature(nowIdx, _arm)
    local weaponInfo = self._roleWeapons[nowIdx]
    if _arm  then
        -- _arm:removeFromParentAndCleanup(true)
        _arm:removeFromParent()
    end
    -- 动画
    local armature = zc.battle.createHeroArmature({
        fileName = self._nowModel , 
        async = true, 
        actName = "idle",
        loop = true,
        heroDataWeaponId = weaponInfo["weaponId"],
        asyncCallback = function ( _armature )
            if _armature then
                --换兵器
                _armature:getAnimation():play("idle", -1, 1)
                zc.soldierChangeWeapon(_armature, weaponInfo["weaponId"])
            end
        end,
    })
    armature:setScaleX( -1.0 )
    return armature
end

return UnlockGodWeponLayer