--[[
    武神塔战斗结果页面
wcc 2015-10-15
]]
local BattleWushenResultPop = class("BattleWushenResultPop",function ()
    return ZCPopLayer:create()
end)

function BattleWushenResultPop:ctor(data)
    -- dump(data, "BattleWushenResultPop ==== ")
    self._scene = data.scene
    local con = self:getContainerLayer()
    con:setTouchEndedCallback(function() end)
    local bgSp = ccui.Scale9Sprite:create(cc.rect(0.5,0.5,1,1), "res/Main/common/img_empty.png")
    bgSp:setContentSize(cc.size(zc.width, zc.height))
    bgSp:setAnchorPoint(cc.p(0.5, 0.5))
    bgSp:setPosition( cc.p(zc.width/2, zc.height/2) )
    self:addContent(bgSp)
    self._bgSp = bgSp
    local yingyin = cc.Sprite:create( "res/Main/battle/battleresult/battle_bg.png" )
    yingyin:setAnchorPoint( 0.5, 1 )
    yingyin:setPosition( zc.width/2, zc.height/2 + 65 )
    yingyin:setName("yingyin")
    bgSp:addChild(yingyin)

    self:initData(data)


    if tonumber(self._data.batlestatus) == 1 then
        ccs.ArmatureDataManager:getInstance():addArmatureFileInfoAsync("res/Main/battle/battleresult/win/win.csb", function()
            --胜利了
            musicManager.playEffect(zc.effect.battleWin)
            self:initSucessUI()
        end)
    else
        --失败了
        musicManager.playEffect(zc.effect.battleLose)
        self:initFailUI()
    end
    self:initCommonUI()
    self:show()
end
function BattleWushenResultPop:initData(parmas)
    local data = parmas.data
    -- dump(data, " BattleWushenResultPop data ")
    self._data = {
        items = table.copy(data["data"]["items"]),
        crit = data["data"]["returnAwards"]["crit"],
        wushenAwards = data["wushenAwards"],
        batlestatus = data["data"]["pass"],
        battleType = BattleType.WuShen_Tower,
        passLayer = data["data"]["info"]["nowLayer"],
        addStar = data["data"]["addStar"],
        quit = parmas.quit,
        replay = parmas.replay,
        warkey = data.data.warKey,
        enemyname = data.data.warModel[4][1],
    }
    -- 能否分享
    self._canShare = data.canShare
    -- dump(self._data)
    --计算层
    if self._data.passLayer and next(self._data.passLayer) then
        self._nowLayer = math.floor((tonumber(self._data.passLayer[1].id) - 1)/3) + 1
    end
end
--失败了
function BattleWushenResultPop:initFailUI()
    if self._bgSp:getChildByName("yingyin") then
        self._bgSp:getChildByName("yingyin"):removeFromParent()
    end
    local bg =  zc.createImageView({
        src = "res/Main/battle/battleresult/battle_bg.png",
        ap = cc.p(0.5, 0),
        pos = cc.p(zc.width/2, -10),
    })
    self._bgSp:addChild(bg)
    local failboy = zc.getSpine("failboy")
    failboy:playAction("idle",true)
    failboy:setPosition( bg:getContentSize().width/2 + 100, bg:getContentSize().height + 40)
    self._bgSp:addChild( failboy )
    --battle_zi
    local zi =  zc.createImageView({
        src = "res/Main/battle/battleresult/battle_zi.png",
        pos = cc.p(bg:getContentSize().width/2, bg:getContentSize().height - 30),
    })
    -- bg:addChild(zi)
    local zi = zc.createLabel({
       text = zc.lang("tips_through_tollgate_condition_unenough"),
       stroke = true,
       fontSize = 27,
       pos = cc.p(bg:getContentSize().width/2, bg:getContentSize().height - 30),
       pixel = 1.3
    })
    bg:addChild(zi)
          
    local line =  zc.createImageView({
        src = "res/Main/battle/battleresult/battle_line.png",
        pos = cc.p(bg:getContentSize().width/2, bg:getContentSize().height - 60),
    })
    bg:addChild(line)
    local btnH = 200
    local touchScale = 0.9
    --合理布阵
    local buzhenButton = zc.createImageView({
        src = "res/Main/common/common_icon_buzhen.png",
        pos = cc.p(bg:getContentSize().width/2 - 70*3, btnH), 
        listener = function () 
            LayerManager.backToMainCity()
            zc.createBuzhenLayer()
        end,
        scale = 0.7,
        touchScale = touchScale
    })
    local _label_buzhen = zc.createLabel({
        text = zc.lang("helibuzhen"),
        fontSize = 30,
        stroke = true,
        pixel = 3,
        ap = cc.p(0.5,0),
        pos = cc.p(buzhenButton:getContentSize().width/2, -25),
    })
    buzhenButton:addChild(_label_buzhen)
    bg:addChild(buzhenButton)
    --培养武将
    local generalButton = zc.createImageView({
        src = "res/Main/common/common_icon_wujiang.png",
        pos = cc.p(bg:getContentSize().width/2 - 70, btnH), 
        listener = function () 
            LayerManager.backToMainCity()
            zc.createHeroListLayer()
        end,
        scale = 0.7,
        touchScale = touchScale
    })
    local _label_general = zc.createLabel({
        text = LANGUAGE_ROLE.culture .. zc.lang("general"),
        fontSize = 30,
        stroke = true,
        pixel = 3,
        ap = cc.p(0.5,0),
        pos = cc.p(generalButton:getContentSize().width/2, -25),
    })
    generalButton:addChild(_label_general)
    bg:addChild(generalButton)
    --培养主角
    local roleButton = zc.createImageView({
        src = "res/Main/common/common_icon_zhujue.png",
        pos = cc.p(bg:getContentSize().width/2 + 70, btnH), 
        listener = function () 
            LayerManager.backToMainCity()
            zc.createRoleScene({isMainRole = true})
        end,
        scale = 0.7,
        touchScale = touchScale
    })
    local _label_role = zc.createLabel({
        text = LANGUAGE_ROLE.culture .. zc.lang("leading_actor"),
        fontSize = 30,
        stroke = true,
        pixel = 3,
        ap = cc.p(0.5,0),
        pos = cc.p(roleButton:getContentSize().width/2, -25),
    })
    roleButton:addChild(_label_role)
    bg:addChild(roleButton)
    --打造兵器
    local weaponButton = zc.createImageView({
        src = "res/Main/common/common_icon_bingqipu.png",
        pos = cc.p(bg:getContentSize().width/2 + 70*3, btnH), 
        listener = function () 
            LayerManager.backToMainCity()
            local smithyInfo = PlayerData:getHouseInfoByHouseId(11)
            zc.createSmithLayer({houseInfo = smithyInfo, layertype = 2 })
        end,
        scale = 0.7,
        touchScale = touchScale
    })
    local _label_weapon = zc.createLabel({
        text = zc.lang("dazhao_weapon"),
        fontSize = 30,
        stroke = true,
        pixel = 3,
        ap = cc.p(0.5,0),
        pos = cc.p(weaponButton:getContentSize().width/2, -25),
    })
    weaponButton:addChild(_label_weapon)
    bg:addChild(weaponButton)
end

--胜利了
function BattleWushenResultPop:initSucessUI()
    local curStar = 1
    curStar = tonumber(self._data.addStar) or 1
    local bgSp = self._bgSp
    local armature = ccs.Armature:create("win")
    armature:setPosition(cc.p(zc.width/2, zc.height/2 + 110))
    bgSp:addChild(armature)
    armature:getAnimation():play("star_"..curStar, -1, 0)
    armature:getAnimation():setMovementEventCallFunc(function(armature, movementType, movementID)
        if 1 == tonumber(movementType) then
            armature:getAnimation():play("idle_"..curStar, -1, 1)
        end
    end) 
    
    self._enemyData = {}
    self._enemyData["DropItemArray"] = {}--掉落装备
    self._enemyData["DropResArray"] = {}--掉落资源

    -- dump(self._data.items ,"self._data.items ========= ")
    if self._data.items then
        for i=1,#self._data.items do
            if tonumber(self._data.items[i].itemType) == 1 or tonumber(self._data.items[i].itemType) == 6  then 
                --资源  1资源 6主角经验
                self._enemyData["DropResArray"][#self._enemyData["DropResArray"]+1] = self._data.items[i]
            else
                --装备
                self._enemyData["DropItemArray"][#self._enemyData["DropItemArray"]+1] = self._data.items[i]
            end
        end
    end

    -- dump(self._enemyData)
    local critTable = {}
    local wushenAwards = string.split(self._data.wushenAwards, ",")
    -- dump(wushenAwards, "wushenAwards ============ ")
    if wushenAwards then
        local awardInfo = {}
        for i = 1, #wushenAwards do
            awardInfo[i] = string.split(wushenAwards[i], "|")
        end
        for i = 1, #awardInfo do
            critTable[tonumber(awardInfo[i][2])] = self._data.crit[i]
        end
    end
    -- dump(critTable,"critTable")
    self._reward = {}
    for i = 1, #self._enemyData["DropResArray"] do
        self._reward[i] = {}
        self._reward[i].mainType = self._enemyData["DropResArray"][i].itemType
        self._reward[i].type = self._enemyData["DropResArray"][i].itemId
        self._reward[i].id = self._enemyData["DropResArray"][i].itemId
        self._reward[i].num = self._enemyData["DropResArray"][i].changeNum
        self._reward[i].flag = 0 --0未暴击 1暴击 2大暴击 3幸运暴击
        if critTable[tonumber(self._reward[i].id)] then
            self._reward[i].flag = critTable[tonumber(self._reward[i].id)]
        end
    end
    -- dump(self._reward)
    --test
    -- self._reward[2] = self._reward[1]
    -- self._reward[3] = self._reward[1]

    local pos = zc.sortFromMiddle(cc.p(bgSp:getContentSize().width/2, bgSp:getContentSize().height/2 - 215), #self._reward, 90)
    local passReward = zc.createLabel({
        text = zc.lang("finish_tollgate") .. zc.lang("reward") .. ":",
        stroke = true,
        fontSize = 25,
        pos = cc.p(bgSp:getContentSize().width/2, bgSp:getContentSize().height/2 - 120),
        color = display.COLOR_GOLD,
        pixel = 1.3
    })
    -- bgSp:addChild(passReward)
    --获得奖励
    local getreward = zc.createImageView({
        src = "res/Main/battle/battle_getreward.png",
        pos = cc.p(zc.width/2, bgSp:getContentSize().height/2 - 120),
    })
    getreward:setScaleX(0.1)
    getreward:runAction(cc.Sequence:create(
        cc.ScaleTo:create(0.1, 1)
    ))
    bgSp:addChild(getreward)
    --线
    local line = zc.createImageView({
        src = "res/Main/battle/battle_line.png",
        pos = cc.p(zc.width/2, bgSp:getContentSize().height/2 - 140),
    })
    line:setScaleX(0.1)
    bgSp:addChild(line)
    line:runAction(cc.Sequence:create(
        cc.ScaleTo:create(0.1, 1)
    ))
    local boajiStrTa = LANGUAGE_wushen_resoult_baoji_type()
    for i = 1, #self._reward do
        local item = zc.createIconByData({
            data = self._reward[i],
            showDetailPop = true,
            pos = cc.p(pos[i]), 
        })
        item:setScale(0.01)
        bgSp:addChild(item)
        local boajiStr = ""
        if self._reward[i].flag and tonumber(self._reward[i].flag) >0 then
            boajiStr = boajiStrTa[tonumber(self._reward[i].flag)]
        end
        local baojiLab = zc.createLabel({
            text = boajiStr,
            stroke = true,
            fontSize = 35,
            ap = cc.p(0.5, 0),
            pos = cc.p(item:getContentSize().width/2, item:getContentSize().height+3),
            color = display.COLOR_RED,
            pixel = 1.3
        })
        item:addChild(baojiLab)
            

        item:runAction(cc.Sequence:create(
            cc.DelayTime:create(0.1*(i-1)),
            cc.ScaleTo:create(0.1, 1),
            cc.ScaleTo:create(0.1, 0.6)
        ))
    end

    local passCondition = zc.createLabel({
        text = zc.lang("finish_tollgate") .. zc.lang("evaluate") .. ":",
        stroke = true,
        fontSize = 25,
        pos = cc.p(bgSp:getContentSize().width/2, bgSp:getContentSize().height/2),
        color = display.COLOR_GOLD,
        pixel = 1.3
    })
    bgSp:addChild(passCondition)

    local getStar = zc.createLabel({
        text = zc.lang("get") .. " ".. self._data.addStar .. zc.lang("star"),
        stroke = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(passCondition:getPositionX()+passCondition:getContentSize().width/2, passCondition:getPositionY()),
        color = display.COLOR_GOLD,
        pixel = 1.3
    })
    -- bgSp:addChild(getStar)

    local tipLab = zc.createLabel({
        text = " " .. zc.lang("get"),
        stroke = true,
        fontSize = 25,
        ap = cc.p(0, 0.5),
        pos = cc.p(passCondition:getPositionX(), passCondition:getPositionY()),
        color = display.COLOR_GOLD,
        pixel = 1.3
    })
    bgSp:addChild(tipLab)
    local star = cc.Sprite:create("res/Main/common/common_hero_star_1.png")
    star:setAnchorPoint(0, 0.5)
    star:setPosition(passCondition:getPositionX()+tipLab:getContentSize().width/2+15, tipLab:getPositionY())
    bgSp:addChild(star)
    star:setScale(0.9)
    local starNumLab = zc.createLabel({
        text = "x"..self._data.addStar,
        stroke = true,
        fontSize = 25,
        ap = cc.p(0, 0.5),
        pos = cc.p(passCondition:getPositionX(), tipLab:getPositionY()),
        color = display.COLOR_GOLD,
        pixel = 1.3
    })
    bgSp:addChild(starNumLab)
    
    --调整居中
    local tipLabWidth = tipLab:getContentSize().width
    local starWidth = star:getContentSize().width
    local numLabWidth = starNumLab:getContentSize().width
    passCondition:setPositionX(bgSp:getContentSize().width/2-(tipLabWidth+starWidth+numLabWidth)/2)
    tipLab:setPositionX(passCondition:getPositionX()+passCondition:getContentSize().width/2)
    star:setPositionX(tipLab:getPositionX()+tipLab:getContentSize().width)
    starNumLab:setPositionX(star:getPositionX()+star:getContentSize().width)
    
    --过关条件
    local layerReward = gameData.getDataFromCacheWithPrimaryKey("arenaTower_layer", self._nowLayer)
    -- dump(layerReward)
    local conditionStr = LANGUAGE_GET_CONDITION_BY_ID(tonumber(layerReward.conditionType), true)
    local conditionLab1 = zc.createLabel({
        text = zc.lang("finish_tollgate_achieve") .. "："..conditionStr,
        stroke = true,
        fontSize = 22,
        pos = cc.p(bgSp:getContentSize().width/2, bgSp:getContentSize().height/2 -40),
        pixel = 1.3
    })
    bgSp:addChild(conditionLab1)
    local conditionNum = ""
    if tonumber(layerReward.conditionValue) == 0 then

    elseif tonumber(layerReward.conditionValue) < 1 then
        conditionNum = tonumber(layerReward.conditionValue)*100 .. "%"
    elseif tonumber(layerReward.conditionValue) >= 1 then
        conditionNum = tonumber(layerReward.conditionValue)
    end
    local conditionLab2 = zc.createLabel({
        text = conditionNum,
        stroke = true,
        fontSize = 24,
        ap = cc.p(0, 0.5),
        pos = cc.p(conditionLab1:getPositionX()+conditionLab1:getContentSize().width/2, bgSp:getContentSize().height/2-40),
        color = display.COLOR_RED,
        pixel = 1.3
    })
    bgSp:addChild(conditionLab2)
    conditionLab1:setPositionX(bgSp:getContentSize().width/2-conditionLab2:getContentSize().width/2)
    conditionLab2:setPositionX(conditionLab1:getPositionX()+conditionLab1:getContentSize().width/2)


    local itemsNum = #self._enemyData["DropItemArray"]
    if itemsNum >= 6 then 
        local itemScrollview = zc.createScrollview({
            pos = cc.p((zc.width - 75*5.5)/2, 90),
            size = cc.size(75*5.5, 100),
            innerSize = cc.size(75*itemsNum, 100),
            dir = ccui.ScrollViewDir.horizontal,
            bar = true,
            bounceEnable = true,
        })
        bgSp:addChild(itemScrollview)
        for i=1, itemsNum do 
            local iconcolor = PlayerData:getBagDBInfoByID(self._enemyData["DropItemArray"][i]["itemId"]).color or 1
            local item = zc.createIconByData({
                data = {
                    mainType = zc.mainTypeProp,
                    type = 1, 
                    id = self._enemyData["DropItemArray"][i]["itemId"],
                    num = self._enemyData["DropItemArray"][i]["changeNum"],
                    quality = iconcolor
                }, 
                pos = cc.p(75*(i - 1/2), 40), 
            })
            item:setScale(0.72)
            itemScrollview:addChild(item)
            item:runAction(cc.Sequence:create(
                cc.DelayTime:create(0.1*(i-1)),
                cc.ScaleTo:create(0.1, 1),
                cc.ScaleTo:create(0.1, 0.6)
            ))
        end
    else
        for i=1, itemsNum do 
            local iconcolor = PlayerData:getBagDBInfoByID(self._enemyData["DropItemArray"][i]["itemId"]).color or 1
            local item = zc.createIconByData({
                data = {
                    mainType = zc.mainTypeProp,
                    type = 1, 
                    id = self._enemyData["DropItemArray"][i]["itemId"],
                    num = self._enemyData["DropItemArray"][i]["changeNum"],
                    quality = iconcolor
                }, 
                pos = cc.p(zc.width/2 - ((itemsNum+1)/2- i)*75, bgSp:getContentSize().height/2 -200), 
            })
            item:setScale(0.72)
            bgSp:addChild(item)
            item:runAction(cc.Sequence:create(
                cc.DelayTime:create(0.1*(i-1)),
                cc.ScaleTo:create(0.1, 1),
                cc.ScaleTo:create(0.1, 0.6)
            ))
        end
    end
end
function BattleWushenResultPop:initCommonUI()
    ----------------------------------------按钮
    --返回
    local backBtn = zc.createPushButton({
        normalFile = "res/Main/battle/battle_fh_u.png",
        selectedFile = "res/Main/battle/battle_fh_d.png",
        needSwallow = false,
        touchScale = 0.9,
        pos = cc.p(zc.width - 80, 250),
        endCallback = function()
            if self._isClickEd then
                return
            end 
            self._isClickEd = true
            cc.Director:getInstance():getScheduler():setTimeScale(1)
            local _type = tonumber(self._data.battleType)
            self:colseBattle() 
            if _type == BattleType.WuShen_Tower then
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_WUSHENTOWER})
            end
        end,
    })
    self._bgSp:addChild(backBtn)
    --重播
    local replayBtn = zc.createPushButton({
        normalFile = "res/Main/battle/battle_cb_u.png",
        selectedFile = "res/Main/battle/battle_cb_d.png",
        needSwallow = false,
        touchScale = 0.9,
        pos = cc.p(zc.width - 80, 450),
        endCallback = function()
            self:replayBattle() 
        end,
    })
    self._bgSp:addChild(replayBtn)
    --分享
    local _disable = zc.createSprite("res/Main/battle/battle_fx_d.png")
    zc.setGray(_disable)
    local shareBtn = zc.createPushButton({
        normalFile = "res/Main/battle/battle_fx_u.png",
        selectedFile = "res/Main/battle/battle_fx_d.png",
        disableNode = _disable,
        needSwallow = false,
        touchScale = 0.9,
        pos = cc.p(zc.width - 80, 350),
        endCallback = function()
            local _text = zc.lang("beat_checkpoint","击败了关卡")..self._data.enemyname.."{key="..self._data.warkey.."}"
            print(_text)
            getNetManager():getRequestCenter():sendBattleFieldChatData(_text)
            
            zc.tipInfo(zc.lang("tips_battle_field_success","分享战报成功"))
            self._shareBtn:setEnable(false)
            self._canShare = false
        end,
    })
    self._bgSp:addChild(shareBtn)
    self._shareBtn = shareBtn
    if not self._canShare then
        shareBtn:setEnable(false)
    end
end
--重播
function BattleWushenResultPop:replayBattle()
    local canShare = self._canShare
    local _fun = self._data.replay
    if self._scene then
        self:removeFromParent()
    else
        LayerManager.removeLayout(true)
    end
    if _fun then
        _fun(canShare)
    end
end
function BattleWushenResultPop:create(data)
    return BattleWushenResultPop.new(data)
end
function BattleWushenResultPop:onCleanup()
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/animation/failboy/failboy.png")
end
function BattleWushenResultPop:colseBattle()
    local _fun = self._data.quit
    self:hide()
    if _fun then
        _fun()
    end
end
return BattleWushenResultPop