--[[
-- 其他玩家详情界面
-- @author lph
-- Creation  2016-3-10
]]
local actions = {
    "atk3","atk","atk0"
}
local otherPlayerDetailPop = class("otherPlayerDetailPop",function ()
    return zc.createNormalDialog({
        closeCallBack = function()
            LayerManager.removeLayout(true)
        end
    })
end)

function otherPlayerDetailPop:create(data)
    return otherPlayerDetailPop.new(data)
end
function otherPlayerDetailPop:onCleanup()
    local _forms = PlayerData:getNowFormationFiles()
    for k, v in pairs( self._record ) do
        -- 如果已上阵，不删除
        local _path, _resId = zc.battle.getHeroArmaturePathByResId( k )
        if not _forms[_resId] then
            ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo( _path )
        end
    end
    helper.collectMemory(true)
end
function otherPlayerDetailPop:ctor(data)
    self._record = {}
	self._otherPlayerInfo = data    --其他玩家信息
    self:setMainRoleInfo()
    -- self._tagNames = {"详情", "战魂" }
	self._tagNames = { zc.lang("details")  }
    self._tag = 1--默认是全部
    self._tagButtons = {}
	self:initUI()
	self:initTabButton()
	self:initOtherPlayerAttrUI()
end
--设置主角模型信息
function otherPlayerDetailPop:setMainRoleInfo()
    self._sexId = self._otherPlayerInfo["base"]["seigniorId"] or 1 -- 1男、2女
    self._mainHeroId = self._otherPlayerInfo["base"]["heroId"]
    self._mainRoleIconId = self._otherPlayerInfo["base"]["iconId"]
    local weapons = self._otherPlayerInfo["weapons"]
    --{"长柄","钝器","法杖","剑","扇子","法球"}
    if weapons and next(weapons) then
        for i = 1, #weapons do
            if self._mainHeroId and tonumber(self._mainHeroId) == tonumber(weapons[i]["heroId"]) then
                local weaponId = weapons[i]["weaponId"]
                self._mainRoleWeapon = weaponId
                self._mainRoleWeaponInfo = weapons[i] or {}
                break
            end
        end
    end
    self._mainRoleMold = self._sexId == 1 and "nanzhu" or "nvzhujue"
end
function otherPlayerDetailPop:initUI()
	--背景
    local _otherPlayer_bg = zc.createNormalPop({
        -- tag = 2,
        srcTag = 2,
        width = 930,
        height = 524+31,
    })
    _otherPlayer_bg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addChild(_otherPlayer_bg)
    self._otherPlayer_bg = _otherPlayer_bg

    local _titleImg = zc.getSprite({
        src = "res/Main/common/popBg/titleBg2.jpg",
        ap = cc.p(1, 1),
        name = "titleImg",
    })
    _titleImg:setPosition(cc.p(_otherPlayer_bg:getContentSize().width-3, _otherPlayer_bg:getContentSize().height-3))
    _otherPlayer_bg:addChild(_titleImg,2)

    local titleLeft = zc.createSprite("res/Main/common/popBg/titleBg2.jpg")
    titleLeft:setAnchorPoint(0, 1)
    titleLeft:setPosition(3, _titleImg:getPositionY())
    _otherPlayer_bg:addChild(titleLeft,1)

    --标题
    local _otherPlayer_title = zc.createImageView({
        src = "res/Main/otherPlayer/otherPlayer_title.png",
        pos = cc.p(-30, _otherPlayer_bg:getBoundingBox().height-10),
        ap = cc.p(0,0.5)
    })
    _otherPlayer_bg:addChild(_otherPlayer_title,10)

    --右侧列表bg
    -- self._otherPlayer_right_bg= zc.getScaleNode("res/Main/setting/scale9_1.png", cc.size(513,475))
    self._otherPlayer_right_bg = cc.Node:create()
    self._otherPlayer_right_bg:setContentSize(cc.size(513,475))
    self._otherPlayer_right_bg:setAnchorPoint(cc.p(1,0))
    self._otherPlayer_right_bg:setPosition(_otherPlayer_bg:getContentSize().width-3, 0)
    _otherPlayer_bg:addChild(self._otherPlayer_right_bg, 1)
     --左侧列表bg
    -- self._otherPlayer_left_bg= zc.getScaleNode("res/Main/setting/scale9_1.png", cc.size(253,476))
    self._otherPlayer_left_bg = cc.Node:create()
    self._otherPlayer_left_bg:setContentSize(cc.size(253,476))
    self._otherPlayer_left_bg:setAnchorPoint(cc.p(0,0))
    self._otherPlayer_left_bg:setPosition(156, 0)
    _otherPlayer_bg:addChild(self._otherPlayer_left_bg)

    local leftLine = zc.getScaleNode("res/Main/otherPlayer/line.png", cc.size(5,self._otherPlayer_left_bg:getContentSize().height))
    leftLine:setPosition(cc.p(self._otherPlayer_left_bg:getContentSize().width, self._otherPlayer_left_bg:getContentSize().height/2))
    self._otherPlayer_left_bg:addChild(leftLine)

    local titleImg = self._otherPlayer_bg:getChildByName("titleImg")
    -- 武器图标
    local _weaponIconBg = cc.Sprite:create( "res/Main/role/common/weapon_icon_bg.png" )
    _weaponIconBg:setAnchorPoint( 0.5, 0 )
    _weaponIconBg:setPosition( 450-66, 0 )
    titleImg:addChild( _weaponIconBg ,1)
    local _weaponIcon = cc.Sprite:create(zc.getHeroTypeBigImg( 1 ))
    _weaponIcon:setPosition( _weaponIconBg:getContentSize().width/2 + 2, -10 )
    _weaponIconBg:addChild( _weaponIcon )
    self._weaponIcon = _weaponIcon


    --关闭按钮
    -- local closeButton = zc.createBackButton({
    --     pos = cc.p(_otherPlayer_bg:getBoundingBox().width-10  , _otherPlayer_bg:getBoundingBox().height), 
    --     listener = function () 
    --         LayerManager.removeLayout(true)
    --     end,
    -- })
    -- _otherPlayer_bg:addChild(closeButton,10) 
end

function otherPlayerDetailPop:initOtherPlayerAttrUI()
	--左侧信息
	--玩家信息标题
	local _player_title =  zc.createImageView({
        src = "res/Main/otherPlayer/otherPlayer_info_title.png",
        ap = cc.p(0.5,0), 
        pos = cc.p(self._otherPlayer_left_bg:getContentSize().width/2, 435)
    })
    self._otherPlayer_left_bg:addChild(_player_title)
    local lace_left = zc.createSprite("res/Main/common/lace.png")
    lace_left:setAnchorPoint(1, 0.5)
    lace_left:setPosition(0, _player_title:getContentSize().height/2 )
    _player_title:addChild(lace_left)

    local lace_right = zc.createSprite("res/Main/common/lace.png")
    lace_right:setAnchorPoint(0, 0.5)
    lace_right:setPosition(_player_title:getContentSize().width, lace_left:getPositionY() )
    lace_right:setFlipX(true)
    _player_title:addChild(lace_right)
    --文字描述bg
    local _player_text_bg_s = zc.createScale9Sprite({
        size = cc.size(226, 76),
        file = "res/Main/role/common/shadow_bg.png",
        pos = cc.p(_player_title:getPositionX(), 430),
    })
    _player_text_bg_s:setAnchorPoint(cc.p(0.5,1))
    self._otherPlayer_left_bg:addChild(_player_text_bg_s)

    local _player_name_lab = zc.createLabel({
        text = zc.lang("player_name") .. "：", 
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(15, 90-37),
        outLine = true,
        color = cc.c3b(223,216,197),
    })
    _player_text_bg_s:addChild(_player_name_lab)
    --姓名
    local _player_name_text = zc.createLabel({
        text = " "..self._otherPlayerInfo.base.userName, 
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(_player_name_lab:getPositionX()+_player_name_lab:getContentSize().width, _player_name_lab:getPositionY() ),
        outLine = true,
        --color = display.COLOR_YELLOW,
    })
    _player_text_bg_s:addChild(_player_name_text)
    --国家
    local _country_name_Lab = zc.createLabel({
        text = zc.lang("country") .. "：", 
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(15, 60-40),
        outLine = true,
        color = cc.c3b(223,216,197),
    })
    _player_text_bg_s:addChild(_country_name_Lab)
    local _country_name_text = zc.createLabel({
        text = " "..self._otherPlayerInfo.base.countryName, 
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(_country_name_Lab:getPositionX()+_country_name_Lab:getContentSize().width, _country_name_Lab:getPositionY() ),
        outLine = true,
        --color = display.COLOR_YELLOW,
    })
    _player_text_bg_s:addChild(_country_name_text)
    --战斗力img
    local _player_combat_img = zc.createSprite("res/Main/role/common/fight_bg.png")
    _player_combat_img:setAnchorPoint(cc.p(0,0.5))
    _player_combat_img:setPosition(cc.p(-8,25-70) )
    _player_text_bg_s:addChild(_player_combat_img)
    --战力
    local _fighting_str = tostring(self._otherPlayerInfo.base.fighting)
    local _player_combat = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight_change.fnt",
        text = _fighting_str,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 75, _player_combat_img:getContentSize().height/2 ),
        addwidth = -8,
    })
    _player_combat:setScale( 0.7 )
    _player_combat_img:addChild( _player_combat )

    --显示阵法武将
    self._cur_heroData = nil
    self:initMatrixView()

	--右侧信息
    self:initRightUI()
    
end

function otherPlayerDetailPop:initRightUI()
    self._otherPlayer_right_bg:removeAllChildren()
    if not tolua.isnull(self._armature) then
        self._armature:removeFromParent()
    end

   local nameBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(360,32) )
    nameBg:setPosition(cc.p(self._otherPlayer_right_bg:getContentSize().width/2, self._otherPlayer_right_bg:getContentSize().height-28))
    self._otherPlayer_right_bg:addChild(nameBg, 10)
    self._nameBg = nameBg
    local nameLab = zc.createLabel({
        text = "xxx",
        outLine = true,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(30, nameBg:getContentSize().height/2 ),
    })
    nameBg:addChild(nameLab)
    self._heroNameLab = nameLab

    local titleName = zc.createLabel({
        text = "<xxxxx>",
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(0, nameLab:getPositionY()),
        color = zc.COLOR_PURPLE,
    })
    nameBg:addChild(titleName)
    self._titleName = titleName



    self.weaponData = nil
    for k,v in pairs(self._otherPlayerInfo.weapons) do
        if tonumber(v.heroId) == tonumber(self._cur_heroData.id) then
            self.weaponData = v
            break
        end
    end
    zc.createHeroStar( self._otherPlayer_right_bg, self._cur_heroData.star, cc.p( 34, 428 ) )

    --武将名，武将modelid,武将天赋
    local _nameStr,heroName, _talentId , _heroTitle =  self:getHeroModelId(self._cur_heroData.heroId) 
    local _isMainRole =false
    if tonumber(self._cur_heroData.id) == tonumber(self._otherPlayerInfo.base.heroId) then
        _nameStr = self._otherPlayerInfo.base.userName
        heroName = self._mainRoleMold
        _isMainRole = true
        _heroTitle = zc.getGodNameById(self._otherPlayerInfo.base.godName)
    end
    --角色名称


    --名称 
    local _reincarnate = ""
    if self._cur_heroData.reincarnate and tonumber(self._cur_heroData.reincarnate) > 0 then
        _reincarnate = self._cur_heroData.reincarnate.. zc.lang("turn")
    end
    local nameStr = _reincarnate..zc.getLevelTipShow()..self._cur_heroData["level"].." ".._nameStr
    self._heroNameLab:setString(nameStr)

    local titleStr = "<".._heroTitle..">"
    self._titleName:setString(titleStr)

    self._heroNameLab:setPositionX(self._nameBg:getContentSize().width/2-self._titleName:getContentSize().width/2-10)
    self._titleName:setPositionX(self._heroNameLab:getPositionX()+self._heroNameLab:getContentSize().width/2+10)

    --战斗力img
    local _player_combat_img = zc.createSprite("res/Main/role/common/fight_bg.png")
    _player_combat_img:setAnchorPoint(cc.p(0,0.5))
    _player_combat_img:setPosition(cc.p(55,190-10) )
    self._otherPlayer_right_bg:addChild(_player_combat_img)
    --战力
    local _player_combat = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight_change.fnt",
        text = self._cur_heroData["fighting"],
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 75, _player_combat_img:getContentSize().height/2 ),
        addwidth = -8,
    })
    _player_combat:setScale( 0.7 )
    _player_combat_img:addChild( _player_combat )

    --
    local _role_talent_bg_s = zc.getScaleNode("res/Main/role/common/shadow_bg.png", cc.size(398, 102))
    _role_talent_bg_s:setPosition(cc.p(self._otherPlayer_right_bg:getContentSize().width/2, 93))
    self._otherPlayer_right_bg:addChild(_role_talent_bg_s)
    
    local effList = {
        [1] = {name = zc.lang("wuli") .. "：", num = self._cur_heroData.attribute.force},
        [2] = {name = zc.lang("tili") .. "：", num = self._cur_heroData.attribute.soma},
        [3] = {name = zc.lang("wisdom") .. "：", num = self._cur_heroData.attribute.wisdom},
    }
    local posX_left     = _role_talent_bg_s:getContentSize().width/4
    local posX_right    = _role_talent_bg_s:getContentSize().width/4*3
    local posH = 73
    for i = 1, #effList do
        local posx = i % 2 == 1 and posX_left or posX_right
        local attrDi = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(179, 35))
        attrDi:setPosition(cc.p(posx, posH - (math.floor((i-1)/2)*45)))
        _role_talent_bg_s:addChild(attrDi)
        local effectInfo = effList[i]
        local effectStrLab = zc.createRichLabel({
            text = effectInfo.name,
            fontSize = 20,
        })
        effectStrLab:setAnchorPoint(0, 0.5)
        effectStrLab:setPosition(6, attrDi:getContentSize().height/2)
        effectStrLab:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
        attrDi:addChild(effectStrLab)
        local effectLab = zc.createLabel({
            text = effectInfo.num,
            outLine = true,
            fontSize = 20,
            ap = cc.p(1, 0.5),
            pos = cc.p(attrDi:getContentSize().width-8,attrDi:getContentSize().height/2),
        })
        attrDi:addChild(effectLab)
    end

    --法阵
    local _spine = zc.getSpine( "jsxxyxg" )
    _spine:setPosition( cc.p(100+65,320) )
    _spine:playAction( "animation", true )
    self._otherPlayer_right_bg:addChild(_spine,2)
    self._role_magic_img = _spine

    --加载动画
    local armature
    if _isMainRole then
        armature = zc.battle.createHeroArmatureWithResId(heroName, self._mainRoleWeapon)
    else
        armature = zc.battle.createHeroArmatureWithResId(heroName)
    end
    self._record[heroName] = true
    -- armature:setPosition( cc.p(120+55,240) )
    -- self._otherPlayer_right_bg:addChild(armature,12)
    local worldPos = self._otherPlayer_right_bg:convertToWorldSpace( cc.p(120+55,240) )
    armature:setPosition( worldPos )
    self:addChild(armature, 10)
    armature:getAnimation():play("idle")
    self._armature = armature
    local function animationEvent(armatureBack,movementType,movementID)
        local id = movementID
        if movementType == ccs.MovementEventType.complete then
            self._armature:getAnimation():play("idle")
        end
    end
    self._armature:getAnimation():setMovementEventCallFunc(animationEvent)
     --更换兵器
    local _weaponId = 0
    if self.weaponData then
        _weaponId = self.weaponData.weaponId
    end
    zc.soldierChangeWeapon(armature, _weaponId)

    -- 按钮
    if not self._heroBtn then
        -- local scaleSize = cc.size(120, 150)
        -- local myScale9 = zc.getScaleNode("res/Main/common/common_inner22.png", scaleSize)
        local heroBtn = zc.createPushButton({
            touchSize = cc.size( 120, 150 ),
            -- normalNode = myScale9,
            noScaleAction = true,
            pos = cc.p(  self._armature:getPositionX() , self._armature:getPositionY()+60 ),
            endCallback = function()
                local _action = zc.random(1, 3)
                if self._action and self._action == _action then
                    if _action < 3 then
                        _action = _action + 1
                    else 
                       _action = 1 
                    end
                end
                self._action = _action
                local _actions = {"atk3", "atk", "atk0"}
                if not tolua.isnull(self._armature) then
                    self._armature:getAnimation():play( _actions[_action], -1, 0 )
                    self._armature:getAnimation():setMovementEventCallFunc(function(_armature, movementType, movementID)
                        if 1 == tonumber(movementType) then
                            if not tolua.isnull(self._armature) then
                                self._armature:getAnimation():play("idle", -1, 1)
                            end
                        end
                    end)
                end
            end
        })
        -- self._otherPlayer_right_bg:addChild( heroBtn )
        self:addChild( heroBtn, 10 )
        self._heroBtn = heroBtn
    end

    --兵器
    local _weapon_id = 0
    local _static_weaponinfo = nil
    local _weaponType = 1

    if self.weaponData then
        _weapon_id = self.weaponData.weaponId
        _static_weaponinfo = gameData.getDataFromCacheWithPrimaryKey("weapon", _weapon_id)
        _weaponType = tonumber(_static_weaponinfo.type) or 1
        local heroTypeImg = zc.getHeroTypeBigImg( _weaponType )
        self._weaponIcon:setTexture(heroTypeImg)
    else
        local static = gameData.getDataFromCacheWithPrimaryKey("hero", self._cur_heroData.heroId)
        local wea = string.split(tostring(static.weaponType), "|")
        local heroTypeImg = zc.getHeroTypeBigImg( wea[1] or 1 )
        self._weaponIcon:setTexture(heroTypeImg)
    end

    local _weaponBgPath = ""
    if _isMainRole then
        -- 神兵
        _weaponBgPath = "res/Main/role/attribute/weaponBg_main.png"
    else
        -- 兵器
        _weaponBgPath = "res/Main/role/attribute/weaponBg_hero.png"
    end

    local _weaponBg = zc.createSprite(_weaponBgPath)
    _weaponBg:setAnchorPoint(1, 0.5)
    _weaponBg:setPosition(self._otherPlayer_right_bg:getContentSize().width-30, self._otherPlayer_right_bg:getContentSize().height-160)
    self._otherPlayer_right_bg:addChild(_weaponBg)

    -- 武器图片
    local _weaponSp = cc.Sprite:create()
    -- stencil
    local _stencil = cc.Sprite:create( "res/Main/role/attribute/weaponBg_main.png" )
    _stencil:setPositionY(5)
    -- clippingNode
    local clippingNode = cc.ClippingNode:create()
    clippingNode:addChild( _weaponSp )
    clippingNode:setStencil( _stencil )
    clippingNode:setInverted( false )
    clippingNode:setAlphaThreshold( 0.5 )
    clippingNode:setPosition(cc.p(_weaponBg:getContentSize().width/2, _weaponBg:getContentSize().height/2))
    _weaponBg:addChild( clippingNode )

    _weaponSp:setPositionY( _weaponSp:getPositionY() - 20 )
    _weaponSp:setPositionX( _weaponSp:getPositionX() - 5 )
    -- 渐变
    local _weaponTopSp = cc.Sprite:create( "res/Main/role/attribute/opacity.png" )
    _weaponTopSp:setAnchorPoint( 0, 0 )
    _weaponTopSp:setPosition( 0, 0 )
    _weaponBg:addChild( _weaponTopSp )
    if _weapon_id > 0 then
        _weaponSp:setTexture( "res/Main/weapon/weaponImage/"..( _static_weaponinfo.iconId or 1 )..".png" )
        zc.showWeaponEffect( _weaponSp, _weapon_id )
        -- 位置
        if _weaponType == 1 then
            _weaponSp:setPositionY( _weaponSp:getPositionY() - 55 )
            _weaponSp:setRotation( 90 )
            _weaponTopSp:setVisible( true )
        elseif _weaponType == 3 then
            if _weapon_id == 37 then
                _weaponSp:setPositionX( _weaponSp:getPositionX()-7 )
                _weaponSp:setPositionY( _weaponSp:getPositionY()+10 )
            end
        elseif _weaponType == 2 or _weaponType == 4 then
            _weaponSp:setRotation( 90 )
            _weaponTopSp:setVisible( false )
        elseif _weaponType == 5 or _weaponType == 6 then
            _weaponSp:setPositionX( _weaponSp:getPositionX() - 5 )
            _weaponTopSp:setVisible( false )
        else
            _weaponSp:setRotation( 0 )
            _weaponTopSp:setVisible( false )
        end
    else
        _weaponSp:setTexture("res/Main/role/attribute/unequip.png")
        _weaponSp:setPositionY( _weaponSp:getPositionY() - 5 )
        _weaponSp:setPositionX( _weaponSp:getPositionX() - 5 )
    end

end

function otherPlayerDetailPop:initMatrixView()
    --当前阵法
    local _cur_matrix = nil
    for k,v in pairs(self._otherPlayerInfo.formations) do
        if tonumber(v.status) == 1 then
            _cur_matrix = v
        end
    end
    --阵法名
    local formation_name = ""
    local _data = gameData.getDataFromCacheWithPrimaryKey("formation", _cur_matrix.formationId)
    if next(_data) ~= nil then
        formation_name = _data.name
    end
    local formation_bg = zc.createImageView({
        src = "res/Main/otherPlayer/otherPlayer_formation_bg.png",
        ap = cc.p(0.5,0),
        pos = cc.p(self._otherPlayer_left_bg:getContentSize().width/2,250),
    })
    self._otherPlayer_left_bg:addChild(formation_bg)
    local formation_name_label = zc.createLabel({
        text = formation_name,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(55, 12),
        outLine = true,
        --color = display.COLOR_YELLOW,
    })
    formation_bg:addChild(formation_name_label)
    self._selectLightList = {}
    if _cur_matrix then
        for i=1,9 do
             --选中的亮光
            local _str = "location"..i
            local _id = _cur_matrix[_str]
            local _heroId = 0
            local _quality = 1
            local _heroDataTemp = nil
            local _mainRoleIcon = nil
            local _qualifications = nil
            for k,v in pairs(self._otherPlayerInfo.heros) do
                if tonumber(v.id) == tonumber(_id) then
                    _heroId = v.heroId
                    _quality = v.star
                    _heroDataTemp = v
                    if v["id"] and tonumber(v["id"]) == tonumber(self._mainHeroId) then
                        self._cur_heroData = v
                    end
                    if tonumber(v.id) == tonumber(self._mainHeroId ) then
                        _mainRoleIcon = self._mainRoleIconId
                        _qualifications = gameData.getDataFromCache( "hero_talent", {convertId = _heroDataTemp["talentId"]}).convertQuality
                    end
                    break
                end
            end
            local _headIcon
            if _heroId ~= 0 then
                _headIcon = zc.createIconByData({
                    data = {
                        mainType = zc.mainTypeSoldier,
                        type = 1, 
                        id = _heroId,
                    }, 
                    pos = cc.p(0, 0), 
                    quality = _heroDataTemp.newAdvance, --突破数
                    mainRoleIcon = _mainRoleIcon,
                    listener = function ()
                        if _heroDataTemp then
                            if tonumber(self._cur_heroData.id) ~= tonumber(_heroDataTemp.id) then
                                for k,v in pairs(self._selectLightList) do
                                    v:setVisible(false)
                                end
                                self._selectLightList[i]:setVisible(true)
                                self._cur_heroData = _heroDataTemp
                                self:initRightUI()
                            end
                        end
                    end,
                })
            else
                _headIcon = zc.createSprite("res/Main/hero/hero_item1.png")
            end
            _headIcon:setScale(0.5)
            self._otherPlayer_left_bg:addChild(_headIcon)
            local _selectLight = ccui.Scale9Sprite:create( cc.rect(10,10,3,3), "res/Main/common/common_select_box.png" )
            _selectLight:setContentSize( _headIcon:getContentSize().width + 5, _headIcon:getContentSize().height + 5 )
            _selectLight:setPosition( _headIcon:getContentSize().width/2, _headIcon:getContentSize().height/2 )
            _headIcon:addChild(_selectLight)
            if self._cur_heroData and tonumber(self._cur_heroData.heroId) == tonumber(_heroId) then 
                _selectLight:setVisible(true)
            else
                _selectLight:setVisible(false)
            end
            table.insert(self._selectLightList,_selectLight)
            local _label = zc.createLabel({
                text = zc.lang("front"),
                fontSize = 28,
                ap = cc.p(0.5, 0.5),
                pos = cc.p(55, 55),
                stroke = true,
            })
            _headIcon:addChild(_label)
            if _heroDataTemp then
                _label:setVisible(false)
            else
                _label:setVisible(true)
            end
            if i <= 3 then
                _headIcon:setPosition(cc.p(90-35,210-70*(i-1)))
                _label:setText(zc.lang("front"))
            elseif i <= 6 and i > 3 then
                _headIcon:setPosition(cc.p(160-35,210-70*(i-4)))
                _label:setText(zc.lang("middle"))
            else
                _headIcon:setPosition(cc.p(230-35,210-70*(i-7)))
                _label:setText(zc.lang("back_1"))
            end
        end
    end
end

--左侧按钮标签
function otherPlayerDetailPop:initTabButton()
    local bgImg2 = zc.getScaleNode("res/Main/otherPlayer/otherPlayer_tag_bg.png", cc.size(154, 473))
    bgImg2:setAnchorPoint(cc.p(0, 0))
    bgImg2:setPosition(cc.p(1, 1))
    self._otherPlayer_bg:addChild(bgImg2)
    local splitY = cc.Sprite:create( "res/Main/common/tab_split_y.png" )
    splitY:setPosition(154,473/2+16)
    bgImg2:addChild(splitY)

    --右侧tab条 按钮们
    for i=1,#self._tagNames do
        local tab_btn = zc.createComTabButton({
            tag = 3,
            btnText = self._tagNames[i],
            endCallback = function()
                self:selectTag(i)
            end
        })
        tab_btn:setPosition( cc.p(154/2-2, 480 - i*(73+1)) )
        bgImg2:addChild(tab_btn, 10)
        self._tagButtons[i] = tab_btn

        if self._tag == i then
            tab_btn:setSelected(true)
        else
            self._tagButtons[i]:setLocalZOrder(10)
        end

        if i ~= 1 then 
            local itemLine = zc.createImageView({
                src = "res/Main/hero/hero_tabline.png",
                pos = cc.p(rightline1:getPositionX() + 6, 485 - (i+1/2)*(73+1)), 
                ap = cc.p(0, 1)
            })
            self._tagButtons[i]._itemLine = itemLine
            itemLine:setScaleX(0.75)
            bgImg2:addChild(itemLine, 15)
        end
    end
end
function otherPlayerDetailPop:selectTag(tag)
    if self._tag == tag then
        return 
    end
    self._tagButtons[self._tag]:setLocalZOrder(10)
    self._tagButtons[tag]:setLocalZOrder(11)
    self._tag = tag

end

--创建进度条
function otherPlayerDetailPop:createProgress(src1,src2,pos)
    local expImgBg = cc.Sprite:create(src1)
    expImgBg:setAnchorPoint(cc.p(0, 0.5))
    local expGressImg = cc.Sprite:create(src2)
    expGressImg:setAnchorPoint(cc.p(0, 0.5))
    local expPrgress = cc.ProgressTimer:create(expGressImg)
    expPrgress:setAnchorPoint(cc.p(0, 0.5))
    expPrgress:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    expPrgress:setBarChangeRate(cc.p(1, 0))
    expPrgress:setMidpoint(cc.p(0, 0))
    expImgBg:setPosition(pos)
    expPrgress:setPosition(pos)
    self._otherPlayer_right_bg:addChild(expImgBg)
    self._otherPlayer_right_bg:addChild(expPrgress)
    return expPrgress
end
--获取武将天赋名称及描述
function otherPlayerDetailPop:getSoliderTalentNameAndDesc(talentId)
    local _name = ""
    local _desc = ""
    local _data = gameData.getDataFromCacheWithPrimaryKey("hero_talent", talentId)
    if next(_data) ~= nil then
        _name = _data.name
        _desc = _data.desc
    end
    return _name,_desc
end

--给武将添加modelId talentId 字段
function otherPlayerDetailPop:getHeroModelId(id)
    local modelId = ""
    local talentId = 0
    local _heroTitle = ""

    local _data = gameData.getDataFromCacheWithPrimaryKey("hero", id)
    if next(_data) ~= nil then
        modelId = _data.modelId
        talentId = _data.talentId
        name = _data.name
        _heroTitle = _data.title
    end 
    return name,modelId,talentId,_heroTitle
end
--人物动作
function otherPlayerDetailPop:randomPlayAction() 
    local _key =  zc.random(1, 3)
    ---暂时写死
    _key = 1
    -- print("----key---",_key)
    local _action_str = actions[_key]
    if _action_str then
        self._armature:getAnimation():play(_action_str,-1,0)
    end
end
function otherPlayerDetailPop:createOtherPlayerInfo() 
    -- dump(self._cur_heroData, "self._cur_heroData================ ")
    local curData = self._cur_heroData
    local otherInfo = self._otherPlayerInfo
    if otherInfo and otherInfo["base"] and otherInfo["heros"] and otherInfo["weapons"] then
        local baseInfo          = otherInfo["base"]
        local heroInfo          = otherInfo["heros"]
        local weaponInfo        = otherInfo["weapons"]
        local otherPlayerId     = baseInfo["heroId"]
        local curHeroId         = curData["id"]
        local mainName          = baseInfo["userName"]
        -- print("curHeroId -------> ", curHeroId)
        -- local
        local otherMainInfo     = {}
        local optherMainWeapon  = {}
        for i = 1, #heroInfo do
            local v = heroInfo[i]
            if tonumber(v.id) == tonumber(curHeroId) then
                otherMainInfo = v
                break
            end
        end
        for i = 1, #weaponInfo do
            local v = weaponInfo[i]
            if tonumber(v.heroId) == tonumber(curHeroId) then
                optherMainWeapon = v
                break
            end
        end

        -- dump(heroInfo, "heroInfo +++++++++++ ")
        -- dump(weaponInfo, "weaponInfo +++++++++++ ")

        local isMain = false
        if tonumber(curHeroId) == tonumber(otherPlayerId) then
            isMain = true
            optherMainWeapon = self._mainRoleWeaponInfo
        end

        if otherMainInfo["id"]  then
            -- print("to create info ======= ")
            zc.createHeroInfoPop({
                heroData    = otherMainInfo,
                weaponData  = optherMainWeapon,
                isMainRole  = isMain,
                name = mainName
            })
        end
    end
end

return otherPlayerDetailPop